diff -pruN 1.22.1-1/.cirrus.yml 1.23.0-1/.cirrus.yml
--- 1.22.1-1/.cirrus.yml	2024-02-21 20:29:06.000000000 +0000
+++ 1.23.0-1/.cirrus.yml	2024-07-16 18:44:48.000000000 +0000
@@ -2,7 +2,7 @@ env:
   GOFLAGS: -mod=vendor
 
 freebsd_instance:
-  image_family: freebsd-13-2
+  image_family: freebsd-13-3
 
 test_task:
   install_script: pkg install -y go gcc git
diff -pruN 1.22.1-1/.teamcity/settings.kts 1.23.0-1/.teamcity/settings.kts
--- 1.22.1-1/.teamcity/settings.kts	2024-02-21 20:29:06.000000000 +0000
+++ 1.23.0-1/.teamcity/settings.kts	2024-07-16 18:44:48.000000000 +0000
@@ -41,25 +41,25 @@ To debug in IntelliJ Idea, open the 'Mav
 version = "2023.05"
 
 val targets = arrayOf(
-        "linux/amd64/1.20",
         "linux/amd64/1.21",
         "linux/amd64/1.22",
+        "linux/amd64/1.23",
         "linux/amd64/tip",
 
-        "linux/386/1.22",
+        "linux/386/1.23",
 
-        "linux/arm64/1.22",
+        "linux/arm64/1.23",
         "linux/arm64/tip",
 
-        "linux/ppc64le/1.22",
+        "linux/ppc64le/1.23",
 
-        "windows/amd64/1.22",
+        "windows/amd64/1.23",
         "windows/amd64/tip",
 
-        "mac/amd64/1.22",
+        "mac/amd64/1.23",
         "mac/amd64/tip",
 
-        "mac/arm64/1.22",
+        "mac/arm64/1.23",
         "mac/arm64/tip"
 )
 
diff -pruN 1.22.1-1/CHANGELOG.md 1.23.0-1/CHANGELOG.md
--- 1.22.1-1/CHANGELOG.md	2024-02-21 20:29:06.000000000 +0000
+++ 1.23.0-1/CHANGELOG.md	2024-07-16 18:44:48.000000000 +0000
@@ -3,6 +3,37 @@
 All notable changes to this project will be documented in this file.
 This project adheres to Semantic Versioning.
 
+## [1.23.0] 2024-07-16
+
+Deprecation notice: starting with the next version of Delve version 1 of the API will be removed. Version 2 was added in version 0.12.0 in 2017 and has been the recommended way to connect to Delve since.
+
+### Added
+
+- Support for Go 1.23, particularly the new range-over-func statement (#3663, #3697, #3736, #3738, #3750, #3755, #3763, #3778, @aarzilli)
+- `next-instruction` command (#3671, @derekparker)
+- Support reading captured variables of closure functions (#3682, @aarzilli)
+- Breakpoint command `break` now allows adding a condition the a breakpoint with a postfix notation (`break <name> <locspec> if <condition>`) (#3693, #3702, @derekparker)
+- When the `step` command is executed on `go funccall()` statements it will stop on the newly created goroutine (#3686, @aarzilli)
+- Invocation of [rr](https://github.com/rr-debugger/rr/) when it is used as a backend can be now controlled with environment variables `$DELVE_RR_RECORD_FLAGS` and `$DELVE_RR_REPLAY_FLAGS` (#3726, @aarzilli)
+- Added new suboption `--follow-calls` to trace command (#3594, @archanaravindar)
+
+### Fixed
+
+- Better behavior on stripped files (#3678, #3695, @aarzilli, @derekparker)
+- Support rr version 5.7.0 and later (#3705, #3718, @howardjohn, @aarzilli)
+- Watchpoints on newer versions of macOS (#3703, @derekparker)
+- Bug related to watchpoints going out of scope (#3742, @aarzilli)
+- Bug invoking debuginfod-find (#3762, @derekparker)
+- Miscellaneus fixes (#3707, #3761, #3759, #3767, @scop, @jayantxie, @aarzilli, @zdyj3170101136)
+
+### Changed
+
+- Improved auto-completions for shells (#3696, #3699, @scop)
+- Print more informations on tracepoint stops (#3675, #3712, @derekparker, @archanaravindar)
+- Improved performance of the default macOS backend (#3715, @derekparker)
+- When a breakpoint is hit on a headless instance of Delve while no clients are connected a message will be printed to stdout (#3632,#3747, @fatanugraha, @aarzilli)
+- Miscellaneous code and documentation improvements (#3676, #3677, #3698, #3716, #3727, #3722, #3730, #3731, #3753, #3752, #3756, #3757, #3741, #3773, #3775, #3770, #3769, #3772, #3779, #3774, @alexandear, @aarzilli, @abbasudo, @jayantxie)
+
 ## [1.22.1] 2024-02-21
 
 ### Added
@@ -46,7 +77,7 @@ This project adheres to Semantic Version
 ### Changed
 
 - Type casts from slice to string and vice versa will now use the load configuration for the target type, which is more intuitive (#3596, @aarzilli)
-- Miscellaneous impreovements to documentation (#3531, #3555, #3556, #3562, #3564, #3575, #3576, @alexandear, @testwill)
+- Miscellaneous improvements to documentation (#3531, #3555, #3556, #3562, #3564, #3575, #3576, @alexandear, @testwill)
 
 ## [1.21.2] 2023-10-30
 
@@ -207,7 +238,7 @@ This project adheres to Semantic Version
 - Add support for empty string in substitutePath (@RuijieC-dev)
 - Support gnu_debuglink section (@aarzilli)
 - Support exact matches in SubstitutePath (@eandre)
-- Add ability to show disassembly instead of source code (@aazilli)
+- Add ability to show disassembly instead of source code (@aarzilli)
 - Add -per-g-hitcount to breakpoint conditions (@yangxikun)
 
 ### Fixed
@@ -218,7 +249,7 @@ This project adheres to Semantic Version
 - Do not panic reading bad G struct (@aarzilli)
 - Fix parsing DWARFv5 file table (@derekparker)
 - Improve trace subcommand output (@derekparker)
-- Fix documentation for examinemem (@aaarzilli)
+- Fix documentation for examinemem (@aarzilli)
 - Fix step instruction on 1 byte instruction with software breakpoint (@qmuntal)
 - Fix handling of function entry / return in ebpf tracing backend (@derekparker)
 - Fix size of ebpf type for fn_addr (@derekparker)
@@ -389,7 +420,7 @@ This project adheres to Semantic Version
 ### Fixed
 
 * Correctly check for 1.17 and regabi (@aarzilli)
-* Print config output strings quouted (@aarzilli, @krobelus)
+* Print config output strings quoted (@aarzilli, @krobelus)
 * Update check for system goroutines (@suzmue)
 * DAP: Halt before detach in Stop (@polinasok)
 * DAP: Do not send halt request if debuggee is not running (@suzmue)
diff -pruN 1.22.1-1/Documentation/api/ClientHowto.md 1.23.0-1/Documentation/api/ClientHowto.md
--- 1.22.1-1/Documentation/api/ClientHowto.md	2024-02-21 20:29:06.000000000 +0000
+++ 1.23.0-1/Documentation/api/ClientHowto.md	2024-07-16 18:44:48.000000000 +0000
@@ -27,7 +27,7 @@ Command line arguments that should be ha
 dlv exec --headless ./somebinary -- these arguments are for the inferior process
 ```
 
-Specifying a static port number, like in the [README](//github.com/go-delve/Delve/tree/master/Documentation/README.md) example, can be done using `--listen=127.0.0.1:portnumber`. 
+Specifying a static port number, like in the [README](//github.com/go-delve/delve/tree/master/Documentation/README.md) example, can be done using `--listen=127.0.0.1:portnumber`. 
 
 This will, however, cause problems if you actually spawn multiple instances of the debugger. 
 
@@ -39,11 +39,11 @@ The `--log-dest` option can be used to r
 
 Once you have a running headless instance you can connect to it and start sending commands. Delve's protocol is built on top of the [JSON-RPC 1.0 specification](https://www.jsonrpc.org/specification_v1).
 
-The methods of a `service/rpc2.RPCServer` are exposed through this connection, to find out which requests you can send see the documentation of RPCServer on [godoc](https://godoc.org/github.com/go-delve/Delve/service/rpc2#RPCServer). 
+The methods of a `service/rpc2.RPCServer` are exposed through this connection, to find out which requests you can send see the documentation of RPCServer on [Go Reference](https://pkg.go.dev/github.com/go-delve/delve/service/rpc2#RPCServer). 
 
 ### Example
 
-Let's say you are trying to create a breakpoint. By looking at [godoc](https://godoc.org/github.com/go-delve/Delve/service/rpc2#RPCServer) you'll find that there is a `CreateBreakpoint` method in `RPCServer`.
+Let's say you are trying to create a breakpoint. By looking at [Go Reference](https://pkg.go.dev/github.com/go-delve/delve/service/rpc2#RPCServer) you'll find that there is a `CreateBreakpoint` method in `RPCServer`.
 
 This method, like all other methods of RPCServer that you can call through the API, has two arguments: `args` and `out`: `args` contains all the input arguments of `CreateBreakpoint`, while `out` is what `CreateBreakpoint` will return to you.
 
@@ -190,7 +190,7 @@ If you want to let your users specify a
 from a list of all functions you should specify the name of the function in
 the FunctionName field of Breakpoint.
 
-If you want to support the [same language as dlv's break and trace commands](//github.com/go-delve/Delve/tree/master/Documentation/cli/locspec.md)
+If you want to support the [same language as dlv's break and trace commands](//github.com/go-delve/delve/tree/master/Documentation/cli/locspec.md)
  you should call RPCServer.FindLocation and
 then use the returned slice of Location objects to create Breakpoints to
 pass to CreateBreakpoint: just fill each Breakpoint.Addr with the
@@ -244,7 +244,7 @@ are interested in the topmost stack fram
 thread) use: `EvalScope{ GoroutineID: -1, Frame: 0 }`.
 
 More information on the expression language interpreted by RPCServer.Eval
-can be found [here](//github.com/go-delve/Delve/tree/master/Documentation/cli/expr.md).
+can be found [here](//github.com/go-delve/delve/tree/master/Documentation/cli/expr.md).
 
 ### Variable shadowing
 
diff -pruN 1.22.1-1/Documentation/api/json-rpc/README.md 1.23.0-1/Documentation/api/json-rpc/README.md
--- 1.22.1-1/Documentation/api/json-rpc/README.md	2024-02-21 20:29:06.000000000 +0000
+++ 1.23.0-1/Documentation/api/json-rpc/README.md	2024-07-16 18:44:48.000000000 +0000
@@ -7,11 +7,11 @@ Note that this JSON-RPC interface is ser
 # API versions
 
 Delve currently supports two versions of its API. By default a headless instance of `dlv` will serve APIv1 for backward compatibility with old clients, however new clients should use APIv2 as new features will only be made available through version 2. To select APIv2 use `--api-version=2` command line argument. 
-Clients can also select APIv2 by sending a [SetApiVersion](https://godoc.org/github.com/go-delve/delve/service/rpccommon#RPCServer.SetApiVersion) request specifying `APIVersion = 2` after connecting to the headless instance.
+Clients can also select APIv2 by sending a [SetApiVersion](https://pkg.go.dev/github.com/go-delve/delve/service/rpccommon#RPCServer.SetApiVersion) request specifying `APIVersion = 2` after connecting to the headless instance.
 
 # API version 2 documentation
 
-All the methods of the type `service/rpc2.RPCServer` can be called using JSON-RPC, the documentation for these calls is [available on godoc](https://godoc.org/github.com/go-delve/delve/service/rpc2#RPCServer). 
+All the methods of the type `service/rpc2.RPCServer` can be called using JSON-RPC, the documentation for these calls is [available on godoc](https://pkg.go.dev/github.com/go-delve/delve/service/rpc2#RPCServer).
 
 Note that all exposed methods take one single input parameter (usually called `args`) of a struct type and also return a result of a struct type. Also note that the method name should be prefixed with `RPCServer.` in JSON-RPC.
 
diff -pruN 1.22.1-1/Documentation/backend_test_health.md 1.23.0-1/Documentation/backend_test_health.md
--- 1.22.1-1/Documentation/backend_test_health.md	2024-02-21 20:29:06.000000000 +0000
+++ 1.23.0-1/Documentation/backend_test_health.md	2024-07-16 18:44:48.000000000 +0000
@@ -1,9 +1,9 @@
 Tests skipped by each supported backend:
 
-* 386 skipped = 7
+* 386 skipped = 8
 	* 1 broken
 	* 3 broken - cgo stacktraces
-	* 3 not implemented
+	* 4 not implemented
 * arm64 skipped = 1
 	* 1 broken - global variable symbolication
 * darwin skipped = 3
@@ -13,10 +13,10 @@ Tests skipped by each supported backend:
 	* 1 broken - cgo stacktraces
 * darwin/lldb skipped = 1
 	* 1 upstream issue
-* freebsd skipped = 10
+* freebsd skipped = 11
 	* 2 flaky
 	* 2 follow exec not implemented on freebsd
-	* 4 not implemented
+	* 5 not implemented
 	* 2 not working on freebsd
 * linux/386 skipped = 2
 	* 2 not working on linux/386
@@ -31,14 +31,14 @@ Tests skipped by each supported backend:
 	* 3 broken - pie mode
 * pie skipped = 2
 	* 2 upstream issue - https://github.com/golang/go/issues/29322
-* ppc64le skipped = 11
+* ppc64le skipped = 12
 	* 6 broken
 	* 1 broken - global variable symbolication
-	* 4 not implemented
-* windows skipped = 6
+	* 5 not implemented
+* windows skipped = 7
 	* 1 broken
 	* 2 not working on windows
-	* 3 see https://github.com/go-delve/delve/issues/2768
+	* 4 see https://github.com/go-delve/delve/issues/2768
 * windows/arm64 skipped = 5
 	* 3 broken
 	* 1 broken - cgo stacktraces
diff -pruN 1.22.1-1/Documentation/cli/README.md 1.23.0-1/Documentation/cli/README.md
--- 1.22.1-1/Documentation/cli/README.md	2024-02-21 20:29:06.000000000 +0000
+++ 1.23.0-1/Documentation/cli/README.md	2024-07-16 18:44:48.000000000 +0000
@@ -13,6 +13,7 @@ Command | Description
 [call](#call) | Resumes process, injecting a function call (EXPERIMENTAL!!!)
 [continue](#continue) | Run until breakpoint or program termination.
 [next](#next) | Step over to next source line.
+[next-instruction](#next-instruction) | Single step a single cpu instruction, skipping function calls.
 [rebuild](#rebuild) | Rebuild the target executable and restarts it. It does not work if the executable was not built by delve.
 [restart](#restart) | Restart process.
 [rev](#rev) | Reverses the execution of the target program for the command specified.
@@ -107,9 +108,32 @@ If regex is specified only function argu
 ## break
 Sets a breakpoint.
 
-	break [name] [locspec]
+	break [name] [locspec] [if <condition>]
 
-See [Documentation/cli/locspec.md](//github.com/go-delve/delve/tree/master/Documentation/cli/locspec.md) for the syntax of locspec. If locspec is omitted a breakpoint will be set on the current line.
+Locspec is a location specifier in the form of:
+
+  * *<address> Specifies the location of memory address address. address can be specified as a decimal, hexadecimal or octal number
+  * <filename>:<line> Specifies the line in filename. filename can be the partial path to a file or even just the base name as long as the expression remains unambiguous.
+  * <line> Specifies the line in the current file
+  * +<offset> Specifies the line offset lines after the current one
+  * -<offset> Specifies the line offset lines before the current one
+  * <function>[:<line>] Specifies the line inside function.
+      The full syntax for function is <package>.(*<receiver type>).<function name> however the only required element is the function name,
+      everything else can be omitted as long as the expression remains unambiguous. For setting a breakpoint on an init function (ex: main.init),
+      the <filename>:<line> syntax should be used to break in the correct init function at the correct location.
+  * /<regex>/ Specifies the location of all the functions matching regex
+
+If locspec is omitted a breakpoint will be set on the current line.
+
+If you would like to assign a name to the breakpoint you can do so with the form:
+
+  break mybpname main.go:4
+
+Finally, you can assign a condition to the newly created breakpoint by using the 'if' postfix form, like so:
+
+  break main.go:55 if i == 5
+
+Alternatively you can set a condition on a breakpoint after created by using the 'on' command.
 
 See also: "help on", "help cond" and "help clear"
 
@@ -523,6 +547,11 @@ Optional [count] argument allows you to
 
 Aliases: n
 
+## next-instruction
+Single step a single cpu instruction, skipping function calls.
+
+Aliases: ni nexti
+
 ## on
 Executes a command when a breakpoint is hit.
 
@@ -658,7 +687,7 @@ Aliases: s
 ## step-instruction
 Single step a single cpu instruction.
 
-Aliases: si
+Aliases: si stepi
 
 ## stepout
 Step out of the current function.
diff -pruN 1.22.1-1/Documentation/cli/starlark.md 1.23.0-1/Documentation/cli/starlark.md
--- 1.22.1-1/Documentation/cli/starlark.md	2024-02-21 20:29:06.000000000 +0000
+++ 1.23.0-1/Documentation/cli/starlark.md	2024-07-16 18:44:48.000000000 +0000
@@ -17,56 +17,56 @@ Global functions with a name that begins
 <!-- BEGIN MAPPING TABLE -->
 Function | API Call
 ---------|---------
-amend_breakpoint(Breakpoint) | Equivalent to API call [AmendBreakpoint](https://godoc.org/github.com/go-delve/delve/service/rpc2#RPCServer.AmendBreakpoint)
-ancestors(GoroutineID, NumAncestors, Depth) | Equivalent to API call [Ancestors](https://godoc.org/github.com/go-delve/delve/service/rpc2#RPCServer.Ancestors)
-attached_to_existing_process() | Equivalent to API call [AttachedToExistingProcess](https://godoc.org/github.com/go-delve/delve/service/rpc2#RPCServer.AttachedToExistingProcess)
-build_id() | Equivalent to API call [BuildID](https://godoc.org/github.com/go-delve/delve/service/rpc2#RPCServer.BuildID)
-cancel_next() | Equivalent to API call [CancelNext](https://godoc.org/github.com/go-delve/delve/service/rpc2#RPCServer.CancelNext)
-checkpoint(Where) | Equivalent to API call [Checkpoint](https://godoc.org/github.com/go-delve/delve/service/rpc2#RPCServer.Checkpoint)
-clear_breakpoint(Id, Name) | Equivalent to API call [ClearBreakpoint](https://godoc.org/github.com/go-delve/delve/service/rpc2#RPCServer.ClearBreakpoint)
-clear_checkpoint(ID) | Equivalent to API call [ClearCheckpoint](https://godoc.org/github.com/go-delve/delve/service/rpc2#RPCServer.ClearCheckpoint)
-raw_command(Name, ThreadID, GoroutineID, ReturnInfoLoadConfig, Expr, UnsafeCall) | Equivalent to API call [Command](https://godoc.org/github.com/go-delve/delve/service/rpc2#RPCServer.Command)
-create_breakpoint(Breakpoint, LocExpr, SubstitutePathRules, Suspended) | Equivalent to API call [CreateBreakpoint](https://godoc.org/github.com/go-delve/delve/service/rpc2#RPCServer.CreateBreakpoint)
-create_ebpf_tracepoint(FunctionName) | Equivalent to API call [CreateEBPFTracepoint](https://godoc.org/github.com/go-delve/delve/service/rpc2#RPCServer.CreateEBPFTracepoint)
-create_watchpoint(Scope, Expr, Type) | Equivalent to API call [CreateWatchpoint](https://godoc.org/github.com/go-delve/delve/service/rpc2#RPCServer.CreateWatchpoint)
-debug_info_directories(Set, List) | Equivalent to API call [DebugInfoDirectories](https://godoc.org/github.com/go-delve/delve/service/rpc2#RPCServer.DebugInfoDirectories)
-detach(Kill) | Equivalent to API call [Detach](https://godoc.org/github.com/go-delve/delve/service/rpc2#RPCServer.Detach)
-disassemble(Scope, StartPC, EndPC, Flavour) | Equivalent to API call [Disassemble](https://godoc.org/github.com/go-delve/delve/service/rpc2#RPCServer.Disassemble)
-dump_cancel() | Equivalent to API call [DumpCancel](https://godoc.org/github.com/go-delve/delve/service/rpc2#RPCServer.DumpCancel)
-dump_start(Destination) | Equivalent to API call [DumpStart](https://godoc.org/github.com/go-delve/delve/service/rpc2#RPCServer.DumpStart)
-dump_wait(Wait) | Equivalent to API call [DumpWait](https://godoc.org/github.com/go-delve/delve/service/rpc2#RPCServer.DumpWait)
-eval(Scope, Expr, Cfg) | Equivalent to API call [Eval](https://godoc.org/github.com/go-delve/delve/service/rpc2#RPCServer.Eval)
-examine_memory(Address, Length) | Equivalent to API call [ExamineMemory](https://godoc.org/github.com/go-delve/delve/service/rpc2#RPCServer.ExamineMemory)
-find_location(Scope, Loc, IncludeNonExecutableLines, SubstitutePathRules) | Equivalent to API call [FindLocation](https://godoc.org/github.com/go-delve/delve/service/rpc2#RPCServer.FindLocation)
-follow_exec(Enable, Regex) | Equivalent to API call [FollowExec](https://godoc.org/github.com/go-delve/delve/service/rpc2#RPCServer.FollowExec)
-follow_exec_enabled() | Equivalent to API call [FollowExecEnabled](https://godoc.org/github.com/go-delve/delve/service/rpc2#RPCServer.FollowExecEnabled)
-function_return_locations(FnName) | Equivalent to API call [FunctionReturnLocations](https://godoc.org/github.com/go-delve/delve/service/rpc2#RPCServer.FunctionReturnLocations)
-get_breakpoint(Id, Name) | Equivalent to API call [GetBreakpoint](https://godoc.org/github.com/go-delve/delve/service/rpc2#RPCServer.GetBreakpoint)
-get_buffered_tracepoints() | Equivalent to API call [GetBufferedTracepoints](https://godoc.org/github.com/go-delve/delve/service/rpc2#RPCServer.GetBufferedTracepoints)
-get_thread(Id) | Equivalent to API call [GetThread](https://godoc.org/github.com/go-delve/delve/service/rpc2#RPCServer.GetThread)
-is_multiclient() | Equivalent to API call [IsMulticlient](https://godoc.org/github.com/go-delve/delve/service/rpc2#RPCServer.IsMulticlient)
-last_modified() | Equivalent to API call [LastModified](https://godoc.org/github.com/go-delve/delve/service/rpc2#RPCServer.LastModified)
-breakpoints(All) | Equivalent to API call [ListBreakpoints](https://godoc.org/github.com/go-delve/delve/service/rpc2#RPCServer.ListBreakpoints)
-checkpoints() | Equivalent to API call [ListCheckpoints](https://godoc.org/github.com/go-delve/delve/service/rpc2#RPCServer.ListCheckpoints)
-dynamic_libraries() | Equivalent to API call [ListDynamicLibraries](https://godoc.org/github.com/go-delve/delve/service/rpc2#RPCServer.ListDynamicLibraries)
-function_args(Scope, Cfg) | Equivalent to API call [ListFunctionArgs](https://godoc.org/github.com/go-delve/delve/service/rpc2#RPCServer.ListFunctionArgs)
-functions(Filter) | Equivalent to API call [ListFunctions](https://godoc.org/github.com/go-delve/delve/service/rpc2#RPCServer.ListFunctions)
-goroutines(Start, Count, Filters, GoroutineGroupingOptions, EvalScope) | Equivalent to API call [ListGoroutines](https://godoc.org/github.com/go-delve/delve/service/rpc2#RPCServer.ListGoroutines)
-local_vars(Scope, Cfg) | Equivalent to API call [ListLocalVars](https://godoc.org/github.com/go-delve/delve/service/rpc2#RPCServer.ListLocalVars)
-package_vars(Filter, Cfg) | Equivalent to API call [ListPackageVars](https://godoc.org/github.com/go-delve/delve/service/rpc2#RPCServer.ListPackageVars)
-packages_build_info(IncludeFiles, Filter) | Equivalent to API call [ListPackagesBuildInfo](https://godoc.org/github.com/go-delve/delve/service/rpc2#RPCServer.ListPackagesBuildInfo)
-registers(ThreadID, IncludeFp, Scope) | Equivalent to API call [ListRegisters](https://godoc.org/github.com/go-delve/delve/service/rpc2#RPCServer.ListRegisters)
-sources(Filter) | Equivalent to API call [ListSources](https://godoc.org/github.com/go-delve/delve/service/rpc2#RPCServer.ListSources)
-targets() | Equivalent to API call [ListTargets](https://godoc.org/github.com/go-delve/delve/service/rpc2#RPCServer.ListTargets)
-threads() | Equivalent to API call [ListThreads](https://godoc.org/github.com/go-delve/delve/service/rpc2#RPCServer.ListThreads)
-types(Filter) | Equivalent to API call [ListTypes](https://godoc.org/github.com/go-delve/delve/service/rpc2#RPCServer.ListTypes)
-process_pid() | Equivalent to API call [ProcessPid](https://godoc.org/github.com/go-delve/delve/service/rpc2#RPCServer.ProcessPid)
-recorded() | Equivalent to API call [Recorded](https://godoc.org/github.com/go-delve/delve/service/rpc2#RPCServer.Recorded)
-restart(Position, ResetArgs, NewArgs, Rerecord, Rebuild, NewRedirects) | Equivalent to API call [Restart](https://godoc.org/github.com/go-delve/delve/service/rpc2#RPCServer.Restart)
-set_expr(Scope, Symbol, Value) | Equivalent to API call [Set](https://godoc.org/github.com/go-delve/delve/service/rpc2#RPCServer.Set)
-stacktrace(Id, Depth, Full, Defers, Opts, Cfg) | Equivalent to API call [Stacktrace](https://godoc.org/github.com/go-delve/delve/service/rpc2#RPCServer.Stacktrace)
-state(NonBlocking) | Equivalent to API call [State](https://godoc.org/github.com/go-delve/delve/service/rpc2#RPCServer.State)
-toggle_breakpoint(Id, Name) | Equivalent to API call [ToggleBreakpoint](https://godoc.org/github.com/go-delve/delve/service/rpc2#RPCServer.ToggleBreakpoint)
+amend_breakpoint(Breakpoint) | Equivalent to API call [AmendBreakpoint](https://pkg.go.dev/github.com/go-delve/delve/service/rpc2#RPCServer.AmendBreakpoint)
+ancestors(GoroutineID, NumAncestors, Depth) | Equivalent to API call [Ancestors](https://pkg.go.dev/github.com/go-delve/delve/service/rpc2#RPCServer.Ancestors)
+attached_to_existing_process() | Equivalent to API call [AttachedToExistingProcess](https://pkg.go.dev/github.com/go-delve/delve/service/rpc2#RPCServer.AttachedToExistingProcess)
+build_id() | Equivalent to API call [BuildID](https://pkg.go.dev/github.com/go-delve/delve/service/rpc2#RPCServer.BuildID)
+cancel_next() | Equivalent to API call [CancelNext](https://pkg.go.dev/github.com/go-delve/delve/service/rpc2#RPCServer.CancelNext)
+checkpoint(Where) | Equivalent to API call [Checkpoint](https://pkg.go.dev/github.com/go-delve/delve/service/rpc2#RPCServer.Checkpoint)
+clear_breakpoint(Id, Name) | Equivalent to API call [ClearBreakpoint](https://pkg.go.dev/github.com/go-delve/delve/service/rpc2#RPCServer.ClearBreakpoint)
+clear_checkpoint(ID) | Equivalent to API call [ClearCheckpoint](https://pkg.go.dev/github.com/go-delve/delve/service/rpc2#RPCServer.ClearCheckpoint)
+raw_command(Name, ThreadID, GoroutineID, ReturnInfoLoadConfig, Expr, UnsafeCall) | Equivalent to API call [Command](https://pkg.go.dev/github.com/go-delve/delve/service/rpc2#RPCServer.Command)
+create_breakpoint(Breakpoint, LocExpr, SubstitutePathRules, Suspended) | Equivalent to API call [CreateBreakpoint](https://pkg.go.dev/github.com/go-delve/delve/service/rpc2#RPCServer.CreateBreakpoint)
+create_ebpf_tracepoint(FunctionName) | Equivalent to API call [CreateEBPFTracepoint](https://pkg.go.dev/github.com/go-delve/delve/service/rpc2#RPCServer.CreateEBPFTracepoint)
+create_watchpoint(Scope, Expr, Type) | Equivalent to API call [CreateWatchpoint](https://pkg.go.dev/github.com/go-delve/delve/service/rpc2#RPCServer.CreateWatchpoint)
+debug_info_directories(Set, List) | Equivalent to API call [DebugInfoDirectories](https://pkg.go.dev/github.com/go-delve/delve/service/rpc2#RPCServer.DebugInfoDirectories)
+detach(Kill) | Equivalent to API call [Detach](https://pkg.go.dev/github.com/go-delve/delve/service/rpc2#RPCServer.Detach)
+disassemble(Scope, StartPC, EndPC, Flavour) | Equivalent to API call [Disassemble](https://pkg.go.dev/github.com/go-delve/delve/service/rpc2#RPCServer.Disassemble)
+dump_cancel() | Equivalent to API call [DumpCancel](https://pkg.go.dev/github.com/go-delve/delve/service/rpc2#RPCServer.DumpCancel)
+dump_start(Destination) | Equivalent to API call [DumpStart](https://pkg.go.dev/github.com/go-delve/delve/service/rpc2#RPCServer.DumpStart)
+dump_wait(Wait) | Equivalent to API call [DumpWait](https://pkg.go.dev/github.com/go-delve/delve/service/rpc2#RPCServer.DumpWait)
+eval(Scope, Expr, Cfg) | Equivalent to API call [Eval](https://pkg.go.dev/github.com/go-delve/delve/service/rpc2#RPCServer.Eval)
+examine_memory(Address, Length) | Equivalent to API call [ExamineMemory](https://pkg.go.dev/github.com/go-delve/delve/service/rpc2#RPCServer.ExamineMemory)
+find_location(Scope, Loc, IncludeNonExecutableLines, SubstitutePathRules) | Equivalent to API call [FindLocation](https://pkg.go.dev/github.com/go-delve/delve/service/rpc2#RPCServer.FindLocation)
+follow_exec(Enable, Regex) | Equivalent to API call [FollowExec](https://pkg.go.dev/github.com/go-delve/delve/service/rpc2#RPCServer.FollowExec)
+follow_exec_enabled() | Equivalent to API call [FollowExecEnabled](https://pkg.go.dev/github.com/go-delve/delve/service/rpc2#RPCServer.FollowExecEnabled)
+function_return_locations(FnName) | Equivalent to API call [FunctionReturnLocations](https://pkg.go.dev/github.com/go-delve/delve/service/rpc2#RPCServer.FunctionReturnLocations)
+get_breakpoint(Id, Name) | Equivalent to API call [GetBreakpoint](https://pkg.go.dev/github.com/go-delve/delve/service/rpc2#RPCServer.GetBreakpoint)
+get_buffered_tracepoints() | Equivalent to API call [GetBufferedTracepoints](https://pkg.go.dev/github.com/go-delve/delve/service/rpc2#RPCServer.GetBufferedTracepoints)
+get_thread(Id) | Equivalent to API call [GetThread](https://pkg.go.dev/github.com/go-delve/delve/service/rpc2#RPCServer.GetThread)
+is_multiclient() | Equivalent to API call [IsMulticlient](https://pkg.go.dev/github.com/go-delve/delve/service/rpc2#RPCServer.IsMulticlient)
+last_modified() | Equivalent to API call [LastModified](https://pkg.go.dev/github.com/go-delve/delve/service/rpc2#RPCServer.LastModified)
+breakpoints(All) | Equivalent to API call [ListBreakpoints](https://pkg.go.dev/github.com/go-delve/delve/service/rpc2#RPCServer.ListBreakpoints)
+checkpoints() | Equivalent to API call [ListCheckpoints](https://pkg.go.dev/github.com/go-delve/delve/service/rpc2#RPCServer.ListCheckpoints)
+dynamic_libraries() | Equivalent to API call [ListDynamicLibraries](https://pkg.go.dev/github.com/go-delve/delve/service/rpc2#RPCServer.ListDynamicLibraries)
+function_args(Scope, Cfg) | Equivalent to API call [ListFunctionArgs](https://pkg.go.dev/github.com/go-delve/delve/service/rpc2#RPCServer.ListFunctionArgs)
+functions(Filter, FollowCalls) | Equivalent to API call [ListFunctions](https://pkg.go.dev/github.com/go-delve/delve/service/rpc2#RPCServer.ListFunctions)
+goroutines(Start, Count, Filters, GoroutineGroupingOptions, EvalScope) | Equivalent to API call [ListGoroutines](https://pkg.go.dev/github.com/go-delve/delve/service/rpc2#RPCServer.ListGoroutines)
+local_vars(Scope, Cfg) | Equivalent to API call [ListLocalVars](https://pkg.go.dev/github.com/go-delve/delve/service/rpc2#RPCServer.ListLocalVars)
+package_vars(Filter, Cfg) | Equivalent to API call [ListPackageVars](https://pkg.go.dev/github.com/go-delve/delve/service/rpc2#RPCServer.ListPackageVars)
+packages_build_info(IncludeFiles, Filter) | Equivalent to API call [ListPackagesBuildInfo](https://pkg.go.dev/github.com/go-delve/delve/service/rpc2#RPCServer.ListPackagesBuildInfo)
+registers(ThreadID, IncludeFp, Scope) | Equivalent to API call [ListRegisters](https://pkg.go.dev/github.com/go-delve/delve/service/rpc2#RPCServer.ListRegisters)
+sources(Filter) | Equivalent to API call [ListSources](https://pkg.go.dev/github.com/go-delve/delve/service/rpc2#RPCServer.ListSources)
+targets() | Equivalent to API call [ListTargets](https://pkg.go.dev/github.com/go-delve/delve/service/rpc2#RPCServer.ListTargets)
+threads() | Equivalent to API call [ListThreads](https://pkg.go.dev/github.com/go-delve/delve/service/rpc2#RPCServer.ListThreads)
+types(Filter) | Equivalent to API call [ListTypes](https://pkg.go.dev/github.com/go-delve/delve/service/rpc2#RPCServer.ListTypes)
+process_pid() | Equivalent to API call [ProcessPid](https://pkg.go.dev/github.com/go-delve/delve/service/rpc2#RPCServer.ProcessPid)
+recorded() | Equivalent to API call [Recorded](https://pkg.go.dev/github.com/go-delve/delve/service/rpc2#RPCServer.Recorded)
+restart(Position, ResetArgs, NewArgs, Rerecord, Rebuild, NewRedirects) | Equivalent to API call [Restart](https://pkg.go.dev/github.com/go-delve/delve/service/rpc2#RPCServer.Restart)
+set_expr(Scope, Symbol, Value) | Equivalent to API call [Set](https://pkg.go.dev/github.com/go-delve/delve/service/rpc2#RPCServer.Set)
+stacktrace(Id, Depth, Full, Defers, Opts, Cfg) | Equivalent to API call [Stacktrace](https://pkg.go.dev/github.com/go-delve/delve/service/rpc2#RPCServer.Stacktrace)
+state(NonBlocking) | Equivalent to API call [State](https://pkg.go.dev/github.com/go-delve/delve/service/rpc2#RPCServer.State)
+toggle_breakpoint(Id, Name) | Equivalent to API call [ToggleBreakpoint](https://pkg.go.dev/github.com/go-delve/delve/service/rpc2#RPCServer.ToggleBreakpoint)
 dlv_command(command) | Executes the specified command as if typed at the dlv_prompt
 read_file(path) | Reads the file as a string
 write_file(path, contents) | Writes string to a file
@@ -83,7 +83,7 @@ There are two ways to resume the executi
 	raw_command("continue")
 	dlv_command("continue")
 
-The first one maps to the API call [Command](https://godoc.org/github.com/derekparker/delve/service/rpc2#RPCServer.Command). As such all the caveats explained in the [Client HowTo](../api/ClientHowto.md).
+The first one maps to the API call [Command](https://pkg.go.dev/github.com/go-delve/delve/service/rpc2#RPCServer.Command). As such all the caveats explained in the [Client HowTo](../api/ClientHowto.md).
 
 The latter is equivalent to typing `continue` to the `(dlv)` command line and should do what you expect.
 
@@ -99,7 +99,7 @@ If the command function has a doc string
 
 # Working with variables
 
-Variables of the target program can be accessed using `local_vars`, `function_args` or the `eval` functions. Each variable will be returned as a [Variable](https://godoc.org/github.com/go-delve/delve/service/api#Variable) struct, with one special field: `Value`.
+Variables of the target program can be accessed using `local_vars`, `function_args` or the `eval` functions. Each variable will be returned as a [Variable](https://pkg.go.dev/github.com/go-delve/delve/service/api#Variable) struct, with one special field: `Value`.
 
 ## Variable.Value
 
diff -pruN 1.22.1-1/Documentation/usage/dlv_backend.md 1.23.0-1/Documentation/usage/dlv_backend.md
--- 1.22.1-1/Documentation/usage/dlv_backend.md	2024-02-21 20:29:06.000000000 +0000
+++ 1.23.0-1/Documentation/usage/dlv_backend.md	2024-07-16 18:44:48.000000000 +0000
@@ -12,6 +12,11 @@ are:
 	lldb		Uses lldb-server or debugserver.
 	rr		Uses mozilla rr (https://github.com/mozilla/rr).
 
+Some backends can be configured using environment variables:
+
+* DELVE_DEBUGSERVER_PATH specifies the path of the debugserver executable for the lldb backend
+* DELVE_RR_RECORD_FLAGS specifies additional flags used when calling 'rr record'
+* DELVE_RR_REPLAY_FLAGS specifies additional flags used when calling 'rr replay'
 
 
 ### Options
diff -pruN 1.22.1-1/Documentation/usage/dlv_trace.md 1.23.0-1/Documentation/usage/dlv_trace.md
--- 1.22.1-1/Documentation/usage/dlv_trace.md	2024-02-21 20:29:06.000000000 +0000
+++ 1.23.0-1/Documentation/usage/dlv_trace.md	2024-07-16 18:44:48.000000000 +0000
@@ -21,14 +21,15 @@ dlv trace [package] regexp [flags]
 ### Options
 
 ```
-      --ebpf            Trace using eBPF (experimental).
-  -e, --exec string     Binary file to exec and trace.
-  -h, --help            help for trace
-      --output string   Output path for the binary.
-  -p, --pid int         Pid to attach to.
-  -s, --stack int       Show stack trace with given depth. (Ignored with --ebpf)
-  -t, --test            Trace a test binary.
-      --timestamp       Show timestamp in the output
+      --ebpf               Trace using eBPF (experimental).
+  -e, --exec string        Binary file to exec and trace.
+      --follow-calls int   Trace all children of the function to the required depth
+  -h, --help               help for trace
+      --output string      Output path for the binary.
+  -p, --pid int            Pid to attach to.
+  -s, --stack int          Show stack trace with given depth. (Ignored with --ebpf)
+  -t, --test               Trace a test binary.
+      --timestamp          Show timestamp in the output
 ```
 
 ### Options inherited from parent commands
diff -pruN 1.22.1-1/README.md 1.23.0-1/README.md
--- 1.22.1-1/README.md	2024-02-21 20:29:06.000000000 +0000
+++ 1.23.0-1/README.md	2024-07-16 18:44:48.000000000 +0000
@@ -1,7 +1,7 @@
 ![Delve](https://raw.githubusercontent.com/go-delve/delve/master/assets/delve_horizontal.png)
 
-[![license](http://img.shields.io/badge/license-MIT-blue.svg)](https://raw.githubusercontent.com/go-delve/delve/master/LICENSE)
-[![GoDoc](https://godoc.org/github.com/go-delve/delve?status.svg)](https://godoc.org/github.com/go-delve/delve)
+[![license](https://img.shields.io/badge/license-MIT-blue.svg)](https://raw.githubusercontent.com/go-delve/delve/master/LICENSE)
+[![Go Reference](https://pkg.go.dev/badge/github.com/go-delve/delve.svg)](https://pkg.go.dev/github.com/go-delve/delve)
 [![Build Status](https://delve.teamcity.com/app/rest/builds/buildType:(id:Delve_AggregatorBuild)/statusIcon.svg)](https://delve.teamcity.com/viewType.html?buildTypeId=Delve_AggregatorBuild&guest=1)
 
 The GitHub issue tracker is for **bugs** only. Please use the [developer mailing list](https://groups.google.com/forum/#!forum/delve-dev) for any feature proposals and discussions.
diff -pruN 1.22.1-1/_fixtures/closurecontents.go 1.23.0-1/_fixtures/closurecontents.go
--- 1.22.1-1/_fixtures/closurecontents.go	1970-01-01 00:00:00.000000000 +0000
+++ 1.23.0-1/_fixtures/closurecontents.go	2024-07-16 18:44:48.000000000 +0000
@@ -0,0 +1,25 @@
+package main
+
+import (
+	"fmt"
+	"runtime"
+)
+
+func makeAcc(scale int) func(x int) int {
+	a := 0
+	return func(x int) int {
+		a += x * scale
+		return a
+	}
+}
+
+func main() {
+	acc := makeAcc(3)
+	runtime.Breakpoint()
+	fmt.Println(acc(1))
+	runtime.Breakpoint()
+	fmt.Println(acc(2))
+	runtime.Breakpoint()
+	fmt.Println(acc(6))
+	runtime.Breakpoint()
+}
diff -pruN 1.22.1-1/_fixtures/databpcountstest.go 1.23.0-1/_fixtures/databpcountstest.go
--- 1.22.1-1/_fixtures/databpcountstest.go	2024-02-21 20:29:06.000000000 +0000
+++ 1.23.0-1/_fixtures/databpcountstest.go	2024-07-16 18:44:48.000000000 +0000
@@ -1,7 +1,6 @@
 package main
 
 import (
-	"fmt"
 	"math/rand"
 	"sync"
 	"time"
@@ -12,7 +11,6 @@ var globalvar1 int
 func demo(id int, wait *sync.WaitGroup) {
 	for i := 0; i < 100; i++ {
 		sleep := rand.Intn(10) + 1
-		fmt.Printf("id: %d step: %d sleeping %d\n", id, i, sleep)
 		globalvar1 = globalvar1 + 1
 		time.Sleep(time.Duration(sleep) * time.Millisecond)
 	}
diff -pruN 1.22.1-1/_fixtures/issue2896.go 1.23.0-1/_fixtures/issue2896.go
--- 1.22.1-1/_fixtures/issue2896.go	2024-02-21 20:29:06.000000000 +0000
+++ 1.23.0-1/_fixtures/issue2896.go	2024-07-16 18:44:48.000000000 +0000
@@ -6,7 +6,7 @@ type Vehicle interface {
 	Run()
 }
 
-// BMWS1000RR defines the motocycle bmw s1000rr
+// BMWS1000RR defines the motorcycle bmw s1000rr
 type BMWS1000RR struct {
 }
 
diff -pruN 1.22.1-1/_fixtures/leaf4.go 1.23.0-1/_fixtures/leaf4.go
--- 1.22.1-1/_fixtures/leaf4.go	1970-01-01 00:00:00.000000000 +0000
+++ 1.23.0-1/_fixtures/leaf4.go	2024-07-16 18:44:48.000000000 +0000
@@ -0,0 +1,23 @@
+package main
+
+import "fmt"
+
+func D(i int) int {
+	return i * i * i
+}
+func C(i int) int {
+
+	return i + 20
+}
+func B(i int) int {
+	d := C(i) + 40
+	return d + D(i)
+}
+func A(i int) int {
+	return 10 + B(i)
+}
+func main() {
+	j := 0
+	j += A(2)
+	fmt.Println(j)
+}
diff -pruN 1.22.1-1/_fixtures/leafcommon.go 1.23.0-1/_fixtures/leafcommon.go
--- 1.22.1-1/_fixtures/leafcommon.go	1970-01-01 00:00:00.000000000 +0000
+++ 1.23.0-1/_fixtures/leafcommon.go	2024-07-16 18:44:48.000000000 +0000
@@ -0,0 +1,23 @@
+package main
+
+import "fmt"
+
+func D(i int) int {
+	return i * i * i
+}
+func C(i int) int {
+
+	return D(i+10) + 20
+}
+func B(i int) int {
+	return i * D(i)
+}
+func A(i int) int {
+	d := 10 + B(i)
+	return d + C(i)
+}
+func main() {
+	j := 0
+	j += A(2)
+	fmt.Println(j)
+}
diff -pruN 1.22.1-1/_fixtures/leafindrec.go 1.23.0-1/_fixtures/leafindrec.go
--- 1.22.1-1/_fixtures/leafindrec.go	1970-01-01 00:00:00.000000000 +0000
+++ 1.23.0-1/_fixtures/leafindrec.go	2024-07-16 18:44:48.000000000 +0000
@@ -0,0 +1,23 @@
+package main
+
+import "fmt"
+
+func B(i int) int {
+	if i > 0 {
+		return A(i - 1)
+	} else {
+		return 0
+	}
+}
+func A(n int) int {
+	if n <= 1 {
+		return n
+	} else {
+		return B(n - 3)
+	}
+}
+func main() {
+	j := 0
+	j += B(12)
+	fmt.Println(j)
+}
diff -pruN 1.22.1-1/_fixtures/leafrec.go 1.23.0-1/_fixtures/leafrec.go
--- 1.22.1-1/_fixtures/leafrec.go	1970-01-01 00:00:00.000000000 +0000
+++ 1.23.0-1/_fixtures/leafrec.go	2024-07-16 18:44:48.000000000 +0000
@@ -0,0 +1,17 @@
+package main
+
+import "fmt"
+
+func A(i int, n int) int {
+	if n == 1 {
+		return i
+	} else {
+		n--
+		return (i * A(i-1, n))
+	}
+}
+func main() {
+	j := 0
+	j += A(5, 5)
+	fmt.Println(j)
+}
diff -pruN 1.22.1-1/_fixtures/leafregex.go 1.23.0-1/_fixtures/leafregex.go
--- 1.22.1-1/_fixtures/leafregex.go	1970-01-01 00:00:00.000000000 +0000
+++ 1.23.0-1/_fixtures/leafregex.go	2024-07-16 18:44:48.000000000 +0000
@@ -0,0 +1,23 @@
+package main
+
+import "fmt"
+
+func callmed(i int) int {
+	return i * i * i
+}
+func callmee(i int) int {
+
+	return i + 20
+}
+func callme2(i int) int {
+	d := callmee(i) + 40
+	return d + callmed(i)
+}
+func callme(i int) int {
+	return 10 + callme2(i)
+}
+func main() {
+	j := 0
+	j += callme(2)
+	fmt.Println(j)
+}
diff -pruN 1.22.1-1/_fixtures/panicex.go 1.23.0-1/_fixtures/panicex.go
--- 1.22.1-1/_fixtures/panicex.go	1970-01-01 00:00:00.000000000 +0000
+++ 1.23.0-1/_fixtures/panicex.go	2024-07-16 18:44:48.000000000 +0000
@@ -0,0 +1,28 @@
+package main
+
+        func F0() {
+                defer func() {
+                        recover()
+                }()
+                F1()
+        }
+
+        func F1() {
+                F2()
+        }
+
+        func F2() {
+                F3()
+        }
+
+        func F3() {
+                F4()
+        }
+
+        func F4() {
+                panic("blah")
+        }
+
+        func main() {
+                F0()
+        }
diff -pruN 1.22.1-1/_fixtures/rangeoverfunc.go 1.23.0-1/_fixtures/rangeoverfunc.go
--- 1.22.1-1/_fixtures/rangeoverfunc.go	1970-01-01 00:00:00.000000000 +0000
+++ 1.23.0-1/_fixtures/rangeoverfunc.go	2024-07-16 18:44:48.000000000 +0000
@@ -0,0 +1,323 @@
+package main
+
+// The tests here are adapted from $GOROOT/src/cmd/compile/internal/rangefunc/rangefunc_test.go
+
+import (
+	"fmt"
+)
+
+/*
+
+
+
+THESE
+LINES
+INTENTIONALLY
+LEFT
+BLANK
+
+
+
+
+*/
+
+func TestTrickyIterAll() {
+	trickItAll := TrickyIterator{}
+	i := 0
+	for _, x := range trickItAll.iterAll([]int{30, 7, 8, 9, 10}) {
+		i += x
+		if i >= 36 {
+			break
+		}
+	}
+
+	fmt.Println("Got i = ", i)
+}
+
+func TestTrickyIterAll2() {
+	trickItAll := TrickyIterator{}
+	i := 0
+	for _, x := range trickItAll.iterAll([]int{42, 47}) {
+		i += x
+	}
+	fmt.Println(i)
+}
+
+func TestBreak1() {
+	var result []int
+	for _, x := range OfSliceIndex([]int{-1, -2, -4}) {
+		if x == -4 {
+			break
+		}
+		for _, y := range OfSliceIndex([]int{1, 2, 3, 4, 5, 6, 7, 8, 9, 10}) {
+			if y == 3 {
+				break
+			}
+			result = append(result, y)
+		}
+		result = append(result, x)
+	}
+	fmt.Println(result)
+}
+
+func TestBreak2() {
+	var result []int
+outer:
+	for _, x := range OfSliceIndex([]int{-1, -2, -4}) {
+		for _, y := range OfSliceIndex([]int{1, 2, 3, 4, 5, 6, 7, 8, 9, 10}) {
+			if y == 3 {
+				break
+			}
+			if x == -4 {
+				break outer
+			}
+			result = append(result, y)
+		}
+		result = append(result, x)
+	}
+	fmt.Println(result)
+}
+
+func TestMultiCont0() {
+	var result []int
+
+W:
+	for _, w := range OfSliceIndex([]int{1000, 2000}) {
+		result = append(result, w)
+		if w == 2000 {
+			break
+		}
+		for _, x := range OfSliceIndex([]int{100, 200, 300, 400}) {
+			for _, y := range OfSliceIndex([]int{10, 20, 30, 40}) {
+				result = append(result, y)
+				for _, z := range OfSliceIndex([]int{1, 2, 3, 4, 5, 6, 7, 8, 9, 10}) {
+					if z&1 == 1 {
+						continue
+					}
+					result = append(result, z)
+					if z >= 4 {
+						continue W // modified to be multilevel
+					}
+				}
+				result = append(result, -y) // should never be executed
+			}
+			result = append(result, x)
+		}
+	}
+	fmt.Println(result)
+}
+
+func TestPanickyIterator1() {
+	var result []int
+	defer func() {
+		r := recover()
+		fmt.Println("Recovering", r)
+	}()
+	for _, z := range PanickyOfSliceIndex([]int{1, 2, 3, 4}) {
+		result = append(result, z)
+		if z == 4 {
+			break
+		}
+	}
+	fmt.Println(result)
+}
+
+func TestPanickyIterator2() {
+	var result []int
+	defer func() {
+		r := recover()
+		fmt.Println("Recovering ", r)
+	}()
+	for _, x := range OfSliceIndex([]int{100, 200}) {
+		result = append(result, x)
+	Y:
+		// swallows panics and iterates to end BUT `break Y` disables the body, so--> 10, 1, 2
+		for _, y := range VeryBadOfSliceIndex([]int{10, 20}) {
+			result = append(result, y)
+
+			// converts early exit into a panic --> 1, 2
+			for k, z := range PanickyOfSliceIndex([]int{1, 2}) { // iterator panics
+				result = append(result, z)
+				if k == 1 {
+					break Y
+				}
+			}
+		}
+	}
+}
+
+func TestPanickyIteratorWithNewDefer() {
+	var result []int
+	defer func() {
+		r := recover()
+		fmt.Println("Recovering ", r)
+	}()
+	for _, x := range OfSliceIndex([]int{100, 200}) {
+		result = append(result, x)
+	Y:
+		// swallows panics and iterates to end BUT `break Y` disables the body, so--> 10, 1, 2
+		for _, y := range VeryBadOfSliceIndex([]int{10, 20}) {
+			defer func() { // This defer will be set on TestPanickyIteratorWithNewDefer from TestPanickyIteratorWithNewDefer-range2
+				fmt.Println("y loop defer")
+			}()
+			result = append(result, y)
+
+			// converts early exit into a panic --> 1, 2
+			for k, z := range PanickyOfSliceIndex([]int{1, 2}) { // iterator panics
+				result = append(result, z)
+				if k == 1 {
+					break Y
+				}
+			}
+		}
+	}
+}
+
+func TestLongReturnWrapper() {
+	TestLongReturn()
+	fmt.Println("returned")
+}
+
+func TestLongReturn() {
+	for _, x := range OfSliceIndex([]int{1, 2, 3}) {
+		for _, y := range OfSliceIndex([]int{10, 20, 30}) {
+			if y == 10 {
+				return
+			}
+		}
+		fmt.Println(x)
+	}
+}
+
+func TestGotoA1() {
+	result := []int{}
+	for _, x := range OfSliceIndex([]int{-1, -4, -5}) {
+		result = append(result, x)
+		if x == -4 {
+			break
+		}
+		for _, y := range OfSliceIndex([]int{1, 2, 3, 4, 5, 6, 7, 8, 9, 10}) {
+			if y == 3 {
+				goto A
+			}
+			result = append(result, y)
+		}
+	A:
+		result = append(result, x)
+	}
+	fmt.Println(result)
+}
+
+func TestGotoB1() {
+	result := []int{}
+	for _, x := range OfSliceIndex([]int{-1, -2, -3, -4, -5}) {
+		result = append(result, x)
+		if x == -4 {
+			break
+		}
+		for _, y := range OfSliceIndex([]int{1, 2, 3, 4, 5, 6, 7, 8, 9, 10}) {
+			if y == 3 {
+				goto B
+			}
+			result = append(result, y)
+		}
+		result = append(result, x)
+	}
+B:
+	result = append(result, 999)
+	fmt.Println(result)
+}
+
+func TestRecur(n int) {
+	result := []int{}
+	if n > 0 {
+		TestRecur(n - 1)
+	}
+	for _, x := range OfSliceIndex([]int{10, 20, 30}) {
+		result = append(result, x)
+		if n == 3 {
+			TestRecur(0)
+		}
+	}
+	fmt.Println(result)
+}
+
+func main() {
+	TestTrickyIterAll()
+	TestTrickyIterAll2()
+	TestBreak1()
+	TestBreak2()
+	TestMultiCont0()
+	TestPanickyIterator1()
+	TestPanickyIterator2()
+	TestPanickyIteratorWithNewDefer()
+	TestLongReturnWrapper()
+	TestGotoA1()
+	TestGotoB1()
+	TestRecur(3)
+}
+
+type Seq[T any] func(yield func(T) bool)
+type Seq2[T1, T2 any] func(yield func(T1, T2) bool)
+
+type TrickyIterator struct {
+	yield func()
+}
+
+func (ti *TrickyIterator) iterAll(s []int) Seq2[int, int] {
+	return func(yield func(int, int) bool) {
+		// NOTE: storing the yield func in the iterator has been removed because
+		// it make the closure escape to the heap which breaks the .closureptr
+		// heuristic. Eventually we will need to figure out what to do when that
+		// happens.
+		// ti.yield = yield // Save yield for future abuse
+		for i, v := range s {
+			if !yield(i, v) {
+				return
+			}
+		}
+		return
+	}
+}
+
+// OfSliceIndex returns a Seq2 over the elements of s. It is equivalent
+// to range s.
+func OfSliceIndex[T any, S ~[]T](s S) Seq2[int, T] {
+	return func(yield func(int, T) bool) {
+		for i, v := range s {
+			if !yield(i, v) {
+				return
+			}
+		}
+		return
+	}
+}
+
+// PanickyOfSliceIndex iterates the slice but panics if it exits the loop early
+func PanickyOfSliceIndex[T any, S ~[]T](s S) Seq2[int, T] {
+	return func(yield func(int, T) bool) {
+		for i, v := range s {
+			if !yield(i, v) {
+				panic(fmt.Errorf("Panicky iterator panicking"))
+			}
+		}
+		return
+	}
+}
+
+// VeryBadOfSliceIndex is "very bad" because it ignores the return value from yield
+// and just keeps on iterating, and also wraps that call in a defer-recover so it can
+// keep on trying after the first panic.
+func VeryBadOfSliceIndex[T any, S ~[]T](s S) Seq2[int, T] {
+	return func(yield func(int, T) bool) {
+		for i, v := range s {
+			func() {
+				defer func() {
+					recover()
+				}()
+				yield(i, v)
+			}()
+		}
+		return
+	}
+}
diff -pruN 1.22.1-1/_fixtures/stackwatchbug.go 1.23.0-1/_fixtures/stackwatchbug.go
--- 1.22.1-1/_fixtures/stackwatchbug.go	1970-01-01 00:00:00.000000000 +0000
+++ 1.23.0-1/_fixtures/stackwatchbug.go	2024-07-16 18:44:48.000000000 +0000
@@ -0,0 +1,20 @@
+package main
+
+import (
+	"fmt"
+)
+
+func multiRound() {
+	vars := []int{0, 1, 2, 3, 4, 5}
+	for i := range vars { // line 9: set watchpoints
+		if i > 0 {
+			vars[i] = vars[i-1]
+			fmt.Println() // line 12: watchpoints hit
+		}
+	}
+}
+
+func main() {
+	multiRound() // line 18: after restart, last watchpoint out of scope
+	return       // line 19: all watchpoints should go out of scope
+}
diff -pruN "1.22.1-1/_fixtures/test if path/main.go" "1.23.0-1/_fixtures/test if path/main.go"
--- "1.22.1-1/_fixtures/test if path/main.go"	1970-01-01 00:00:00.000000000 +0000
+++ "1.23.0-1/_fixtures/test if path/main.go"	2024-07-16 18:44:48.000000000 +0000
@@ -0,0 +1,5 @@
+package main
+
+func main() {
+	println("here")
+}
diff -pruN 1.22.1-1/_fixtures/testtracefns.go 1.23.0-1/_fixtures/testtracefns.go
--- 1.22.1-1/_fixtures/testtracefns.go	1970-01-01 00:00:00.000000000 +0000
+++ 1.23.0-1/_fixtures/testtracefns.go	2024-07-16 18:44:48.000000000 +0000
@@ -0,0 +1,81 @@
+package main
+
+import "fmt"
+
+func D(i int) int {
+	return i * i * i
+}
+func C(i int) int {
+
+	return D(i+10) + 20
+}
+func B(i int) int {
+	return i * D(i)
+}
+func A(i int) int {
+	d := 10 + B(i)
+	return d + C(i)
+}
+func second(i int) int {
+	if i > 0 {
+		return first(i - 1)
+	} else {
+		return 0
+	}
+}
+func first(n int) int {
+	if n <= 1 {
+		return n
+	} else {
+		return second(n - 3)
+	}
+}
+
+func callmed(i int) int {
+	return i * i * i
+}
+func callmee(i int) int {
+
+	return i + 20
+}
+func callme2(i int) int {
+	d := callmee(i) + 40
+	return d + callmed(i)
+}
+func callme(i int) int {
+	return 10 + callme2(i)
+}
+
+func F0() {
+	defer func() {
+		recover()
+	}()
+	F1()
+}
+
+func F1() {
+	F2()
+}
+
+func F2() {
+	F3()
+}
+
+func F3() {
+	F4()
+}
+
+func F4() {
+	panic("blah")
+}
+
+func main() {
+	j := 0
+	j += A(2)
+
+	j += first(6)
+	j += callme(2)
+	fmt.Println(j)
+	F0()
+
+}
diff -pruN 1.22.1-1/_scripts/gen-faq-toc.go 1.23.0-1/_scripts/gen-faq-toc.go
--- 1.22.1-1/_scripts/gen-faq-toc.go	2024-02-21 20:29:06.000000000 +0000
+++ 1.23.0-1/_scripts/gen-faq-toc.go	2024-07-16 18:44:48.000000000 +0000
@@ -50,12 +50,12 @@ func spliceDocs(docpath string, docs []b
 	footer := v[1]
 
 	outbuf := bytes.NewBuffer(make([]byte, 0, len(header)+len(docs)+len(footer)+len(startOfToc)+len(endOfToc)+1))
-	outbuf.Write([]byte(header))
-	outbuf.Write([]byte(startOfToc))
+	outbuf.WriteString(header)
+	outbuf.WriteString(startOfToc)
 	outbuf.WriteByte('\n')
 	outbuf.Write(docs)
-	outbuf.Write([]byte(endOfToc))
-	outbuf.Write([]byte(footer))
+	outbuf.WriteString(endOfToc)
+	outbuf.WriteString(footer)
 
 	if outpath != "-" {
 		err = os.WriteFile(outpath, outbuf.Bytes(), 0o664)
diff -pruN 1.22.1-1/_scripts/gen-starlark-bindings.go 1.23.0-1/_scripts/gen-starlark-bindings.go
--- 1.22.1-1/_scripts/gen-starlark-bindings.go	2024-02-21 20:29:06.000000000 +0000
+++ 1.23.0-1/_scripts/gen-starlark-bindings.go	2024-07-16 18:44:48.000000000 +0000
@@ -260,7 +260,7 @@ func genDocs(bindings []binding) []byte
 
 	for _, binding := range bindings {
 		argNames := strings.Join(binding.argNames, ", ")
-		fmt.Fprintf(&buf, "%s(%s) | Equivalent to API call [%s](https://godoc.org/github.com/go-delve/delve/service/rpc2#RPCServer.%s)\n", binding.name, argNames, binding.fn.Name(), binding.fn.Name())
+		fmt.Fprintf(&buf, "%s(%s) | Equivalent to API call [%s](https://pkg.go.dev/github.com/go-delve/delve/service/rpc2#RPCServer.%s)\n", binding.name, argNames, binding.fn.Name(), binding.fn.Name())
 	}
 
 	fmt.Fprintf(&buf, "dlv_command(command) | Executes the specified command as if typed at the dlv_prompt\n")
diff -pruN 1.22.1-1/_scripts/gen-travis.go 1.23.0-1/_scripts/gen-travis.go
--- 1.22.1-1/_scripts/gen-travis.go	2024-02-21 20:29:06.000000000 +0000
+++ 1.23.0-1/_scripts/gen-travis.go	2024-07-16 18:44:48.000000000 +0000
@@ -78,7 +78,7 @@ jobs:
           - go: {{index .GoVersions 2}}
             os: ubuntu-latest
     steps:
-      - uses: actions/checkout@v2
+      - uses: actions/checkout@v4
       - uses: actions/setup-go@v1
         with:
           go-version: ${{"{{"}}matrix.go{{"}}"}}
diff -pruN 1.22.1-1/_scripts/latestver.py 1.23.0-1/_scripts/latestver.py
--- 1.22.1-1/_scripts/latestver.py	2024-02-21 20:29:06.000000000 +0000
+++ 1.23.0-1/_scripts/latestver.py	2024-07-16 18:44:48.000000000 +0000
@@ -1,6 +1,6 @@
-#!/usr/bin/python
+#!/usr/bin/python3
 import json
-import urllib
+import urllib.request
 import sys
 import re
 
@@ -19,9 +19,9 @@ def splitver(x):
 	return v
 
 ver = sys.argv[1]
-d = json.loads(urllib.urlopen('https://go.dev/dl/?mode=json&include=all').read())
+d = json.loads(urllib.request.urlopen('https://go.dev/dl/?mode=json&include=all').read())
 ds = sorted(d, reverse=True, key=lambda it: splitver(it['version'][2:]))
 for x in ds:
 	if x['version'][:len(ver)] == ver:
-		print x['version']
+		print(x['version'])
 		exit(0)
diff -pruN 1.22.1-1/_scripts/rtype-out.txt 1.23.0-1/_scripts/rtype-out.txt
--- 1.22.1-1/_scripts/rtype-out.txt	2024-02-21 20:29:06.000000000 +0000
+++ 1.23.0-1/_scripts/rtype-out.txt	2024-07-16 18:44:48.000000000 +0000
@@ -27,7 +27,7 @@ type g struct {
 	waitsince int64
 	waitreason waitReason (optional)
 	stack stack
-	atomicstatus uint32|runtime/internal/atomic.Uint32
+	atomicstatus uint32|runtime/internal/atomic.Uint32|internal/runtime/atomic.Uint32
 }
 
 type gobuf struct {
@@ -45,23 +45,15 @@ type hmap struct {
 }
 
 type iface struct {
-	tab *itab
+	tab *itab|*internal/abi.ITab
 	data unsafe.Pointer
 }
 
-type itab struct {
-	_type *_type|*internal/abi.Type
-}
-
 type moduledata struct {
 	text uintptr
 	types uintptr
 }
 
-type runtime/internal/atomic.Uint32 struct {
-	value uint32
-}
-
 type stack struct {
 	hi uintptr
 	lo uintptr
@@ -71,11 +63,11 @@ const emptyOne = 1
 
 const emptyRest = 0
 
-const kindDirectIface = 32
+const kindDirectIface|internal/abi.KindDirectIface = 32
 
-const kindGCProg = 64
+const kindGCProg|internal/abi.KindGCProg = 64
 
-const kindMask = 31
+const kindMask|internal/abi.KindMask = 31
 
 const minTopHash = 4
 or const minTopHash = 5
diff -pruN 1.22.1-1/_scripts/rtype.go 1.23.0-1/_scripts/rtype.go
--- 1.22.1-1/_scripts/rtype.go	2024-02-21 20:29:06.000000000 +0000
+++ 1.23.0-1/_scripts/rtype.go	2024-07-16 18:44:48.000000000 +0000
@@ -459,7 +459,9 @@ func addCheckVarType(V, T string, pos to
 }
 
 func addCheckFieldType(S, F, T string, opt bool, pos token.Pos) {
-	checkFieldTypeRules[S] = append(checkFieldTypeRules[S], &checkFieldType{S, F, T, opt, pos})
+	if !strings.Contains(S, "|") {
+		checkFieldTypeRules[S] = append(checkFieldTypeRules[S], &checkFieldType{S, F, T, opt, pos})
+	}
 }
 
 func addCheckConstVal(C string, V constant.Value, pos token.Pos) {
@@ -547,7 +549,6 @@ func check() {
 	allok := true
 
 	for _, rule := range checkVarTypeRules {
-		//TODO: implement
 		pos := fset.Position(rule.pos)
 		def := lookupPackage(pkgmap, "runtime").Types.Scope().Lookup(rule.V)
 		if def == nil {
@@ -618,7 +619,7 @@ func check() {
 	for _, C := range Cs {
 		rules := checkConstValRules[C]
 		pos := fset.Position(rules[0].pos)
-		def := lookupPackage(pkgmap, "runtime").Types.Scope().Lookup(C)
+		def := findConst(pkgmap, C)
 		if def == nil {
 			fmt.Fprintf(os.Stderr, "%s:%d: could not find constant %s\n", pos.Filename, pos.Line, C)
 			allok = false
@@ -652,6 +653,21 @@ func fieldTypeByName(typ *types.Struct,
 		}
 	}
 	return nil
+}
+
+func findConst(pkgmap map[string]*packages.Package, Cs string) types.Object {
+	for _, C := range strings.Split(Cs, "|") {
+		pkg := lookupPackage(pkgmap, "runtime")
+		if dot := strings.Index(C, "."); dot >= 0 {
+			pkg = lookupPackage(pkgmap, C[:dot])
+			C = C[dot+1:]
+		}
+		def := pkg.Types.Scope().Lookup(C)
+		if def != nil {
+			return def
+		}
+	}
+	return nil
 }
 
 func matchType(typ types.Type, T string) bool {
diff -pruN 1.22.1-1/_scripts/test_mac.sh 1.23.0-1/_scripts/test_mac.sh
--- 1.22.1-1/_scripts/test_mac.sh	2024-02-21 20:29:06.000000000 +0000
+++ 1.23.0-1/_scripts/test_mac.sh	2024-07-16 18:44:48.000000000 +0000
@@ -25,7 +25,7 @@ if [ "$GOVERSION" = "gotip" ]; then
     cd -
 else
     echo Finding latest patch version for $GOVERSION
-    GOVERSION=$(python _scripts/latestver.py $GOVERSION)
+    GOVERSION=$(python3 _scripts/latestver.py $GOVERSION)
     echo Go $GOVERSION on $ARCH
     cd $TMPDIR
     curl -sSL "https://storage.googleapis.com/golang/$GOVERSION.darwin-$ARCH.tar.gz" | tar -xz
diff -pruN 1.22.1-1/cmd/dlv/cmds/commands.go 1.23.0-1/cmd/dlv/cmds/commands.go
--- 1.22.1-1/cmd/dlv/cmds/commands.go	2024-02-21 20:29:06.000000000 +0000
+++ 1.23.0-1/cmd/dlv/cmds/commands.go	2024-07-16 18:44:48.000000000 +0000
@@ -4,6 +4,7 @@ import (
 	"encoding/json"
 	"errors"
 	"fmt"
+	"log"
 	"net"
 	"os"
 	"os/exec"
@@ -35,8 +36,8 @@ import (
 )
 
 var (
-	// log is whether to log debug statements.
-	log bool
+	// logFlag is whether to log debug statements.
+	logFlag bool
 	// logOutput is a comma separated list of components that should produce debug output.
 	logOutput string
 	// logDest is the file path or file descriptor where logs should go.
@@ -87,6 +88,7 @@ var (
 	traceStackDepth    int
 	traceUseEBPF       bool
 	traceShowTimestamp bool
+	traceFollowCalls   int
 
 	// redirect specifications for target process
 	redirects []string
@@ -138,21 +140,30 @@ func New(docCall bool) *cobra.Command {
 	}
 
 	rootCommand.PersistentFlags().StringVarP(&addr, "listen", "l", "127.0.0.1:0", "Debugging server listen address. Prefix with 'unix:' to use a unix domain socket.")
+	must(rootCommand.RegisterFlagCompletionFunc("listen", cobra.NoFileCompletions))
 
-	rootCommand.PersistentFlags().BoolVarP(&log, "log", "", false, "Enable debugging server logging.")
+	rootCommand.PersistentFlags().BoolVarP(&logFlag, "log", "", false, "Enable debugging server logging.")
 	rootCommand.PersistentFlags().StringVarP(&logOutput, "log-output", "", "", `Comma separated list of components that should produce debug output (see 'dlv help log')`)
+	must(rootCommand.RegisterFlagCompletionFunc("log-output", cobra.FixedCompletions([]string{"debugger", "gdbwire", "lldbout", "debuglineerr", "rpc", "dap", "fncall", "minidump", "stack"}, cobra.ShellCompDirectiveNoFileComp)))
 	rootCommand.PersistentFlags().StringVarP(&logDest, "log-dest", "", "", "Writes logs to the specified file or file descriptor (see 'dlv help log').")
+	must(rootCommand.MarkPersistentFlagFilename("log-dest", "log"))
 
 	rootCommand.PersistentFlags().BoolVarP(&headless, "headless", "", false, "Run debug server only, in headless mode. Server will accept both JSON-RPC or DAP client connections.")
 	rootCommand.PersistentFlags().BoolVarP(&acceptMulti, "accept-multiclient", "", false, "Allows a headless server to accept multiple client connections via JSON-RPC or DAP.")
 	rootCommand.PersistentFlags().IntVar(&apiVersion, "api-version", 1, "Selects JSON-RPC API version when headless. New clients should use v2. Can be reset via RPCServer.SetApiVersion. See Documentation/api/json-rpc/README.md.")
+	must(rootCommand.RegisterFlagCompletionFunc("api-version", cobra.FixedCompletions([]string{"1", "2"}, cobra.ShellCompDirectiveNoFileComp)))
 	rootCommand.PersistentFlags().StringVar(&initFile, "init", "", "Init file, executed by the terminal client.")
+	must(rootCommand.MarkPersistentFlagFilename("init"))
 	rootCommand.PersistentFlags().StringVar(&buildFlags, "build-flags", buildFlagsDefault, "Build flags, to be passed to the compiler. For example: --build-flags=\"-tags=integration -mod=vendor -cover -v\"")
+	must(rootCommand.RegisterFlagCompletionFunc("build-flags", cobra.NoFileCompletions))
 	rootCommand.PersistentFlags().StringVar(&workingDir, "wd", "", "Working directory for running the program.")
+	must(rootCommand.MarkPersistentFlagDirname("wd"))
 	rootCommand.PersistentFlags().BoolVarP(&checkGoVersion, "check-go-version", "", true, "Exits if the version of Go in use is not compatible (too old or too new) with the version of Delve.")
 	rootCommand.PersistentFlags().BoolVarP(&checkLocalConnUser, "only-same-user", "", true, "Only connections from the same user that started this instance of Delve are allowed to connect.")
 	rootCommand.PersistentFlags().StringVar(&backend, "backend", "default", `Backend selection (see 'dlv help backend').`)
+	must(rootCommand.RegisterFlagCompletionFunc("backend", cobra.FixedCompletions([]string{"default", "native", "lldb", "rr"}, cobra.ShellCompDirectiveNoFileComp)))
 	rootCommand.PersistentFlags().StringArrayVarP(&redirects, "redirect", "r", []string{}, "Specifies redirect rules for target process (see 'dlv help redirect')")
+	must(rootCommand.MarkPersistentFlagFilename("redirect"))
 	rootCommand.PersistentFlags().BoolVar(&allowNonTerminalInteractive, "allow-non-terminal-interactive", false, "Allows interactive sessions of Delve that don't have a terminal as stdin, stdout and stderr")
 	rootCommand.PersistentFlags().BoolVar(&disableASLR, "disable-aslr", false, "Disables address space randomization")
 
@@ -173,11 +184,20 @@ option to let the process continue or ki
 			return nil
 		},
 		Run: attachCmd,
+		ValidArgsFunction: func(cmd *cobra.Command, args []string, toComplete string) ([]string, cobra.ShellCompDirective) {
+			if len(args) != 1 {
+				return nil, cobra.ShellCompDirectiveNoFileComp
+			}
+			return nil, cobra.ShellCompDirectiveDefault
+		},
 	}
 	attachCommand.Flags().BoolVar(&continueOnStart, "continue", false, "Continue the debugged process on start.")
 	attachCommand.Flags().StringVar(&attachWaitFor, "waitfor", "", "Wait for a process with a name beginning with this prefix")
+	must(attachCommand.RegisterFlagCompletionFunc("waitfor", cobra.NoFileCompletions))
 	attachCommand.Flags().Float64Var(&attachWaitForInterval, "waitfor-interval", 1, "Interval between checks of the process list, in millisecond")
+	must(attachCommand.RegisterFlagCompletionFunc("waitfor-interval", cobra.NoFileCompletions))
 	attachCommand.Flags().Float64Var(&attachWaitForDuration, "waitfor-duration", 0, "Total time to wait for a process")
+	must(attachCommand.RegisterFlagCompletionFunc("waitfor-duration", cobra.NoFileCompletions))
 	rootCommand.AddCommand(attachCommand)
 
 	// 'connect' subcommand.
@@ -191,7 +211,8 @@ option to let the process continue or ki
 			}
 			return nil
 		},
-		Run: connectCmd,
+		Run:               connectCmd,
+		ValidArgsFunction: cobra.NoFileCompletions,
 	}
 	rootCommand.AddCommand(connectCommand)
 
@@ -220,9 +241,11 @@ execution is resumed at the start of the
 The --client-addr flag is a special flag that makes the server initiate a debug session
 by dialing in to the host:port where a DAP client is waiting. This server process
 will exit when the debug session ends.`,
-		Run: dapCmd,
+		Run:               dapCmd,
+		ValidArgsFunction: cobra.NoFileCompletions,
 	}
 	dapCommand.Flags().StringVar(&dapClientAddr, "client-addr", "", "host:port where the DAP client is waiting for the DAP server to dial in")
+	must(dapCommand.RegisterFlagCompletionFunc("client-addr", cobra.NoFileCompletions))
 
 	// TODO(polina): support --tty when dlv dap allows to launch a program from command-line
 	rootCommand.AddCommand(dapCommand)
@@ -237,11 +260,14 @@ By default, with no arguments, Delve wil
 current directory, and begin to debug it. Alternatively you can specify a
 package name and Delve will compile that package instead, and begin a new debug
 session.`,
-		Run: debugCmd,
+		Run:               debugCmd,
+		ValidArgsFunction: cobra.NoFileCompletions,
 	}
 	debugCommand.Flags().String("output", "", "Output path for the binary.")
+	must(debugCommand.MarkFlagFilename("output"))
 	debugCommand.Flags().BoolVar(&continueOnStart, "continue", false, "Continue the debugged process on start.")
 	debugCommand.Flags().StringVar(&tty, "tty", "", "TTY to use for the target program")
+	must(debugCommand.MarkFlagFilename("tty"))
 	rootCommand.AddCommand(debugCommand)
 
 	// 'exec' subcommand.
@@ -264,8 +290,15 @@ or later, -gcflags="-N -l" on earlier ve
 		Run: func(cmd *cobra.Command, args []string) {
 			os.Exit(execute(0, args, conf, "", debugger.ExecutingExistingFile, args, buildFlags))
 		},
+		ValidArgsFunction: func(cmd *cobra.Command, args []string, toComplete string) ([]string, cobra.ShellCompDirective) {
+			if len(args) != 0 {
+				return nil, cobra.ShellCompDirectiveNoFileComp
+			}
+			return nil, cobra.ShellCompDirectiveDefault
+		},
 	}
 	execCommand.Flags().StringVar(&tty, "tty", "", "TTY to use for the target program")
+	must(execCommand.MarkFlagFilename("tty"))
 	execCommand.Flags().BoolVar(&continueOnStart, "continue", false, "Continue the debugged process on start.")
 	rootCommand.AddCommand(execCommand)
 
@@ -295,9 +328,11 @@ that package instead. Double-dashes ` +
 dlv test [package] -- -test.run TestSomething -test.v -other-argument
 
 See also: 'go help testflag'.`,
-		Run: testCmd,
+		Run:               testCmd,
+		ValidArgsFunction: cobra.NoFileCompletions,
 	}
 	testCommand.Flags().String("output", "", "Output path for the binary.")
+	must(testCommand.MarkFlagFilename("output"))
 	rootCommand.AddCommand(testCommand)
 
 	// 'trace' subcommand.
@@ -316,14 +351,20 @@ only see the output of the trace operati
 		Run: func(cmd *cobra.Command, args []string) {
 			os.Exit(traceCmd(cmd, args, conf))
 		},
+		ValidArgsFunction: cobra.NoFileCompletions,
 	}
 	traceCommand.Flags().IntVarP(&traceAttachPid, "pid", "p", 0, "Pid to attach to.")
+	must(traceCommand.RegisterFlagCompletionFunc("pid", cobra.NoFileCompletions))
 	traceCommand.Flags().StringVarP(&traceExecFile, "exec", "e", "", "Binary file to exec and trace.")
+	must(traceCommand.MarkFlagFilename("exec"))
 	traceCommand.Flags().BoolVarP(&traceTestBinary, "test", "t", false, "Trace a test binary.")
 	traceCommand.Flags().BoolVarP(&traceUseEBPF, "ebpf", "", false, "Trace using eBPF (experimental).")
 	traceCommand.Flags().BoolVarP(&traceShowTimestamp, "timestamp", "", false, "Show timestamp in the output")
 	traceCommand.Flags().IntVarP(&traceStackDepth, "stack", "s", 0, "Show stack trace with given depth. (Ignored with --ebpf)")
+	must(traceCommand.RegisterFlagCompletionFunc("stack", cobra.NoFileCompletions))
 	traceCommand.Flags().String("output", "", "Output path for the binary.")
+	must(traceCommand.MarkFlagFilename("output"))
+	traceCommand.Flags().IntVarP(&traceFollowCalls, "follow-calls", "", 0, "Trace all children of the function to the required depth")
 	rootCommand.AddCommand(traceCommand)
 
 	coreCommand := &cobra.Command{
@@ -343,6 +384,12 @@ Currently supports linux/amd64 and linux
 			return nil
 		},
 		Run: coreCmd,
+		ValidArgsFunction: func(cmd *cobra.Command, args []string, toComplete string) ([]string, cobra.ShellCompDirective) {
+			if len(args) > 2 {
+				return nil, cobra.ShellCompDirectiveNoFileComp
+			}
+			return nil, cobra.ShellCompDirectiveDefault
+		},
 	}
 	// -c is unused and exists so delve can be used with coredumpctl
 	core := false
@@ -361,6 +408,7 @@ Currently supports linux/amd64 and linux
 				fmt.Printf("Build Details: %s\n", version.BuildInfo())
 			}
 		},
+		ValidArgsFunction: cobra.NoFileCompletions,
 	}
 	versionCommand.Flags().BoolVarP(&versionVerbose, "verbose", "v", false, "print verbose version info")
 	rootCommand.AddCommand(versionCommand)
@@ -384,10 +432,17 @@ https://github.com/mozilla/rr
 				backend = "rr"
 				os.Exit(execute(0, []string{}, conf, args[0], debugger.ExecutingOther, args, buildFlags))
 			},
+			ValidArgsFunction: func(cmd *cobra.Command, args []string, toComplete string) ([]string, cobra.ShellCompDirective) {
+				if len(args) > 2 {
+					return nil, cobra.ShellCompDirectiveNoFileComp
+				}
+				return nil, cobra.ShellCompDirectiveDefault
+			},
 		}
 
 		replayCommand.Flags().IntVarP(&rrOnProcessPid, "onprocess", "p", 0,
 			"Pass onprocess pid to rr.")
+		must(replayCommand.RegisterFlagCompletionFunc("onprocess", cobra.NoFileCompletions))
 
 		rootCommand.AddCommand(replayCommand)
 	}
@@ -403,6 +458,11 @@ are:
 	lldb		Uses lldb-server or debugserver.
 	rr		Uses mozilla rr (https://github.com/mozilla/rr).
 
+Some backends can be configured using environment variables:
+
+* DELVE_DEBUGSERVER_PATH specifies the path of the debugserver executable for the lldb backend
+* DELVE_RR_RECORD_FLAGS specifies additional flags used when calling 'rr record'
+* DELVE_RR_REPLAY_FLAGS specifies additional flags used when calling 'rr replay'
 `})
 
 	rootCommand.AddCommand(&cobra.Command{
@@ -461,7 +521,7 @@ File redirects can also be changed using
 
 func dapCmd(cmd *cobra.Command, args []string) {
 	status := func() int {
-		if err := logflags.Setup(log, logOutput, logDest); err != nil {
+		if err := logflags.Setup(logFlag, logOutput, logDest); err != nil {
 			fmt.Fprintf(os.Stderr, "%v\n", err)
 			return 1
 		}
@@ -591,7 +651,7 @@ func debugCmd(cmd *cobra.Command, args [
 
 func traceCmd(cmd *cobra.Command, args []string, conf *config.Config) int {
 	status := func() int {
-		err := logflags.Setup(log, logOutput, logDest)
+		err := logflags.Setup(logFlag, logOutput, logDest)
 		defer logflags.Close()
 		if err != nil {
 			fmt.Fprintf(os.Stderr, "%v\n", err)
@@ -644,6 +704,10 @@ func traceCmd(cmd *cobra.Command, args [
 
 			processArgs = append([]string{debugname}, targetArgs...)
 		}
+		if dlvArgsLen >= 3 && traceFollowCalls <= 0 {
+			fmt.Fprintln(os.Stderr, "Need to specify a trace depth of atleast 1")
+			return 1
+		}
 
 		// Make a local in-memory connection that client and server use to communicate
 		listener, clientConn := service.ListenerPipe()
@@ -680,8 +744,7 @@ func traceCmd(cmd *cobra.Command, args [
 			<-ch
 			client.Halt()
 		}()
-
-		funcs, err := client.ListFunctions(regexp)
+		funcs, err := client.ListFunctions(regexp, traceFollowCalls)
 		if err != nil {
 			fmt.Fprintln(os.Stderr, err)
 			return 1
@@ -697,13 +760,22 @@ func traceCmd(cmd *cobra.Command, args [
 				}
 			} else {
 				// Fall back to breakpoint based tracing if we get an error.
+				var stackdepth int
+				// Default size of stackdepth to trace function calls and descendants=20
+				stackdepth = traceStackDepth
+				if traceFollowCalls > 0 && stackdepth == 0 {
+					stackdepth = 20
+				}
 				_, err = client.CreateBreakpoint(&api.Breakpoint{
-					FunctionName: funcs[i],
-					Tracepoint:   true,
-					Line:         -1,
-					Stacktrace:   traceStackDepth,
-					LoadArgs:     &terminal.ShortLoadConfig,
+					FunctionName:     funcs[i],
+					Tracepoint:       true,
+					Line:             -1,
+					Stacktrace:       stackdepth,
+					LoadArgs:         &terminal.ShortLoadConfig,
+					TraceFollowCalls: traceFollowCalls,
+					RootFuncName:     regexp,
 				})
+
 				if err != nil && !isBreakpointExistsErr(err) {
 					fmt.Fprintf(os.Stderr, "unable to set tracepoint on function %s: %#v\n", funcs[i], err)
 					continue
@@ -717,11 +789,13 @@ func traceCmd(cmd *cobra.Command, args [
 				}
 				for i := range addrs {
 					_, err = client.CreateBreakpoint(&api.Breakpoint{
-						Addr:        addrs[i],
-						TraceReturn: true,
-						Stacktrace:  traceStackDepth,
-						Line:        -1,
-						LoadArgs:    &terminal.ShortLoadConfig,
+						Addr:             addrs[i],
+						TraceReturn:      true,
+						Stacktrace:       stackdepth,
+						Line:             -1,
+						LoadArgs:         &terminal.ShortLoadConfig,
+						TraceFollowCalls: traceFollowCalls,
+						RootFuncName:     regexp,
 					})
 					if err != nil && !isBreakpointExistsErr(err) {
 						fmt.Fprintf(os.Stderr, "unable to set tracepoint on function %s: %#v\n", funcs[i], err)
@@ -857,7 +931,7 @@ func coreCmd(_ *cobra.Command, args []st
 }
 
 func connectCmd(_ *cobra.Command, args []string) {
-	if err := logflags.Setup(log, logOutput, logDest); err != nil {
+	if err := logflags.Setup(logFlag, logOutput, logDest); err != nil {
 		fmt.Fprintf(os.Stderr, "%v\n", err)
 		os.Exit(1)
 		return
@@ -913,7 +987,9 @@ func connect(addr string, clientConn net
 	// Create and start a terminal - attach to running instance
 	var client *rpc2.RPCClient
 	if clientConn == nil {
-		clientConn = netDial(addr)
+		if clientConn = netDial(addr); clientConn == nil {
+			return 1 // already logged
+		}
 	}
 	client = rpc2.NewClientFromConn(clientConn)
 	if client.IsMulticlient() {
@@ -940,7 +1016,7 @@ func connect(addr string, clientConn net
 }
 
 func execute(attachPid int, processArgs []string, conf *config.Config, coreFile string, kind debugger.ExecuteKind, dlvArgs []string, buildFlags string) int {
-	if err := logflags.Setup(log, logOutput, logDest); err != nil {
+	if err := logflags.Setup(logFlag, logOutput, logDest); err != nil {
 		fmt.Fprintf(os.Stderr, "%v\n", err)
 		return 1
 	}
@@ -1154,3 +1230,9 @@ func netDial(addr string) net.Conn {
 	}
 	return conn
 }
+
+func must(err error) {
+	if err != nil {
+		log.Fatal(err)
+	}
+}
diff -pruN 1.22.1-1/cmd/dlv/dlv_test.go 1.23.0-1/cmd/dlv/dlv_test.go
--- 1.22.1-1/cmd/dlv/dlv_test.go	2024-02-21 20:29:06.000000000 +0000
+++ 1.23.0-1/cmd/dlv/dlv_test.go	2024-07-16 18:44:48.000000000 +0000
@@ -251,6 +251,35 @@ func TestOutput(t *testing.T) {
 	}
 }
 
+// TestUnattendedBreakpoint tests whether dlv will print a message to stderr when the client that sends continue is disconnected
+// or not.
+func TestUnattendedBreakpoint(t *testing.T) {
+	const listenAddr = "127.0.0.1:40573"
+
+	fixturePath := filepath.Join(protest.FindFixturesDir(), "panic.go")
+	cmd := exec.Command(getDlvBin(t), "debug", "--continue", "--headless", "--accept-multiclient", "--listen", listenAddr, fixturePath)
+	stderr, err := cmd.StderrPipe()
+	assertNoError(err, t, "stdout pipe")
+	defer stderr.Close()
+
+	assertNoError(cmd.Start(), t, "start headless instance")
+
+	scan := bufio.NewScanner(stderr)
+	for scan.Scan() {
+		t.Log(scan.Text())
+		if strings.Contains(scan.Text(), "execution is paused because your program is panicking") {
+			break
+		}
+	}
+
+	// and detach from and kill the headless instance
+	client := rpc2.NewClient(listenAddr)
+	if err := client.Detach(true); err != nil {
+		t.Fatalf("error detaching from headless instance: %v", err)
+	}
+	cmd.Wait()
+}
+
 // TestContinue verifies that the debugged executable starts immediately with --continue
 func TestContinue(t *testing.T) {
 	const listenAddr = "127.0.0.1:40573"
@@ -896,7 +925,7 @@ func TestDAPCmdWithClient(t *testing.T)
 func TestTrace(t *testing.T) {
 	dlvbin := getDlvBin(t)
 
-	expected := []byte("> goroutine(1): main.foo(99, 9801)\n>> goroutine(1): => (9900)\n")
+	expected := []byte("> goroutine(1): main.foo(99, 9801)\n>> goroutine(1): main.foo => (9900)\n")
 
 	fixtures := protest.FindFixturesDir()
 	cmd := exec.Command(dlvbin, "trace", "--output", filepath.Join(t.TempDir(), "__debug"), filepath.Join(fixtures, "issue573.go"), "foo")
@@ -920,7 +949,7 @@ func TestTrace(t *testing.T) {
 func TestTrace2(t *testing.T) {
 	dlvbin := getDlvBin(t)
 
-	expected := []byte("> goroutine(1): main.callme(2)\n>> goroutine(1): => (4)\n")
+	expected := []byte("> goroutine(1): main.callme(2)\n>> goroutine(1): main.callme => (4)\n")
 
 	fixtures := protest.FindFixturesDir()
 	cmd := exec.Command(dlvbin, "trace", "--output", filepath.Join(t.TempDir(), "__debug"), filepath.Join(fixtures, "traceprog.go"), "callme")
@@ -941,6 +970,39 @@ func TestTrace2(t *testing.T) {
 	assertNoError(cmd.Wait(), t, "cmd.Wait()")
 }
 
+func TestTraceDirRecursion(t *testing.T) {
+	dlvbin := getDlvBin(t)
+
+	expected := []byte("> goroutine(1):frame(1) main.A(5, 5)\n > goroutine(1):frame(2) main.A(4, 4)\n  > goroutine(1):frame(3) main.A(3, 3)\n   > goroutine(1):frame(4) main.A(2, 2)\n    > goroutine(1):frame(5) main.A(1, 1)\n    >> goroutine(1):frame(5) main.A => (1)\n   >> goroutine(1):frame(4) main.A => (2)\n  >> goroutine(1):frame(3) main.A => (6)\n >> goroutine(1):frame(2) main.A => (24)\n>> goroutine(1):frame(1) main.A => (120)\n")
+
+	fixtures := protest.FindFixturesDir()
+	cmd := exec.Command(dlvbin, "trace", "--output", filepath.Join(t.TempDir(), "__debug"), filepath.Join(fixtures, "leafrec.go"), "main.A", "--follow-calls", "4")
+	rdr, err := cmd.StderrPipe()
+	assertNoError(err, t, "stderr pipe")
+	defer rdr.Close()
+
+	cmd.Dir = filepath.Join(fixtures, "buildtest")
+
+	assertNoError(cmd.Start(), t, "running trace")
+	// Parse output to ignore calls to morestack_noctxt for comparison
+	scan := bufio.NewScanner(rdr)
+	text := ""
+	outputtext := ""
+	for scan.Scan() {
+		text = scan.Text()
+		if !strings.Contains(text, "morestack_noctxt") {
+			outputtext += text
+			outputtext += "\n"
+		}
+	}
+	output := []byte(outputtext)
+
+	if !bytes.Contains(output, expected) {
+		t.Fatalf("expected:\n%s\ngot:\n%s", string(expected), string(output))
+	}
+	assertNoError(cmd.Wait(), t, "cmd.Wait()")
+}
+
 func TestTraceMultipleGoroutines(t *testing.T) {
 	dlvbin := getDlvBin(t)
 
@@ -948,7 +1010,7 @@ func TestTraceMultipleGoroutines(t *test
 	// I think a future improvement could be to use regexp captures to match the
 	// goroutine IDs at function entry and exit.
 	expected := []byte("main.callme(0, \"five\")\n")
-	expected2 := []byte("=> (0)\n")
+	expected2 := []byte("main.callme => (0)\n")
 
 	fixtures := protest.FindFixturesDir()
 	cmd := exec.Command(dlvbin, "trace", "--output", filepath.Join(t.TempDir(), "__debug"), filepath.Join(fixtures, "goroutines-trace.go"), "callme")
@@ -983,7 +1045,7 @@ func TestTracePid(t *testing.T) {
 
 	dlvbin := getDlvBin(t)
 
-	expected := []byte("goroutine(1): main.A()\n>> goroutine(1): => ()\n")
+	expected := []byte("goroutine(1): main.A()\n>> goroutine(1): main.A => ()\n")
 
 	// make process run
 	fix := protest.BuildFixture("issue2023", 0)
@@ -1020,7 +1082,7 @@ func TestTraceBreakpointExists(t *testin
 	// We always set breakpoints on some runtime functions at startup, so this would return with
 	// a breakpoints exists error.
 	// TODO: Perhaps we shouldn't be setting these default breakpoints in trace mode, however.
-	cmd := exec.Command(dlvbin, "trace", "--output", filepath.Join(t.TempDir(), "__debug"), filepath.Join(fixtures, "issue573.go"), "runtime.*")
+	cmd := exec.Command(dlvbin, "trace", "--output", filepath.Join(t.TempDir(), "__debug"), filepath.Join(fixtures, "issue573.go"), "runtime.*panic")
 	rdr, err := cmd.StderrPipe()
 	assertNoError(err, t, "stderr pipe")
 	defer rdr.Close()
@@ -1303,6 +1365,9 @@ func TestVersion(t *testing.T) {
 }
 
 func TestStaticcheck(t *testing.T) {
+	if goversion.VersionAfterOrEqual(runtime.Version(), 1, 23) {
+		t.Skip("staticcheck does not support go1.23 yet")
+	}
 	_, err := exec.LookPath("staticcheck")
 	if err != nil {
 		t.Skip("staticcheck not installed")
diff -pruN 1.22.1-1/debian/changelog 1.23.0-1/debian/changelog
--- 1.22.1-1/debian/changelog	2024-02-23 12:05:09.000000000 +0000
+++ 1.23.0-1/debian/changelog	2024-08-13 09:02:33.000000000 +0000
@@ -1,3 +1,10 @@
+delve (1.23.0-1) unstable; urgency=medium
+
+  * New upstream version 1.23.0
+  * Bump golang-starlark-dev to 0.0~git20240725
+
+ -- Shengjing Zhu <zhsj@debian.org>  Tue, 13 Aug 2024 17:02:33 +0800
+
 delve (1.22.1-1) unstable; urgency=medium
 
   * New upstream version 1.22.1
diff -pruN 1.22.1-1/debian/control 1.23.0-1/debian/control
--- 1.22.1-1/debian/control	2024-02-23 12:05:09.000000000 +0000
+++ 1.23.0-1/debian/control	2024-08-13 09:02:33.000000000 +0000
@@ -21,7 +21,7 @@ Build-Depends: clang [amd64],
                golang-golang-x-arch-dev,
                golang-golang-x-sys-dev,
                golang-gopkg-yaml.v2-dev,
-               golang-starlark-dev (>= 0.0~git20230726.7dadff3~),
+               golang-starlark-dev (>= 0.0~git20240725~),
                libbpf-dev [amd64],
                libc6-dev-i386 [amd64],
                llvm [amd64],
diff -pruN 1.22.1-1/debian/patches/0002-Ignore-all-main_test.patch 1.23.0-1/debian/patches/0002-Ignore-all-main_test.patch
--- 1.22.1-1/debian/patches/0002-Ignore-all-main_test.patch	2024-02-23 12:05:09.000000000 +0000
+++ 1.23.0-1/debian/patches/0002-Ignore-all-main_test.patch	2024-08-13 09:02:33.000000000 +0000
@@ -12,7 +12,7 @@ Forwarded: not-needed
  1 file changed, 2 insertions(+)
 
 diff --git a/cmd/dlv/dlv_test.go b/cmd/dlv/dlv_test.go
-index c4e903c..b0bbc51 100644
+index c9fd264..8084e50 100644
 --- a/cmd/dlv/dlv_test.go
 +++ b/cmd/dlv/dlv_test.go
 @@ -1,3 +1,5 @@
diff -pruN 1.22.1-1/debian/patches/0003-Skip-TestIssue827.patch 1.23.0-1/debian/patches/0003-Skip-TestIssue827.patch
--- 1.22.1-1/debian/patches/0003-Skip-TestIssue827.patch	2024-02-23 12:05:09.000000000 +0000
+++ 1.23.0-1/debian/patches/0003-Skip-TestIssue827.patch	2024-08-13 09:02:33.000000000 +0000
@@ -8,7 +8,7 @@ Forwarded: not-needed
  1 file changed, 1 insertion(+)
 
 diff --git a/pkg/terminal/command_test.go b/pkg/terminal/command_test.go
-index d97d0bc..b392dbd 100644
+index 5f49460..173f54b 100644
 --- a/pkg/terminal/command_test.go
 +++ b/pkg/terminal/command_test.go
 @@ -690,6 +690,7 @@ func TestRestart(t *testing.T) {
diff -pruN 1.22.1-1/debian/patches/0004-Skip-failed-test-on-arm64.patch 1.23.0-1/debian/patches/0004-Skip-failed-test-on-arm64.patch
--- 1.22.1-1/debian/patches/0004-Skip-failed-test-on-arm64.patch	2024-02-23 12:05:09.000000000 +0000
+++ 1.23.0-1/debian/patches/0004-Skip-failed-test-on-arm64.patch	2024-08-13 09:02:33.000000000 +0000
@@ -9,10 +9,10 @@ Bug: https://github.com/go-delve/delve/i
  2 files changed, 5 insertions(+)
 
 diff --git a/pkg/proc/proc_test.go b/pkg/proc/proc_test.go
-index 5ed0fd8..f1f51f5 100644
+index 3437a2a..e281a92 100644
 --- a/pkg/proc/proc_test.go
 +++ b/pkg/proc/proc_test.go
-@@ -3346,6 +3346,7 @@ func frameInFile(frame proc.Stackframe, file string) bool {
+@@ -3401,6 +3401,7 @@ func frameInFile(frame proc.Stackframe, file string) bool {
  }
  
  func TestCgoStacktrace(t *testing.T) {
@@ -20,19 +20,19 @@ index 5ed0fd8..f1f51f5 100644
  	if runtime.GOOS == "windows" {
  		ver, _ := goversion.Parse(runtime.Version())
  		if ver.Major > 0 && !ver.AfterOrEqual(goversion.GoVersion{Major: 1, Minor: 9, Rev: -1}) {
-@@ -5454,6 +5455,7 @@ func TestWatchpointCounts(t *testing.T) {
+@@ -5500,6 +5501,7 @@ func TestWatchpointsBasic(t *testing.T) {
+ }
+ 
+ func TestWatchpointCounts(t *testing.T) {
++	skipOn(t, "only fail on ci.debian.net machine", "arm64")
+ 	skipOn(t, "not implemented", "freebsd")
  	skipOn(t, "not implemented", "386")
  	skipOn(t, "see https://github.com/go-delve/delve/issues/2768", "windows")
- 	skipOn(t, "not implemented", "ppc64le")
-+	skipOn(t, "only fail on ci.debian.net machine", "arm64")
- 	protest.AllowRecording(t)
- 
- 	withTestProcess("databpcountstest", t, func(p *proc.Target, grp *proc.TargetGroup, fixture protest.Fixture) {
 diff --git a/pkg/proc/variables_test.go b/pkg/proc/variables_test.go
-index 24740ab..e688e1c 100644
+index 459f910..460a9e2 100644
 --- a/pkg/proc/variables_test.go
 +++ b/pkg/proc/variables_test.go
-@@ -1570,6 +1570,9 @@ func TestPluginVariables(t *testing.T) {
+@@ -1569,6 +1569,9 @@ func TestPluginVariables(t *testing.T) {
  }
  
  func TestCgoEval(t *testing.T) {
diff -pruN 1.22.1-1/go.mod 1.23.0-1/go.mod
--- 1.22.1-1/go.mod	2024-02-21 20:29:06.000000000 +0000
+++ 1.23.0-1/go.mod	2024-07-16 18:44:48.000000000 +0000
@@ -8,7 +8,7 @@ require (
 	github.com/creack/pty v1.1.20
 	github.com/derekparker/trie v0.0.0-20230829180723-39f4de51ef7d
 	github.com/go-delve/liner v1.2.3-0.20231231155935-4726ab1d7f62
-	github.com/google/go-dap v0.11.0
+	github.com/google/go-dap v0.12.0
 	github.com/hashicorp/golang-lru v1.0.2
 	github.com/mattn/go-colorable v0.1.13
 	github.com/mattn/go-isatty v0.0.20
@@ -17,9 +17,9 @@ require (
 	github.com/spf13/pflag v1.0.5
 	go.starlark.net v0.0.0-20231101134539-556fd59b42f6
 	golang.org/x/arch v0.6.0
-	golang.org/x/sys v0.13.0
+	golang.org/x/sys v0.17.0
 	golang.org/x/tools v0.14.0
-	gopkg.in/yaml.v2 v2.4.0
+	gopkg.in/yaml.v3 v3.0.1
 )
 
 require (
@@ -31,5 +31,4 @@ require (
 	github.com/stretchr/testify v1.8.4 // indirect
 	golang.org/x/exp v0.0.0-20230224173230-c95f2b4c22f2 // indirect
 	golang.org/x/mod v0.14.0 // indirect
-	gopkg.in/yaml.v3 v3.0.1 // indirect
 )
diff -pruN 1.22.1-1/go.sum 1.23.0-1/go.sum
--- 1.22.1-1/go.sum	2024-02-21 20:29:06.000000000 +0000
+++ 1.23.0-1/go.sum	2024-07-16 18:44:48.000000000 +0000
@@ -17,8 +17,8 @@ github.com/go-delve/liner v1.2.3-0.20231
 github.com/go-delve/liner v1.2.3-0.20231231155935-4726ab1d7f62/go.mod h1:biJCRbqp51wS+I92HMqn5H8/A0PAhxn2vyOT+JqhiGI=
 github.com/google/go-cmp v0.5.9 h1:O2Tfq5qg4qc4AmwVlvv0oLiVAGB7enBSJ2x2DqQFi38=
 github.com/google/go-cmp v0.5.9/go.mod h1:17dUlkBOakJ0+DkrSSNjCkIjxS6bF9zb3elmeNGIjoY=
-github.com/google/go-dap v0.11.0 h1:SpAZJL41rOOvd85PuLCCLE1dteTQOyKNnn0H3DBHywo=
-github.com/google/go-dap v0.11.0/go.mod h1:HAeyoSd2WIfTfg+0GRXcFrb+RnojAtGNh+k+XTIxJDE=
+github.com/google/go-dap v0.12.0 h1:rVcjv3SyMIrpaOoTAdFDyHs99CwVOItIJGKLQFQhNeM=
+github.com/google/go-dap v0.12.0/go.mod h1:tNjCASCm5cqePi/RVXXWEVqtnNLV1KTWtYOqu6rZNzc=
 github.com/hashicorp/golang-lru v1.0.2 h1:dV3g9Z/unq5DpblPpw+Oqcv4dU/1omnb4Ok8iPY6p1c=
 github.com/hashicorp/golang-lru v1.0.2/go.mod h1:iADmTwqILo4mZ8BN3D2Q6+9jd8WM5uGBxy+E8yxSoD4=
 github.com/inconshreveable/mousetrap v1.1.0 h1:wN+x4NVGpMsO7ErUn/mUI3vEoE6Jt13X2s0bqwp9tc8=
@@ -67,16 +67,14 @@ golang.org/x/sys v0.0.0-20211117180635-d
 golang.org/x/sys v0.0.0-20220715151400-c0bba94af5f8/go.mod h1:oPkhp1MJrh7nUepCBck5+mAzfO9JrbApNNgaTdGDITg=
 golang.org/x/sys v0.0.0-20220811171246-fbc7d0a398ab/go.mod h1:oPkhp1MJrh7nUepCBck5+mAzfO9JrbApNNgaTdGDITg=
 golang.org/x/sys v0.6.0/go.mod h1:oPkhp1MJrh7nUepCBck5+mAzfO9JrbApNNgaTdGDITg=
-golang.org/x/sys v0.13.0 h1:Af8nKPmuFypiUBjVoU9V20FiaFXOcuZI21p0ycVYYGE=
-golang.org/x/sys v0.13.0/go.mod h1:oPkhp1MJrh7nUepCBck5+mAzfO9JrbApNNgaTdGDITg=
+golang.org/x/sys v0.17.0 h1:25cE3gD+tdBA7lp7QfhuV+rJiE9YXTcS3VG1SqssI/Y=
+golang.org/x/sys v0.17.0/go.mod h1:/VUhepiaJMQUp4+oa/7Zr1D23ma6VTLIYjOOTFZPUcA=
 golang.org/x/tools v0.14.0 h1:jvNa2pY0M4r62jkRQ6RwEZZyPcymeL9XZMLBbV7U2nc=
 golang.org/x/tools v0.14.0/go.mod h1:uYBEerGOWcJyEORxN+Ek8+TT266gXkNlHdJBwexUsBg=
 google.golang.org/protobuf v1.25.0 h1:Ejskq+SyPohKW+1uil0JJMtmHCgJPJ/qWTxr8qp+R4c=
 google.golang.org/protobuf v1.25.0/go.mod h1:9JNX74DMeImyA3h4bdi1ymwjUzf21/xIlbajtzgsN7c=
 gopkg.in/check.v1 v0.0.0-20161208181325-20d25e280405 h1:yhCVgyC4o1eVCa2tZl7eS0r+SDo693bJlVdllGtEeKM=
 gopkg.in/check.v1 v0.0.0-20161208181325-20d25e280405/go.mod h1:Co6ibVJAznAaIkqp8huTwlJQCZ016jof/cbN4VW5Yz0=
-gopkg.in/yaml.v2 v2.4.0 h1:D8xgwECY7CYvx+Y2n4sBz93Jn9JRvxdiyyo8CTfuKaY=
-gopkg.in/yaml.v2 v2.4.0/go.mod h1:RDklbk79AGWmwhnvt/jBztapEOGDOx6ZbXqjP6csGnQ=
 gopkg.in/yaml.v3 v3.0.0-20200313102051-9f266ea9e77c/go.mod h1:K4uyk7z7BCEPqu6E+C64Yfv1cQ7kz7rIZviUmN+EgEM=
 gopkg.in/yaml.v3 v3.0.1 h1:fxVm/GzAzEWqLHuvctI91KS9hhNmmWOoWu0XTYJS7CA=
 gopkg.in/yaml.v3 v3.0.1/go.mod h1:K4uyk7z7BCEPqu6E+C64Yfv1cQ7kz7rIZviUmN+EgEM=
diff -pruN 1.22.1-1/pkg/astutil/astutil.go 1.23.0-1/pkg/astutil/astutil.go
--- 1.22.1-1/pkg/astutil/astutil.go	2024-02-21 20:29:06.000000000 +0000
+++ 1.23.0-1/pkg/astutil/astutil.go	2024-07-16 18:44:48.000000000 +0000
@@ -1,6 +1,5 @@
 // This package contains utility functions used by pkg/proc to generate
 // ast.Expr expressions.
-
 package astutil
 
 import (
diff -pruN 1.22.1-1/pkg/config/config.go 1.23.0-1/pkg/config/config.go
--- 1.22.1-1/pkg/config/config.go	2024-02-21 20:29:06.000000000 +0000
+++ 1.23.0-1/pkg/config/config.go	2024-07-16 18:44:48.000000000 +0000
@@ -9,7 +9,7 @@ import (
 	"runtime"
 
 	"github.com/go-delve/delve/service/api"
-	"gopkg.in/yaml.v2"
+	"gopkg.in/yaml.v3"
 )
 
 const (
diff -pruN 1.22.1-1/pkg/dwarf/dwarfbuilder/info.go 1.23.0-1/pkg/dwarf/dwarfbuilder/info.go
--- 1.22.1-1/pkg/dwarf/dwarfbuilder/info.go	2024-02-21 20:29:06.000000000 +0000
+++ 1.23.0-1/pkg/dwarf/dwarfbuilder/info.go	2024-07-16 18:44:48.000000000 +0000
@@ -137,7 +137,7 @@ func (b *Builder) Attr(attr dwarf.Attr,
 	switch x := val.(type) {
 	case string:
 		tag.form = append(tag.form, DW_FORM_string)
-		b.info.Write([]byte(x))
+		b.info.WriteString(x)
 		b.info.WriteByte(0)
 	case uint8:
 		tag.form = append(tag.form, DW_FORM_data1)
@@ -244,6 +244,8 @@ func (b *Builder) makeAbbrevTable() []by
 		leb128.EncodeUnsigned(&abbrev, 0)
 	}
 
+	leb128.EncodeUnsigned(&abbrev, uint64(0))
+
 	return abbrev.Bytes()
 }
 
diff -pruN 1.22.1-1/pkg/dwarf/frame/entries_test.go 1.23.0-1/pkg/dwarf/frame/entries_test.go
--- 1.22.1-1/pkg/dwarf/frame/entries_test.go	2024-02-21 20:29:06.000000000 +0000
+++ 1.23.0-1/pkg/dwarf/frame/entries_test.go	2024-07-16 18:44:48.000000000 +0000
@@ -38,8 +38,8 @@ func TestFDEForPC(t *testing.T) {
 		{300, frames[3]},
 		{309, frames[3]},
 		{310, nil},
-		{400, nil}} {
-
+		{400, nil},
+	} {
 		out, err := frames.FDEForPC(test.pc)
 		if test.fde != nil {
 			if err != nil {
diff -pruN 1.22.1-1/pkg/dwarf/godwarf/tree.go 1.23.0-1/pkg/dwarf/godwarf/tree.go
--- 1.22.1-1/pkg/dwarf/godwarf/tree.go	2024-02-21 20:29:06.000000000 +0000
+++ 1.23.0-1/pkg/dwarf/godwarf/tree.go	2024-07-16 18:44:48.000000000 +0000
@@ -2,6 +2,7 @@ package godwarf
 
 import (
 	"debug/dwarf"
+	"errors"
 	"fmt"
 	"sort"
 )
@@ -39,7 +40,7 @@ func (ce compositeEntry) AttrField(a dwa
 // DWARF standard is unclear on how this should be handled
 func LoadAbstractOriginAndSpecification(entry *dwarf.Entry, aordr *dwarf.Reader) (Entry, dwarf.Offset) {
 	ao, ok := getAbstractOriginOrSpecification(entry)
-	if !ok {
+	if !ok || ao == entry.Offset {
 		return entry, entry.Offset
 	}
 
@@ -54,7 +55,7 @@ func LoadAbstractOriginAndSpecification(
 		r = append(r, e)
 
 		ao, ok = getAbstractOriginOrSpecification(e)
-		if !ok {
+		if !ok || ao == entry.Offset {
 			break
 		}
 	}
@@ -90,6 +91,9 @@ type Tree struct {
 // range of addresses that is not covered by its parent LoadTree will fix
 // the parent entry.
 func LoadTree(off dwarf.Offset, dw *dwarf.Data, staticBase uint64) (*Tree, error) {
+	if dw == nil {
+		return nil, errors.New("unable to load DWARF tree: no DWARF information present")
+	}
 	rdr := dw.Reader()
 	rdr.Seek(off)
 
@@ -274,7 +278,7 @@ func (n *Tree) Type(dw *dwarf.Data, inde
 	if n.typ == nil {
 		offset, ok := n.Val(dwarf.AttrType).(dwarf.Offset)
 		if !ok {
-			return nil, fmt.Errorf("malformed variable DIE (offset)")
+			return nil, errors.New("malformed variable DIE (offset)")
 		}
 
 		var err error
diff -pruN 1.22.1-1/pkg/dwarf/godwarf/type.go 1.23.0-1/pkg/dwarf/godwarf/type.go
--- 1.22.1-1/pkg/dwarf/godwarf/type.go	2024-02-21 20:29:06.000000000 +0000
+++ 1.23.0-1/pkg/dwarf/godwarf/type.go	2024-07-16 18:44:48.000000000 +0000
@@ -27,6 +27,7 @@ const (
 	AttrGoRuntimeType   dwarf.Attr = 0x2904
 	AttrGoPackageName   dwarf.Attr = 0x2905
 	AttrGoDictIndex     dwarf.Attr = 0x2906
+	AttrGoClosureOffset dwarf.Attr = 0x2907
 )
 
 // Basic type encodings -- the value for AttrEncoding in a TagBaseType Entry.
diff -pruN 1.22.1-1/pkg/dwarf/line/line_parser_test.go 1.23.0-1/pkg/dwarf/line/line_parser_test.go
--- 1.22.1-1/pkg/dwarf/line/line_parser_test.go	2024-02-21 20:29:06.000000000 +0000
+++ 1.23.0-1/pkg/dwarf/line/line_parser_test.go	2024-07-16 18:44:48.000000000 +0000
@@ -6,7 +6,6 @@ import (
 	"debug/macho"
 	"debug/pe"
 	"flag"
-	"fmt"
 	"io"
 	"os"
 	"os/exec"
@@ -272,7 +271,7 @@ func runTestPCToLine(t testing.TB, lineI
 		file, line := lineInfos[0].PCToLine(basePC, pc)
 		if pc == entries[i].pc {
 			if i%samples == 0 && log {
-				fmt.Printf("match %x / %x (%v)\n", pc, entries[len(entries)-1].pc, time.Since(t0)/samples)
+				t.Logf("match %x / %x (%v)\n", pc, entries[len(entries)-1].pc, time.Since(t0)/samples)
 				t0 = time.Now()
 			}
 
@@ -377,5 +376,4 @@ func TestDebugLineDwarf4(t *testing.T) {
 			}
 		}
 	}
-
 }
diff -pruN 1.22.1-1/pkg/dwarf/line/state_machine_test.go 1.23.0-1/pkg/dwarf/line/state_machine_test.go
--- 1.22.1-1/pkg/dwarf/line/state_machine_test.go	2024-02-21 20:29:06.000000000 +0000
+++ 1.23.0-1/pkg/dwarf/line/state_machine_test.go	2024-07-16 18:44:48.000000000 +0000
@@ -238,7 +238,6 @@ func TestMultipleSequences(t *testing.T)
 		if curline != testCase.line {
 			t.Errorf("Wrong line returned for %#x: got %d expected %d", testCase.pc, curline, testCase.line)
 		}
-
 	}
 
 	// Test that AllPCsBetween is correct for all three sequences
diff -pruN 1.22.1-1/pkg/dwarf/loclist/dwarf5_loclist.go 1.23.0-1/pkg/dwarf/loclist/dwarf5_loclist.go
--- 1.22.1-1/pkg/dwarf/loclist/dwarf5_loclist.go	2024-02-21 20:29:06.000000000 +0000
+++ 1.23.0-1/pkg/dwarf/loclist/dwarf5_loclist.go	2024-07-16 18:44:48.000000000 +0000
@@ -118,10 +118,6 @@ func (it *loclistsIterator) next() bool
 
 	case _DW_LLE_base_addressx:
 		baseIdx, _ := leb128.DecodeUnsigned(it.buf)
-		if err != nil {
-			it.err = err
-			return false
-		}
 		it.base, it.err = it.debugAddr.Get(baseIdx)
 		it.base += it.staticBase
 		it.onRange = false
diff -pruN 1.22.1-1/pkg/dwarf/reader/reader.go 1.23.0-1/pkg/dwarf/reader/reader.go
--- 1.22.1-1/pkg/dwarf/reader/reader.go	2024-02-21 20:29:06.000000000 +0000
+++ 1.23.0-1/pkg/dwarf/reader/reader.go	2024-07-16 18:44:48.000000000 +0000
@@ -41,7 +41,7 @@ func (reader *Reader) AddrFor(name strin
 	}
 	instructions, ok := entry.Val(dwarf.AttrLocation).([]byte)
 	if !ok {
-		return 0, fmt.Errorf("type assertion failed")
+		return 0, errors.New("type assertion failed")
 	}
 	addr, _, err := op.ExecuteStackProgram(op.DwarfRegisters{StaticBase: staticBase}, instructions, ptrSize, nil)
 	if err != nil {
@@ -58,7 +58,7 @@ var ErrTypeNotFound = errors.New("no typ
 func (reader *Reader) SeekToType(entry *dwarf.Entry, resolveTypedefs bool, resolvePointerTypes bool) (*dwarf.Entry, error) {
 	offset, ok := entry.Val(dwarf.AttrType).(dwarf.Offset)
 	if !ok {
-		return nil, fmt.Errorf("entry does not have a type attribute")
+		return nil, errors.New("entry does not have a type attribute")
 	}
 
 	// Seek to the first type offset
@@ -187,7 +187,7 @@ func (reader *Reader) InstructionsForEnt
 	if entry.Tag == dwarf.TagMember {
 		instructions, ok := entry.Val(dwarf.AttrDataMemberLoc).([]byte)
 		if !ok {
-			return nil, fmt.Errorf("member data has no data member location attribute")
+			return nil, errors.New("member data has no data member location attribute")
 		}
 		// clone slice to prevent stomping on the dwarf data
 		return append([]byte{}, instructions...), nil
@@ -196,7 +196,7 @@ func (reader *Reader) InstructionsForEnt
 	// non-member
 	instructions, ok := entry.Val(dwarf.AttrLocation).([]byte)
 	if !ok {
-		return nil, fmt.Errorf("entry has no location attribute")
+		return nil, errors.New("entry has no location attribute")
 	}
 
 	// clone slice to prevent stomping on the dwarf data
diff -pruN 1.22.1-1/pkg/dwarf/reader/variables.go 1.23.0-1/pkg/dwarf/reader/variables.go
--- 1.22.1-1/pkg/dwarf/reader/variables.go	2024-02-21 20:29:06.000000000 +0000
+++ 1.23.0-1/pkg/dwarf/reader/variables.go	2024-07-16 18:44:48.000000000 +0000
@@ -24,6 +24,7 @@ const (
 	VariablesSkipInlinedSubroutines
 	VariablesTrustDeclLine
 	VariablesNoDeclLineCheck
+	VariablesOnlyCaptured
 )
 
 // Variables returns a list of variables contained inside 'root'.
@@ -32,15 +33,15 @@ const (
 // returned. If the VariablesSkipInlinedSubroutines is set, variables from
 // inlined subroutines will be skipped.
 func Variables(root *godwarf.Tree, pc uint64, line int, flags VariablesFlags) []Variable {
-	return variablesInternal(nil, root, 0, pc, line, flags)
+	return variablesInternal(nil, root, 0, pc, line, flags, true)
 }
 
 // variablesInternal appends to 'v' variables from 'root'. The function calls
 // itself with an incremented scope for all sub-blocks in 'root'.
-func variablesInternal(v []Variable, root *godwarf.Tree, depth int, pc uint64, line int, flags VariablesFlags) []Variable {
+func variablesInternal(v []Variable, root *godwarf.Tree, depth int, pc uint64, line int, flags VariablesFlags, first bool) []Variable {
 	switch root.Tag {
 	case dwarf.TagInlinedSubroutine:
-		if flags&VariablesSkipInlinedSubroutines != 0 {
+		if !first && flags&VariablesSkipInlinedSubroutines != 0 {
 			return v
 		}
 		fallthrough
@@ -49,7 +50,7 @@ func variablesInternal(v []Variable, roo
 		// pc (or if we don't care about visibility).
 		if (flags&VariablesOnlyVisible == 0) || root.ContainsPC(pc) {
 			for _, child := range root.Children {
-				v = variablesInternal(v, child, depth+1, pc, line, flags)
+				v = variablesInternal(v, child, depth+1, pc, line, flags, false)
 			}
 		}
 		return v
diff -pruN 1.22.1-1/pkg/elfwriter/writer.go 1.23.0-1/pkg/elfwriter/writer.go
--- 1.22.1-1/pkg/elfwriter/writer.go	2024-02-21 20:29:06.000000000 +0000
+++ 1.23.0-1/pkg/elfwriter/writer.go	2024-07-16 18:44:48.000000000 +0000
@@ -2,9 +2,7 @@
 // contents in memory at any one time.
 // This package is incomplete, only features needed to write core files are
 // implemented, notably missing:
-// - section headers
 // - program headers at the beginning of the file
-
 package elfwriter
 
 import (
@@ -22,12 +20,17 @@ type WriteCloserSeeker interface {
 
 // Writer writes ELF files.
 type Writer struct {
-	w     WriteCloserSeeker
-	Err   error
-	Progs []*elf.ProgHeader
+	w        WriteCloserSeeker
+	Err      error
+	Progs    []*elf.ProgHeader
+	Sections []*elf.SectionHeader
 
 	seekProgHeader int64
 	seekProgNum    int64
+
+	seekSectionHeader int64
+	seekSectionNum    int64
+	seekShstrndx      int64
 }
 
 type Note struct {
@@ -41,6 +44,7 @@ func New(w WriteCloserSeeker, fhdr *elf.
 	const (
 		ehsize    = 64
 		phentsize = 56
+		shentsize = 64
 	)
 
 	if seek, _ := w.Seek(0, io.SeekCurrent); seek != 0 {
@@ -65,15 +69,18 @@ func New(w WriteCloserSeeker, fhdr *elf.
 	r.u32(uint32(fhdr.Version)) // e_version
 	r.u64(0)                    // e_entry
 	r.seekProgHeader = r.Here()
-	r.u64(0)         // e_phoff
+	r.u64(0) // e_phoff
+	r.seekSectionHeader = r.Here()
 	r.u64(0)         // e_shoff
 	r.u32(0)         // e_flags
 	r.u16(ehsize)    // e_ehsize
 	r.u16(phentsize) // e_phentsize
 	r.seekProgNum = r.Here()
-	r.u16(0)                     // e_phnum
-	r.u16(0)                     // e_shentsize
-	r.u16(0)                     // e_shnum
+	r.u16(0)         // e_phnum
+	r.u16(shentsize) // e_shentsize
+	r.seekSectionNum = r.Here()
+	r.u16(0) // e_shnum
+	r.seekShstrndx = r.Here()
 	r.u16(uint16(elf.SHN_UNDEF)) // e_shstrndx
 
 	// Sanity check, size of file header should be the same as ehsize
@@ -120,7 +127,7 @@ func (w *Writer) WriteProgramHeaders() {
 	w.w.Seek(w.seekProgHeader, io.SeekStart)
 	w.u64(uint64(phoff))
 	w.w.Seek(w.seekProgNum, io.SeekStart)
-	w.u64(uint64(len(w.Progs)))
+	w.u16(uint16(len(w.Progs)))
 	w.w.Seek(0, io.SeekEnd)
 
 	for _, prog := range w.Progs {
@@ -135,6 +142,60 @@ func (w *Writer) WriteProgramHeaders() {
 	}
 }
 
+// WriteSectionHeaders writes the section headers at the current location
+// and patches the file header accordingly.
+func (w *Writer) WriteSectionHeaders() {
+	shstrndx := len(w.Sections)
+	strtab := &elf.SectionHeader{
+		Name:      ".strtab",
+		Type:      elf.SHT_STRTAB,
+		Offset:    uint64(w.Here()),
+		Addralign: 1,
+	}
+	w.Sections = append(w.Sections, strtab)
+
+	strtabStart := w.Here()
+
+	strToIndex := map[string]int64{}
+
+	w.Write([]byte{0}) // first entry must be the NUL character
+
+	for _, sect := range w.Sections {
+		if _, ok := strToIndex[sect.Name]; ok {
+			continue
+		}
+		strToIndex[sect.Name] = w.Here() - strtabStart
+		w.Write([]byte(sect.Name))
+		w.Write([]byte{0})
+	}
+
+	strtab.Size = uint64(w.Here() - strtabStart)
+
+	shoff := w.Here()
+
+	// Patch File Header
+	w.w.Seek(w.seekSectionHeader, io.SeekStart)
+	w.u64(uint64(shoff))
+	w.w.Seek(w.seekSectionNum, io.SeekStart)
+	w.u16(uint16(len(w.Sections)))
+	w.w.Seek(w.seekShstrndx, io.SeekStart)
+	w.u16(uint16(shstrndx))
+	w.w.Seek(0, io.SeekEnd)
+
+	for _, sect := range w.Sections {
+		w.u32(uint32(strToIndex[sect.Name]))
+		w.u32(uint32(sect.Type))
+		w.u64(uint64(sect.Flags))
+		w.u64(sect.Addr)
+		w.u64(sect.Offset)
+		w.u64(sect.Size)
+		w.u32(sect.Link)
+		w.u32(sect.Info)
+		w.u64(sect.Addralign)
+		w.u64(sect.Entsize)
+	}
+}
+
 // Here returns the current seek offset from the start of the file.
 func (w *Writer) Here() int64 {
 	r, err := w.w.Seek(0, io.SeekCurrent)
diff -pruN 1.22.1-1/pkg/goversion/compat.go 1.23.0-1/pkg/goversion/compat.go
--- 1.22.1-1/pkg/goversion/compat.go	2024-02-21 20:29:06.000000000 +0000
+++ 1.23.0-1/pkg/goversion/compat.go	2024-07-16 18:44:48.000000000 +0000
@@ -8,9 +8,9 @@ import (
 
 var (
 	MinSupportedVersionOfGoMajor = 1
-	MinSupportedVersionOfGoMinor = 19
+	MinSupportedVersionOfGoMinor = 21
 	MaxSupportedVersionOfGoMajor = 1
-	MaxSupportedVersionOfGoMinor = 22
+	MaxSupportedVersionOfGoMinor = 23
 	goTooOldErr                  = fmt.Sprintf("Go version %%s is too old for this version of Delve (minimum supported version %d.%d, suppress this error with --check-go-version=false)", MinSupportedVersionOfGoMajor, MinSupportedVersionOfGoMinor)
 	goTooOldWarn                 = fmt.Sprintf("WARNING: undefined behavior - Go version %%s is too old for this version of Delve (minimum supported version %d.%d)", MinSupportedVersionOfGoMajor, MinSupportedVersionOfGoMinor)
 	dlvTooOldErr                 = fmt.Sprintf("Version of Delve is too old for Go version %%s (maximum supported version %d.%d, suppress this error with --check-go-version=false)", MaxSupportedVersionOfGoMajor, MaxSupportedVersionOfGoMinor)
diff -pruN 1.22.1-1/pkg/internal/gosym/symtab.go 1.23.0-1/pkg/internal/gosym/symtab.go
--- 1.22.1-1/pkg/internal/gosym/symtab.go	2024-02-21 20:29:06.000000000 +0000
+++ 1.23.0-1/pkg/internal/gosym/symtab.go	2024-07-16 18:44:48.000000000 +0000
@@ -140,7 +140,6 @@ func (T *Table) GetInlineTree(f *Func, g
 	//goFuncValue := FuncSymName(strver)
 	//return T.go12line.InlineTree(f,goFuncValue,baseaddr,progReader)
 	return T.go12line.InlineTree(f, goFuncVal, baseaddr, progReader)
-
 }
 func ProgContaining(elfFile *elf.File, addr uint64) *elf.Prog {
 	for _, p := range elfFile.Progs {
diff -pruN 1.22.1-1/pkg/locspec/locations.go 1.23.0-1/pkg/locspec/locations.go
--- 1.22.1-1/pkg/locspec/locations.go	2024-02-21 20:29:06.000000000 +0000
+++ 1.23.0-1/pkg/locspec/locations.go	2024-07-16 18:44:48.000000000 +0000
@@ -1,6 +1,7 @@
 package locspec
 
 import (
+	"errors"
 	"fmt"
 	"go/constant"
 	"path"
@@ -272,7 +273,7 @@ func packageMatch(specPkg, symPkg string
 func (loc *RegexLocationSpec) Find(t *proc.Target, _ []string, scope *proc.EvalScope, locStr string, includeNonExecutableLines bool, _ [][2]string) ([]api.Location, string, error) {
 	if scope == nil {
 		//TODO(aarzilli): this needs only the list of function we should make it work
-		return nil, "", fmt.Errorf("could not determine location (scope is nil)")
+		return nil, "", errors.New("could not determine location (scope is nil)")
 	}
 	funcs := scope.BinInfo.Functions
 	matches, err := regexFilterFuncs(loc.FuncRegex, funcs)
@@ -294,7 +295,7 @@ func (loc *AddrLocationSpec) Find(t *pro
 	if scope == nil {
 		addr, err := strconv.ParseInt(loc.AddrExpr, 0, 64)
 		if err != nil {
-			return nil, "", fmt.Errorf("could not determine current location (scope is nil)")
+			return nil, "", errors.New("could not determine current location (scope is nil)")
 		}
 		return []api.Location{{PC: uint64(addr)}}, "", nil
 	}
@@ -361,7 +362,6 @@ func (ale AmbiguousLocationError) Error(
 		for i := range ale.CandidatesLocation {
 			candidates = append(candidates, ale.CandidatesLocation[i].Function.Name())
 		}
-
 	} else {
 		candidates = ale.CandidatesString
 	}
@@ -417,7 +417,7 @@ func (loc *NormalLocationSpec) Find(t *p
 	if len(candidateFiles) == 1 {
 		if loc.LineOffset < 0 {
 			//lint:ignore ST1005 backwards compatibility
-			return nil, "", fmt.Errorf("Malformed breakpoint location, no line offset specified")
+			return nil, "", errors.New("Malformed breakpoint location, no line offset specified")
 		}
 		addrs, err = proc.FindFileLocation(t, candidateFiles[0], loc.LineOffset)
 		if includeNonExecutableLines {
@@ -618,7 +618,7 @@ func addressesToLocation(addrs []uint64)
 // Find returns the location after adding the offset amount to the current line number.
 func (loc *OffsetLocationSpec) Find(t *proc.Target, _ []string, scope *proc.EvalScope, _ string, includeNonExecutableLines bool, _ [][2]string) ([]api.Location, string, error) {
 	if scope == nil {
-		return nil, "", fmt.Errorf("could not determine current location (scope is nil)")
+		return nil, "", errors.New("could not determine current location (scope is nil)")
 	}
 	file, line, fn := scope.BinInfo.PCToLine(scope.PC)
 	if loc.Offset == 0 {
@@ -629,7 +629,7 @@ func (loc *OffsetLocationSpec) Find(t *p
 		return []api.Location{{PC: scope.PC}}, subst, nil
 	}
 	if fn == nil {
-		return nil, "", fmt.Errorf("could not determine current location")
+		return nil, "", errors.New("could not determine current location")
 	}
 	subst := fmt.Sprintf("%s:%d", file, line+loc.Offset)
 	addrs, err := proc.FindFileLocation(t, file, line+loc.Offset)
@@ -644,11 +644,11 @@ func (loc *OffsetLocationSpec) Find(t *p
 // Find will return the location at the given line in the current file.
 func (loc *LineLocationSpec) Find(t *proc.Target, _ []string, scope *proc.EvalScope, _ string, includeNonExecutableLines bool, _ [][2]string) ([]api.Location, string, error) {
 	if scope == nil {
-		return nil, "", fmt.Errorf("could not determine current location (scope is nil)")
+		return nil, "", errors.New("could not determine current location (scope is nil)")
 	}
 	file, _, fn := scope.BinInfo.PCToLine(scope.PC)
 	if fn == nil {
-		return nil, "", fmt.Errorf("could not determine current location")
+		return nil, "", errors.New("could not determine current location")
 	}
 	subst := fmt.Sprintf("%s:%d", file, loc.Line)
 	addrs, err := proc.FindFileLocation(t, file, loc.Line)
diff -pruN 1.22.1-1/pkg/proc/amd64util/debugregs.go 1.23.0-1/pkg/proc/amd64util/debugregs.go
--- 1.22.1-1/pkg/proc/amd64util/debugregs.go	2024-02-21 20:29:06.000000000 +0000
+++ 1.23.0-1/pkg/proc/amd64util/debugregs.go	2024-07-16 18:44:48.000000000 +0000
@@ -60,7 +60,7 @@ func (drs *DebugRegisters) breakpoint(id
 // nothing.
 func (drs *DebugRegisters) SetBreakpoint(idx uint8, addr uint64, read, write bool, sz int) error {
 	if int(idx) >= len(drs.pAddrs) {
-		return fmt.Errorf("hardware breakpoints exhausted")
+		return errors.New("hardware breakpoints exhausted")
 	}
 	curaddr, curread, curwrite, cursz := drs.breakpoint(idx)
 	if curaddr != 0 {
@@ -115,7 +115,7 @@ func (drs *DebugRegisters) ClearBreakpoi
 // GetActiveBreakpoint returns the active hardware breakpoint and resets the
 // condition flags.
 func (drs *DebugRegisters) GetActiveBreakpoint() (ok bool, idx uint8) {
-	for idx := uint8(0); idx < 3; idx++ {
+	for idx := uint8(0); idx <= 3; idx++ {
 		enable := *(drs.pDR7) & (1 << enableBitOffset(idx))
 		if enable == 0 {
 			continue
diff -pruN 1.22.1-1/pkg/proc/bininfo.go 1.23.0-1/pkg/proc/bininfo.go
--- 1.22.1-1/pkg/proc/bininfo.go	2024-02-21 20:29:06.000000000 +0000
+++ 1.23.0-1/pkg/proc/bininfo.go	2024-07-16 18:44:48.000000000 +0000
@@ -53,9 +53,6 @@ type BinaryInfo struct {
 
 	DebugInfoDirectories []string
 
-	// BuildID of this binary.
-	BuildID string
-
 	// Functions is a list of all DW_TAG_subprogram entries in debug_info, sorted by entry point
 	Functions []Function
 	// Sources is a list of all source files found in debug_line.
@@ -207,7 +204,6 @@ func FindFileLocation(p Process, filenam
 	selectedPCs := []uint64{}
 
 	for fn, pcs := range pcByFunc {
-
 		// 3. for each concrete function split instruction between the inlined functions it contains
 
 		if strings.Contains(fn.Name, "·dwrap·") || fn.trampoline {
@@ -502,7 +498,24 @@ type Function struct {
 	trampoline bool // DW_AT_trampoline attribute set to true
 
 	// InlinedCalls lists all inlined calls to this function
-	InlinedCalls []InlinedCall
+	InlinedCalls         []InlinedCall
+	rangeParentNameCache int // see rangeParentName
+	// extraCache contains information about this function that is only needed for
+	// some operations and is expensive to compute or store for every function.
+	extraCache *functionExtra
+}
+
+type functionExtra struct {
+	// closureStructType is the cached struct type for closures for this function
+	closureStructType *godwarf.StructType
+
+	// rangeParent is set when this function is a range-over-func body closure
+	// and points to the function that the closure was generated from.
+	rangeParent *Function
+	// rangeBodies is the list of range-over-func body closures for this
+	// function. Only one between rangeParent and rangeBodies should be set at
+	// any given time.
+	rangeBodies []*Function
 }
 
 // instRange returns the indexes in fn.Name of the type parameter
@@ -639,6 +652,106 @@ func (fn *Function) privateRuntime() boo
 	return len(name) > n && name[:n] == "runtime." && !('A' <= name[n] && name[n] <= 'Z')
 }
 
+func rangeParentName(fnname string) int {
+	const rangeSuffix = "-range"
+	ridx := strings.Index(fnname, rangeSuffix)
+	if ridx <= 0 {
+		return -1
+	}
+	ok := true
+	for i := ridx + len(rangeSuffix); i < len(fnname); i++ {
+		if fnname[i] < '0' || fnname[i] > '9' {
+			ok = false
+			break
+		}
+	}
+	if !ok {
+		return -1
+	}
+	return ridx
+}
+
+// rangeParentName, if this function is a range-over-func body closure
+// returns the name of the parent function, otherwise returns ""
+func (fn *Function) rangeParentName() string {
+	if fn.rangeParentNameCache == 0 {
+		ridx := rangeParentName(fn.Name)
+		fn.rangeParentNameCache = ridx
+	}
+	if fn.rangeParentNameCache < 0 {
+		return ""
+	}
+	return fn.Name[:fn.rangeParentNameCache]
+}
+
+// extra loads information about fn that is expensive to compute and we
+// only need for a minority of the functions.
+func (fn *Function) extra(bi *BinaryInfo) *functionExtra {
+	if fn.extraCache != nil {
+		return fn.extraCache
+	}
+
+	if fn.cu.image.Stripped() {
+		fn.extraCache = &functionExtra{}
+		return fn.extraCache
+	}
+
+	fn.extraCache = &functionExtra{}
+
+	// Calculate closureStructType
+	{
+		dwarfTree, err := fn.cu.image.getDwarfTree(fn.offset)
+		if err != nil {
+			return nil
+		}
+		st := &godwarf.StructType{
+			Kind: "struct",
+		}
+		vars := reader.Variables(dwarfTree, 0, 0, reader.VariablesNoDeclLineCheck|reader.VariablesSkipInlinedSubroutines)
+		for _, v := range vars {
+			off, ok := v.Val(godwarf.AttrGoClosureOffset).(int64)
+			if ok {
+				n, _ := v.Val(dwarf.AttrName).(string)
+				typ, err := v.Type(fn.cu.image.dwarf, fn.cu.image.index, fn.cu.image.typeCache)
+				if err == nil {
+					sz := typ.Common().ByteSize
+					st.Field = append(st.Field, &godwarf.StructField{
+						Name:       n,
+						Type:       typ,
+						ByteOffset: off,
+						ByteSize:   sz,
+						BitOffset:  off * 8,
+						BitSize:    sz * 8,
+					})
+				}
+			}
+		}
+
+		if len(st.Field) > 0 {
+			lf := st.Field[len(st.Field)-1]
+			st.ByteSize = lf.ByteOffset + lf.Type.Common().ByteSize
+		}
+		fn.extraCache.closureStructType = st
+	}
+
+	// Find rangeParent for this function (if it is a range-over-func body closure)
+	if rangeParentName := fn.rangeParentName(); rangeParentName != "" {
+		fn.extraCache.rangeParent = bi.lookupOneFunc(rangeParentName)
+	}
+
+	// Find range-over-func bodies of this function
+	if fn.extraCache.rangeParent == nil {
+		for i := range bi.Functions {
+			fn2 := &bi.Functions[i]
+			if strings.HasPrefix(fn2.Name, fn.Name) && fn2.rangeParentName() == fn.Name {
+				fn.extraCache.rangeBodies = append(fn.extraCache.rangeBodies, fn2)
+			}
+		}
+	}
+
+	return fn.extraCache
+}
+
 type constantsMap map[dwarfRef]*constantType
 
 type constantType struct {
@@ -836,6 +949,7 @@ func (bi *BinaryInfo) PCToImage(pc uint6
 type Image struct {
 	Path       string
 	StaticBase uint64
+	BuildID    string
 	addr       uint64
 
 	index int // index of this object in BinaryInfo.SharedObjects
@@ -912,7 +1026,7 @@ func (bi *BinaryInfo) AddImage(path stri
 }
 
 // moduleDataToImage finds the image corresponding to the given module data object.
-func (bi *BinaryInfo) moduleDataToImage(md *moduleData) *Image {
+func (bi *BinaryInfo) moduleDataToImage(md *ModuleData) *Image {
 	fn := bi.PCToFunc(md.text)
 	if fn != nil {
 		return bi.funcToImage(fn)
@@ -931,7 +1045,7 @@ func (bi *BinaryInfo) moduleDataToImage(
 }
 
 // imageToModuleData finds the module data in mds corresponding to the given image.
-func (bi *BinaryInfo) imageToModuleData(image *Image, mds []moduleData) *moduleData {
+func (bi *BinaryInfo) imageToModuleData(image *Image, mds []ModuleData) *ModuleData {
 	for _, md := range mds {
 		im2 := bi.moduleDataToImage(&md)
 		if im2 != nil && im2.index == image.index {
@@ -1321,10 +1435,10 @@ func (bi *BinaryInfo) openSeparateDebugI
 		}
 	}
 
-	if debugFilePath == "" && len(bi.BuildID) > 2 {
+	if debugFilePath == "" && len(image.BuildID) > 2 {
 		// Build ID method: look for a file named .build-id/nn/nnnnnnnn.debug in
 		// every debug info directory.
-		find(nil, fmt.Sprintf(".build-id/%s/%s.debug", bi.BuildID[:2], bi.BuildID[2:]))
+		find(nil, fmt.Sprintf(".build-id/%s/%s.debug", image.BuildID[:2], image.BuildID[2:]))
 	}
 
 	if debugFilePath == "" {
@@ -1358,16 +1472,15 @@ func (bi *BinaryInfo) openSeparateDebugI
 					bi.logger.Errorf("gnu_debuglink CRC check failed for %s (want %x got %x)", debugFilePath, crc, computedCRC)
 					debugFilePath = ""
 				}
-
 			}
 		}
 	}
 
-	if debugFilePath == "" && len(bi.BuildID) > 2 {
+	if debugFilePath == "" && len(image.BuildID) > 2 {
 		// Previous versions of delve looked for the build id in every debug info
 		// directory that contained the build-id substring. This behavior deviates
 		// from the ones specified by GDB but we keep it for backwards compatibility.
-		find(func(dir string) bool { return strings.Contains(dir, "build-id") }, fmt.Sprintf("%s/%s.debug", bi.BuildID[:2], bi.BuildID[2:]))
+		find(func(dir string) bool { return strings.Contains(dir, "build-id") }, fmt.Sprintf("%s/%s.debug", image.BuildID[:2], image.BuildID[2:]))
 	}
 
 	if debugFilePath == "" {
@@ -1382,7 +1495,7 @@ func (bi *BinaryInfo) openSeparateDebugI
 	// has debuginfod so that we can use that in order to find any relevant debug information.
 	if debugFilePath == "" {
 		var err error
-		debugFilePath, err = debuginfod.GetDebuginfo(bi.BuildID)
+		debugFilePath, err = debuginfod.GetDebuginfo(image.BuildID)
 		if err != nil {
 			return nil, nil, ErrNoDebugInfoFound
 		}
@@ -1455,63 +1568,10 @@ func loadBinaryInfoElf(bi *BinaryInfo, i
 			if len(bi.Images) <= 1 {
 				fmt.Fprintln(os.Stderr, "Warning: no debug info found, some functionality will be missing such as stack traces and variable evaluation.")
 			}
-			cu := &compileUnit{}
-			cu.image = image
-			symTable, symTabAddr, err := readPcLnTableElf(elfFile, path)
+			err := loadBinaryInfoGoRuntimeElf(bi, image, path, elfFile)
 			if err != nil {
 				return fmt.Errorf("could not read debug info (%v) and could not read go symbol table (%v)", dwerr, err)
 			}
-			image.symTable = symTable
-			noPtrSectionData, err := elfFile.Section(".noptrdata").Data()
-			if err != nil {
-				return err
-			}
-			md, err := parseModuleData(noPtrSectionData, symTabAddr)
-			if err != nil {
-				return err
-			}
-			roDataAddr := elfFile.Section(".rodata").Addr
-			goFuncVal, err := findGoFuncVal(md, roDataAddr, bi.Arch.ptrSize)
-			if err != nil {
-				return err
-			}
-			prog := gosym.ProgContaining(elfFile, goFuncVal)
-			inlFuncs := make(map[string]*Function)
-			for _, f := range image.symTable.Funcs {
-				fnEntry := f.Entry + image.StaticBase
-				if prog != nil {
-					inlCalls, err := image.symTable.GetInlineTree(&f, goFuncVal, prog.Vaddr, prog.ReaderAt)
-					if err != nil {
-						return err
-					}
-					for _, inlfn := range inlCalls {
-						newInlinedCall := InlinedCall{cu: cu, LowPC: fnEntry + uint64(inlfn.ParentPC)}
-						if fn, ok := inlFuncs[inlfn.Name]; ok {
-							fn.InlinedCalls = append(fn.InlinedCalls, newInlinedCall)
-							continue
-						}
-						inlFuncs[inlfn.Name] = &Function{
-							Name:  inlfn.Name,
-							Entry: 0, End: 0,
-							cu: cu,
-							InlinedCalls: []InlinedCall{
-								newInlinedCall,
-							},
-						}
-					}
-				}
-				fn := Function{Name: f.Name, Entry: fnEntry, End: f.End + image.StaticBase, cu: cu}
-				bi.Functions = append(bi.Functions, fn)
-			}
-			for i := range inlFuncs {
-				bi.Functions = append(bi.Functions, *inlFuncs[i])
-			}
-			sort.Sort(functionsDebugInfoByEntry(bi.Functions))
-			for f := range image.symTable.Files {
-				bi.Sources = append(bi.Sources, f)
-			}
-			sort.Strings(bi.Sources)
-			bi.Sources = uniq(bi.Sources)
 			return nil
 		}
 		image.sepDebugCloser = sepFile
@@ -1646,7 +1706,7 @@ func (bi *BinaryInfo) loadBuildID(image
 		bi.logger.Warnf("can't read build-id desc: %v", err)
 		return
 	}
-	bi.BuildID = hex.EncodeToString(descBinary)
+	image.BuildID = hex.EncodeToString(descBinary)
 }
 
 func (bi *BinaryInfo) getDebugLink(exe *elf.File) (debugLink string, crc uint32) {
@@ -1846,18 +1906,18 @@ func (bi *BinaryInfo) setGStructOffsetPE
 		producer := bi.Producer()
 		if producer != "" && goversion.ProducerAfterOrEqual(producer, 1, 20) {
 			// Use runtime.tls_g as pointer to offset from GS to G struct:
-			// https://golang.org/src/runtime/sys_windows_amd64.s
+			// https://go.dev/src/runtime/sys_windows_amd64.s
 			bi.gStructOffset = readtls_g()
 			bi.gStructOffsetIsPtr = true
 		} else {
 			// Use ArbitraryUserPointer (0x28) as pointer to pointer
 			// to G struct per:
-			// https://golang.org/src/runtime/cgo/gcc_windows_amd64.c
+			// https://go.dev/src/runtime/cgo/gcc_windows_amd64.c
 			bi.gStructOffset = 0x28
 		}
 	case _IMAGE_FILE_MACHINE_ARM64:
 		// Use runtime.tls_g as pointer to offset from R18 to G struct:
-		// https://golang.org/src/runtime/sys_windows_arm64.s
+		// https://go.dev/src/runtime/sys_windows_arm64.s
 		bi.gStructOffset = readtls_g()
 		bi.gStructOffsetIsPtr = true
 	}
@@ -1888,7 +1948,6 @@ func (bi *BinaryInfo) parseDebugFramePE(
 // loadBinaryInfoMacho specifically loads information from a Mach-O binary.
 func loadBinaryInfoMacho(bi *BinaryInfo, image *Image, path string, entryPoint uint64, wg *sync.WaitGroup) error {
 	exe, err := macho.Open(path)
-
 	if err != nil {
 		return err
 	}
@@ -1917,63 +1976,10 @@ func loadBinaryInfoMacho(bi *BinaryInfo,
 		if len(bi.Images) <= 1 {
 			fmt.Fprintln(os.Stderr, "Warning: no debug info found, some functionality will be missing such as stack traces and variable evaluation.")
 		}
-		symTable, symTabAddr, err := readPcLnTableMacho(exe, path)
+		err := loadBinaryInfoGoRuntimeMacho(bi, image, path, exe)
 		if err != nil {
 			return fmt.Errorf("could not read debug info (%v) and could not read go symbol table (%v)", dwerr, err)
 		}
-		image.symTable = symTable
-		cu := &compileUnit{}
-		cu.image = image
-		noPtrSectionData, err := exe.Section("__noptrdata").Data()
-		if err != nil {
-			return err
-		}
-		md, err := parseModuleData(noPtrSectionData, symTabAddr)
-		if err != nil {
-			return err
-		}
-		roDataAddr := exe.Section("__rodata").Addr
-		goFuncVal, err := findGoFuncVal(md, roDataAddr, bi.Arch.ptrSize)
-		if err != nil {
-			return err
-		}
-		seg := gosym.SegmentContaining(exe, goFuncVal)
-		inlFuncs := make(map[string]*Function)
-		for _, f := range image.symTable.Funcs {
-			fnEntry := f.Entry + image.StaticBase
-			if seg != nil {
-				inlCalls, err := image.symTable.GetInlineTree(&f, goFuncVal, seg.Addr, seg.ReaderAt)
-				if err != nil {
-					return err
-				}
-				for _, inlfn := range inlCalls {
-					newInlinedCall := InlinedCall{cu: cu, LowPC: fnEntry + uint64(inlfn.ParentPC)}
-					if fn, ok := inlFuncs[inlfn.Name]; ok {
-						fn.InlinedCalls = append(fn.InlinedCalls, newInlinedCall)
-						continue
-					}
-					inlFuncs[inlfn.Name] = &Function{
-						Name:  inlfn.Name,
-						Entry: 0, End: 0,
-						cu: cu,
-						InlinedCalls: []InlinedCall{
-							newInlinedCall,
-						},
-					}
-				}
-			}
-			fn := Function{Name: f.Name, Entry: fnEntry, End: f.End + image.StaticBase, cu: cu}
-			bi.Functions = append(bi.Functions, fn)
-		}
-		for i := range inlFuncs {
-			bi.Functions = append(bi.Functions, *inlFuncs[i])
-		}
-		sort.Sort(functionsDebugInfoByEntry(bi.Functions))
-		for f := range image.symTable.Files {
-			bi.Sources = append(bi.Sources, f)
-		}
-		sort.Strings(bi.Sources)
-		bi.Sources = uniq(bi.Sources)
 		return nil
 	}
 	debugInfoBytes, err := godwarf.GetDebugSectionMacho(exe, "info")
@@ -2127,6 +2133,132 @@ func (bi *BinaryInfo) macOSDebugFrameBug
 	}
 }
 
+// GO RUNTIME INFO ////////////////////////////////////////////////////////////
+
+// loadBinaryInfoGoRuntimeElf loads information from the Go runtime sections
+// of an ELF binary, it is only called when debug info has been stripped.
+func loadBinaryInfoGoRuntimeElf(bi *BinaryInfo, image *Image, path string, elfFile *elf.File) (err error) {
+	// This is a best-effort procedure, it can go wrong in unexpected ways, so
+	// recover all panics.
+	defer func() {
+		ierr := recover()
+		if ierr != nil {
+			err = fmt.Errorf("error loading binary info from Go runtime: %v", ierr)
+		}
+	}()
+
+	cu := &compileUnit{}
+	cu.image = image
+	symTable, symTabAddr, err := readPcLnTableElf(elfFile, path)
+	if err != nil {
+		return err
+	}
+	image.symTable = symTable
+	noPtrSectionData, err := elfFile.Section(".noptrdata").Data()
+	if err != nil {
+		return err
+	}
+	md, err := parseModuleData(noPtrSectionData, symTabAddr)
+	if err != nil {
+		return err
+	}
+	roDataAddr := elfFile.Section(".rodata").Addr
+	goFuncVal, err := findGoFuncVal(md, roDataAddr, bi.Arch.ptrSize)
+	if err != nil {
+		return err
+	}
+	prog := gosym.ProgContaining(elfFile, goFuncVal)
+	var progAddr uint64
+	var progReaderAt io.ReaderAt
+	if prog != nil {
+		progAddr = prog.Vaddr
+		progReaderAt = prog.ReaderAt
+	}
+	return loadBinaryInfoGoRuntimeCommon(bi, image, cu, goFuncVal, progAddr, progReaderAt)
+}
+
+// loadBinaryInfoGoRuntimeMacho loads information from the Go runtime sections
+// of an Macho-o binary, it is only called when debug info has been stripped.
+func loadBinaryInfoGoRuntimeMacho(bi *BinaryInfo, image *Image, path string, exe *macho.File) (err error) {
+	// This is a best-effort procedure, it can go wrong in unexpected ways, so
+	// recover all panics.
+	defer func() {
+		ierr := recover()
+		if ierr != nil {
+			err = fmt.Errorf("error loading binary info from Go runtime: %v", ierr)
+		}
+	}()
+
+	cu := &compileUnit{}
+	cu.image = image
+	symTable, symTabAddr, err := readPcLnTableMacho(exe, path)
+	if err != nil {
+		return err
+	}
+	image.symTable = symTable
+	noPtrSectionData, err := exe.Section("__noptrdata").Data()
+	if err != nil {
+		return err
+	}
+	md, err := parseModuleData(noPtrSectionData, symTabAddr)
+	if err != nil {
+		return err
+	}
+	roDataAddr := exe.Section("__rodata").Addr
+	goFuncVal, err := findGoFuncVal(md, roDataAddr, bi.Arch.ptrSize)
+	if err != nil {
+		return err
+	}
+	seg := gosym.SegmentContaining(exe, goFuncVal)
+	var segAddr uint64
+	var segReaderAt io.ReaderAt
+	if seg != nil {
+		segAddr = seg.Addr
+		segReaderAt = seg.ReaderAt
+	}
+	return loadBinaryInfoGoRuntimeCommon(bi, image, cu, goFuncVal, segAddr, segReaderAt)
+}
+
+func loadBinaryInfoGoRuntimeCommon(bi *BinaryInfo, image *Image, cu *compileUnit, goFuncVal uint64, goFuncSegAddr uint64, goFuncReader io.ReaderAt) error {
+	inlFuncs := make(map[string]*Function)
+	for _, f := range image.symTable.Funcs {
+		fnEntry := f.Entry + image.StaticBase
+		if goFuncReader != nil {
+			inlCalls, err := image.symTable.GetInlineTree(&f, goFuncVal, goFuncSegAddr, goFuncReader)
+			if err != nil {
+				return err
+			}
+			for _, inlfn := range inlCalls {
+				newInlinedCall := InlinedCall{cu: cu, LowPC: fnEntry + uint64(inlfn.ParentPC)}
+				if fn, ok := inlFuncs[inlfn.Name]; ok {
+					fn.InlinedCalls = append(fn.InlinedCalls, newInlinedCall)
+					continue
+				}
+				inlFuncs[inlfn.Name] = &Function{
+					Name:  inlfn.Name,
+					Entry: 0, End: 0,
+					cu: cu,
+					InlinedCalls: []InlinedCall{
+						newInlinedCall,
+					},
+				}
+			}
+		}
+		fn := Function{Name: f.Name, Entry: fnEntry, End: f.End + image.StaticBase, cu: cu}
+		bi.Functions = append(bi.Functions, fn)
+	}
+	for i := range inlFuncs {
+		bi.Functions = append(bi.Functions, *inlFuncs[i])
+	}
+	sort.Sort(functionsDebugInfoByEntry(bi.Functions))
+	for f := range image.symTable.Files {
+		bi.Sources = append(bi.Sources, f)
+	}
+	sort.Strings(bi.Sources)
+	bi.Sources = uniq(bi.Sources)
+	return nil
+}
+
 // Do not call this function directly it isn't able to deal correctly with package paths
 func (bi *BinaryInfo) findType(name string) (godwarf.Type, error) {
 	name = strings.ReplaceAll(name, "interface{", "interface {")
diff -pruN 1.22.1-1/pkg/proc/breakpoints.go 1.23.0-1/pkg/proc/breakpoints.go
--- 1.22.1-1/pkg/proc/breakpoints.go	2024-02-21 20:29:06.000000000 +0000
+++ 1.23.0-1/pkg/proc/breakpoints.go	2024-07-16 18:44:48.000000000 +0000
@@ -63,6 +63,11 @@ type Breakpoint struct {
 	// ReturnInfo describes how to collect return variables when this
 	// breakpoint is hit as a return breakpoint.
 	returnInfo *returnBreakpointInfo
+
+	// RootFuncName is the name of the root function from where tracing needs to be done
+	RootFuncName string
+	// TraceFollowCalls indicates the depth of tracing
+	TraceFollowCalls int
 }
 
 // Breaklet represents one of multiple breakpoints that can overlap on a
@@ -135,7 +140,14 @@ const (
 	// been loaded and we should try to enable suspended breakpoints.
 	PluginOpenBreakpoint
 
-	steppingMask = NextBreakpoint | NextDeferBreakpoint | StepBreakpoint
+	// StepIntoNewProc is a breakpoint used to step into a newly created
+	// goroutine.
+	StepIntoNewProcBreakpoint
+
+	// NextInactivatedBreakpoint a NextBreakpoint that has been inactivated, see rangeFrameInactivateNextBreakpoints
+	NextInactivatedBreakpoint
+
+	steppingMask = NextBreakpoint | NextDeferBreakpoint | StepBreakpoint | StepIntoNewProcBreakpoint | NextInactivatedBreakpoint
 )
 
 // WatchType is the watchpoint type
@@ -210,6 +222,10 @@ func (bp *Breakpoint) VerboseDescr() []s
 			r = append(r, fmt.Sprintf("StackResizeBreakpoint Cond=%q", exprToString(breaklet.Cond)))
 		case PluginOpenBreakpoint:
 			r = append(r, "PluginOpenBreakpoint")
+		case StepIntoNewProcBreakpoint:
+			r = append(r, "StepIntoNewProcBreakpoint")
+		case NextInactivatedBreakpoint:
+			r = append(r, "NextInactivatedBreakpoint")
 		default:
 			r = append(r, fmt.Sprintf("Unknown %d", breaklet.Kind))
 		}
@@ -304,9 +320,12 @@ func (bpstate *BreakpointState) checkCon
 			}
 		}
 
-	case StackResizeBreakpoint, PluginOpenBreakpoint:
+	case StackResizeBreakpoint, PluginOpenBreakpoint, StepIntoNewProcBreakpoint:
 		// no further checks
 
+	case NextInactivatedBreakpoint:
+		active = false
+
 	default:
 		bpstate.CondError = fmt.Errorf("internal error unknown breakpoint kind %v", breaklet.Kind)
 	}
@@ -823,6 +842,29 @@ func (t *Target) ClearSteppingBreakpoint
 	return nil
 }
 
+func (t *Target) clearInactivatedSteppingBreakpoint() error {
+	threads := t.ThreadList()
+	for _, bp := range t.Breakpoints().M {
+		for i := range bp.Breaklets {
+			if bp.Breaklets[i].Kind == NextInactivatedBreakpoint {
+				bp.Breaklets[i] = nil
+			}
+		}
+		cleared, err := t.finishClearBreakpoint(bp)
+		if err != nil {
+			return err
+		}
+		if cleared {
+			for _, thread := range threads {
+				if thread.Breakpoint().Breakpoint == bp {
+					thread.Breakpoint().Clear()
+				}
+			}
+		}
+	}
+	return nil
+}
+
 // finishClearBreakpoint clears nil breaklets from the breaklet list of bp
 // and if it is empty erases the breakpoint.
 // Returns true if the breakpoint was deleted
@@ -949,7 +991,7 @@ func (rbpi *returnBreakpointInfo) Collec
 		return returnInfoError("could not read function entry", err, thread.ProcessMemory())
 	}
 
-	vars, err := scope.Locals(0)
+	vars, err := scope.Locals(0, "")
 	if err != nil {
 		return returnInfoError("could not evaluate return variables", err, thread.ProcessMemory())
 	}
@@ -1010,6 +1052,10 @@ type LogicalBreakpoint struct {
 	Cond ast.Expr
 
 	UserData interface{} // Any additional information about the breakpoint
+	// Name of root function from where tracing needs to be done
+	RootFuncName string
+	// depth of tracing
+	TraceFollowCalls int
 }
 
 // SetBreakpoint describes how a breakpoint should be set.
diff -pruN 1.22.1-1/pkg/proc/core/linux_core.go 1.23.0-1/pkg/proc/core/linux_core.go
--- 1.22.1-1/pkg/proc/core/linux_core.go	2024-02-21 20:29:06.000000000 +0000
+++ 1.23.0-1/pkg/proc/core/linux_core.go	2024-07-16 18:44:48.000000000 +0000
@@ -4,6 +4,7 @@ import (
 	"bytes"
 	"debug/elf"
 	"encoding/binary"
+	"errors"
 	"fmt"
 	"io"
 	"os"
@@ -35,7 +36,7 @@ const _NT_AUXV elf.NType = 0x6
 const _NT_FPREGSET elf.NType = 0x2
 
 // Fetch architecture using exeELF.Machine from core file
-// Refer http://man7.org/linux/man-pages/man5/elf.5.html
+// Refer https://man7.org/linux/man-pages/man5/elf.5.html
 const (
 	_EM_AARCH64          = 183
 	_EM_X86_64           = 62
@@ -88,9 +89,9 @@ func linuxThreadsFromNotes(p *process, n
 // readLinuxOrPlatformIndependentCore reads a core file from corePath
 // corresponding to the executable at exePath. For details on the Linux ELF
 // core format, see:
-// http://www.gabriel.urdhr.fr/2015/05/29/core-file/,
-// http://uhlo.blogspot.fr/2012/05/brief-look-into-core-dumps.html,
-// elf_core_dump in http://lxr.free-electrons.com/source/fs/binfmt_elf.c,
+// https://www.gabriel.urdhr.fr/2015/05/29/core-file/,
+// https://uhlo.blogspot.com/2012/05/brief-look-into-core-dumps.html,
+// elf_core_dump in https://elixir.bootlin.com/linux/v4.20.17/source/fs/binfmt_elf.c,
 // and, if absolutely desperate, readelf.c from the binutils source.
 func readLinuxOrPlatformIndependentCore(corePath, exePath string) (*process, proc.Thread, error) {
 	coreFile, err := elf.Open(corePath)
@@ -147,7 +148,7 @@ func readLinuxOrPlatformIndependentCore(
 		case _EM_AARCH64:
 			bi = proc.NewBinaryInfo("linux", "arm64")
 		default:
-			return nil, nil, fmt.Errorf("unsupported machine type")
+			return nil, nil, errors.New("unsupported machine type")
 		}
 	}
 
@@ -255,7 +256,7 @@ func readNotes(core *elf.File, machineTy
 // readNote reads a single note from r, decoding the descriptor if possible.
 func readNote(r io.ReadSeeker, machineType elf.Machine) (*note, error) {
 	// Notes are laid out as described in the SysV ABI:
-	// http://www.sco.com/developers/gabi/latest/ch5.pheader.html#note_section
+	// https://www.sco.com/developers/gabi/latest/ch5.pheader.html#note_section
 	note := &note{}
 	hdr := &elfNotesHdr{}
 
@@ -286,7 +287,7 @@ func readNote(r io.ReadSeeker, machineTy
 		case _EM_AARCH64:
 			note.Desc = &linuxPrStatusARM64{}
 		default:
-			return nil, fmt.Errorf("unsupported machine type")
+			return nil, errors.New("unsupported machine type")
 		}
 		if err := binary.Read(descReader, binary.LittleEndian, note.Desc); err != nil {
 			return nil, fmt.Errorf("reading NT_PRSTATUS: %v", err)
@@ -368,7 +369,6 @@ func buildMemory(core, exeELF *elf.File,
 				}
 				memory.Add(r, entry.Start, entry.End-entry.Start)
 			}
-
 		}
 	}
 
@@ -406,7 +406,7 @@ func findEntryPoint(notes []*note, ptrSi
 // LinuxPrPsInfo has various structures from the ELF spec and the Linux kernel.
 // AMD64 specific primarily because of unix.PtraceRegs, but also
 // because some of the fields are word sized.
-// See http://lxr.free-electrons.com/source/include/uapi/linux/elfcore.h
+// See https://elixir.bootlin.com/linux/v4.20.17/source/include/uapi/linux/elfcore.h
 type linuxPrPsInfo struct {
 	State                uint8
 	Sname                int8
diff -pruN 1.22.1-1/pkg/proc/dump.go 1.23.0-1/pkg/proc/dump.go
--- 1.22.1-1/pkg/proc/dump.go	2024-02-21 20:29:06.000000000 +0000
+++ 1.23.0-1/pkg/proc/dump.go	2024-07-16 18:44:48.000000000 +0000
@@ -273,7 +273,7 @@ func (t *Target) dumpThreadNotes(notes [
 
 	for _, reg := range regsv {
 		binary.Write(buf, binary.LittleEndian, uint16(len(reg.Name)))
-		buf.Write([]byte(reg.Name))
+		buf.WriteString(reg.Name)
 		if reg.Reg.Bytes != nil {
 			binary.Write(buf, binary.LittleEndian, uint16(len(reg.Reg.Bytes)))
 			buf.Write(reg.Reg.Bytes)
diff -pruN 1.22.1-1/pkg/proc/dwarf_expr_test.go 1.23.0-1/pkg/proc/dwarf_expr_test.go
--- 1.22.1-1/pkg/proc/dwarf_expr_test.go	2024-02-21 20:29:06.000000000 +0000
+++ 1.23.0-1/pkg/proc/dwarf_expr_test.go	2024-07-16 18:44:48.000000000 +0000
@@ -370,7 +370,6 @@ func TestLocationCovers(t *testing.T) {
 	if fmt.Sprintf("%x", ranges) != "[[40100 40700] [40700 41000]]" {
 		t.Error("wrong value returned by LocationCover")
 	}
-
 }
 
 func TestIssue1636_InlineWithoutOrigin(t *testing.T) {
diff -pruN 1.22.1-1/pkg/proc/eval.go 1.23.0-1/pkg/proc/eval.go
--- 1.22.1-1/pkg/proc/eval.go	2024-02-21 20:29:06.000000000 +0000
+++ 1.23.0-1/pkg/proc/eval.go	2024-07-16 18:44:48.000000000 +0000
@@ -25,7 +25,10 @@ import (
 
 var errOperationOnSpecialFloat = errors.New("operations on non-finite floats not implemented")
 
-const goDictionaryName = ".dict"
+const (
+	goDictionaryName = ".dict"
+	goClosurePtr     = ".closureptr"
+)
 
 // EvalScope is the scope for variable evaluation. Contains the thread,
 // current location (PC), and canonical frame address.
@@ -48,6 +51,9 @@ type EvalScope struct {
 	callCtx *callContext
 
 	dictAddr uint64 // dictionary address for instantiated generic functions
+
+	enclosingRangeScopes []*EvalScope
+	rangeFrames          []Stackframe
 }
 
 type localsFlags uint8
@@ -61,6 +67,10 @@ const (
 	// If localsNoDeclLineCheck the declaration line isn't checked at
 	// all to determine if the variable is in scope.
 	localsNoDeclLineCheck
+
+	// If localsOnlyRangeBodyClosures is set simpleLocals only returns
+	// variables containing the range body closure.
+	localsOnlyRangeBodyClosures
 )
 
 // ConvertEvalScope returns a new EvalScope in the context of the
@@ -203,81 +213,6 @@ func (s scopeToEvalLookup) FindTypeExpr(
 	return s.BinInfo.findTypeExpr(expr)
 }
 
-func (scope scopeToEvalLookup) HasLocal(name string) bool {
-	if scope.Fn == nil {
-		return false
-	}
-
-	flags := reader.VariablesOnlyVisible
-	if scope.BinInfo.Producer() != "" && goversion.ProducerAfterOrEqual(scope.BinInfo.Producer(), 1, 15) {
-		flags |= reader.VariablesTrustDeclLine
-	}
-
-	dwarfTree, err := scope.image().getDwarfTree(scope.Fn.offset)
-	if err != nil {
-		return false
-	}
-
-	varEntries := reader.Variables(dwarfTree, scope.PC, scope.Line, flags)
-	for _, entry := range varEntries {
-		curname, _ := entry.Val(dwarf.AttrName).(string)
-		if curname == name {
-			return true
-		}
-		if len(curname) > 0 && curname[0] == '&' {
-			if curname[1:] == name {
-				return true
-			}
-		}
-	}
-	return false
-}
-
-func (scope scopeToEvalLookup) HasGlobal(pkgName, varName string) bool {
-	hasGlobalInternal := func(name string) bool {
-		for _, pkgvar := range scope.BinInfo.packageVars {
-			if pkgvar.name == name || strings.HasSuffix(pkgvar.name, "/"+name) {
-				return true
-			}
-		}
-		for _, fn := range scope.BinInfo.Functions {
-			if fn.Name == name || strings.HasSuffix(fn.Name, "/"+name) {
-				return true
-			}
-		}
-		for _, ctyp := range scope.BinInfo.consts {
-			for _, cval := range ctyp.values {
-				if cval.fullName == name || strings.HasSuffix(cval.fullName, "/"+name) {
-					return true
-				}
-			}
-		}
-		return false
-	}
-
-	if pkgName == "" {
-		if scope.Fn == nil {
-			return false
-		}
-		return hasGlobalInternal(scope.Fn.PackageName() + "." + varName)
-	}
-
-	for _, pkgPath := range scope.BinInfo.PackageMap[pkgName] {
-		if hasGlobalInternal(pkgPath + "." + varName) {
-			return true
-		}
-	}
-	return hasGlobalInternal(pkgName + "." + varName)
-}
-
-func (scope scopeToEvalLookup) LookupRegisterName(name string) (int, bool) {
-	s := validRegisterName(name)
-	if s == "" {
-		return 0, false
-	}
-	return scope.BinInfo.Arch.RegisterNameToDwarf(s)
-}
-
 func (scope scopeToEvalLookup) HasBuiltin(name string) bool {
 	return supportedBuiltins[name] != nil
 }
@@ -365,12 +300,102 @@ func (scope *EvalScope) ChanGoroutines(e
 	return goids, nil
 }
 
-// Locals returns all variables in 'scope'.
-func (scope *EvalScope) Locals(flags localsFlags) ([]*Variable, error) {
+// Locals returns all variables in 'scope' named wantedName, or all of them
+// if wantedName is "".
+// If scope is the scope for a range-over-func closure body it will merge in
+// the scopes of the enclosing functions.
+func (scope *EvalScope) Locals(flags localsFlags, wantedName string) ([]*Variable, error) {
+	var scopes [][]*Variable
+	filter := func(vars []*Variable) []*Variable {
+		if wantedName == "" || vars == nil {
+			return vars
+		}
+		vars2 := []*Variable{}
+		for _, v := range vars {
+			if v.Name == wantedName {
+				vars2 = append(vars2, v)
+			}
+		}
+		return vars2
+	}
+
+	vars0, err := scope.simpleLocals(flags, wantedName)
+	if err != nil {
+		return nil, err
+	}
+	vars0 = filter(vars0)
+	if scope.Fn.extra(scope.BinInfo).rangeParent == nil || scope.target == nil || scope.g == nil {
+		return vars0, nil
+	}
+	if wantedName != "" && len(vars0) > 0 {
+		return vars0, nil
+	}
+
+	scopes = append(scopes, vars0)
+
+	if scope.rangeFrames == nil {
+		err := scope.setupRangeFrames()
+		if err != nil {
+			return nil, err
+		}
+	}
+	for i, scope2 := range scope.enclosingRangeScopes {
+		if scope2 == nil {
+			scope2 = FrameToScope(scope.target, scope.target.Memory(), scope.g, scope.threadID, scope.rangeFrames[2*i:]...)
+			scope.enclosingRangeScopes[i] = scope2
+		}
+		vars, err := scope2.simpleLocals(flags, wantedName)
+		if err != nil {
+			return nil, err
+		}
+		vars = filter(vars)
+		scopes = append(scopes, vars)
+		if wantedName != "" && len(vars) > 0 {
+			return vars, nil
+		}
+	}
+
+	vars := []*Variable{}
+	for i := len(scopes) - 1; i >= 0; i-- {
+		vars = append(vars, scopes[i]...)
+	}
+
+	// Apply shadowning
+	lvn := map[string]*Variable{}
+	for _, v := range vars {
+		if otherv := lvn[v.Name]; otherv != nil {
+			otherv.Flags |= VariableShadowed
+		}
+		lvn[v.Name] = v
+	}
+	return vars, nil
+}
+
+func (scope *EvalScope) setupRangeFrames() error {
+	var err error
+	scope.rangeFrames, err = rangeFuncStackTrace(scope.target, scope.g)
+	if err != nil {
+		return err
+	}
+	scope.rangeFrames = scope.rangeFrames[2:] // skip the first frame and its return frame
+	scope.enclosingRangeScopes = make([]*EvalScope, len(scope.rangeFrames)/2)
+	return nil
+}
+
+// simpleLocals returns all local variables in 'scope'.
+// This function does not try to merge the scopes of range-over-func closure
+// bodies with their enclosing function, for that use (*EvalScope).Locals or
+// (*EvalScope).FindLocal instead.
+// If wantedName is specified only variables called wantedName or "&"+wantedName are returned.
+func (scope *EvalScope) simpleLocals(flags localsFlags, wantedName string) ([]*Variable, error) {
 	if scope.Fn == nil {
 		return nil, errors.New("unable to find function context")
 	}
 
+	if scope.image().Stripped() {
+		return nil, errors.New("unable to find locals: no debug information present in binary")
+	}
+
 	trustArgOrder := (flags&localsTrustArgOrder != 0) && scope.BinInfo.Producer() != "" && goversion.ProducerAfterOrEqual(scope.BinInfo.Producer(), 1, 12) && scope.Fn != nil && (scope.PC == scope.Fn.Entry)
 
 	dwarfTree, err := scope.image().getDwarfTree(scope.Fn.offset)
@@ -378,7 +403,7 @@ func (scope *EvalScope) Locals(flags loc
 		return nil, err
 	}
 
-	variablesFlags := reader.VariablesOnlyVisible
+	variablesFlags := reader.VariablesOnlyVisible | reader.VariablesSkipInlinedSubroutines
 	if flags&localsNoDeclLineCheck != 0 {
 		variablesFlags = reader.VariablesNoDeclLineCheck
 	}
@@ -390,29 +415,29 @@ func (scope *EvalScope) Locals(flags loc
 
 	// look for dictionary entry
 	if scope.dictAddr == 0 {
-		for _, entry := range varEntries {
-			name, _ := entry.Val(dwarf.AttrName).(string)
-			if name == goDictionaryName {
-				dictVar, err := extractVarInfoFromEntry(scope.target, scope.BinInfo, scope.image(), scope.Regs, scope.Mem, entry.Tree, 0)
-				if err != nil {
-					logflags.DebuggerLogger().Errorf("could not load %s variable: %v", name, err)
-				} else if dictVar.Unreadable != nil {
-					logflags.DebuggerLogger().Errorf("could not load %s variable: %v", name, dictVar.Unreadable)
-				} else {
-					scope.dictAddr, err = readUintRaw(dictVar.mem, dictVar.Addr, int64(scope.BinInfo.Arch.PtrSize()))
-					if err != nil {
-						logflags.DebuggerLogger().Errorf("could not load %s variable: %v", name, err)
-					}
-				}
-				break
-			}
-		}
+		scope.dictAddr = readLocalPtrVar(dwarfTree, goDictionaryName, scope.target, scope.BinInfo, scope.image(), scope.Regs, scope.Mem)
 	}
 
 	vars := make([]*Variable, 0, len(varEntries))
 	depths := make([]int, 0, len(varEntries))
 	for _, entry := range varEntries {
-		if name, _ := entry.Val(dwarf.AttrName).(string); name == goDictionaryName {
+		name, _ := entry.Val(dwarf.AttrName).(string)
+		switch {
+		case wantedName != "":
+			if name != wantedName && name != "&"+wantedName {
+				continue
+			}
+		case flags&localsOnlyRangeBodyClosures != 0:
+			if !strings.HasPrefix(name, "#yield") && !strings.HasPrefix(name, "&#yield") {
+				continue
+			}
+		default:
+			if name == goDictionaryName || name == goClosurePtr || strings.HasPrefix(name, "#yield") || strings.HasPrefix(name, "&#yield") {
+				continue
+			}
+		}
+		if scope.Fn.rangeParentName() != "" && (strings.HasPrefix(name, "~") || entry.Val(godwarf.AttrGoClosureOffset) != nil) {
+			// Skip unnamed parameters and closure variables for range-over-func closure bodies
 			continue
 		}
 		val, err := extractVarInfoFromEntry(scope.target, scope.BinInfo, scope.image(), scope.Regs, scope.Mem, entry.Tree, scope.dictAddr)
@@ -458,7 +483,7 @@ func (scope *EvalScope) Locals(flags loc
 			declLine := v.DeclLine
 			v = v.maybeDereference()
 			if v.Addr == 0 && v.Unreadable == nil {
-				v.Unreadable = fmt.Errorf("no address for escaped variable")
+				v.Unreadable = errors.New("no address for escaped variable")
 			}
 			v.Name = name[1:]
 			v.Flags |= VariableEscaped
@@ -489,6 +514,31 @@ func afterLastArgAddr(vars []*Variable)
 	return 0
 }
 
+// readLocalPtrVar reads the value of the local pointer variable vname. This
+// is a low level helper function, it does not support nested scopes, range
+// resolution across range bodies, type parameters, &c...
+func readLocalPtrVar(dwarfTree *godwarf.Tree, vname string, tgt *Target, bi *BinaryInfo, image *Image, regs op.DwarfRegisters, mem MemoryReadWriter) uint64 {
+	for _, entry := range dwarfTree.Children {
+		name, _ := entry.Val(dwarf.AttrName).(string)
+		if name == vname {
+			v, err := extractVarInfoFromEntry(tgt, bi, image, regs, mem, entry, 0)
+			if err != nil {
+				logflags.DebuggerLogger().Errorf("could not load %s variable: %v", name, err)
+			} else if v.Unreadable != nil {
+				logflags.DebuggerLogger().Errorf("could not load %s variable: %v", name, v.Unreadable)
+			} else {
+				r, err := readUintRaw(v.mem, v.Addr, int64(bi.Arch.PtrSize()))
+				if err != nil {
+					logflags.DebuggerLogger().Errorf("could not load %s variable: %v", name, err)
+				}
+				return r
+			}
+			break
+		}
+	}
+	return 0
+}
+
 // setValue writes the value of srcv to dstv.
 //   - If srcv is a numerical literal constant and srcv is of a compatible type
 //     the necessary type conversion is performed.
@@ -590,7 +640,7 @@ func (scope *EvalScope) SetVariable(name
 
 // LocalVariables returns all local variables from the current function scope.
 func (scope *EvalScope) LocalVariables(cfg LoadConfig) ([]*Variable, error) {
-	vars, err := scope.Locals(0)
+	vars, err := scope.Locals(0, "")
 	if err != nil {
 		return nil, err
 	}
@@ -604,7 +654,7 @@ func (scope *EvalScope) LocalVariables(c
 
 // FunctionArguments returns the name, value, and type of all current function arguments.
 func (scope *EvalScope) FunctionArguments(cfg LoadConfig) ([]*Variable, error) {
-	vars, err := scope.Locals(0)
+	vars, err := scope.Locals(0, "")
 	if err != nil {
 		return nil, err
 	}
@@ -676,7 +726,20 @@ func (scope *EvalScope) findGlobal(pkgNa
 	if err != nil || v != nil {
 		return v, err
 	}
-	return nil, fmt.Errorf("could not find symbol value for %s.%s", pkgName, varName)
+	return nil, &errCouldNotFindSymbol{fmt.Sprintf("%s.%s", pkgName, varName)}
+}
+
+type errCouldNotFindSymbol struct {
+	name string
+}
+
+func (e *errCouldNotFindSymbol) Error() string {
+	return fmt.Sprintf("could not find symbol %s", e.name)
+}
+
+func isSymbolNotFound(e error) bool {
+	var e2 *errCouldNotFindSymbol
+	return errors.As(e, &e2)
 }
 
 func (scope *EvalScope) findGlobalInternal(name string) (*Variable, error) {
@@ -841,6 +904,8 @@ func (stack *evalStack) resume(g *G) {
 	scope.Regs.FrameBase = stack.fboff + int64(scope.g.stack.hi)
 	scope.Regs.CFA = scope.frameOffset + int64(scope.g.stack.hi)
 	stack.curthread = g.Thread
+	scope.rangeFrames = nil
+	scope.enclosingRangeScopes = nil
 
 	finished := funcCallStep(scope, stack, g.Thread)
 	if finished {
@@ -956,6 +1021,16 @@ func (stack *evalStack) executeOp() {
 	case *evalop.PushFrameoff:
 		stack.push(newConstant(constant.MakeInt64(scope.frameOffset), scope.Mem))
 
+	case *evalop.PushRangeParentOffset:
+		if scope.rangeFrames == nil {
+			stack.err = scope.setupRangeFrames()
+		}
+		if len(scope.rangeFrames) > 0 {
+			stack.push(newConstant(constant.MakeInt64(scope.rangeFrames[len(scope.rangeFrames)-2].FrameOffset()), scope.Mem))
+		} else {
+			stack.push(newConstant(constant.MakeInt64(0), scope.Mem))
+		}
+
 	case *evalop.PushThreadID:
 		stack.push(newConstant(constant.MakeInt64(int64(scope.threadID)), scope.Mem))
 
@@ -963,30 +1038,7 @@ func (stack *evalStack) executeOp() {
 		stack.push(newConstant(op.Value, scope.Mem))
 
 	case *evalop.PushLocal:
-		var vars []*Variable
-		var err error
-		if op.Frame != 0 {
-			frameScope, err2 := ConvertEvalScope(scope.target, -1, int(op.Frame), 0)
-			if err2 != nil {
-				stack.err = err2
-				return
-			}
-			vars, err = frameScope.Locals(0)
-		} else {
-			vars, err = scope.Locals(0)
-		}
-		if err != nil {
-			stack.err = err
-			return
-		}
-		found := false
-		for i := range vars {
-			if vars[i].Name == op.Name && vars[i].Flags&VariableShadowed == 0 {
-				stack.push(vars[i])
-				found = true
-				break
-			}
-		}
+		found := stack.pushLocal(scope, op.Name, op.Frame)
 		if !found {
 			stack.err = fmt.Errorf("could not find symbol value for %s", op.Name)
 		}
@@ -994,52 +1046,39 @@ func (stack *evalStack) executeOp() {
 	case *evalop.PushNil:
 		stack.push(nilVariable)
 
-	case *evalop.PushRegister:
-		reg := scope.Regs.Reg(uint64(op.Regnum))
-		if reg == nil {
-			stack.err = fmt.Errorf("could not find symbol value for %s", op.Regname)
+	case *evalop.PushPackageVarOrSelect:
+		v, err := scope.findGlobal(op.Name, op.Sel)
+		if err != nil && !isSymbolNotFound(err) {
+			stack.err = err
 			return
 		}
-		reg.FillBytes()
-
-		var typ godwarf.Type
-		if len(reg.Bytes) <= 8 {
-			typ = godwarf.FakeBasicType("uint", 64)
+		if v != nil {
+			stack.push(v)
 		} else {
-			var err error
-			typ, err = scope.BinInfo.findType("string")
-			if err != nil {
-				stack.err = err
+			if op.NameIsString {
+				stack.err = fmt.Errorf("%q (type string) is not a struct", op.Name)
+				return
+			}
+			found := stack.pushIdent(scope, op.Name)
+			if stack.err != nil {
 				return
 			}
+			if found {
+				scope.evalStructSelector(&evalop.Select{Name: op.Sel}, stack)
+			} else {
+				stack.err = fmt.Errorf("could not find symbol value for %s", op.Name)
+			}
 		}
 
-		v := newVariable(op.Regname, 0, typ, scope.BinInfo, scope.Mem)
-		if v.Kind == reflect.String {
-			v.Len = int64(len(reg.Bytes) * 2)
-			v.Base = fakeAddressUnresolv
+	case *evalop.PushIdent:
+		found := stack.pushIdent(scope, op.Name)
+		if !found {
+			stack.err = fmt.Errorf("could not find symbol value for %s", op.Name)
 		}
-		v.Addr = fakeAddressUnresolv
-		v.Flags = VariableCPURegister
-		v.reg = reg
-		stack.push(v)
 
-	case *evalop.PushPackageVar:
-		pkgName := op.PkgName
-		replaceName := false
-		if pkgName == "" {
-			replaceName = true
-			pkgName = scope.Fn.PackageName()
-		}
-		v, err := scope.findGlobal(pkgName, op.Name)
-		if err != nil {
-			stack.err = err
-			return
-		}
-		if replaceName {
-			v.Name = op.Name
-		}
-		stack.push(v)
+	case *evalop.PushLen:
+		v := stack.peek()
+		stack.push(newConstant(constant.MakeInt64(v.Len), scope.Mem))
 
 	case *evalop.Select:
 		scope.evalStructSelector(op, stack)
@@ -1108,8 +1147,11 @@ func (stack *evalStack) executeOp() {
 		stack.fncallPeek().undoInjection = nil
 		stack.callInjectionContinue = true
 
-	case *evalop.CallInjectionAllocString:
-		stack.callInjectionContinue = scope.allocString(op.Phase, stack, curthread)
+	case *evalop.CallInjectionStartSpecial:
+		stack.callInjectionContinue = scope.callInjectionStartSpecial(stack, op, curthread)
+
+	case *evalop.ConvertAllocToString:
+		scope.convertAllocToString(stack)
 
 	case *evalop.SetValue:
 		lhv := stack.pop()
@@ -1123,6 +1165,98 @@ func (stack *evalStack) executeOp() {
 	stack.opidx++
 }
 
+func (stack *evalStack) pushLocal(scope *EvalScope, name string, frame int64) (found bool) {
+	var vars []*Variable
+	var err error
+	if frame != 0 {
+		frameScope, err2 := ConvertEvalScope(scope.target, -1, int(frame), 0)
+		if err2 != nil {
+			stack.err = err2
+			return
+		}
+		vars, err = frameScope.Locals(0, name)
+	} else {
+		vars, err = scope.Locals(0, name)
+	}
+	if err != nil {
+		stack.err = err
+		return
+	}
+	found = false
+	for i := range vars {
+		if vars[i].Name == name && vars[i].Flags&VariableShadowed == 0 {
+			stack.push(vars[i])
+			found = true
+			break
+		}
+	}
+	return found
+}
+
+func (stack *evalStack) pushIdent(scope *EvalScope, name string) (found bool) {
+	found = stack.pushLocal(scope, name, 0)
+	if found || stack.err != nil {
+		return found
+	}
+	v, err := scope.findGlobal(scope.Fn.PackageName(), name)
+	if err != nil && !isSymbolNotFound(err) {
+		stack.err = err
+		return false
+	}
+	if v != nil {
+		v.Name = name
+		stack.push(v)
+		return true
+	}
+
+	switch name {
+	case "true", "false":
+		stack.push(newConstant(constant.MakeBool(name == "true"), scope.Mem))
+		return true
+	case "nil":
+		stack.push(nilVariable)
+		return true
+	}
+
+	regname := validRegisterName(name)
+	if regname == "" {
+		return false
+	}
+	regnum, ok := scope.BinInfo.Arch.RegisterNameToDwarf(regname)
+	if !ok {
+		return false
+	}
+
+	reg := scope.Regs.Reg(uint64(regnum))
+	if reg == nil {
+		return
+	}
+	reg.FillBytes()
+
+	var typ godwarf.Type
+	if len(reg.Bytes) <= 8 {
+		typ = godwarf.FakeBasicType("uint", 64)
+	} else {
+		var err error
+		typ, err = scope.BinInfo.findType("string")
+		if err != nil {
+			stack.err = err
+			return false
+		}
+	}
+
+	v = newVariable(regname, 0, typ, scope.BinInfo, scope.Mem)
+	if v.Kind == reflect.String {
+		v.Len = int64(len(reg.Bytes) * 2)
+		v.Base = fakeAddressUnresolv
+	}
+	v.Addr = fakeAddressUnresolv
+	v.Flags = VariableCPURegister
+	v.reg = reg
+	stack.push(v)
+	return true
+}
+
 func (scope *EvalScope) evalAST(t ast.Expr) (*Variable, error) {
 	ops, err := evalop.CompileAST(scopeToEvalLookup{scope}, t)
 	if err != nil {
@@ -1151,6 +1285,14 @@ func (scope *EvalScope) evalJump(op *eva
 		v = true
 	case evalop.JumpIfFalse:
 		v = false
+	case evalop.JumpIfAllocStringChecksFail:
+		stringChecksFailed := x.Kind != reflect.String || x.Addr != 0 || x.Flags&VariableConstant == 0 || x.Len <= 0
+		nilCallCtx := scope.callCtx == nil // do not complain here, setValue will if no other errors happen
+		if stringChecksFailed || nilCallCtx {
+			stack.opidx = op.Target - 1
+			return
+		}
+		return
 	}
 
 	if x.Kind != reflect.Bool {
@@ -1908,13 +2050,13 @@ func (scope *EvalScope) evalReslice(op *
 		return
 	case reflect.Map:
 		if op.Node.High != nil {
-			stack.err = fmt.Errorf("second slice argument must be empty for maps")
+			stack.err = errors.New("second slice argument must be empty for maps")
 			return
 		}
 		xev.mapSkip += int(low)
 		xev.mapIterator() // reads map length
 		if int64(xev.mapSkip) >= xev.Len {
-			stack.err = fmt.Errorf("map index out of bounds")
+			stack.err = errors.New("map index out of bounds")
 			return
 		}
 		stack.push(xev)
@@ -1941,7 +2083,7 @@ func (scope *EvalScope) evalPointerDeref
 	}
 
 	if xev == nilVariable {
-		stack.err = fmt.Errorf("nil can not be dereferenced")
+		stack.err = errors.New("nil can not be dereferenced")
 		return
 	}
 
@@ -1961,7 +2103,7 @@ func (scope *EvalScope) evalPointerDeref
 	}
 	rv := &xev.Children[0]
 	if rv.Addr == 0 {
-		stack.err = fmt.Errorf("nil pointer dereference")
+		stack.err = errors.New("nil pointer dereference")
 		return
 	}
 	stack.push(rv)
@@ -2075,7 +2217,7 @@ func negotiateType(op token.Token, xv, y
 			// ok
 		case reflect.Int, reflect.Int8, reflect.Int16, reflect.Int32, reflect.Int64:
 			if constant.Sign(yv.Value) < 0 {
-				return nil, fmt.Errorf("shift count must not be negative")
+				return nil, errors.New("shift count must not be negative")
 			}
 		default:
 			return nil, fmt.Errorf("shift count type %s, must be unsigned integer", yv.Kind.String())
@@ -2243,7 +2385,7 @@ func compareOp(op token.Token, xv *Varia
 			yv.loadValue(loadFullValueLongerStrings)
 		}
 		if int64(len(constant.StringVal(xv.Value))) != xv.Len || int64(len(constant.StringVal(yv.Value))) != yv.Len {
-			return false, fmt.Errorf("string too long for comparison")
+			return false, errors.New("string too long for comparison")
 		}
 		return constantCompare(op, xv.Value, yv.Value)
 	}
@@ -2278,7 +2420,7 @@ func compareOp(op token.Token, xv *Varia
 		eql = xv.Children[0].Addr == yv.Children[0].Addr
 	case reflect.Array:
 		if int64(len(xv.Children)) != xv.Len || int64(len(yv.Children)) != yv.Len {
-			return false, fmt.Errorf("array too long for comparison")
+			return false, errors.New("array too long for comparison")
 		}
 		eql, err = equalChildren(xv, yv, true)
 	case reflect.Struct:
@@ -2286,7 +2428,7 @@ func compareOp(op token.Token, xv *Varia
 			return false, nil
 		}
 		if int64(len(xv.Children)) != xv.Len || int64(len(yv.Children)) != yv.Len {
-			return false, fmt.Errorf("structure too deep for comparison")
+			return false, errors.New("structure too deep for comparison")
 		}
 		eql, err = equalChildren(xv, yv, false)
 	case reflect.Slice, reflect.Map, reflect.Func, reflect.Chan:
@@ -2473,13 +2615,13 @@ func (v *Variable) sliceAccess(idx int)
 		wrong = idx < 0
 	}
 	if wrong {
-		return nil, fmt.Errorf("index out of bounds")
+		return nil, errors.New("index out of bounds")
 	}
 	if v.loaded {
 		if v.Kind == reflect.String {
 			s := constant.StringVal(v.Value)
 			if idx >= len(s) {
-				return nil, fmt.Errorf("index out of bounds")
+				return nil, errors.New("index out of bounds")
 			}
 			r := v.newVariable("", v.Base+uint64(int64(idx)*v.stride), v.fieldType, v.mem)
 			r.loaded = true
@@ -2487,7 +2629,7 @@ func (v *Variable) sliceAccess(idx int)
 			return r, nil
 		} else {
 			if idx >= len(v.Children) {
-				return nil, fmt.Errorf("index out of bounds")
+				return nil, errors.New("index out of bounds")
 			}
 			return &v.Children[idx], nil
 		}
@@ -2538,7 +2680,7 @@ func (v *Variable) mapAccess(idx *Variab
 		return nil, v.Unreadable
 	}
 	// go would return zero for the map value type here, we do not have the ability to create zeroes
-	return nil, fmt.Errorf("key not found")
+	return nil, errors.New("key not found")
 }
 
 // LoadResliced returns a new array, slice or map that starts at index start and contains
@@ -2560,7 +2702,7 @@ func (v *Variable) LoadResliced(start in
 		newV.loaded = false
 		newV.mapSkip = start
 	default:
-		return nil, fmt.Errorf("variable to reslice is not an array, slice, or map")
+		return nil, errors.New("variable to reslice is not an array, slice, or map")
 	}
 	newV.loadValue(cfg)
 	return newV, nil
@@ -2579,14 +2721,14 @@ func (v *Variable) reslice(low int64, hi
 		cptrNeedsFakeSlice = v.Kind != reflect.String
 	}
 	if wrong {
-		return nil, fmt.Errorf("index out of bounds")
+		return nil, errors.New("index out of bounds")
 	}
 
 	base := v.Base + uint64(low*v.stride)
 	len := high - low
 
 	if high-low < 0 {
-		return nil, fmt.Errorf("index out of bounds")
+		return nil, errors.New("index out of bounds")
 	}
 
 	typ := v.DwarfType
diff -pruN 1.22.1-1/pkg/proc/evalop/eval_go117.go 1.23.0-1/pkg/proc/evalop/eval_go117.go
--- 1.22.1-1/pkg/proc/evalop/eval_go117.go	2024-02-21 20:29:06.000000000 +0000
+++ 1.23.0-1/pkg/proc/evalop/eval_go117.go	1970-01-01 00:00:00.000000000 +0000
@@ -1,9 +0,0 @@
-//go:build !go1.18
-
-package evalop
-
-import "go/ast"
-
-type astIndexListExpr struct {
-	ast.Expr
-}
diff -pruN 1.22.1-1/pkg/proc/evalop/eval_go118.go 1.23.0-1/pkg/proc/evalop/eval_go118.go
--- 1.22.1-1/pkg/proc/evalop/eval_go118.go	2024-02-21 20:29:06.000000000 +0000
+++ 1.23.0-1/pkg/proc/evalop/eval_go118.go	1970-01-01 00:00:00.000000000 +0000
@@ -1,7 +0,0 @@
-//go:build go1.18
-
-package evalop
-
-import "go/ast"
-
-type astIndexListExpr = ast.IndexListExpr
diff -pruN 1.22.1-1/pkg/proc/evalop/evalcompile.go 1.23.0-1/pkg/proc/evalop/evalcompile.go
--- 1.22.1-1/pkg/proc/evalop/evalcompile.go	2024-02-21 20:29:06.000000000 +0000
+++ 1.23.0-1/pkg/proc/evalop/evalcompile.go	2024-07-16 18:44:48.000000000 +0000
@@ -30,10 +30,7 @@ type compileCtx struct {
 
 type evalLookup interface {
 	FindTypeExpr(ast.Expr) (godwarf.Type, error)
-	HasLocal(string) bool
-	HasGlobal(string, string) bool
 	HasBuiltin(string) bool
-	LookupRegisterName(string) (int, bool)
 }
 
 // CompileAST compiles the expression t into a list of instructions.
@@ -112,9 +109,38 @@ func CompileSet(lookup evalLookup, lhexp
 }
 
 func (ctx *compileCtx) compileAllocLiteralString() {
-	ctx.pushOp(&CallInjectionAllocString{Phase: 0})
-	ctx.pushOp(&CallInjectionAllocString{Phase: 1})
-	ctx.pushOp(&CallInjectionAllocString{Phase: 2})
+	jmp := &Jump{When: JumpIfAllocStringChecksFail}
+	ctx.pushOp(jmp)
+
+	ctx.compileSpecialCall("runtime.mallocgc", []ast.Expr{
+		&ast.BasicLit{Kind: token.INT, Value: "0"},
+		&ast.Ident{Name: "nil"},
+		&ast.Ident{Name: "false"},
+	}, []Op{
+		&PushLen{},
+		&PushNil{},
+		&PushConst{constant.MakeBool(false)},
+	})
+
+	ctx.pushOp(&ConvertAllocToString{})
+	jmp.Target = len(ctx.ops)
+}
+
+func (ctx *compileCtx) compileSpecialCall(fnname string, argAst []ast.Expr, args []Op) {
+	id := ctx.curCall
+	ctx.curCall++
+	ctx.pushOp(&CallInjectionStartSpecial{
+		id:     id,
+		FnName: fnname,
+		ArgAst: argAst})
+	ctx.pushOp(&CallInjectionSetTarget{id: id})
+
+	for i := range args {
+		ctx.pushOp(args[i])
+		ctx.pushOp(&CallInjectionCopyArg{id: id, ArgNum: i})
+	}
+
+	ctx.pushOp(&CallInjectionComplete{id: id})
 }
 
 func (ctx *compileCtx) pushOp(op Op) {
@@ -192,15 +218,11 @@ func (ctx *compileCtx) compileAST(t ast.
 			case x.Name == "runtime" && node.Sel.Name == "threadid":
 				ctx.pushOp(&PushThreadID{})
 
-			case ctx.HasLocal(x.Name):
-				ctx.pushOp(&PushLocal{Name: x.Name})
-				ctx.pushOp(&Select{node.Sel.Name})
-
-			case ctx.HasGlobal(x.Name, node.Sel.Name):
-				ctx.pushOp(&PushPackageVar{x.Name, node.Sel.Name})
+			case x.Name == "runtime" && node.Sel.Name == "rangeParentOffset":
+				ctx.pushOp(&PushRangeParentOffset{})
 
 			default:
-				return ctx.compileUnary(node.X, &Select{node.Sel.Name})
+				ctx.pushOp(&PushPackageVarOrSelect{Name: x.Name, Sel: node.Sel.Name})
 			}
 
 		case *ast.CallExpr:
@@ -229,15 +251,10 @@ func (ctx *compileCtx) compileAST(t ast.
 			if err != nil {
 				return err
 			}
-			if ctx.HasGlobal(s, node.Sel.Name) {
-				ctx.pushOp(&PushPackageVar{s, node.Sel.Name})
-				return nil
-			}
-			return ctx.compileUnary(node.X, &Select{node.Sel.Name})
+			ctx.pushOp(&PushPackageVarOrSelect{Name: s, Sel: node.Sel.Name, NameIsString: true})
 
 		default:
 			return ctx.compileUnary(node.X, &Select{node.Sel.Name})
-
 		}
 
 	case *ast.TypeAssertExpr: // <expression>.(<type>)
@@ -248,7 +265,7 @@ func (ctx *compileCtx) compileAST(t ast.
 
 	case *ast.SliceExpr:
 		if node.Slice3 {
-			return fmt.Errorf("3-index slice expressions not supported")
+			return errors.New("3-index slice expressions not supported")
 		}
 		return ctx.compileReslice(node)
 
@@ -339,13 +356,10 @@ func (ctx *compileCtx) compileTypeCastOr
 		}
 		return ctx.compileFunctionCall(node)
 	case *ast.Ident:
-		if ctx.HasBuiltin(n.Name) {
-			return ctx.compileFunctionCall(node)
+		if typ, _ := ctx.FindTypeExpr(n); typ != nil {
+			return ctx.compileTypeCast(node, fmt.Errorf("could not find symbol value for %s", n.Name))
 		}
-		if ctx.HasGlobal("", n.Name) || ctx.HasLocal(n.Name) {
-			return ctx.compileFunctionCall(node)
-		}
-		return ctx.compileTypeCast(node, fmt.Errorf("could not find symbol value for %s", n.Name))
+		return ctx.compileFunctionCall(node)
 	case *ast.IndexExpr:
 		// Ambiguous, could be a parametric type
 		switch n.X.(type) {
@@ -359,7 +373,7 @@ func (ctx *compileCtx) compileTypeCastOr
 		default:
 			return ctx.compileFunctionCall(node)
 		}
-	case *astIndexListExpr:
+	case *ast.IndexListExpr:
 		return ctx.compileTypeCast(node, nil)
 	default:
 		// All other expressions must be function calls
@@ -410,25 +424,7 @@ func (ctx *compileCtx) compileBuiltinCal
 }
 
 func (ctx *compileCtx) compileIdent(node *ast.Ident) error {
-	switch {
-	case ctx.HasLocal(node.Name):
-		ctx.pushOp(&PushLocal{Name: node.Name})
-	case ctx.HasGlobal("", node.Name):
-		ctx.pushOp(&PushPackageVar{"", node.Name})
-	case node.Name == "true" || node.Name == "false":
-		ctx.pushOp(&PushConst{constant.MakeBool(node.Name == "true")})
-	case node.Name == "nil":
-		ctx.pushOp(&PushNil{})
-	default:
-		found := false
-		if regnum, ok := ctx.LookupRegisterName(node.Name); ok {
-			ctx.pushOp(&PushRegister{regnum, node.Name})
-			found = true
-		}
-		if !found {
-			return fmt.Errorf("could not find symbol value for %s", node.Name)
-		}
-	}
+	ctx.pushOp(&PushIdent{node.Name})
 	return nil
 }
 
diff -pruN 1.22.1-1/pkg/proc/evalop/ops.go 1.23.0-1/pkg/proc/evalop/ops.go
--- 1.22.1-1/pkg/proc/evalop/ops.go	2024-02-21 20:29:06.000000000 +0000
+++ 1.23.0-1/pkg/proc/evalop/ops.go	2024-07-16 18:44:48.000000000 +0000
@@ -30,6 +30,12 @@ type PushThreadID struct {
 
 func (*PushThreadID) depthCheck() (npop, npush int) { return 0, 1 }
 
+// PushRangeParentOffset pushes the frame offset of the range-over-func closure body parent.
+type PushRangeParentOffset struct {
+}
+
+func (*PushRangeParentOffset) depthCheck() (npop, npush int) { return 0, 1 }
+
 // PushConst pushes a constant on the stack.
 type PushConst struct {
 	Value constant.Value
@@ -45,26 +51,36 @@ type PushLocal struct {
 
 func (*PushLocal) depthCheck() (npop, npush int) { return 0, 1 }
 
-// PushNil pushes an untyped nil on the stack.
-type PushNil struct {
+// PushIdent pushes a local or global variable or a predefined identifier
+// (true, false, etc) or the value of a register on the stack.
+type PushIdent struct {
+	Name string
 }
 
-func (*PushNil) depthCheck() (npop, npush int) { return 0, 1 }
+func (*PushIdent) depthCheck() (npop, npush int) { return 0, 1 }
+
+// PushPackageVarOrSelect pushes the value of Name.Sel on the stack, which
+// could either be a global variable (with the package name specified), or a
+// field of a local variable.
+type PushPackageVarOrSelect struct {
+	Name, Sel    string
+	NameIsString bool
+}
+
+func (*PushPackageVarOrSelect) depthCheck() (npop, npush int) { return 0, 1 }
 
-// PushRegister pushes the CPU register Regnum on the stack.
-type PushRegister struct {
-	Regnum  int
-	Regname string
+// PushNil pushes an untyped nil on the stack.
+type PushNil struct {
 }
 
-func (*PushRegister) depthCheck() (npop, npush int) { return 0, 1 }
+func (*PushNil) depthCheck() (npop, npush int) { return 0, 1 }
 
-// PushPackageVar pushes a package variable on the stack.
-type PushPackageVar struct {
-	PkgName, Name string // if PkgName == "" use current function's package
+// PushLen pushes the length of the variable at the top of the stack into
+// the stack.
+type PushLen struct {
 }
 
-func (*PushPackageVar) depthCheck() (npop, npush int) { return 0, 1 }
+func (*PushLen) depthCheck() (npop, npush int) { return 1, 2 }
 
 // Select replaces the topmost stack variable v with v.Name.
 type Select struct {
@@ -160,6 +176,7 @@ type JumpCond uint8
 const (
 	JumpIfFalse JumpCond = iota
 	JumpIfTrue
+	JumpIfAllocStringChecksFail
 )
 
 // Binary pops two variables from the stack, applies the specified binary
@@ -229,20 +246,24 @@ type CallInjectionComplete struct {
 
 func (*CallInjectionComplete) depthCheck() (npop, npush int) { return 0, 1 }
 
-// CallInjectionAllocString uses the call injection protocol to allocate the
-// value of a string literal somewhere on the target's memory so that it can
-// be assigned to a variable (or passed to a function).
-// There are three phases to CallInjectionAllocString, distinguished by the
-// Phase field. They must always appear in sequence in the program:
-//
-//	CallInjectionAllocString{Phase: 0}
-//	CallInjectionAllocString{Phase: 1}
-//	CallInjectionAllocString{Phase: 2}
-type CallInjectionAllocString struct {
-	Phase int
+// CallInjectionStartSpecial starts call injection for a function with a
+// name and arguments known at compile time.
+type CallInjectionStartSpecial struct {
+	id     int
+	FnName string
+	ArgAst []ast.Expr
+}
+
+func (*CallInjectionStartSpecial) depthCheck() (npop, npush int) { return 0, 1 }
+
+// ConvertAllocToString pops two variables from the stack, a constant string
+// and the return value of runtime.mallocgc (mallocv), copies the contents
+// of the string at the address in mallocv and pushes on the stack a new
+// string value that uses the backing storage of mallocv.
+type ConvertAllocToString struct {
 }
 
-func (op *CallInjectionAllocString) depthCheck() (npop, npush int) { return 1, 1 }
+func (*ConvertAllocToString) depthCheck() (npop, npush int) { return 2, 1 }
 
 // SetValue pops to variables from the stack, lhv and rhv, and sets lhv to
 // rhv.
diff -pruN 1.22.1-1/pkg/proc/fncall.go 1.23.0-1/pkg/proc/fncall.go
--- 1.22.1-1/pkg/proc/fncall.go	2024-02-21 20:29:06.000000000 +0000
+++ 1.23.0-1/pkg/proc/fncall.go	2024-07-16 18:44:48.000000000 +0000
@@ -7,7 +7,6 @@ import (
 	"fmt"
 	"go/ast"
 	"go/constant"
-	"go/token"
 	"reflect"
 	"sort"
 	"strconv"
@@ -532,13 +531,14 @@ type funcCallArg struct {
 func funcCallCopyOneArg(scope *EvalScope, fncall *functionCallState, actualArg *Variable, formalArg *funcCallArg, thread Thread) error {
 	if scope.callCtx.checkEscape {
 		//TODO(aarzilli): only apply the escapeCheck to leaking parameters.
-		if err := escapeCheck(actualArg, formalArg.name, scope.g.stack); err != nil {
-			return fmt.Errorf("cannot use %s as argument %s in function %s: %v", actualArg.Name, formalArg.name, fncall.fn.Name, err)
-		}
-		for _, stack := range scope.callCtx.stacks {
-			if err := escapeCheck(actualArg, formalArg.name, stack); err != nil {
-				return fmt.Errorf("cannot use %s as argument %s in function %s: %v", actualArg.Name, formalArg.name, fncall.fn.Name, err)
+		err := allPointers(actualArg, formalArg.name, func(addr uint64, name string) error {
+			if !pointerEscapes(addr, scope.g.stack, scope.callCtx.stacks) {
+				return fmt.Errorf("cannot use %s as argument %s in function %s: stack object passed to escaping pointer: %s", actualArg.Name, formalArg.name, fncall.fn.Name, name)
 			}
+			return nil
+		})
+		if err != nil {
+			return err
 		}
 	}
 
@@ -691,7 +691,8 @@ func alignAddr(addr, align int64) int64
 	return (addr + align - 1) &^ (align - 1)
 }
 
-func escapeCheck(v *Variable, name string, stack stack) error {
+// allPointers calls f on every pointer contained in v
+func allPointers(v *Variable, name string, f func(addr uint64, name string) error) error {
 	if v.Unreadable != nil {
 		return fmt.Errorf("escape check for %s failed, variable unreadable: %v", name, v.Unreadable)
 	}
@@ -704,31 +705,31 @@ func escapeCheck(v *Variable, name strin
 		} else {
 			w = v.maybeDereference()
 		}
-		return escapeCheckPointer(w.Addr, name, stack)
+		return f(w.Addr, name)
 	case reflect.Chan, reflect.String, reflect.Slice:
-		return escapeCheckPointer(v.Base, name, stack)
+		return f(v.Base, name)
 	case reflect.Map:
 		sv := v.clone()
 		sv.RealType = resolveTypedef(&(v.RealType.(*godwarf.MapType).TypedefType))
 		sv = sv.maybeDereference()
-		return escapeCheckPointer(sv.Addr, name, stack)
+		return f(sv.Addr, name)
 	case reflect.Struct:
 		t := v.RealType.(*godwarf.StructType)
 		for _, field := range t.Field {
 			fv, _ := v.toField(field)
-			if err := escapeCheck(fv, fmt.Sprintf("%s.%s", name, field.Name), stack); err != nil {
+			if err := allPointers(fv, fmt.Sprintf("%s.%s", name, field.Name), f); err != nil {
 				return err
 			}
 		}
 	case reflect.Array:
 		for i := int64(0); i < v.Len; i++ {
 			sv, _ := v.sliceAccess(int(i))
-			if err := escapeCheck(sv, fmt.Sprintf("%s[%d]", name, i), stack); err != nil {
+			if err := allPointers(sv, fmt.Sprintf("%s[%d]", name, i), f); err != nil {
 				return err
 			}
 		}
 	case reflect.Func:
-		if err := escapeCheckPointer(v.funcvalAddr(), name, stack); err != nil {
+		if err := f(v.funcvalAddr(), name); err != nil {
 			return err
 		}
 	}
@@ -736,11 +737,16 @@ func escapeCheck(v *Variable, name strin
 	return nil
 }
 
-func escapeCheckPointer(addr uint64, name string, stack stack) error {
+func pointerEscapes(addr uint64, stack stack, stacks []stack) bool {
 	if addr >= stack.lo && addr < stack.hi {
-		return fmt.Errorf("stack object passed to escaping pointer: %s", name)
+		return false
 	}
-	return nil
+	for _, stack := range stacks {
+		if addr >= stack.lo && addr < stack.hi {
+			return false
+		}
+	}
+	return true
 }
 
 const (
@@ -849,7 +855,7 @@ func funcCallStep(callScope *EvalScope,
 			flags |= localsTrustArgOrder
 		}
 
-		fncall.retvars, err = retScope.Locals(flags)
+		fncall.retvars, err = retScope.Locals(flags, "")
 		if err != nil {
 			fncall.err = fmt.Errorf("could not get return values: %v", err)
 			break
@@ -986,92 +992,45 @@ func fakeFunctionEntryScope(scope *EvalS
 	return nil
 }
 
-func (scope *EvalScope) allocString(phase int, stack *evalStack, curthread Thread) bool {
-	switch phase {
-	case 0:
-		x := stack.peek()
-		if !(x.Kind == reflect.String && x.Addr == 0 && (x.Flags&VariableConstant) != 0 && x.Len > 0) {
-			stack.opidx += 2 // skip the next two allocString phases, we don't need to do an allocation
-			return false
-		}
-		if scope.callCtx == nil {
-			// do not complain here, setValue will if no other errors happen
-			stack.opidx += 2
-			return false
-		}
-		mallocv, err := scope.findGlobal("runtime", "mallocgc")
-		if mallocv == nil {
-			stack.err = err
-			return false
-		}
-		stack.push(mallocv)
-		scope.evalCallInjectionStart(&evalop.CallInjectionStart{HasFunc: true, Node: &ast.CallExpr{
-			Fun: &ast.SelectorExpr{
-				X:   &ast.Ident{Name: "runtime"},
-				Sel: &ast.Ident{Name: "mallocgc"},
-			},
-			Args: []ast.Expr{
-				&ast.BasicLit{Kind: token.INT, Value: "0"},
-				&ast.Ident{Name: "nil"},
-				&ast.Ident{Name: "false"},
-			},
-		}}, stack)
-		if stack.err == nil {
-			stack.pop() // return value of evalop.CallInjectionStart
-		}
-		return true
-
-	case 1:
-		fncall := stack.fncallPeek()
-		savedLoadCfg := scope.callCtx.retLoadCfg
-		scope.callCtx.retLoadCfg = loadFullValue
-		defer func() {
-			scope.callCtx.retLoadCfg = savedLoadCfg
-		}()
-
-		scope.evalCallInjectionSetTarget(nil, stack, curthread)
-
-		strvar := stack.peek()
-
-		stack.err = funcCallCopyOneArg(scope, fncall, newConstant(constant.MakeInt64(strvar.Len), scope.Mem), &fncall.formalArgs[0], curthread)
-		if stack.err != nil {
-			return false
-		}
-		stack.err = funcCallCopyOneArg(scope, fncall, nilVariable, &fncall.formalArgs[1], curthread)
-		if stack.err != nil {
-			return false
-		}
-		stack.err = funcCallCopyOneArg(scope, fncall, newConstant(constant.MakeBool(false), scope.Mem), &fncall.formalArgs[2], curthread)
-		if stack.err != nil {
-			return false
-		}
+func (scope *EvalScope) callInjectionStartSpecial(stack *evalStack, op *evalop.CallInjectionStartSpecial, curthread Thread) bool {
+	fnv, err := scope.findGlobalInternal(op.FnName)
+	if fnv == nil {
+		stack.err = err
+		return false
+	}
+	stack.push(fnv)
+	scope.evalCallInjectionStart(&evalop.CallInjectionStart{HasFunc: true, Node: &ast.CallExpr{
+		Fun:  &ast.Ident{Name: op.FnName},
+		Args: op.ArgAst,
+	}}, stack)
+	if stack.err == nil {
+		stack.pop() // return value of evalop.CallInjectionStart
 		return true
+	}
+	return false
+}
 
-	case 2:
-		mallocv := stack.pop()
-		v := stack.pop()
-		if mallocv.Unreadable != nil {
-			stack.err = mallocv.Unreadable
-			return false
-		}
-
-		if mallocv.DwarfType.String() != "*void" {
-			stack.err = fmt.Errorf("unexpected return type for mallocgc call: %v", mallocv.DwarfType.String())
-			return false
-		}
+func (scope *EvalScope) convertAllocToString(stack *evalStack) {
+	mallocv := stack.pop()
+	v := stack.pop()
+	if mallocv.Unreadable != nil {
+		stack.err = mallocv.Unreadable
+		return
+	}
 
-		if len(mallocv.Children) != 1 {
-			stack.err = errors.New("internal error, could not interpret return value of mallocgc call")
-			return false
-		}
+	if mallocv.DwarfType.String() != "*void" {
+		stack.err = fmt.Errorf("unexpected return type for mallocgc call: %v", mallocv.DwarfType.String())
+		return
+	}
 
-		v.Base = mallocv.Children[0].Addr
-		_, stack.err = scope.Mem.WriteMemory(v.Base, []byte(constant.StringVal(v.Value)))
-		stack.push(v)
-		return false
+	if len(mallocv.Children) != 1 {
+		stack.err = errors.New("internal error, could not interpret return value of mallocgc call")
+		return
 	}
 
-	panic("unreachable")
+	v.Base = mallocv.Children[0].Addr
+	_, stack.err = scope.Mem.WriteMemory(v.Base, []byte(constant.StringVal(v.Value)))
+	stack.push(v)
 }
 
 func isCallInjectionStop(t *Target, thread Thread, loc *Location) bool {
diff -pruN 1.22.1-1/pkg/proc/gdbserial/gdbserver.go 1.23.0-1/pkg/proc/gdbserial/gdbserver.go
--- 1.22.1-1/pkg/proc/gdbserial/gdbserver.go	2024-02-21 20:29:06.000000000 +0000
+++ 1.23.0-1/pkg/proc/gdbserial/gdbserver.go	2024-07-16 18:44:48.000000000 +0000
@@ -11,7 +11,7 @@
 // The protocol is specified at:
 //   https://sourceware.org/gdb/onlinedocs/gdb/Remote-Protocol.html
 // with additional documentation for lldb specific extensions described at:
-//   https://github.com/llvm/llvm-project/blob/main/lldb/docs/lldb-gdb-remote.txt
+//   https://github.com/llvm/llvm-project/blob/main/lldb/docs/resources/lldbgdbremote.md
 //
 // Terminology:
 //  * inferior: the program we are trying to debug
@@ -182,6 +182,7 @@ type gdbThread struct {
 	sig               uint8  // signal received by thread after last stop
 	setbp             bool   // thread was stopped because of a breakpoint
 	watchAddr         uint64 // if > 0 this is the watchpoint address
+	watchReg          int    // if < 0 there are no active watchpoints returned
 	common            proc.CommonThread
 }
 
@@ -725,7 +726,7 @@ func (p *gdbProcess) initialize(path, cm
 		}
 	}
 
-	err = p.updateThreadList(&threadUpdater{p: p})
+	err = p.updateThreadList(&threadUpdater{p: p}, nil)
 	if err != nil {
 		p.conn.conn.Close()
 		p.bi.Close()
@@ -851,7 +852,13 @@ func (p *gdbProcess) ContinueOnce(cctx *
 	if p.conn.direction == proc.Forward {
 		// step threads stopped at any breakpoint over their breakpoint
 		for _, thread := range p.threads {
-			if thread.CurrentBreakpoint.Breakpoint != nil {
+			// Do not single step over a breakpoint if it is a watchpoint. The PC will already have advanced and we
+			// won't experience the same stutter effect as with a breakpoint. Also, there is a bug in certain versions
+			// of the MacOS mach kernel where single stepping when we have hardware watchpoints set will cause the
+			// kernel to send a spurious mach exception.
+			// See: https://github.com/llvm/llvm-project/blob/b9f2c16b50f68c978e90190f46a7c0db3f39e98c/lldb/source/Plugins/Process/Utility/StopInfoMachException.cpp#L814
+			// TODO(deparker): We can skip single stepping in the case of thread.BinInfo().Arch.BreakInstrMovesPC().
+			if thread.CurrentBreakpoint.Breakpoint != nil && thread.CurrentBreakpoint.WatchType == 0 {
 				if err := thread.stepInstruction(); err != nil {
 					return nil, proc.StopUnknown, err
 				}
@@ -870,6 +877,7 @@ func (p *gdbProcess) ContinueOnce(cctx *
 	var trapthread *gdbThread
 	var tu = threadUpdater{p: p}
 	var atstart bool
+	var trapThreadRegs map[uint64]uint64
 continueLoop:
 	for {
 		tu.Reset()
@@ -888,7 +896,7 @@ continueLoop:
 		// NOTE: because debugserver will sometimes send two stop packets after a
 		// continue it is important that this is the very first thing we do after
 		// resume(). See comment in threadStopInfo for an explanation.
-		p.updateThreadList(&tu)
+		p.updateThreadList(&tu, sp.jstopInfo)
 
 		trapthread = p.findThreadByStrID(threadID)
 		if trapthread != nil && !p.threadStopInfo {
@@ -896,6 +904,7 @@ continueLoop:
 			// reason the thread returned by resume() stopped.
 			trapthread.sig = sp.sig
 			trapthread.watchAddr = sp.watchAddr
+			trapthread.watchReg = sp.watchReg
 		}
 
 		var shouldStop, shouldExitErr bool
@@ -905,11 +914,16 @@ continueLoop:
 			return nil, proc.StopExited, proc.ErrProcessExited{Pid: p.conn.pid}
 		}
 		if shouldStop {
+			trapThreadRegs = sp.regs
 			break continueLoop
 		}
 	}
 
 	p.clearThreadRegisters()
+	// TODO(deparker): Can we support this optimization for the RR backend?
+	if p.conn.isDebugserver {
+		trapthread.reloadRegisters(trapThreadRegs)
+	}
 
 	stopReason := proc.StopUnknown
 	if atstart {
@@ -992,7 +1006,6 @@ func (p *gdbProcess) handleThreadSignals
 		// Unfortunately debugserver can not convert them into signals for the
 		// process so we must stop here.
 		case debugServerTargetExcBadAccess, debugServerTargetExcBadInstruction, debugServerTargetExcArithmetic, debugServerTargetExcEmulation, debugServerTargetExcSoftware, debugServerTargetExcBreakpoint:
-
 			trapthreadCandidate = th
 			shouldStop = true
 
@@ -1119,7 +1132,7 @@ func (p *gdbProcess) Restart(cctx *proc.
 		return nil, err
 	}
 
-	err = p.updateThreadList(&threadUpdater{p: p})
+	err = p.updateThreadList(&threadUpdater{p: p}, nil)
 	if err != nil {
 		return nil, err
 	}
@@ -1397,7 +1410,7 @@ func (tu *threadUpdater) Finish() {
 // Some stubs will return the list of running threads in the stop packet, if
 // this happens the threadUpdater will know that we have already updated the
 // thread list and the first step of updateThreadList will be skipped.
-func (p *gdbProcess) updateThreadList(tu *threadUpdater) error {
+func (p *gdbProcess) updateThreadList(tu *threadUpdater, jstopInfo map[int]stopPacket) error {
 	if !tu.done {
 		first := true
 		for {
@@ -1418,7 +1431,13 @@ func (p *gdbProcess) updateThreadList(tu
 	}
 
 	for _, th := range p.threads {
-		if p.threadStopInfo {
+		queryThreadInfo := true
+		if jstopInfo != nil {
+			// TODO(derekparker): Use jstopInfo directly, if present, instead of
+			// issuing another stop info request.
+			_, queryThreadInfo = jstopInfo[th.ID]
+		}
+		if p.threadStopInfo && queryThreadInfo {
 			sp, err := p.conn.threadStopInfo(th.strID)
 			if err != nil {
 				if isProtocolErrorUnsupported(err) {
@@ -1427,12 +1446,12 @@ func (p *gdbProcess) updateThreadList(tu
 				}
 				return err
 			}
-			th.setbp = (sp.reason == "breakpoint" || (sp.reason == "" && sp.sig == breakpointSignal) || (sp.watchAddr > 0))
+			th.setbp = (sp.reason == "breakpoint" || (sp.reason == "" && sp.sig == breakpointSignal) || (sp.watchAddr > 0) || (sp.watchReg >= 0))
 			th.sig = sp.sig
 			th.watchAddr = sp.watchAddr
+			th.watchReg = sp.watchReg
 		} else {
-			th.sig = 0
-			th.watchAddr = 0
+			th.clearBreakpointState()
 		}
 	}
 
@@ -1527,7 +1546,7 @@ func (t *gdbThread) ThreadID() int {
 // Registers returns the CPU registers for this thread.
 func (t *gdbThread) Registers() (proc.Registers, error) {
 	if t.regs.regs == nil {
-		if err := t.reloadRegisters(); err != nil {
+		if err := t.reloadRegisters(nil); err != nil {
 			return nil, err
 		}
 	}
@@ -1679,25 +1698,42 @@ func (regs *gdbRegisters) gdbRegisterNew
 // It will also load the address of the thread's G.
 // Loading the address of G can be done in one of two ways reloadGAlloc, if
 // the stub can allocate memory, or reloadGAtPC, if the stub can't.
-func (t *gdbThread) reloadRegisters() error {
+func (t *gdbThread) reloadRegisters(regs map[uint64]uint64) error {
 	if t.regs.regs == nil {
 		t.regs.init(t.p.conn.regsInfo, t.p.bi.Arch, t.p.regnames)
 	}
 
-	if t.p.gcmdok {
-		if err := t.p.conn.readRegisters(t.strID, t.regs.buf); err != nil {
-			gdberr, isProt := err.(*GdbProtocolError)
-			if isProtocolErrorUnsupported(err) || (t.p.conn.isDebugserver && isProt && gdberr.code == "E74") {
-				t.p.gcmdok = false
-			} else {
-				return err
+	if regs == nil {
+		if t.p.gcmdok {
+			if err := t.p.conn.readRegisters(t.strID, t.regs.buf); err != nil {
+				gdberr, isProt := err.(*GdbProtocolError)
+				if isProtocolErrorUnsupported(err) || (t.p.conn.isDebugserver && isProt && gdberr.code == "E74") {
+					t.p.gcmdok = false
+				} else {
+					return err
+				}
 			}
 		}
-	}
-	if !t.p.gcmdok {
-		for _, reginfo := range t.p.conn.regsInfo {
-			if err := t.p.conn.readRegister(t.strID, reginfo.Regnum, t.regs.regs[reginfo.Name].value); err != nil {
-				return err
+		if !t.p.gcmdok {
+			for _, reginfo := range t.p.conn.regsInfo {
+				if err := t.p.conn.readRegister(t.strID, reginfo.Regnum, t.regs.regs[reginfo.Name].value); err != nil {
+					return err
+				}
+			}
+		}
+	} else {
+		for _, r := range t.p.conn.regsInfo {
+			if val, ok := regs[uint64(r.Regnum)]; ok {
+				switch r.Bitsize / 8 {
+				case 8:
+					binary.BigEndian.PutUint64(t.regs.regs[r.Name].value, val)
+				case 4:
+					binary.BigEndian.PutUint32(t.regs.regs[r.Name].value, uint32(val))
+				}
+			} else {
+				if err := t.p.conn.readRegister(t.strID, r.Regnum, t.regs.regs[r.Name].value); err != nil {
+					return err
+				}
 			}
 		}
 	}
@@ -1748,7 +1784,6 @@ func (t *gdbThread) writeRegisters() err
 		} else {
 			return err
 		}
-
 	}
 	for _, r := range t.regs.regs {
 		if r.ignoreOnWrite {
@@ -1913,6 +1948,8 @@ func (t *gdbThread) reloadGAlloc() error
 
 func (t *gdbThread) clearBreakpointState() {
 	t.setbp = false
+	t.watchAddr = 0
+	t.watchReg = -1
 	t.CurrentBreakpoint.Clear()
 }
 
@@ -1921,13 +1958,36 @@ func (t *gdbThread) SetCurrentBreakpoint
 	// adjustPC is ignored, it is the stub's responsibility to set the PC
 	// address correctly after hitting a breakpoint.
 	t.CurrentBreakpoint.Clear()
+	// t.watchAddr on certain mach kernel versions could contain the address of a
+	// software breakpoint, hardcoded breakpoint (e.g. runtime.Breakpoint) or a
+	// hardware watchpoint. The mach exception produced by the kernel *should* disambiguate
+	// but it doesn't.
 	if t.watchAddr > 0 {
 		t.CurrentBreakpoint.Breakpoint = t.p.Breakpoints().M[t.watchAddr]
 		if t.CurrentBreakpoint.Breakpoint == nil {
+			buf := make([]byte, t.BinInfo().Arch.BreakpointSize())
+			_, err := t.p.ReadMemory(buf, t.watchAddr)
+			isHardcodedBreakpoint := err == nil && (bytes.Equal(t.BinInfo().Arch.BreakpointInstruction(), buf) || bytes.Equal(t.BinInfo().Arch.AltBreakpointInstruction(), buf))
+			if isHardcodedBreakpoint {
+				// This is a hardcoded breakpoint, ignore.
+				// TODO(deparker): There's an optimization here since we will do this
+				// again at a higher level to determine if we've stopped at a hardcoded breakpoint.
+				// We could set some state here so that we don't do extra work later.
+				t.watchAddr = 0
+				return nil
+			}
 			return fmt.Errorf("could not find watchpoint at address %#x", t.watchAddr)
 		}
 		return nil
 	}
+	if t.watchReg >= 0 {
+		for _, bp := range t.p.Breakpoints().M {
+			if bp.WatchType != 0 && bp.HWBreakIndex == uint8(t.watchReg) {
+				t.CurrentBreakpoint.Breakpoint = bp
+				return nil
+			}
+		}
+	}
 	regs, err := t.Registers()
 	if err != nil {
 		return err
diff -pruN 1.22.1-1/pkg/proc/gdbserial/gdbserver_conn.go 1.23.0-1/pkg/proc/gdbserial/gdbserver_conn.go
--- 1.22.1-1/pkg/proc/gdbserial/gdbserver_conn.go	2024-02-21 20:29:06.000000000 +0000
+++ 1.23.0-1/pkg/proc/gdbserial/gdbserver_conn.go	2024-07-16 18:44:48.000000000 +0000
@@ -4,6 +4,7 @@ import (
 	"bufio"
 	"bytes"
 	"debug/macho"
+	"encoding/hex"
 	"encoding/json"
 	"encoding/xml"
 	"errors"
@@ -723,6 +724,17 @@ type stopPacket struct {
 	sig       uint8
 	reason    string
 	watchAddr uint64
+	watchReg  int
+	jstopInfo map[int]stopPacket
+	regs      map[uint64]uint64
+}
+
+type jsonStopPacket struct {
+	Tid    int      `json:"tid"`
+	Signal int      `json:"signal"`
+	Metype int      `json:"metype"`
+	Medata []uint64 `json:"medata"`
+	Reason string   `json:"reason"`
 }
 
 // Mach exception codes used to decode metype/medata keys in stop packets (necessary to support watchpoints with debugserver).
@@ -732,9 +744,10 @@ type stopPacket struct {
 //	https://opensource.apple.com/source/xnu/xnu-4570.1.46/osfmk/mach/i386/exception.h.auto.html
 //	https://opensource.apple.com/source/xnu/xnu-4570.1.46/osfmk/mach/arm/exception.h.auto.html
 const (
-	_EXC_BREAKPOINT   = 6     // mach exception type for hardware breakpoints
-	_EXC_I386_SGL     = 1     // mach exception code for single step on x86, for some reason this is also used for watchpoints
-	_EXC_ARM_DA_DEBUG = 0x102 // mach exception code for debug fault on arm/arm64
+	_EXC_BREAKPOINT     = 6     // mach exception type for hardware breakpoints
+	_EXC_I386_SGL       = 1     // mach exception code for single step on x86, for some reason this is also used for watchpoints
+	_EXC_ARM_DA_DEBUG   = 0x102 // mach exception code for debug fault on arm/arm64
+	_EXC_ARM_BREAKPOINT = 1     // mach exception code for breakpoint on arm/arm64
 )
 
 // executes 'vCont' (continue/step) command
@@ -750,18 +763,55 @@ func (conn *gdbConn) parseStopPacket(res
 			return false, stopPacket{}, fmt.Errorf("malformed stop packet: %s", string(resp))
 		}
 		sp.sig = uint8(sig)
+		sp.watchReg = -1
+		sp.regs = make(map[uint64]uint64)
 
 		if logflags.GdbWire() && gdbWireFullStopPacket {
 			conn.log.Debugf("full stop packet: %s", string(resp))
 		}
 
 		var metype int
-		var medata = make([]uint64, 0, 10)
+		medata := make([]uint64, 0, 10)
+
+		parseMachException := func(sp *stopPacket, metype int, medata []uint64) {
+			// Debugserver does not report watchpoint stops in the standard way preferring
+			// instead the semi-undocumented metype/medata keys.
+			// These values also have different meanings depending on the CPU architecture.
+			switch conn.goarch {
+			case "amd64":
+				if metype == _EXC_BREAKPOINT && len(medata) >= 2 && medata[0] == _EXC_I386_SGL {
+					sp.watchAddr = medata[1] // this should be zero if this is really a single step stop and non-zero for watchpoints
+				}
+			case "arm64":
+				if metype == _EXC_BREAKPOINT && len(medata) >= 2 && (medata[0] == _EXC_ARM_DA_DEBUG || medata[0] == _EXC_ARM_BREAKPOINT) {
+					// The arm64 specification allows for up to 16 debug registers.
+					// The registers are zero indexed, thus a value less than 16 will
+					// be a hardware breakpoint register index.
+					// See: https://developer.arm.com/documentation/102120/0101/Debug-exceptions
+					// TODO(deparker): we can ask debugserver for the number of hardware breakpoints
+					// directly.
+					if medata[1] < 16 {
+						sp.watchReg = int(medata[1])
+					} else {
+						sp.watchAddr = medata[1]
+					}
+				}
+			}
+		}
 
 		csp := colonSemicolonParser{buf: resp[3:]}
 		for csp.next() {
 			key, value := csp.key, csp.value
 
+			if reg, err := strconv.ParseUint(string(key), 16, 64); err == nil {
+				// This is a register.
+				v, err := strconv.ParseUint(string(value), 16, 64)
+				if err != nil {
+					return false, stopPacket{}, fmt.Errorf("malformed stop packet: %s", string(resp))
+				}
+				sp.regs[reg] = v
+			}
+
 			switch string(key) {
 			case "thread":
 				sp.threadID = string(value)
@@ -784,30 +834,36 @@ func (conn *gdbConn) parseStopPacket(res
 				// mach exception data (debugserver extension)
 				d, _ := strconv.ParseUint(string(value), 16, 64)
 				medata = append(medata, d)
+			case "jstopinfo":
+				jstopinfo, err := hex.DecodeString(string(value))
+				if err != nil {
+					return false, stopPacket{}, fmt.Errorf("malformed stop packet: %s (wrong jstopinfo)", string(resp))
+				}
+				parsedJstopInfo := []jsonStopPacket{}
+				if err := json.Unmarshal(jstopinfo, &parsedJstopInfo); err != nil {
+					return false, stopPacket{}, fmt.Errorf("malformed stop packet: %s (wrong jstopinfo)", string(resp))
+				}
+				sp.jstopInfo = make(map[int]stopPacket)
+				for _, jsp := range parsedJstopInfo {
+					threadID := fmt.Sprintf("%d", jsp.Tid)
+					newStopPacket := stopPacket{
+						threadID: threadID,
+						reason:   jsp.Reason,
+						sig:      uint8(jsp.Signal),
+					}
+					parseMachException(&newStopPacket, jsp.Metype, jsp.Medata)
+					sp.jstopInfo[jsp.Tid] = newStopPacket
+				}
 			}
 		}
 
-		// Debugserver does not report watchpoint stops in the standard way preferring
-		// instead the semi-undocumented metype/medata keys.
-		// These values also have different meanings depending on the CPU architecture.
-		switch conn.goarch {
-		case "amd64":
-			if metype == _EXC_BREAKPOINT && len(medata) >= 2 && medata[0] == _EXC_I386_SGL {
-				sp.watchAddr = medata[1] // this should be zero if this is really a single step stop and non-zero for watchpoints
-			}
-		case "arm64":
-			if metype == _EXC_BREAKPOINT && len(medata) >= 2 && medata[0] == _EXC_ARM_DA_DEBUG {
-				sp.watchAddr = medata[1]
-			}
-		}
+		parseMachException(&sp, metype, medata)
 
 		return false, sp, nil
 
 	case 'W', 'X':
 		// process exited, next two character are exit code
-
 		semicolon := bytes.Index(resp, []byte{';'})
-
 		if semicolon < 0 {
 			semicolon = len(resp)
 		}
@@ -929,7 +985,10 @@ func (conn *gdbConn) queryThreads(first
 }
 
 func (conn *gdbConn) selectThread(kind byte, threadID string, context string) error {
-	if conn.threadSuffixSupported {
+	if conn.threadSuffixSupported && kind != 'c' {
+		// kind == 'c' is still allowed because 'rr' is weird about it's support
+		// for thread suffixes and the specification for it doesn't really say how
+		// it should be used with packets 'bc' and 'bs'.
 		panic("selectThread when thread suffix is supported")
 	}
 	conn.outbuf.Reset()
@@ -1133,9 +1192,15 @@ func (conn *gdbConn) qRRCmd(args ...stri
 	}
 	conn.outbuf.Reset()
 	fmt.Fprint(&conn.outbuf, "$qRRCmd")
-	for _, arg := range args {
+	for i, arg := range args {
 		fmt.Fprint(&conn.outbuf, ":")
-		writeAsciiBytes(&conn.outbuf, []byte(arg))
+		if i == 0 && conn.threadSuffixSupported {
+			// newer versions of RR require the command to be followed by a thread id
+			// and the command name to be unescaped.
+			fmt.Fprintf(&conn.outbuf, "%s:-1", arg)
+		} else {
+			writeAsciiBytes(&conn.outbuf, []byte(arg))
+		}
 	}
 	resp, err := conn.exec(conn.outbuf.Bytes(), "qRRCmd")
 	if err != nil {
diff -pruN 1.22.1-1/pkg/proc/gdbserial/rr.go 1.23.0-1/pkg/proc/gdbserial/rr.go
--- 1.22.1-1/pkg/proc/gdbserial/rr.go	2024-02-21 20:29:06.000000000 +0000
+++ 1.23.0-1/pkg/proc/gdbserial/rr.go	2024-07-16 18:44:48.000000000 +0000
@@ -15,6 +15,11 @@ import (
 	"github.com/go-delve/delve/pkg/proc"
 )
 
+const (
+	delveRecordFlagsEnvVar = "DELVE_RR_RECORD_FLAGS"
+	delveReplayFlagsEnvVar = "DELVE_RR_REPLAY_FLAGS"
+)
+
 // RecordAsync configures rr to record the execution of the specified
 // program. Returns a run function which will actually record the program, a
 // stop function which will prematurely terminate the recording of the
@@ -31,6 +36,7 @@ func RecordAsync(cmd []string, wd string
 
 	args := make([]string, 0, len(cmd)+2)
 	args = append(args, "record", "--print-trace-dir=3")
+	args = append(args, config.SplitQuotedFields(os.Getenv(delveRecordFlagsEnvVar), '"')...)
 	args = append(args, cmd...)
 	rrcmd := exec.Command("rr", args...)
 	var closefn func()
@@ -141,6 +147,7 @@ func Replay(tracedir string, quiet, dele
 	if rrOnProcessPid != 0 {
 		args = append(args, fmt.Sprintf("--onprocess=%d", rrOnProcessPid))
 	}
+	args = append(args, config.SplitQuotedFields(os.Getenv(delveReplayFlagsEnvVar), '\'')...)
 	args = append(args, tracedir)
 
 	rrcmd := exec.Command("rr", args...)
@@ -216,9 +223,11 @@ type rrInit struct {
 }
 
 const (
-	rrGdbCommandPrefix = "  gdb "
-	rrGdbLaunchPrefix  = "Launch gdb with"
-	targetCmd          = "target extended-remote "
+	rrGdbCommandLegacyPrefix = "  gdb "
+	rrGdbCommandPrefix       = "  'gdb' "
+	rrGdbLaunchLegacyPrefix  = "Launch gdb with"
+	rrGdbLaunchPrefix        = "Launch debugger with"
+	targetCmd                = "target extended-remote "
 )
 
 func rrStderrParser(stderr io.ReadCloser, initch chan<- rrInit, quiet bool) {
@@ -233,18 +242,23 @@ func rrStderrParser(stderr io.ReadCloser
 			return
 		}
 
-		if strings.HasPrefix(line, rrGdbCommandPrefix) {
-			initch <- rrParseGdbCommand(line[len(rrGdbCommandPrefix):])
+		var flags string
+		var foundPrefix bool
+		if flags, foundPrefix = strings.CutPrefix(line, rrGdbCommandPrefix); !foundPrefix {
+			flags, foundPrefix = strings.CutPrefix(line, rrGdbCommandLegacyPrefix)
+		}
+		if foundPrefix {
+			initch <- rrParseGdbCommand(flags)
 			close(initch)
 			break
 		}
 
-		if strings.HasPrefix(line, rrGdbLaunchPrefix) {
+		if strings.HasPrefix(line, rrGdbLaunchPrefix) || strings.HasPrefix(line, rrGdbLaunchLegacyPrefix) {
 			continue
 		}
 
 		if !quiet {
-			os.Stderr.Write([]byte(line))
+			os.Stderr.WriteString(line)
 		}
 	}
 
diff -pruN 1.22.1-1/pkg/proc/linutil/dynamic.go 1.23.0-1/pkg/proc/linutil/dynamic.go
--- 1.22.1-1/pkg/proc/linutil/dynamic.go	2024-02-21 20:29:06.000000000 +0000
+++ 1.23.0-1/pkg/proc/linutil/dynamic.go	2024-07-16 18:44:48.000000000 +0000
@@ -138,7 +138,7 @@ func readCString(p proc.Process, addr ui
 // ElfUpdateSharedObjects reads the list of dynamic libraries loaded by the
 // dynamic linker from the .dynamic section and uses it to update p.BinInfo().
 // See the SysV ABI for a description of how the .dynamic section works:
-// http://www.sco.com/developers/gabi/latest/contents.html
+// https://www.sco.com/developers/gabi/latest/contents.html
 func ElfUpdateSharedObjects(p proc.Process) error {
 	bi := p.BinInfo()
 	if bi.ElfDynamicSection.Addr == 0 {
diff -pruN 1.22.1-1/pkg/proc/mem.go 1.23.0-1/pkg/proc/mem.go
--- 1.22.1-1/pkg/proc/mem.go	2024-02-21 20:29:06.000000000 +0000
+++ 1.23.0-1/pkg/proc/mem.go	2024-07-16 18:44:48.000000000 +0000
@@ -35,7 +35,12 @@ type memCache struct {
 }
 
 func (m *memCache) contains(addr uint64, size int) bool {
-	return addr >= m.cacheAddr && addr <= (m.cacheAddr+uint64(len(m.cache)-size))
+	end := addr + uint64(size)
+	if end < addr {
+		// overflow
+		return false
+	}
+	return addr >= m.cacheAddr && end <= m.cacheAddr+uint64(len(m.cache))
 }
 
 func (m *memCache) ReadMemory(data []byte, addr uint64) (n int, err error) {
@@ -69,6 +74,10 @@ func cacheMemory(mem MemoryReadWriter, a
 	if size <= 0 {
 		return mem
 	}
+	if addr+uint64(size) < addr {
+		// overflow
+		return mem
+	}
 	switch cacheMem := mem.(type) {
 	case *memCache:
 		if cacheMem.contains(addr, size) {
diff -pruN 1.22.1-1/pkg/proc/moduledata.go 1.23.0-1/pkg/proc/moduledata.go
--- 1.22.1-1/pkg/proc/moduledata.go	2024-02-21 20:29:06.000000000 +0000
+++ 1.23.0-1/pkg/proc/moduledata.go	2024-07-16 18:44:48.000000000 +0000
@@ -1,13 +1,13 @@
 package proc
 
-// delve counterpart to runtime.moduledata
-type moduleData struct {
+// ModuleData counterpart to runtime.moduleData
+type ModuleData struct {
 	text, etext   uint64
 	types, etypes uint64
 	typemapVar    *Variable
 }
 
-func loadModuleData(bi *BinaryInfo, mem MemoryReadWriter) ([]moduleData, error) {
+func LoadModuleData(bi *BinaryInfo, mem MemoryReadWriter) ([]ModuleData, error) {
 	// +rtype -var firstmoduledata moduledata
 	// +rtype -field moduledata.text uintptr
 	// +rtype -field moduledata.types uintptr
@@ -19,7 +19,7 @@ func loadModuleData(bi *BinaryInfo, mem
 		return nil, err
 	}
 
-	r := []moduleData{}
+	r := []ModuleData{}
 
 	for md.Addr != 0 {
 		const (
@@ -38,7 +38,6 @@ func loadModuleData(bi *BinaryInfo, mem
 			if err != nil {
 				return nil, err
 			}
-
 		}
 
 		var err error
@@ -52,7 +51,7 @@ func loadModuleData(bi *BinaryInfo, mem
 			return ret
 		}
 
-		r = append(r, moduleData{
+		r = append(r, ModuleData{
 			types: touint(typesField), etypes: touint(etypesField),
 			text: touint(textField), etext: touint(etextField),
 			typemapVar: vars[typemapField],
@@ -70,7 +69,7 @@ func loadModuleData(bi *BinaryInfo, mem
 	return r, nil
 }
 
-func findModuleDataForType(bi *BinaryInfo, mds []moduleData, typeAddr uint64, mem MemoryReadWriter) *moduleData {
+func findModuleDataForType(bi *BinaryInfo, mds []ModuleData, typeAddr uint64, mem MemoryReadWriter) *ModuleData {
 	for i := range mds {
 		if typeAddr >= mds[i].types && typeAddr < mds[i].etypes {
 			return &mds[i]
diff -pruN 1.22.1-1/pkg/proc/native/proc_darwin.c 1.23.0-1/pkg/proc/native/proc_darwin.c
--- 1.22.1-1/pkg/proc/native/proc_darwin.c	2024-02-21 20:29:06.000000000 +0000
+++ 1.23.0-1/pkg/proc/native/proc_darwin.c	2024-07-16 18:44:48.000000000 +0000
@@ -159,7 +159,7 @@ mach_port_wait(mach_port_t port_set, tas
 	switch (msg.hdr.msgh_id) {
 		case 2401: { // Exception
 			// 2401 is the exception_raise event, defined in:
-			// http://opensource.apple.com/source/xnu/xnu-2422.1.72/osfmk/mach/exc.defs?txt
+			// https://opensource.apple.com/source/xnu/xnu-2422.1.72/osfmk/mach/exc.defs?txt
 			// compile this file with mig to get the C version of the description
 			
 			mach_msg_body_t *bod = (mach_msg_body_t*)(&msg.hdr + 1);
diff -pruN 1.22.1-1/pkg/proc/native/ptrace_freebsd.go 1.23.0-1/pkg/proc/native/ptrace_freebsd.go
--- 1.22.1-1/pkg/proc/native/ptrace_freebsd.go	2024-02-21 20:29:06.000000000 +0000
+++ 1.23.0-1/pkg/proc/native/ptrace_freebsd.go	2024-07-16 18:44:48.000000000 +0000
@@ -9,7 +9,6 @@ package native
 import "C"
 
 import (
-	"runtime"
 	"syscall"
 	"unsafe"
 
@@ -61,13 +60,11 @@ func ptraceGetLwpInfo(wpid int) (info sy
 
 // id may be a PID or an LWPID
 func ptraceReadData(id int, addr uintptr, data []byte) (n int, err error) {
-	defer runtime.KeepAlive(&data[0]) // PIN
 	return sys.PtraceIO(sys.PIOD_READ_D, id, addr, data, len(data))
 }
 
 // id may be a PID or an LWPID
 func ptraceWriteData(id int, addr uintptr, data []byte) (n int, err error) {
-	defer runtime.KeepAlive(&data[0]) // PIN
 	return sys.PtraceIO(sys.PIOD_WRITE_D, id, addr, data, len(data))
 }
 
diff -pruN 1.22.1-1/pkg/proc/native/ptrace_linux_386.go 1.23.0-1/pkg/proc/native/ptrace_linux_386.go
--- 1.22.1-1/pkg/proc/native/ptrace_linux_386.go	2024-02-21 20:29:06.000000000 +0000
+++ 1.23.0-1/pkg/proc/native/ptrace_linux_386.go	2024-07-16 18:44:48.000000000 +0000
@@ -43,8 +43,8 @@ func ptraceGetRegset(tid int) (regset am
 }
 
 // ptraceGetTls return the addr of tls by PTRACE_GET_THREAD_AREA for specify thread.
-// See http://man7.org/linux/man-pages/man2/ptrace.2.html for detail about PTRACE_GET_THREAD_AREA.
-// struct user_desc at https://golang.org/src/runtime/sys_linux_386.s
+// See https://man7.org/linux/man-pages/man2/ptrace.2.html for detail about PTRACE_GET_THREAD_AREA.
+// struct user_desc at https://go.dev/src/runtime/sys_linux_386.s
 //
 //	type UserDesc struct {
 //		 EntryNumber uint32
diff -pruN 1.22.1-1/pkg/proc/native/support_sentinel_darwin.go 1.23.0-1/pkg/proc/native/support_sentinel_darwin.go
--- 1.22.1-1/pkg/proc/native/support_sentinel_darwin.go	2024-02-21 20:29:06.000000000 +0000
+++ 1.23.0-1/pkg/proc/native/support_sentinel_darwin.go	2024-07-16 18:44:48.000000000 +0000
@@ -2,4 +2,4 @@
 
 // This file is used to detect build on unsupported GOOS/GOARCH combinations.
 
-package your_darwin_architectur_is_not_supported_by_delve
+package your_darwin_architecture_is_not_supported_by_delve
diff -pruN 1.22.1-1/pkg/proc/pclntab.go 1.23.0-1/pkg/proc/pclntab.go
--- 1.22.1-1/pkg/proc/pclntab.go	2024-02-21 20:29:06.000000000 +0000
+++ 1.23.0-1/pkg/proc/pclntab.go	2024-07-16 18:44:48.000000000 +0000
@@ -3,6 +3,7 @@ package proc
 import (
 	"debug/elf"
 	"debug/macho"
+	"errors"
 	"fmt"
 
 	"github.com/go-delve/delve/pkg/internal/gosym"
@@ -18,12 +19,12 @@ func readPcLnTableElf(exe *elf.File, pat
 		sectionLabel = ".data.rel.ro.gopclntab"
 		section = exe.Section(sectionLabel)
 		if section == nil {
-			return nil, 0, fmt.Errorf("could not read section .gopclntab")
+			return nil, 0, errors.New("could not read section .gopclntab")
 		}
 	}
 	tableData, err := section.Data()
 	if err != nil {
-		return nil, 0, fmt.Errorf("found section but could not read .gopclntab")
+		return nil, 0, errors.New("found section but could not read .gopclntab")
 	}
 
 	addr := exe.Section(".text").Addr
@@ -41,11 +42,11 @@ func readPcLnTableMacho(exe *macho.File,
 
 	section := exe.Section(sectionLabel)
 	if section == nil {
-		return nil, 0, fmt.Errorf("could not read section __gopclntab")
+		return nil, 0, errors.New("could not read section __gopclntab")
 	}
 	tableData, err := section.Data()
 	if err != nil {
-		return nil, 0, fmt.Errorf("found section but could not read __gopclntab")
+		return nil, 0, errors.New("found section but could not read __gopclntab")
 	}
 
 	addr := exe.Section("__text").Addr
diff -pruN 1.22.1-1/pkg/proc/proc_amd64_test.go 1.23.0-1/pkg/proc/proc_amd64_test.go
--- 1.22.1-1/pkg/proc/proc_amd64_test.go	2024-02-21 20:29:06.000000000 +0000
+++ 1.23.0-1/pkg/proc/proc_amd64_test.go	2024-07-16 18:44:48.000000000 +0000
@@ -22,7 +22,7 @@ func TestStepInstructionOnBreakpoint(t *
 		assertNoError(grp.Continue(), t, "Continue()")
 
 		pc := getRegisters(p, t).PC()
-		assertNoError(grp.StepInstruction(), t, "StepInstruction()")
+		assertNoError(grp.StepInstruction(false), t, "StepInstruction()")
 		if pc == getRegisters(p, t).PC() {
 			t.Fatal("Could not step a single instruction")
 		}
diff -pruN 1.22.1-1/pkg/proc/proc_darwin_amd64_test.go 1.23.0-1/pkg/proc/proc_darwin_amd64_test.go
--- 1.22.1-1/pkg/proc/proc_darwin_amd64_test.go	2024-02-21 20:29:06.000000000 +0000
+++ 1.23.0-1/pkg/proc/proc_darwin_amd64_test.go	2024-07-16 18:44:48.000000000 +0000
@@ -36,7 +36,7 @@ func TestSetYMMRegister(t *testing.T) {
 			0x44, 0x44, 0x44, 0x44, 0x44, 0x44, 0x44, 0x44,
 			0x44, 0x44, 0x44, 0x44, 0x44, 0x44, 0x44, 0x44,
 			0x44, 0x44, 0x44, 0x44, 0x44, 0x44, 0x44, 0x44}))
-		assertNoError(grp.StepInstruction(), t, "SetpInstruction")
+		assertNoError(grp.StepInstruction(false), t, "StepInstruction")
 
 		xmm0 := getReg("after")
 
diff -pruN 1.22.1-1/pkg/proc/proc_general_test.go 1.23.0-1/pkg/proc/proc_general_test.go
--- 1.22.1-1/pkg/proc/proc_general_test.go	2024-02-21 20:29:06.000000000 +0000
+++ 1.23.0-1/pkg/proc/proc_general_test.go	2024-07-16 18:44:48.000000000 +0000
@@ -30,6 +30,26 @@ func TestIssue554(t *testing.T) {
 	}
 }
 
+func TestIssue3760(t *testing.T) {
+	// unsigned integer overflow if len(m.cache) < size
+	mem := memCache{true, 0x20, make([]byte, 100), nil}
+	if mem.contains(0x20, 200) {
+		t.Fatalf("should be false")
+	}
+	// test overflow of end addr
+	mem = memCache{true, 0xfffffffffffffff0, make([]byte, 15), nil}
+	if !mem.contains(0xfffffffffffffff0, 15) {
+		t.Fatalf("should contain it")
+	}
+	if mem.contains(0xfffffffffffffff0, 16) {
+		t.Fatalf("shoud be false")
+	}
+	cm := cacheMemory(nil, 0xffffffffffffffff, 1)
+	if cm != nil {
+		t.Fatalf("should be nil")
+	}
+}
+
 type dummyMem struct {
 	t     *testing.T
 	mem   []byte
diff -pruN 1.22.1-1/pkg/proc/proc_test.go 1.23.0-1/pkg/proc/proc_test.go
--- 1.22.1-1/pkg/proc/proc_test.go	2024-02-21 20:29:06.000000000 +0000
+++ 1.23.0-1/pkg/proc/proc_test.go	2024-07-16 18:44:48.000000000 +0000
@@ -3,6 +3,7 @@ package proc_test
 import (
 	"bytes"
 	"encoding/binary"
+	"errors"
 	"flag"
 	"fmt"
 	"go/ast"
@@ -142,6 +143,7 @@ func dataAtAddr(thread proc.MemoryReadWr
 }
 
 func assertNoError(err error, t testing.TB, s string) {
+	t.Helper()
 	if err != nil {
 		_, file, line, _ := runtime.Caller(1)
 		fname := filepath.Base(file)
@@ -173,6 +175,22 @@ func assertLineNumber(p *proc.Target, t
 	return f, l
 }
 
+func assertLineNumberIn(p *proc.Target, t *testing.T, linenos []int, descr string) (string, int) {
+	f, l := currentLineNumber(p, t)
+	found := false
+	for _, lineno := range linenos {
+		if l == lineno {
+			found = true
+			break
+		}
+	}
+	if !found {
+		_, callerFile, callerLine, _ := runtime.Caller(1)
+		t.Fatalf("%s expected lines :%#v got %s:%d\n\tat %s:%d", descr, linenos, f, l, callerFile, callerLine)
+	}
+	return f, l
+}
+
 func assertFunctionName(p *proc.Target, t *testing.T, fnname string, descr string) {
 	pc := currentPC(p, t)
 	f, l, fn := p.BinInfo().PCToLine(pc)
@@ -315,7 +333,7 @@ func TestHalt(t *testing.T) {
 	})
 }
 
-func TestStep(t *testing.T) {
+func TestStepInstruction(t *testing.T) {
 	protest.AllowRecording(t)
 	withTestProcess("testprog", t, func(p *proc.Target, grp *proc.TargetGroup, fixture protest.Fixture) {
 		setFunctionBreakpoint(p, t, "main.helloworld")
@@ -324,7 +342,7 @@ func TestStep(t *testing.T) {
 		regs := getRegisters(p, t)
 		rip := regs.PC()
 
-		err := grp.StepInstruction()
+		err := grp.StepInstruction(false)
 		assertNoError(err, t, "Step()")
 
 		regs = getRegisters(p, t)
@@ -334,6 +352,19 @@ func TestStep(t *testing.T) {
 	})
 }
 
+func TestNextInstruction(t *testing.T) {
+	protest.AllowRecording(t)
+	withTestProcess("testprog", t, func(p *proc.Target, grp *proc.TargetGroup, fixture protest.Fixture) {
+		setFileBreakpoint(p, t, fixture.Source, 19)
+		assertNoError(grp.Continue(), t, "Continue()")
+
+		err := grp.StepInstruction(true)
+		assertNoError(err, t, "Step()")
+
+		assertLineNumber(p, t, 20, "next-instruction did not step over call")
+	})
+}
+
 func TestBreakpoint(t *testing.T) {
 	protest.AllowRecording(t)
 	withTestProcess("testprog", t, func(p *proc.Target, grp *proc.TargetGroup, fixture protest.Fixture) {
@@ -458,114 +489,131 @@ func testseq2(t *testing.T, program stri
 
 func testseq2Args(wd string, args []string, buildFlags protest.BuildFlags, t *testing.T, program string, initialLocation string, testcases []seqTest) {
 	protest.AllowRecording(t)
+	t.Helper()
 	withTestProcessArgs(program, t, wd, args, buildFlags, func(p *proc.Target, grp *proc.TargetGroup, fixture protest.Fixture) {
+		checkBreakpointClear := true
 		var bp *proc.Breakpoint
 		if initialLocation != "" {
 			bp = setFunctionBreakpoint(p, t, initialLocation)
 		} else if testcases[0].cf == contContinue {
 			bp = setFileBreakpoint(p, t, fixture.Source, testcases[0].pos.(int))
+		} else if testcases[0].cf == contNothing {
+			// Do nothing
+			checkBreakpointClear = false
 		} else {
 			panic("testseq2 can not set initial breakpoint")
 		}
 		if traceTestseq2 {
 			t.Logf("initial breakpoint %v", bp)
 		}
-		regs, err := p.CurrentThread().Registers()
-		assertNoError(err, t, "Registers")
 
-		f, ln := currentLineNumber(p, t)
-		for i, tc := range testcases {
-			switch tc.cf {
-			case contNext:
-				if traceTestseq2 {
-					t.Log("next")
-				}
-				assertNoError(grp.Next(), t, "Next() returned an error")
-			case contStep:
-				if traceTestseq2 {
-					t.Log("step")
-				}
-				assertNoError(grp.Step(), t, "Step() returned an error")
-			case contStepout:
-				if traceTestseq2 {
-					t.Log("stepout")
-				}
-				assertNoError(grp.StepOut(), t, "StepOut() returned an error")
-			case contContinue:
-				if traceTestseq2 {
-					t.Log("continue")
-				}
-				assertNoError(grp.Continue(), t, "Continue() returned an error")
-				if i == 0 {
-					if traceTestseq2 {
-						t.Log("clearing initial breakpoint")
-					}
-					err := p.ClearBreakpoint(bp.Addr)
-					assertNoError(err, t, "ClearBreakpoint() returned an error")
-				}
-			case contReverseNext:
-				if traceTestseq2 {
-					t.Log("reverse-next")
-				}
-				assertNoError(grp.ChangeDirection(proc.Backward), t, "direction switch")
-				assertNoError(grp.Next(), t, "reverse Next() returned an error")
-				assertNoError(grp.ChangeDirection(proc.Forward), t, "direction switch")
-			case contReverseStep:
-				if traceTestseq2 {
-					t.Log("reverse-step")
-				}
-				assertNoError(grp.ChangeDirection(proc.Backward), t, "direction switch")
-				assertNoError(grp.Step(), t, "reverse Step() returned an error")
-				assertNoError(grp.ChangeDirection(proc.Forward), t, "direction switch")
-			case contReverseStepout:
-				if traceTestseq2 {
-					t.Log("reverse-stepout")
-				}
-				assertNoError(grp.ChangeDirection(proc.Backward), t, "direction switch")
-				assertNoError(grp.StepOut(), t, "reverse StepOut() returned an error")
-				assertNoError(grp.ChangeDirection(proc.Forward), t, "direction switch")
-			case contContinueToBreakpoint:
-				bp := setFileBreakpoint(p, t, fixture.Source, tc.pos.(int))
+		testseq2intl(t, fixture, grp, p, bp, testcases)
+
+		if countBreakpoints(p) != 0 && checkBreakpointClear {
+			t.Fatal("Not all breakpoints were cleaned up", len(p.Breakpoints().M))
+		}
+	})
+}
+
+func testseq2intl(t *testing.T, fixture protest.Fixture, grp *proc.TargetGroup, p *proc.Target, bp *proc.Breakpoint, testcases []seqTest) {
+	f, ln := currentLineNumber(p, t)
+	for i, tc := range testcases {
+		switch tc.cf {
+		case contNext:
+			if traceTestseq2 {
+				t.Log("next")
+			}
+			assertNoError(grp.Next(), t, "Next() returned an error")
+		case contStep:
+			if traceTestseq2 {
+				t.Log("step")
+			}
+			assertNoError(grp.Step(), t, "Step() returned an error")
+		case contStepout:
+			if traceTestseq2 {
+				t.Log("stepout")
+			}
+			assertNoError(grp.StepOut(), t, "StepOut() returned an error")
+		case contContinue:
+			if traceTestseq2 {
+				t.Log("continue")
+			}
+			assertNoError(grp.Continue(), t, "Continue() returned an error")
+			if i == 0 {
 				if traceTestseq2 {
-					t.Log("continue")
+					t.Log("clearing initial breakpoint")
 				}
-				assertNoError(grp.Continue(), t, "Continue() returned an error")
 				err := p.ClearBreakpoint(bp.Addr)
 				assertNoError(err, t, "ClearBreakpoint() returned an error")
-			case contNothing:
-				// do nothing
 			}
-
-			f, ln = currentLineNumber(p, t)
-			regs, _ = p.CurrentThread().Registers()
-			pc := regs.PC()
-
+		case contReverseNext:
 			if traceTestseq2 {
-				t.Logf("at %#x %s:%d", pc, f, ln)
-				fmt.Printf("at %#x %s:%d\n", pc, f, ln)
+				t.Log("reverse-next")
 			}
-			switch pos := tc.pos.(type) {
-			case int:
-				if pos >= 0 && ln != pos {
-					t.Fatalf("Program did not continue to correct next location expected %d was %s:%d (%#x) (testcase %d)", pos, filepath.Base(f), ln, pc, i)
-				}
-			case string:
-				v := strings.Split(pos, ":")
-				tgtln, _ := strconv.Atoi(v[1])
-				if !strings.HasSuffix(f, v[0]) || (ln != tgtln) {
-					t.Fatalf("Program did not continue to correct next location, expected %s was %s:%d (%#x) (testcase %d)", pos, filepath.Base(f), ln, pc, i)
-				}
-			case func(*proc.Target):
-				pos(p)
-			default:
-				panic(fmt.Errorf("unexpected type %T", pos))
+			assertNoError(grp.ChangeDirection(proc.Backward), t, "direction switch")
+			assertNoError(grp.Next(), t, "reverse Next() returned an error")
+			assertNoError(grp.ChangeDirection(proc.Forward), t, "direction switch")
+		case contReverseStep:
+			if traceTestseq2 {
+				t.Log("reverse-step")
+			}
+			assertNoError(grp.ChangeDirection(proc.Backward), t, "direction switch")
+			assertNoError(grp.Step(), t, "reverse Step() returned an error")
+			assertNoError(grp.ChangeDirection(proc.Forward), t, "direction switch")
+		case contReverseStepout:
+			if traceTestseq2 {
+				t.Log("reverse-stepout")
+			}
+			assertNoError(grp.ChangeDirection(proc.Backward), t, "direction switch")
+			assertNoError(grp.StepOut(), t, "reverse StepOut() returned an error")
+			assertNoError(grp.ChangeDirection(proc.Forward), t, "direction switch")
+		case contContinueToBreakpoint:
+			bp := setFileBreakpoint(p, t, fixture.Source, tc.pos.(int))
+			if traceTestseq2 {
+				t.Log("continue")
 			}
+			assertNoError(grp.Continue(), t, "Continue() returned an error")
+			err := p.ClearBreakpoint(bp.Addr)
+			assertNoError(err, t, "ClearBreakpoint() returned an error")
+		case contNothing:
+			// do nothing
 		}
 
-		if countBreakpoints(p) != 0 {
-			t.Fatal("Not all breakpoints were cleaned up", len(p.Breakpoints().M))
+		if err := p.CurrentThread().Breakpoint().CondError; err != nil {
+			t.Logf("breakpoint condition error: %v", err)
 		}
-	})
+
+		f, ln = currentLineNumber(p, t)
+		regs, _ := p.CurrentThread().Registers()
+		pc := regs.PC()
+		_, _, fn := p.BinInfo().PCToLine(pc)
+
+		if traceTestseq2 {
+			fnname := "?"
+			if fn != nil {
+				fnname = fn.Name
+			}
+			t.Logf("at %#x (%s) %s:%d", pc, fnname, f, ln)
+		}
+		switch pos := tc.pos.(type) {
+		case int:
+			if pos >= 0 && ln != pos {
+				t.Fatalf("Program did not continue to correct next location expected %d was %s:%d (%#x) (testcase %d)", pos, filepath.Base(f), ln, pc, i)
+			}
+		case string:
+			v := strings.Split(pos, ":")
+			tgtln, _ := strconv.Atoi(v[1])
+			if !strings.HasSuffix(f, v[0]) || (ln != tgtln) {
+				t.Fatalf("Program did not continue to correct next location, expected %s was %s:%d (%#x) (testcase %d)", pos, filepath.Base(f), ln, pc, i)
+			}
+		case func(*proc.Target):
+			pos(p)
+		case func(*proc.TargetGroup, *proc.Target):
+			pos(grp, p)
+		default:
+			panic(fmt.Errorf("unexpected type %T", pos))
+		}
+	}
 }
 
 func TestNextGeneral(t *testing.T) {
@@ -968,7 +1016,6 @@ func TestStacktrace2(t *testing.T) {
 			t.Fatalf("Stack error at main.g()\n%v\n", locations)
 		}
 	})
-
 }
 
 func stackMatch(stack []loc, locations []proc.Stackframe, skipRuntime bool) bool {
@@ -1189,7 +1236,7 @@ func findFirstNonRuntimeFrame(p *proc.Ta
 			return frame, nil
 		}
 	}
-	return proc.Stackframe{}, fmt.Errorf("non-runtime frame not found")
+	return proc.Stackframe{}, errors.New("non-runtime frame not found")
 }
 
 func evalVariableOrError(p *proc.Target, symbol string) (*proc.Variable, error) {
@@ -1213,6 +1260,7 @@ func evalVariableOrError(p *proc.Target,
 }
 
 func evalVariable(p *proc.Target, t testing.TB, symbol string) *proc.Variable {
+	t.Helper()
 	v, err := evalVariableOrError(p, symbol)
 	if err != nil {
 		_, file, line, _ := runtime.Caller(1)
@@ -2719,7 +2767,7 @@ func TestStepOnCallPtrInstr(t *testing.T
 				found = true
 				break
 			}
-			assertNoError(grp.StepInstruction(), t, "StepInstruction()")
+			assertNoError(grp.StepInstruction(false), t, "StepInstruction()")
 		}
 
 		if !found {
@@ -3095,7 +3143,7 @@ func TestStepInstructionNoGoroutine(t *t
 	withTestProcess("increment", t, func(p *proc.Target, grp *proc.TargetGroup, fixture protest.Fixture) {
 		// Call StepInstruction immediately after launching the program, it should
 		// work even though no goroutine is selected.
-		assertNoError(grp.StepInstruction(), t, "StepInstruction")
+		assertNoError(grp.StepInstruction(false), t, "StepInstruction")
 	})
 }
 
@@ -3203,11 +3251,19 @@ func TestDebugStripped(t *testing.T) {
 		assertLineNumber(p, t, 37, "first continue")
 		assertNoError(grp.Next(), t, "Next")
 		assertLineNumber(p, t, 38, "after next")
+
+		// Assert that commands like "args", "locals", etc... will
+		// return an error instead of panic.
+		s, err := proc.ThreadScope(p, p.CurrentThread())
+		assertNoError(err, t, "ThreadScope")
+		_, err = s.Locals(0, "")
+		if err == nil {
+			t.Error("expected an error to be returned from scope.Locals in stripped binary")
+		}
 	})
 }
 
 func TestDebugStripped2(t *testing.T) {
-	// Currently only implemented for Linux ELF executables.
 	// TODO(derekparker): Add support for PE.
 	skipOn(t, "not working on windows", "windows")
 	skipOn(t, "not working on freebsd", "freebsd")
@@ -3284,7 +3340,6 @@ func logStacktrace(t *testing.T, p *proc
 		fmt.Fprintf(w, "%#x\t%#x\t%#x\t%#x\t%#x\t%s\t%s:%d\t%s\t%s\t\n",
 			frame.Call.PC, frame.FrameOffset(), frame.FramePointerOffset(), frame.Current.PC, frame.Ret,
 			name, filepath.Base(frame.Call.File), frame.Call.Line, topmostdefer, defers)
-
 	}
 	w.Flush()
 }
@@ -3589,7 +3644,7 @@ func testDeclLineCount(t *testing.T, p *
 	assertLineNumber(p, t, lineno, "Program did not continue to correct next location")
 	scope, err := proc.GoroutineScope(p, p.CurrentThread())
 	assertNoError(err, t, fmt.Sprintf("GoroutineScope (:%d)", lineno))
-	vars, err := scope.Locals(0)
+	vars, err := scope.Locals(0, "")
 	assertNoError(err, t, fmt.Sprintf("Locals (:%d)", lineno))
 	if len(vars) != len(tgtvars) {
 		t.Fatalf("wrong number of variables %d (:%d)", len(vars), lineno)
@@ -3786,9 +3841,9 @@ func checkFrame(frame proc.Stackframe, f
 	}
 	if frame.Inlined != inlined {
 		if inlined {
-			return fmt.Errorf("not inlined")
+			return errors.New("not inlined")
 		}
-		return fmt.Errorf("inlined")
+		return errors.New("inlined")
 	}
 	return nil
 }
@@ -4970,7 +5025,8 @@ func TestStepIntoWrapperForEmbeddedPoint
 			{contStep, 22},
 			{contNext, 23},
 			{contNext, 23},
-			{contNext, 29}})
+			{contNext, 29},
+		})
 	} else {
 		testseq2(t, "ifaceembcall", "", []seqTest{
 			{contContinue, 28}, // main.main, the line calling iface.PtrReceiver()
@@ -4980,8 +5036,8 @@ func TestStepIntoWrapperForEmbeddedPoint
 			{contContinueToBreakpoint, 29}, // main.main, the line calling iface.NonPtrReceiver()
 			{contStep, 22},
 			{contNext, 23},
-			{contNext, 29}})
-
+			{contNext, 29},
+		})
 	}
 }
 
@@ -5082,7 +5138,6 @@ func TestStepOutPreservesGoroutine(t *te
 		} else {
 			pickg = candg[rand.Intn(len(candg))]
 			t.Logf("selected goroutine %d\n", pickg.ID)
-
 		}
 		goid := pickg.ID
 		assertNoError(p.SwitchGoroutine(pickg), t, "SwitchGoroutine")
@@ -5396,13 +5451,8 @@ func TestWatchpointsBasic(t *testing.T)
 	skipOn(t, "see https://github.com/go-delve/delve/issues/2768", "windows")
 	protest.AllowRecording(t)
 
-	position1 := 19
-	position5 := 41
-
-	if runtime.GOARCH == "arm64" {
-		position1 = 18
-		position5 = 40
-	}
+	position1 := []int{18, 19}
+	position5 := []int{40, 41}
 
 	withTestProcess("databpeasy", t, func(p *proc.Target, grp *proc.TargetGroup, fixture protest.Fixture) {
 		setFunctionBreakpoint(p, t, "main.main")
@@ -5418,7 +5468,7 @@ func TestWatchpointsBasic(t *testing.T)
 		assertNoError(err, t, "SetDataBreakpoint(write-only)")
 
 		assertNoError(grp.Continue(), t, "Continue 1")
-		assertLineNumber(p, t, position1, "Continue 1") // Position 1
+		assertLineNumberIn(p, t, position1, "Continue 1") // Position 1
 
 		if curbp := p.CurrentThread().Breakpoint().Breakpoint; curbp == nil || (curbp.LogicalID() != bp.LogicalID()) {
 			t.Fatal("breakpoint not set")
@@ -5445,7 +5495,7 @@ func TestWatchpointsBasic(t *testing.T)
 		assertNoError(err, t, "SetDataBreakpoint(write-only, again)")
 
 		assertNoError(grp.Continue(), t, "Continue 5")
-		assertLineNumber(p, t, position5, "Continue 5") // Position 5
+		assertLineNumberIn(p, t, position5, "Continue 5") // Position 5
 	})
 }
 
@@ -5454,6 +5504,9 @@ func TestWatchpointCounts(t *testing.T)
 	skipOn(t, "not implemented", "386")
 	skipOn(t, "see https://github.com/go-delve/delve/issues/2768", "windows")
 	skipOn(t, "not implemented", "ppc64le")
+	if _, isTeamCityTest := os.LookupEnv("TEAMCITY_VERSION"); isTeamCityTest {
+		skipOn(t, "CI is running a version of macOS that is too old (11.2)", "darwin", "arm64")
+	}
 	protest.AllowRecording(t)
 
 	withTestProcess("databpcountstest", t, func(p *proc.Target, grp *proc.TargetGroup, fixture protest.Fixture) {
@@ -5468,7 +5521,7 @@ func TestWatchpointCounts(t *testing.T)
 
 		for {
 			if err := grp.Continue(); err != nil {
-				if _, exited := err.(proc.ErrProcessExited); exited {
+				if errors.As(err, &proc.ErrProcessExited{}) {
 					break
 				}
 				assertNoError(err, t, "Continue()")
@@ -5570,13 +5623,12 @@ func TestWatchpointStack(t *testing.T) {
 	skipOn(t, "not implemented", "386")
 	skipOn(t, "not implemented", "ppc64le")
 	skipOn(t, "see https://github.com/go-delve/delve/issues/2768", "windows")
+	if _, isTeamCityTest := os.LookupEnv("TEAMCITY_VERSION"); isTeamCityTest {
+		skipOn(t, "CI is running a version of macOS that is too old (11.2)", "darwin", "arm64")
+	}
 	protest.AllowRecording(t)
 
-	position1 := 17
-
-	if runtime.GOARCH == "arm64" {
-		position1 = 16
-	}
+	position1 := []int{16, 17}
 
 	withTestProcess("databpstack", t, func(p *proc.Target, grp *proc.TargetGroup, fixture protest.Fixture) {
 		setFileBreakpoint(p, t, fixture.Source, 11) // Position 0 breakpoint
@@ -5625,7 +5677,7 @@ func TestWatchpointStack(t *testing.T) {
 		}
 
 		assertNoError(grp.Continue(), t, "Continue 1")
-		assertLineNumber(p, t, position1, "Continue 1") // Position 1
+		assertLineNumberIn(p, t, position1, "Continue 1") // Position 1
 
 		assertNoError(grp.Continue(), t, "Continue 2")
 		t.Logf("%#v", p.CurrentThread().Breakpoint().Breakpoint)
@@ -6157,3 +6209,1261 @@ func TestPanicLine(t *testing.T) {
 		}
 	})
 }
+
+func TestReadClosure(t *testing.T) {
+	if !goversion.VersionAfterOrEqual(runtime.Version(), 1, 23) {
+		t.Skip("not implemented")
+	}
+	withTestProcess("closurecontents", t, func(p *proc.Target, grp *proc.TargetGroup, fixture protest.Fixture) {
+		avalues := []int64{0, 3, 9, 27}
+		for i := 0; i < 4; i++ {
+			assertNoError(grp.Continue(), t, "Continue()")
+			accV := evalVariable(p, t, "acc")
+			t.Log(api.ConvertVar(accV).MultilineString("", ""))
+			if len(accV.Children) != 2 {
+				t.Error("wrong number of children")
+			} else {
+				found := 0
+				for j := range accV.Children {
+					v := &accV.Children[j]
+					switch v.Name {
+					case "scale":
+						found++
+						if val, _ := constant.Int64Val(v.Value); val != 3 {
+							t.Error("wrong value for scale")
+						}
+					case "a":
+						found++
+						if val, _ := constant.Int64Val(v.Value); val != avalues[i] {
+							t.Errorf("wrong value for a: %d", val)
+						}
+					}
+				}
+				if found != 2 {
+					t.Error("wrong captured variables")
+				}
+			}
+		}
+	})
+}
+
+func TestStepIntoGoroutine(t *testing.T) {
+	testseq2(t, "goroutinestackprog", "", []seqTest{
+		{contContinue, 23},
+		{contStep, 7},
+		{contNothing, func(p *proc.Target) {
+			vari := api.ConvertVar(evalVariable(p, t, "i"))
+			varis := vari.SinglelineString()
+			t.Logf("i = %s", varis)
+			if varis != "0" {
+				t.Fatalf("wrong value for variable i: %s", vari.SinglelineString())
+			}
+		}},
+	})
+}
+
+func TestRangeOverFuncNext(t *testing.T) {
+	if !goversion.VersionAfterOrEqual(runtime.Version(), 1, 23) {
+		t.Skip("N/A")
+	}
+
+	var bp *proc.Breakpoint
+
+	funcBreak := func(t *testing.T, fnname string) seqTest {
+		return seqTest{
+			contNothing,
+			func(p *proc.Target) {
+				bp = setFunctionBreakpoint(p, t, fnname)
+			}}
+	}
+
+	clearBreak := func(t *testing.T) seqTest {
+		return seqTest{
+			contNothing,
+			func(p *proc.Target) {
+				assertNoError(p.ClearBreakpoint(bp.Addr), t, "ClearBreakpoint")
+			}}
+	}
+
+	notAtEntryPoint := func(t *testing.T) seqTest {
+		return seqTest{contNothing, func(p *proc.Target) {
+			pc := currentPC(p, t)
+			fn := p.BinInfo().PCToFunc(pc)
+			if pc == fn.Entry {
+				t.Fatalf("current PC is entry point")
+			}
+		}}
+	}
+
+	nx := func(n int) seqTest {
+		return seqTest{contNext, n}
+	}
+
+	assertLocals := func(t *testing.T, varnames ...string) seqTest {
+		return seqTest{
+			contNothing,
+			func(p *proc.Target) {
+				scope, err := proc.GoroutineScope(p, p.CurrentThread())
+				assertNoError(err, t, "GoroutineScope")
+				vars, err := scope.Locals(0, "")
+				assertNoError(err, t, "Locals")
+
+				gotnames := make([]string, len(vars))
+				for i := range vars {
+					gotnames[i] = vars[i].Name
+				}
+
+				ok := true
+				if len(vars) != len(varnames) {
+					ok = false
+				} else {
+					for i := range vars {
+						if vars[i].Name != varnames[i] {
+							ok = false
+							break
+						}
+					}
+				}
+				if !ok {
+					t.Errorf("Wrong variable names, expected %q, got %q", varnames, gotnames)
+				}
+			},
+		}
+	}
+
+	assertEval := func(t *testing.T, exprvals ...string) seqTest {
+		return seqTest{
+			contNothing,
+			func(p *proc.Target) {
+				scope, err := proc.GoroutineScope(p, p.CurrentThread())
+				assertNoError(err, t, "GoroutineScope")
+				for i := 0; i < len(exprvals); i += 2 {
+					expr, tgt := exprvals[i], exprvals[i+1]
+					v, err := scope.EvalExpression(expr, normalLoadConfig)
+					if err != nil {
+						t.Errorf("Could not evaluate %q: %v", expr, err)
+					} else {
+						out := api.ConvertVar(v).SinglelineString()
+						if out != tgt {
+							t.Errorf("Wrong value for %q, got %q expected %q", expr, out, tgt)
+						}
+					}
+				}
+			},
+		}
+	}
+
+	assertFunc := func(t *testing.T, fname string) seqTest {
+		return seqTest{
+			contNothing,
+			func(p *proc.Target) {
+				pc := currentPC(p, t)
+				fn := p.BinInfo().PCToFunc(pc)
+				if fn.Name != fname {
+					t.Errorf("Wrong function name, expected %s got %s", fname, fn.Name)
+				}
+			},
+		}
+	}
+
+	withTestProcessArgs("rangeoverfunc", t, ".", []string{}, 0, func(p *proc.Target, grp *proc.TargetGroup, fixture protest.Fixture) {
+		t.Run("TestTrickyIterAll1", func(t *testing.T) {
+			testseq2intl(t, fixture, grp, p, nil, []seqTest{
+				funcBreak(t, "main.TestTrickyIterAll"),
+				{contContinue, 24}, // TestTrickyIterAll
+				nx(25),
+				nx(26),
+				nx(27), // for _, x := range ...
+				assertLocals(t, "trickItAll", "i"),
+				assertEval(t, "i", "0"),
+				nx(27), // for _, x := range ... (TODO: this probably shouldn't be here but it's also very hard to skip stopping here a second time)
+				nx(28), // i += x
+				assertLocals(t, "trickItAll", "i", "x"),
+				assertEval(t,
+					"i", "0",
+					"x", "30"),
+				nx(29), // if i >= 36 {
+				nx(32),
+				nx(27), // for _, x := range ...
+				notAtEntryPoint(t),
+				nx(28), // i += x
+				assertEval(t,
+					"i", "30",
+					"x", "7"),
+				nx(29), // if i >= 36 {
+				nx(30), // break
+				nx(32),
+				nx(34), // fmt.Println
+			})
+		})
+
+		t.Run("TestTrickyIterAll2", func(t *testing.T) {
+			testseq2intl(t, fixture, grp, p, nil, []seqTest{
+				funcBreak(t, "main.TestTrickyIterAll2"),
+				{contContinue, 37}, // TestTrickyIterAll2
+				nx(38),
+				nx(39),
+				nx(40), // for _, x := range...
+				nx(40),
+				nx(41),
+				nx(42),
+				nx(40),
+				notAtEntryPoint(t),
+				nx(41),
+				nx(42),
+				nx(42), // different function from the one above...
+				nx(43),
+			})
+		})
+
+		t.Run("TestBreak1", func(t *testing.T) {
+			testseq2intl(t, fixture, grp, p, nil, []seqTest{
+				funcBreak(t, "main.TestBreak1"),
+				{contContinue, 46}, // TestBreak1
+				nx(47),
+				nx(48), // for _, x := range... (x == -1)
+				nx(48),
+				nx(49), // if x == -4
+				assertLocals(t, "result", "x"),
+				assertEval(t,
+					"result", "[]int len: 0, cap: 0, nil",
+					"x", "-1"),
+
+				nx(52), // for _, y := range... (y == 1)
+				nx(52),
+				nx(53), // if y == 3
+				assertLocals(t, "result", "x", "y"),
+				assertEval(t,
+					"result", "[]int len: 0, cap: 0, nil",
+					"x", "-1",
+					"y", "1"),
+				nx(56), // result = append(result, y)
+				nx(57),
+				nx(52), // for _, y := range... (y == 2)
+				notAtEntryPoint(t),
+				nx(53), // if y == 3
+				assertEval(t,
+					"x", "-1",
+					"y", "2"),
+				nx(56), // result = append(result, y)
+				nx(57),
+				nx(52), // for _, y := range... (y == 3)
+				nx(53), // if y == 3
+				assertEval(t,
+					"x", "-1",
+					"y", "3"),
+				nx(54), // break
+				nx(57),
+				nx(58), // result = append(result, x)
+				nx(59),
+
+				nx(48), // for _, x := range... (x == -2)
+				notAtEntryPoint(t),
+				nx(49), // if x == -4
+				assertEval(t,
+					"result", "[]int len: 3, cap: 4, [1,2,-1]",
+					"x", "-2"),
+				nx(52), // for _, y := range... (y == 1)
+				nx(52),
+				nx(53), // if y == 3
+				nx(56), // result = append(result, y)
+				nx(57),
+				nx(52), // for _, y := range... (y == 2)
+				notAtEntryPoint(t),
+				nx(53), // if y == 3
+				nx(56), // result = append(result, y)
+				nx(57),
+				nx(52), // for _, y := range... (y == 3)
+				nx(53), // if y == 3
+				nx(54), // break
+				nx(57),
+				nx(58), // result = append(result, x)
+				nx(59),
+
+				nx(48), // for _, x := range... (x == -4)
+				assertEval(t,
+					"result", "[]int len: 6, cap: 8, [1,2,-1,1,2,-2]",
+					"x", "-4"),
+				nx(49), // if x == -4
+				nx(50), // break
+				nx(59),
+				nx(60),
+				nx(61),
+			})
+		})
+
+		t.Run("TestBreak2", func(t *testing.T) {
+			testseq2intl(t, fixture, grp, p, nil, []seqTest{
+				funcBreak(t, "main.TestBreak2"),
+
+				{contContinue, 63}, // TestBreak2
+				nx(64),
+				nx(65),
+
+				nx(66), // for _, x := range (x == -1)
+				nx(66),
+				nx(67), // for _, y := range (y == 1)
+				nx(67),
+				nx(68), // if y == 3
+				nx(71), // if x == -4
+				nx(74), // result = append(result, y)
+				nx(75),
+
+				nx(67), // for _, y := range (y == 2)
+				nx(68), // if y == 3
+				nx(71), // if x == -4
+				nx(74), // result = append(result, y)
+				nx(75),
+
+				nx(67), // for _, y := range (y == 3)
+				nx(68), // if y == 3
+				nx(69), // break
+				nx(75),
+				nx(76), // result = append(result, x)
+				nx(77),
+
+				nx(66), // for _, x := range (x == -2)
+				nx(67), // for _, y := range (y == 1)
+				nx(67),
+				nx(68), // if y == 3
+				nx(71), // if x == -4
+				nx(74), // result = append(result, y)
+				nx(75),
+
+				nx(67), // for _, y := range (y == 2)
+				nx(68), // if y == 3
+				nx(71), // if x == -4
+				nx(74), // result = append(result, y)
+				nx(75),
+
+				nx(67), // for _, y := range (y == 3)
+				nx(68), // if y == 3
+				nx(69), // break
+				nx(75),
+				nx(76), // result = append(result, x)
+				nx(77),
+
+				nx(66), // for _, x := range (x == -4)
+				nx(67), // for _, y := range (y == 1)
+				nx(67),
+				nx(68), // if y == 3
+				nx(71), // if x == -4
+				nx(72), // break outer
+				nx(75),
+				nx(77),
+				nx(78),
+				nx(79),
+			})
+		})
+
+		t.Run("TestMultiCont0", func(t *testing.T) {
+			testseq2intl(t, fixture, grp, p, nil, []seqTest{
+				funcBreak(t, "main.TestMultiCont0"),
+				{contContinue, 81},
+				nx(82),
+				nx(84),
+				nx(85), // for _, w := range (w == 1000)
+				nx(85),
+				nx(86), // result = append(result, w)
+				assertEval(t,
+					"w", "1000",
+					"result", "[]int len: 0, cap: 0, nil"),
+				nx(87), // if w == 2000
+				assertLocals(t, "result", "w"),
+				assertEval(t, "result", "[]int len: 1, cap: 1, [1000]"),
+				nx(90), // for _, x := range (x == 100)
+				nx(90),
+				nx(91), // for _, y := range (y == 10)
+				nx(91),
+				nx(92), // result = append(result, y)
+				assertLocals(t, "result", "w", "x", "y"),
+				assertEval(t,
+					"w", "1000",
+					"x", "100",
+					"y", "10"),
+
+				nx(93), // for _, z := range (z == 1)
+				nx(93),
+				nx(94), // if z&1 == 1
+				assertLocals(t, "result", "w", "x", "y", "z"),
+				assertEval(t,
+					"w", "1000",
+					"x", "100",
+					"y", "10",
+					"z", "1"),
+				nx(95), // continue
+
+				nx(93), // for _, z := range (z == 2)
+				nx(94), // if z&1 == 1
+				assertEval(t, "z", "2"),
+				nx(97), // result = append(result, z)
+				nx(98), // if z >= 4 {
+				nx(101),
+
+				nx(93), // for _, z := range (z == 3)
+				nx(94), // if z&1 == 1
+				assertEval(t, "z", "3"),
+				nx(95), // continue
+
+				nx(93), // for _, z := range (z == 4)
+				nx(94), // if z&1 == 1
+				assertEval(t, "z", "4"),
+				nx(97), // result = append(result, z)
+				assertEval(t, "result", "[]int len: 3, cap: 4, [1000,10,2]"),
+				nx(98), // if z >= 4 {
+				nx(99), // continue W
+				nx(101),
+				nx(103),
+				nx(105),
+
+				nx(85), // for _, w := range (w == 2000)
+				nx(86), // result = append(result, w)
+				nx(87), // if w == 2000
+				assertEval(t,
+					"w", "2000",
+					"result", "[]int len: 5, cap: 8, [1000,10,2,4,2000]"),
+				nx(88), // break
+				nx(106),
+				nx(107), // fmt.Println
+			})
+		})
+
+		t.Run("TestPanickyIterator1", func(t *testing.T) {
+			testseq2intl(t, fixture, grp, p, nil, []seqTest{
+				funcBreak(t, "main.TestPanickyIterator1"),
+				{contContinue, 110},
+				nx(111),
+				nx(112),
+				nx(116), // for _, z := range (z == 1)
+				nx(116),
+				nx(117), // result = append(result, z)
+				nx(118), // if z == 4
+				nx(121),
+
+				nx(116), // for _, z := range (z == 2)
+				nx(117), // result = append(result, z)
+				nx(118), // if z == 4
+				nx(121),
+
+				nx(116), // for _, z := range (z == 3)
+				nx(117), // result = append(result, z)
+				nx(118), // if z == 4
+				nx(121),
+
+				nx(116), // for _, z := range (z == 4)
+				nx(117), // result = append(result, z)
+				nx(118), // if z == 4
+				nx(119), // break
+
+				nx(112), // defer func()
+				nx(113), // r := recover()
+				nx(114), // fmt.Println
+			})
+		})
+
+		t.Run("TestPanickyIterator2", func(t *testing.T) {
+			testseq2intl(t, fixture, grp, p, nil, []seqTest{
+				funcBreak(t, "main.TestPanickyIterator2"),
+				{contContinue, 125},
+				nx(126),
+				nx(127),
+				nx(131), // for _, x := range (x == 100)
+				nx(131),
+				nx(132),
+				nx(133),
+				nx(135), // for _, y := range (y == 10)
+				nx(135),
+				nx(136), // result = append(result, y)
+				nx(139), // for k, z := range (k == 0, z == 1)
+				nx(139),
+				nx(140), // result = append(result, z)
+				nx(141), // if k == 1
+				nx(144),
+
+				nx(139), // for k, z := range (k == 1, z == 2)
+				nx(140), // result = append(result, z)
+				nx(141), // if k == 1
+				nx(142), // break Y
+				nx(135),
+				nx(145),
+				nx(127), // defer func()
+				nx(128), // r := recover()
+				nx(129), // fmt.Println
+			})
+		})
+
+		t.Run("TestPanickyIteratorWithNewDefer", func(t *testing.T) {
+			testseq2intl(t, fixture, grp, p, nil, []seqTest{
+				funcBreak(t, "main.TestPanickyIteratorWithNewDefer"),
+				{contContinue, 149},
+				nx(150),
+				nx(151),
+				nx(155), // for _, x := range (x == 100)
+				nx(155),
+				nx(156),
+				nx(157),
+				nx(159), // for _, y := range (y == 10)
+				nx(159),
+				nx(160),
+				nx(163), // result = append(result, y)
+				nx(166), // for k, z := range (k == 0, z == 1)
+				nx(166),
+				nx(167), // result = append(result, z)
+				nx(168), // if k == 1
+				nx(171),
+
+				nx(166), // for k, z := range (k == 0, z == 1)
+				nx(167), // result = append(result, z)
+				nx(168), // if k == 1
+				nx(169), // break Y
+				nx(159),
+				nx(172),
+				nx(160), // defer func()
+				nx(161), // fmt.Println
+			})
+		})
+
+		t.Run("TestLongReturn", func(t *testing.T) {
+			testseq2intl(t, fixture, grp, p, nil, []seqTest{
+				funcBreak(t, "main.TestLongReturn"),
+				{contContinue, 181},
+				nx(182), // for _, x := range (x == 1)
+				nx(182),
+				nx(183), // for _, y := range (y == 10)
+				nx(183),
+				nx(184), // if y == 10
+				nx(185), // return
+				nx(187),
+				nx(189),
+				nx(178), // into TestLongReturnWrapper, fmt.Println
+			})
+		})
+
+		t.Run("TestGotoA1", func(t *testing.T) {
+			testseq2intl(t, fixture, grp, p, nil, []seqTest{
+				funcBreak(t, "main.TestGotoA1"),
+				{contContinue, 192},
+				nx(193),
+				nx(194), // for _, x := range (x == -1)
+				nx(194),
+				nx(195), // result = append(result, x)
+				nx(196), // if x == -4
+				nx(199), // for _, y := range (y == 1)
+				nx(199),
+				nx(200), // if y == 3
+				nx(203), // result = append(result, y)
+				nx(204),
+
+				nx(199), // for _, y := range (y == 2)
+				nx(200), // if y == 3
+				nx(203), // result = append(result, y)
+				nx(204),
+
+				nx(199), // for _, y := range (y == 3)
+				nx(200), // if y == 3
+				nx(201), // goto A
+				nx(204),
+				nx(206), // result = append(result, x)
+				nx(207),
+
+				nx(194), // for _, x := range (x == -4)
+				nx(195), // result = append(result, x)
+				nx(196), // if x == -4
+				nx(197), // break
+				nx(207),
+				nx(208), // fmt.Println
+			})
+		})
+
+		t.Run("TestGotoB1", func(t *testing.T) {
+			testseq2intl(t, fixture, grp, p, nil, []seqTest{
+				funcBreak(t, "main.TestGotoB1"),
+				{contContinue, 211},
+				nx(212),
+				nx(213), // for _, x := range (x == -1)
+				nx(213),
+				nx(214), // result = append(result, x)
+				nx(215), // if x == -4
+				nx(218), // for _, y := range (y == 1)
+				nx(218),
+				nx(219), // if y == 3
+				nx(222), // result = append(result, y)
+				nx(223),
+
+				nx(218), // for _, y := range (y == 2)
+				nx(219), // if y == 3
+				nx(222), // result = append(result, y)
+				nx(223),
+
+				nx(218), // for _, y := range (y == 3)
+				nx(219), // if y == 3
+				nx(220), // goto B
+				nx(223),
+				nx(225),
+				nx(227), // result = append(result, 999)
+				nx(228), // fmt.Println
+			})
+		})
+
+		t.Run("TestRecur", func(t *testing.T) {
+			testseq2intl(t, fixture, grp, p, nil, []seqTest{
+				funcBreak(t, "main.TestRecur"),
+				{contContinue, 231},
+				clearBreak(t),
+				nx(232), // result := []int{}
+				assertEval(t, "n", "3"),
+				nx(233), // if n > 0 {
+				nx(234), // TestRecur
+
+				nx(236), // for _, x := range (x == 10)
+				assertFunc(t, "main.TestRecur"),
+				assertEval(t, "n", "3"),
+				nx(236),
+				assertFunc(t, "main.TestRecur-range1"),
+				assertEval(t, "x", "10", "n", "3"),
+				nx(237), // result = ...
+				nx(238), // if n == 3
+				nx(239), // TestRecur(0)
+				nx(241),
+
+				nx(236), // for _, x := range (x == 20)
+				nx(237), // result = ...
+				assertEval(t, "x", "20", "n", "3"),
+			})
+		})
+	})
+}
+
+func TestRangeOverFuncStepOut(t *testing.T) {
+	if !goversion.VersionAfterOrEqual(runtime.Version(), 1, 23) {
+		t.Skip("N/A")
+	}
+
+	testseq2(t, "rangeoverfunc", "", []seqTest{
+		{contContinue, 97},
+		{contStepout, 251},
+	})
+}
+
+func TestRangeOverFuncNextInlined(t *testing.T) {
+	if !goversion.VersionAfterOrEqual(runtime.Version(), 1, 23) {
+		t.Skip("N/A")
+	}
+
+	var bp *proc.Breakpoint
+
+	funcBreak := func(t *testing.T, fnname string) seqTest {
+		return seqTest{
+			contNothing,
+			func(p *proc.Target) {
+				bp = setFunctionBreakpoint(p, t, fnname)
+			}}
+	}
+
+	clearBreak := func(t *testing.T) seqTest {
+		return seqTest{
+			contNothing,
+			func(p *proc.Target) {
+				assertNoError(p.ClearBreakpoint(bp.Addr), t, "ClearBreakpoint")
+			}}
+	}
+
+	nx := func(n int) seqTest {
+		return seqTest{contNext, n}
+	}
+
+	assertLocals := func(t *testing.T, varnames ...string) seqTest {
+		return seqTest{
+			contNothing,
+			func(p *proc.Target) {
+				scope, err := proc.GoroutineScope(p, p.CurrentThread())
+				assertNoError(err, t, "GoroutineScope")
+				vars, err := scope.Locals(0, "")
+				assertNoError(err, t, "Locals")
+
+				gotnames := make([]string, len(vars))
+				for i := range vars {
+					gotnames[i] = vars[i].Name
+				}
+
+				ok := true
+				if len(vars) != len(varnames) {
+					ok = false
+				} else {
+					for i := range vars {
+						if vars[i].Name != varnames[i] {
+							ok = false
+							break
+						}
+					}
+				}
+				if !ok {
+					t.Errorf("Wrong variable names, expected %q, got %q", varnames, gotnames)
+				}
+			},
+		}
+	}
+
+	assertEval := func(t *testing.T, exprvals ...string) seqTest {
+		return seqTest{
+			contNothing,
+			func(p *proc.Target) {
+				scope, err := proc.GoroutineScope(p, p.CurrentThread())
+				assertNoError(err, t, "GoroutineScope")
+				for i := 0; i < len(exprvals); i += 2 {
+					expr, tgt := exprvals[i], exprvals[i+1]
+					v, err := scope.EvalExpression(expr, normalLoadConfig)
+					if err != nil {
+						t.Errorf("Could not evaluate %q: %v", expr, err)
+					} else {
+						out := api.ConvertVar(v).SinglelineString()
+						if out != tgt {
+							t.Errorf("Wrong value for %q, got %q expected %q", expr, out, tgt)
+						}
+					}
+				}
+			},
+		}
+	}
+
+	assertFunc := func(t *testing.T, fname string) seqTest {
+		return seqTest{
+			contNothing,
+			func(p *proc.Target) {
+				pc := currentPC(p, t)
+				fn := p.BinInfo().PCToFunc(pc)
+				if fn.Name != fname {
+					t.Errorf("Wrong function name, expected %s got %s", fname, fn.Name)
+				}
+			},
+		}
+	}
+
+	withTestProcessArgs("rangeoverfunc", t, ".", []string{}, protest.EnableInlining, func(p *proc.Target, grp *proc.TargetGroup, fixture protest.Fixture) {
+		t.Run("TestTrickyIterAll1", func(t *testing.T) {
+			testseq2intl(t, fixture, grp, p, nil, []seqTest{
+				funcBreak(t, "main.TestTrickyIterAll"),
+				{contContinue, 24}, // TestTrickyIterAll
+				nx(25),
+				nx(26),
+				nx(27), // for _, x := range ...
+				assertLocals(t, "trickItAll", "i"),
+				assertEval(t, "i", "0"),
+				nx(27), // for _, x := range ... (TODO: this probably shouldn't be here but it's also very hard to skip stopping here a second time)
+				nx(28), // i += x
+				assertLocals(t, "trickItAll", "i", "x"),
+				assertEval(t,
+					"i", "0",
+					"x", "30"),
+				nx(29), // if i >= 36 {
+				nx(32),
+				nx(27), // for _, x := range ...
+				nx(28), // i += x
+				assertEval(t,
+					"i", "30",
+					"x", "7"),
+				nx(29), // if i >= 36 {
+				nx(30), // break
+				nx(27),
+				nx(32),
+				nx(34), // fmt.Println
+			})
+		})
+
+		t.Run("TestTrickyIterAll2", func(t *testing.T) {
+			testseq2intl(t, fixture, grp, p, nil, []seqTest{
+				funcBreak(t, "main.TestTrickyIterAll2"),
+				{contContinue, 37}, // TestTrickyIterAll2
+				nx(38),
+				nx(39),
+				nx(40), // for _, x := range...
+				nx(41),
+				nx(42),
+				nx(40),
+				nx(41),
+				nx(42),
+				nx(40),
+				nx(42),
+				nx(43),
+			})
+		})
+
+		t.Run("TestBreak1", func(t *testing.T) {
+			testseq2intl(t, fixture, grp, p, nil, []seqTest{
+				funcBreak(t, "main.TestBreak1"),
+				{contContinue, 46}, // TestBreak1
+				nx(47),
+				nx(48), // for _, x := range... (x == -1)
+				nx(48),
+				nx(49), // if x == -4
+				assertLocals(t, "result", "x"),
+				assertEval(t,
+					"result", "[]int len: 0, cap: 0, nil",
+					"x", "-1"),
+
+				nx(52), // for _, y := range... (y == 1)
+				nx(52),
+				nx(53), // if y == 3
+				assertLocals(t, "result", "x", "y"),
+				assertEval(t,
+					"result", "[]int len: 0, cap: 0, nil",
+					"x", "-1",
+					"y", "1"),
+				nx(56), // result = append(result, y)
+				nx(57),
+				nx(52), // for _, y := range... (y == 2)
+				nx(53), // if y == 3
+				assertEval(t,
+					"x", "-1",
+					"y", "2"),
+				nx(56), // result = append(result, y)
+				nx(57),
+				nx(52), // for _, y := range... (y == 3)
+				nx(53), // if y == 3
+				assertEval(t,
+					"x", "-1",
+					"y", "3"),
+				nx(54), // break
+				nx(52),
+				nx(57),
+				nx(58), // result = append(result, x)
+				nx(59),
+
+				nx(48), // for _, x := range... (x == -2)
+				nx(49), // if x == -4
+				assertEval(t,
+					"result", "[]int len: 3, cap: 4, [1,2,-1]",
+					"x", "-2"),
+				nx(52), // for _, y := range... (y == 1)
+				nx(52),
+				nx(53), // if y == 3
+				nx(56), // result = append(result, y)
+				nx(57),
+				nx(52), // for _, y := range... (y == 2)
+				nx(53), // if y == 3
+				nx(56), // result = append(result, y)
+				nx(57),
+				nx(52), // for _, y := range... (y == 3)
+				nx(53), // if y == 3
+				nx(54), // break
+				nx(52),
+				nx(57),
+				nx(58), // result = append(result, x)
+				nx(59),
+
+				nx(48), // for _, x := range... (x == -4)
+				assertEval(t,
+					"result", "[]int len: 6, cap: 8, [1,2,-1,1,2,-2]",
+					"x", "-4"),
+				nx(49), // if x == -4
+				nx(50), // break
+				nx(48),
+				nx(59),
+				nx(60),
+				nx(61),
+			})
+		})
+
+		t.Run("TestBreak2", func(t *testing.T) {
+			testseq2intl(t, fixture, grp, p, nil, []seqTest{
+				funcBreak(t, "main.TestBreak2"),
+
+				{contContinue, 63}, // TestBreak2
+				nx(64),
+				nx(65),
+
+				nx(66), // for _, x := range (x == -1)
+				nx(66),
+				nx(67), // for _, y := range (y == 1)
+				nx(67),
+				nx(68), // if y == 3
+				nx(71), // if x == -4
+				nx(74), // result = append(result, y)
+				nx(75),
+
+				nx(67), // for _, y := range (y == 2)
+				nx(68), // if y == 3
+				nx(71), // if x == -4
+				nx(74), // result = append(result, y)
+				nx(75),
+
+				nx(67), // for _, y := range (y == 3)
+				nx(68), // if y == 3
+				nx(69), // break
+				nx(67),
+				nx(75),
+				nx(76), // result = append(result, x)
+				nx(77),
+
+				nx(66), // for _, x := range (x == -2)
+				nx(67), // for _, y := range (y == 1)
+				nx(67),
+				nx(68), // if y == 3
+				nx(71), // if x == -4
+				nx(74), // result = append(result, y)
+				nx(75),
+
+				nx(67), // for _, y := range (y == 2)
+				nx(68), // if y == 3
+				nx(71), // if x == -4
+				nx(74), // result = append(result, y)
+				nx(75),
+
+				nx(67), // for _, y := range (y == 3)
+				nx(68), // if y == 3
+				nx(69), // break
+				nx(67),
+				nx(75),
+				nx(76), // result = append(result, x)
+				nx(77),
+
+				nx(66), // for _, x := range (x == -4)
+				nx(67), // for _, y := range (y == 1)
+				nx(67),
+				nx(68), // if y == 3
+				nx(71), // if x == -4
+				nx(72), // break outer
+				nx(67),
+				nx(75),
+				nx(66),
+				nx(77),
+				nx(78),
+				nx(79),
+			})
+		})
+
+		t.Run("TestMultiCont0", func(t *testing.T) {
+			testseq2intl(t, fixture, grp, p, nil, []seqTest{
+				funcBreak(t, "main.TestMultiCont0"),
+				{contContinue, 81},
+				nx(82),
+				nx(84),
+				nx(85), // for _, w := range (w == 1000)
+				nx(85),
+				nx(86), // result = append(result, w)
+				assertEval(t,
+					"w", "1000",
+					"result", "[]int len: 0, cap: 0, nil"),
+				nx(87), // if w == 2000
+				assertLocals(t, "result", "w"),
+				assertEval(t, "result", "[]int len: 1, cap: 1, [1000]"),
+				nx(90), // for _, x := range (x == 100)
+				nx(90),
+				nx(91), // for _, y := range (y == 10)
+				nx(91),
+				nx(92), // result = append(result, y)
+				assertLocals(t, "result", "w", "x", "y"),
+				assertEval(t,
+					"w", "1000",
+					"x", "100",
+					"y", "10"),
+
+				nx(93), // for _, z := range (z == 1)
+				nx(93),
+				nx(94), // if z&1 == 1
+				assertLocals(t, "result", "w", "x", "y", "z"),
+				assertEval(t,
+					"w", "1000",
+					"x", "100",
+					"y", "10",
+					"z", "1"),
+				nx(95), // continue
+
+				nx(93), // for _, z := range (z == 2)
+				nx(94), // if z&1 == 1
+				assertEval(t, "z", "2"),
+				nx(97), // result = append(result, z)
+				nx(98), // if z >= 4 {
+				nx(101),
+
+				nx(93), // for _, z := range (z == 3)
+				nx(94), // if z&1 == 1
+				assertEval(t, "z", "3"),
+				nx(95), // continue
+
+				nx(93), // for _, z := range (z == 4)
+				nx(94), // if z&1 == 1
+				assertEval(t, "z", "4"),
+				nx(97), // result = append(result, z)
+				assertEval(t, "result", "[]int len: 3, cap: 4, [1000,10,2]"),
+				nx(98), // if z >= 4 {
+				nx(99), // continue W
+				nx(93),
+				nx(101),
+				nx(91),
+				nx(103),
+				nx(90),
+				nx(105),
+
+				nx(85), // for _, w := range (w == 2000)
+				nx(86), // result = append(result, w)
+				nx(87), // if w == 2000
+				assertEval(t,
+					"w", "2000",
+					"result", "[]int len: 5, cap: 8, [1000,10,2,4,2000]"),
+				nx(88), // break
+				nx(85),
+				nx(106),
+				nx(107), // fmt.Println
+			})
+		})
+
+		t.Run("TestPanickyIterator1", func(t *testing.T) {
+			testseq2intl(t, fixture, grp, p, nil, []seqTest{
+				funcBreak(t, "main.TestPanickyIterator1"),
+				{contContinue, 110},
+				nx(111),
+				nx(112),
+				nx(116), // for _, z := range (z == 1)
+				nx(116),
+				nx(117), // result = append(result, z)
+				nx(118), // if z == 4
+				nx(121),
+
+				nx(116), // for _, z := range (z == 2)
+				nx(117), // result = append(result, z)
+				nx(118), // if z == 4
+				nx(121),
+
+				nx(116), // for _, z := range (z == 3)
+				nx(117), // result = append(result, z)
+				nx(118), // if z == 4
+				nx(121),
+
+				nx(116), // for _, z := range (z == 4)
+				nx(117), // result = append(result, z)
+				nx(118), // if z == 4
+				nx(119), // break
+
+				nx(112), // defer func()
+				nx(113), // r := recover()
+				nx(114), // fmt.Println
+			})
+		})
+
+		t.Run("TestPanickyIterator2", func(t *testing.T) {
+			testseq2intl(t, fixture, grp, p, nil, []seqTest{
+				funcBreak(t, "main.TestPanickyIterator2"),
+				{contContinue, 125},
+				nx(126),
+				nx(127),
+				nx(131), // for _, x := range (x == 100)
+				nx(131),
+				nx(132),
+				nx(133),
+				nx(135), // for _, y := range (y == 10)
+				nx(135),
+				nx(136), // result = append(result, y)
+				nx(139), // for k, z := range (k == 0, z == 1)
+				nx(139),
+				nx(140), // result = append(result, z)
+				nx(141), // if k == 1
+				nx(144),
+
+				nx(139), // for k, z := range (k == 1, z == 2)
+				nx(140), // result = append(result, z)
+				nx(141), // if k == 1
+				nx(142), // break Y
+				nx(135),
+				nx(145),
+				nx(127), // defer func()
+				nx(128), // r := recover()
+				nx(129), // fmt.Println
+			})
+		})
+
+		t.Run("TestPanickyIteratorWithNewDefer", func(t *testing.T) {
+			testseq2intl(t, fixture, grp, p, nil, []seqTest{
+				funcBreak(t, "main.TestPanickyIteratorWithNewDefer"),
+				{contContinue, 149},
+				nx(150),
+				nx(151),
+				nx(155), // for _, x := range (x == 100)
+				nx(155),
+				nx(156),
+				nx(157),
+				nx(159), // for _, y := range (y == 10)
+				nx(159),
+				nx(160),
+				nx(163), // result = append(result, y)
+				nx(166), // for k, z := range (k == 0, z == 1)
+				nx(166),
+				nx(167), // result = append(result, z)
+				nx(168), // if k == 1
+				nx(171),
+
+				nx(166), // for k, z := range (k == 0, z == 1)
+				nx(167), // result = append(result, z)
+				nx(168), // if k == 1
+				nx(169), // break Y
+				nx(159),
+				nx(172),
+				nx(160), // defer func()
+				nx(161), // fmt.Println
+			})
+		})
+
+		t.Run("TestLongReturn", func(t *testing.T) {
+			testseq2intl(t, fixture, grp, p, nil, []seqTest{
+				funcBreak(t, "main.TestLongReturn"),
+				{contContinue, 181},
+				nx(182), // for _, x := range (x == 1)
+				nx(182),
+				nx(183), // for _, y := range (y == 10)
+				nx(183),
+				nx(184), // if y == 10
+				nx(185), // return
+				nx(183),
+				nx(187),
+				nx(182),
+				nx(189),
+				nx(178), // into TestLongReturnWrapper, fmt.Println
+			})
+		})
+
+		t.Run("TestGotoA1", func(t *testing.T) {
+			testseq2intl(t, fixture, grp, p, nil, []seqTest{
+				funcBreak(t, "main.TestGotoA1"),
+				{contContinue, 192},
+				nx(193),
+				nx(194), // for _, x := range (x == -1)
+				nx(194),
+				nx(195), // result = append(result, x)
+				nx(196), // if x == -4
+				nx(199), // for _, y := range (y == 1)
+				nx(199),
+				nx(200), // if y == 3
+				nx(203), // result = append(result, y)
+				nx(204),
+
+				nx(199), // for _, y := range (y == 2)
+				nx(200), // if y == 3
+				nx(203), // result = append(result, y)
+				nx(204),
+
+				nx(199), // for _, y := range (y == 3)
+				nx(200), // if y == 3
+				nx(201), // goto A
+				nx(199),
+				nx(204),
+				nx(206), // result = append(result, x)
+				nx(207),
+
+				nx(194), // for _, x := range (x == -4)
+				nx(195), // result = append(result, x)
+				nx(196), // if x == -4
+				nx(197), // break
+				nx(194),
+				nx(207),
+				nx(208), // fmt.Println
+			})
+		})
+
+		t.Run("TestGotoB1", func(t *testing.T) {
+			testseq2intl(t, fixture, grp, p, nil, []seqTest{
+				funcBreak(t, "main.TestGotoB1"),
+				{contContinue, 211},
+				nx(212),
+				nx(213), // for _, x := range (x == -1)
+				nx(213),
+				nx(214), // result = append(result, x)
+				nx(215), // if x == -4
+				nx(218), // for _, y := range (y == 1)
+				nx(218),
+				nx(219), // if y == 3
+				nx(222), // result = append(result, y)
+				nx(223),
+
+				nx(218), // for _, y := range (y == 2)
+				nx(219), // if y == 3
+				nx(222), // result = append(result, y)
+				nx(223),
+
+				nx(218), // for _, y := range (y == 3)
+				nx(219), // if y == 3
+				nx(220), // goto B
+				nx(218),
+				nx(223),
+				nx(213),
+				nx(225),
+				nx(227), // result = append(result, 999)
+				nx(228), // fmt.Println
+			})
+		})
+
+		t.Run("TestRecur", func(t *testing.T) {
+			testseq2intl(t, fixture, grp, p, nil, []seqTest{
+				funcBreak(t, "main.TestRecur"),
+				{contContinue, 231},
+				clearBreak(t),
+				nx(232), // result := []int{}
+				assertEval(t, "n", "3"),
+				nx(233), // if n > 0 {
+				nx(234), // TestRecur
+
+				nx(236), // for _, x := range (x == 10)
+				assertFunc(t, "main.TestRecur"),
+				assertEval(t, "n", "3"),
+				nx(236),
+				assertFunc(t, "main.TestRecur-range1"),
+				assertEval(t, "x", "10", "n", "3"),
+				nx(237), // result = ...
+				nx(238), // if n == 3
+				nx(239), // TestRecur(0)
+				nx(241),
+
+				nx(236), // for _, x := range (x == 20)
+				nx(237), // result = ...
+				assertEval(t, "x", "20", "n", "3"),
+			})
+		})
+	})
+}
+
+func TestStackwatchClearBug(t *testing.T) {
+	skipOn(t, "not implemented", "freebsd")
+	skipOn(t, "not implemented", "386")
+	skipOn(t, "not implemented", "ppc64le")
+	skipOn(t, "see https://github.com/go-delve/delve/issues/2768", "windows")
+
+	showbps := func(bps *proc.BreakpointMap) {
+		for _, bp := range bps.M {
+			t.Logf("\t%s\n", bp)
+		}
+	}
+
+	withTestProcess("stackwatchbug", t, func(p *proc.Target, grp *proc.TargetGroup, fixture protest.Fixture) {
+		setFileBreakpoint(p, t, fixture.Source, 9)
+		bpsBefore := p.Breakpoints()
+
+		assertNoError(grp.Continue(), t, "Continue 0")
+
+		scope, err := proc.GoroutineScope(p, p.CurrentThread())
+		assertNoError(err, t, "GoroutineScope")
+
+		for _, s := range []string{"vars[0]", "vars[3]", "vars[2]", "vars[1]"} {
+			_, err := p.SetWatchpoint(0, scope, s, proc.WatchWrite, nil)
+			assertNoError(err, t, "SetWatchpoint(write-only)")
+		}
+
+		t.Logf("After setting watchpoints:")
+		showbps(p.Breakpoints())
+
+		assertNoError(grp.Continue(), t, "Continue 1")
+		assertNoError(grp.Continue(), t, "Continue 2")
+		assertNoError(grp.Continue(), t, "Continue 3")
+		assertNoError(grp.Continue(), t, "Continue 4")
+		f, l := currentLineNumber(p, t)
+		t.Logf("at %s:%d", f, l)
+		if l != 19 {
+			t.Error("Wrong position after fourth continue")
+		}
+
+		bpsAfter := p.Breakpoints()
+		t.Logf("After watchpoint goes out of scope:")
+		showbps(bpsAfter)
+		if len(bpsBefore.M) != len(bpsAfter.M) {
+			t.Errorf("wrong number of breakpoints")
+		}
+	})
+}
diff -pruN 1.22.1-1/pkg/proc/scope_test.go 1.23.0-1/pkg/proc/scope_test.go
--- 1.22.1-1/pkg/proc/scope_test.go	2024-02-21 20:29:06.000000000 +0000
+++ 1.23.0-1/pkg/proc/scope_test.go	2024-07-16 18:44:48.000000000 +0000
@@ -114,7 +114,6 @@ func TestScope(t *testing.T) {
 			t.Errorf("breakpoint at line %d not hit", scopeChecks[i].line)
 		}
 	}
-
 }
 
 type scopeCheck struct {
@@ -288,7 +287,6 @@ func (varCheck *varCheck) checkInScope(l
 	v, err := scope.EvalExpression(varCheck.name, normalLoadConfig)
 	assertNoError(err, t, fmt.Sprintf("EvalVariable(%s)", varCheck.name))
 	varCheck.check(line, v, t, "EvalExpression")
-
 }
 
 func (varCheck *varCheck) check(line int, v *proc.Variable, t *testing.T, ctxt string) {
diff -pruN 1.22.1-1/pkg/proc/stack.go 1.23.0-1/pkg/proc/stack.go
--- 1.22.1-1/pkg/proc/stack.go	2024-02-21 20:29:06.000000000 +0000
+++ 1.23.0-1/pkg/proc/stack.go	2024-07-16 18:44:48.000000000 +0000
@@ -49,6 +49,8 @@ type Stackframe struct {
 	SystemStack bool
 	// Inlined is true if this frame is actually an inlined call.
 	Inlined bool
+	// hasInlines is true if this frame is a concrete function that is executing inlined calls (i.e. if there is at least one inlined call frame on top of this one).
+	hasInlines bool
 	// Bottom is true if this is the bottom of the stack
 	Bottom bool
 
@@ -63,6 +65,11 @@ type Stackframe struct {
 	// Use this value to determine active lexical scopes for the stackframe.
 	lastpc uint64
 
+	// closurePtr is the value of .closureptr, if present. This variable is
+	// used to correlated range-over-func closure bodies with their enclosing
+	// function.
+	closurePtr int64
+
 	// TopmostDefer is the defer that would be at the top of the stack when a
 	// panic unwind would get to this call frame, in other words it's the first
 	// deferred function that will  be called if the runtime unwinds past this
@@ -93,6 +100,12 @@ func (frame *Stackframe) FramePointerOff
 	return int64(frame.Regs.BP()) - int64(frame.stackHi)
 }
 
+// contains returns true if off is between CFA and SP
+func (frame *Stackframe) contains(off int64) bool {
+	p := uint64(off + int64(frame.stackHi))
+	return frame.Regs.SP() < p && p <= uint64(frame.Regs.CFA)
+}
+
 // ThreadStacktrace returns the stack trace for thread.
 // Note the locations in the array are return addresses not call addresses.
 func ThreadStacktrace(tgt *Target, thread Thread, depth int) ([]Stackframe, error) {
@@ -197,6 +210,8 @@ type stackIterator struct {
 	g0_sched_sp        uint64 // value of g0.sched.sp (see comments around its use)
 	g0_sched_sp_loaded bool   // g0_sched_sp was loaded from g0
 
+	count int
+
 	opts StacktraceOptions
 }
 
@@ -346,6 +361,19 @@ func (it *stackIterator) newStackframe(r
 			r.Call.File, r.Call.Line = r.Current.Fn.cu.lineInfo.PCToLine(r.Current.Fn.Entry, it.pc-1)
 		}
 	}
+	if fn != nil && !fn.cu.image.Stripped() && !r.SystemStack && it.g != nil {
+		dwarfTree, _ := fn.cu.image.getDwarfTree(fn.offset)
+		if dwarfTree != nil {
+			c := readLocalPtrVar(dwarfTree, goClosurePtr, it.target, it.bi, fn.cu.image, r.Regs, it.mem)
+			if c != 0 {
+				if c >= it.g.stack.lo && c < it.g.stack.hi {
+					r.closurePtr = int64(c) - int64(it.g.stack.hi)
+				} else {
+					r.closurePtr = int64(c)
+				}
+			}
+		}
+	}
 	return r
 }
 
@@ -353,17 +381,11 @@ func (it *stackIterator) stacktrace(dept
 	if depth < 0 {
 		return nil, errors.New("negative maximum stack depth")
 	}
-	if it.opts&StacktraceG != 0 && it.g != nil {
-		it.switchToGoroutineStack()
-		it.top = true
-	}
 	frames := make([]Stackframe, 0, depth+1)
-	for it.Next() {
-		frames = it.appendInlineCalls(frames, it.Frame())
-		if len(frames) >= depth+1 {
-			break
-		}
-	}
+	it.stacktraceFunc(func(frame Stackframe) bool {
+		frames = append(frames, frame)
+		return len(frames) < depth+1
+	})
 	if err := it.Err(); err != nil {
 		if len(frames) == 0 {
 			return nil, err
@@ -373,25 +395,41 @@ func (it *stackIterator) stacktrace(dept
 	return frames, nil
 }
 
-func (it *stackIterator) appendInlineCalls(frames []Stackframe, frame Stackframe) []Stackframe {
+func (it *stackIterator) stacktraceFunc(callback func(Stackframe) bool) {
+	if it.opts&StacktraceG != 0 && it.g != nil {
+		it.switchToGoroutineStack()
+		it.top = true
+	}
+	for it.Next() {
+		if !it.appendInlineCalls(callback, it.Frame()) {
+			break
+		}
+	}
+}
+
+func (it *stackIterator) appendInlineCalls(callback func(Stackframe) bool, frame Stackframe) bool {
 	if frame.Call.Fn == nil {
-		return append(frames, frame)
+		it.count++
+		return callback(frame)
 	}
 	if frame.Call.Fn.cu.lineInfo == nil {
-		return append(frames, frame)
+		it.count++
+		return callback(frame)
 	}
 
 	callpc := frame.Call.PC
-	if len(frames) > 0 {
+	if it.count > 0 {
 		callpc--
 	}
 
 	dwarfTree, err := frame.Call.Fn.cu.image.getDwarfTree(frame.Call.Fn.offset)
 	if err != nil {
-		return append(frames, frame)
+		it.count++
+		return callback(frame)
 	}
 
 	for _, entry := range reader.InlineStack(dwarfTree, callpc) {
+		frame.hasInlines = true
 		fnname, okname := entry.Val(dwarf.AttrName).(string)
 		fileidx, okfileidx := entry.Val(dwarf.AttrCallFile).(int64)
 		line, okline := entry.Val(dwarf.AttrCallLine).(int64)
@@ -406,7 +444,8 @@ func (it *stackIterator) appendInlineCal
 		}
 
 		inlfn := &Function{Name: fnname, Entry: frame.Call.Fn.Entry, End: frame.Call.Fn.End, offset: entry.Offset, cu: frame.Call.Fn.cu}
-		frames = append(frames, Stackframe{
+		it.count++
+		callback(Stackframe{
 			Current: frame.Current,
 			Call: Location{
 				frame.Call.PC,
@@ -421,13 +460,15 @@ func (it *stackIterator) appendInlineCal
 			SystemStack: frame.SystemStack,
 			Inlined:     true,
 			lastpc:      frame.lastpc,
+			closurePtr:  frame.closurePtr,
 		})
 
 		frame.Call.File = filepath
 		frame.Call.Line = int(line)
 	}
 
-	return append(frames, frame)
+	it.count++
+	return callback(frame)
 }
 
 // advanceRegs calculates the DwarfRegisters for a next stack frame
@@ -618,6 +659,8 @@ type Defer struct {
 	link    *Defer // Next deferred function
 	argSz   int64  // Always 0 in Go >=1.17
 
+	rangefunc []*Defer // See explanation in $GOROOT/src/runtime/panic.go, comment to function runtime.deferrangefunc (this is the equivalent of the rangefunc variable and head fields, combined)
+
 	variable   *Variable
 	Unreadable error
 }
@@ -644,10 +687,10 @@ func (g *G) readDefers(frames []Stackfra
 		}
 
 		if frames[i].TopmostDefer == nil {
-			frames[i].TopmostDefer = curdefer
+			frames[i].TopmostDefer = curdefer.topdefer()
 		}
 
-		if frames[i].SystemStack || curdefer.SP >= uint64(frames[i].Regs.CFA) {
+		if frames[i].SystemStack || frames[i].Inlined || curdefer.SP >= uint64(frames[i].Regs.CFA) {
 			// frames[i].Regs.CFA is the value that SP had before the function of
 			// frames[i] was called.
 			// This means that when curdefer.SP == frames[i].Regs.CFA then curdefer
@@ -660,13 +703,19 @@ func (g *G) readDefers(frames []Stackfra
 			// compared with deferred frames.
 			i++
 		} else {
-			frames[i].Defers = append(frames[i].Defers, curdefer)
+			if len(curdefer.rangefunc) > 0 {
+				frames[i].Defers = append(frames[i].Defers, curdefer.rangefunc...)
+			} else {
+				frames[i].Defers = append(frames[i].Defers, curdefer)
+			}
 			curdefer = curdefer.Next()
 		}
 	}
 }
 
-func (d *Defer) load() {
+const maxRangeFuncDefers = 10
+
+func (d *Defer) load(canrecur bool) {
 	v := d.variable // +rtype _defer
 	v.loadValue(LoadConfig{false, 1, 0, 0, -1, 0})
 	if v.Unreadable != nil {
@@ -701,6 +750,34 @@ func (d *Defer) load() {
 	if linkvar.Addr != 0 {
 		d.link = &Defer{variable: linkvar}
 	}
+
+	if canrecur {
+		h := v
+		for _, fieldname := range []string{"head", "u", "value"} {
+			if h == nil {
+				return
+			}
+			h = h.loadFieldNamed(fieldname)
+		}
+		if h != nil {
+			h := h.newVariable("", h.Addr, pointerTo(linkvar.DwarfType, h.bi.Arch), h.mem).maybeDereference()
+			if h.Addr != 0 {
+				hd := &Defer{variable: h}
+				for {
+					hd.load(false)
+					d.rangefunc = append(d.rangefunc, hd)
+					if hd.link == nil {
+						break
+					}
+					if len(d.rangefunc) > maxRangeFuncDefers {
+						// We don't have a way to know for sure that we haven't gone completely off-road while loading this list so limit it to an arbitrary maximum size.
+						break
+					}
+					hd = hd.link
+				}
+			}
+		}
+	}
 }
 
 // errSPDecreased is used when (*Defer).Next detects a corrupted linked
@@ -715,13 +792,20 @@ func (d *Defer) Next() *Defer {
 	if d.link == nil {
 		return nil
 	}
-	d.link.load()
+	d.link.load(true)
 	if d.link.SP < d.SP {
 		d.link.Unreadable = errSPDecreased
 	}
 	return d.link
 }
 
+func (d *Defer) topdefer() *Defer {
+	if len(d.rangefunc) > 0 {
+		return d.rangefunc[0]
+	}
+	return d
+}
+
 // EvalScope returns an EvalScope relative to the argument frame of this deferred call.
 // The argument frame of a deferred call is stored in memory immediately
 // after the deferred header.
@@ -813,3 +897,148 @@ func ruleString(rule *frame.DWRule, regn
 		return fmt.Sprintf("unknown_rule(%d)", rule.Rule)
 	}
 }
+
+// rangeFuncStackTrace, if the topmost frame of the stack is a the body of a
+// range-over-func statement, returns a slice containing the stack of range
+// bodies on the stack, interleaved with their return frames, the frame of
+// the function containing them and finally the function that called it.
+//
+// For example, given:
+//
+//	func f() {
+//		for _ := range iterator1 {
+//			for _ := range iterator2 {
+//				fmt.Println() // <- YOU ARE HERE
+//			}
+//		}
+//	}
+//
+// It will return the following frames:
+//
+// 0. f-range2()
+// 1. function that called f-range2
+// 2. f-range1()
+// 3. function that called f-range1
+// 4. f()
+// 5. function that called f()
+//
+// If the topmost frame of the stack is *not* the body closure of a
+// range-over-func statement then nothing is returned.
+func rangeFuncStackTrace(tgt *Target, g *G) ([]Stackframe, error) {
+	if g == nil {
+		return nil, nil
+	}
+	it, err := goroutineStackIterator(tgt, g, StacktraceSimple)
+	if err != nil {
+		return nil, err
+	}
+	frames := []Stackframe{}
+
+	const (
+		startStage = iota
+		normalStage
+		lastFrameStage
+		doneStage
+	)
+
+	stage := startStage
+	addRetFrame := false
+
+	var rangeParent *Function
+	nonMonotonicSP := false
+	var closurePtr int64
+
+	appendFrame := func(fr Stackframe) {
+		frames = append(frames, fr)
+		if fr.closurePtr != 0 {
+			closurePtr = fr.closurePtr
+		}
+		addRetFrame = true
+	}
+
+	closurePtrOk := func(fr *Stackframe) bool {
+		if fr.SystemStack {
+			return false
+		}
+		if closurePtr < 0 {
+			// closure is stack allocated, check that it is on this frame
+			return fr.contains(closurePtr)
+		}
+		// otherwise closurePtr is a heap allocated variable, so we need to check
+		// all closure body variables in scope in this frame
+		scope := FrameToScope(tgt, it.mem, it.g, 0, *fr)
+		yields, _ := scope.simpleLocals(localsNoDeclLineCheck|localsOnlyRangeBodyClosures, "")
+		for _, yield := range yields {
+			if yield.Kind != reflect.Func {
+				continue
+			}
+			addr := yield.funcvalAddr()
+			if int64(addr) == closurePtr {
+				return true
+			}
+		}
+		return false
+	}
+
+	it.stacktraceFunc(func(fr Stackframe) bool {
+		if len(frames) > 0 {
+			prev := &frames[len(frames)-1]
+			if fr.Regs.SP() < prev.Regs.SP() {
+				nonMonotonicSP = true
+				return false
+			}
+		}
+
+		if addRetFrame {
+			addRetFrame = false
+			frames = append(frames, fr)
+		}
+
+		switch stage {
+		case startStage:
+			appendFrame(fr)
+			rangeParent = fr.Call.Fn.extra(tgt.BinInfo()).rangeParent
+			stage = normalStage
+			if rangeParent == nil || closurePtr == 0 {
+				frames = nil
+				addRetFrame = false
+				stage = doneStage
+				return false
+			}
+		case normalStage:
+			if fr.Call.Fn.offset == rangeParent.offset && closurePtrOk(&fr) {
+				frames = append(frames, fr)
+				stage = lastFrameStage
+			} else if fr.Call.Fn.extra(tgt.BinInfo()).rangeParent == rangeParent && closurePtrOk(&fr) {
+				appendFrame(fr)
+				if closurePtr == 0 {
+					frames = nil
+					addRetFrame = false
+					stage = doneStage
+					return false
+				}
+			}
+		case lastFrameStage:
+			frames = append(frames, fr)
+			stage = doneStage
+			return false
+		case doneStage:
+			return false
+		}
+		return true
+	})
+	if it.Err() != nil {
+		return nil, err
+	}
+	if nonMonotonicSP {
+		return nil, errors.New("corrupted stack (SP not monotonically decreasing)")
+	}
+	if stage != doneStage {
+		return nil, errors.New("could not find range-over-func closure parent on the stack")
+	}
+	if len(frames)%2 != 0 {
+		return nil, errors.New("incomplete range-over-func stacktrace")
+	}
+	g.readDefers(frames)
+	return frames, nil
+}
diff -pruN 1.22.1-1/pkg/proc/stack_sigtramp.go 1.23.0-1/pkg/proc/stack_sigtramp.go
--- 1.22.1-1/pkg/proc/stack_sigtramp.go	2024-02-21 20:29:06.000000000 +0000
+++ 1.23.0-1/pkg/proc/stack_sigtramp.go	2024-07-16 18:44:48.000000000 +0000
@@ -18,7 +18,7 @@ func (it *stackIterator) readSigtrampgoC
 	bi := it.bi
 
 	findvar := func(name string) *Variable {
-		vars, _ := scope.Locals(0)
+		vars, _ := scope.Locals(0, name)
 		for i := range vars {
 			if vars[i].Name == name {
 				return vars[i]
@@ -429,7 +429,6 @@ func sigtrampContextFromExceptionPointer
 		return 0, err
 	}
 	return ((*exceptionpointers)(unsafe.Pointer(&buf[0]))).context, nil
-
 }
 
 func sigtrampContextWindowsAMD64(mem MemoryReader, addr uint64) (*op.DwarfRegisters, error) {
diff -pruN 1.22.1-1/pkg/proc/stackwatch.go 1.23.0-1/pkg/proc/stackwatch.go
--- 1.22.1-1/pkg/proc/stackwatch.go	2024-02-21 20:29:06.000000000 +0000
+++ 1.23.0-1/pkg/proc/stackwatch.go	2024-07-16 18:44:48.000000000 +0000
@@ -29,7 +29,7 @@ func (t *Target) setStackWatchBreakpoint
 	// Watchpoint Out-of-scope Sentinel
 
 	woos := func(_ Thread, _ *Target) (bool, error) {
-		watchpointOutOfScope(t, watchpoint)
+		t.Breakpoints().WatchOutOfScope = append(t.Breakpoints().WatchOutOfScope, watchpoint)
 		return true, nil
 	}
 
@@ -141,20 +141,6 @@ func (t *Target) clearStackWatchBreakpoi
 	return nil
 }
 
-// watchpointOutOfScope is called when the watchpoint goes out of scope. It
-// is used as a breaklet callback function.
-// Its responsibility is to delete the watchpoint and make sure that the
-// user is notified of the watchpoint going out of scope.
-func watchpointOutOfScope(t *Target, watchpoint *Breakpoint) {
-	t.Breakpoints().WatchOutOfScope = append(t.Breakpoints().WatchOutOfScope, watchpoint)
-	err := t.ClearBreakpoint(watchpoint.Addr)
-	if err != nil {
-		log := logflags.DebuggerLogger()
-		log.Errorf("could not clear out-of-scope watchpoint: %v", err)
-	}
-	delete(t.Breakpoints().Logical, watchpoint.LogicalID())
-}
-
 // adjustStackWatchpoint is called when the goroutine of watchpoint resizes
 // its stack. It is used as a breaklet callback function.
 // Its responsibility is to move the watchpoint to a its new address.
diff -pruN 1.22.1-1/pkg/proc/target_exec.go 1.23.0-1/pkg/proc/target_exec.go
--- 1.22.1-1/pkg/proc/target_exec.go	2024-02-21 20:29:06.000000000 +0000
+++ 1.23.0-1/pkg/proc/target_exec.go	2024-07-16 18:44:48.000000000 +0000
@@ -6,6 +6,7 @@ import (
 	"errors"
 	"fmt"
 	"go/ast"
+	"go/constant"
 	"go/token"
 	"path/filepath"
 	"strings"
@@ -13,6 +14,7 @@ import (
 	"golang.org/x/arch/ppc64/ppc64asm"
 
 	"github.com/go-delve/delve/pkg/astutil"
+	"github.com/go-delve/delve/pkg/dwarf/godwarf"
 	"github.com/go-delve/delve/pkg/dwarf/reader"
 	"github.com/go-delve/delve/pkg/logflags"
 )
@@ -36,7 +38,7 @@ func (grp *TargetGroup) Next() (err erro
 		return err
 	}
 	if grp.HasSteppingBreakpoints() {
-		return fmt.Errorf("next while nexting")
+		return errors.New("next while nexting")
 	}
 
 	if err = next(grp.Selected, false, false); err != nil {
@@ -109,6 +111,19 @@ func (grp *TargetGroup) Continue() error
 				}
 			}
 			it.currentThread = curthread
+			// Clear watchpoints that have gone out of scope
+			for _, watchpoint := range it.Breakpoints().WatchOutOfScope {
+				err := it.ClearBreakpoint(watchpoint.Addr)
+				if err != nil {
+					logflags.DebuggerLogger().Errorf("could not clear out-of-scope watchpoint: %v", err)
+				}
+				delete(it.Breakpoints().Logical, watchpoint.LogicalID())
+			}
+			// Clear inactivated breakpoints
+			err := it.clearInactivatedSteppingBreakpoint()
+			if err != nil {
+				logflags.DebuggerLogger().Errorf("could not clear inactivated stepping breakpoints: %v", err)
+			}
 		}
 
 		if contOnceErr != nil {
@@ -196,7 +211,7 @@ func (grp *TargetGroup) Continue() error
 					if err := dbp.ClearSteppingBreakpoints(); err != nil {
 						return err
 					}
-					return grp.StepInstruction()
+					return grp.StepInstruction(false)
 				}
 			} else {
 				curthread.Common().returnValues = curbp.Breakpoint.returnInfo.Collect(dbp, curthread)
@@ -299,7 +314,7 @@ func conditionErrors(grp *TargetGroup) e
 				if condErr == nil {
 					condErr = bp.CondError
 				} else {
-					return fmt.Errorf("multiple errors evaluating conditions")
+					return errors.New("multiple errors evaluating conditions")
 				}
 			}
 		}
@@ -445,7 +460,7 @@ func (grp *TargetGroup) Step() (err erro
 		return err
 	}
 	if grp.HasSteppingBreakpoints() {
-		return fmt.Errorf("next while nexting")
+		return errors.New("next while nexting")
 	}
 
 	if err = next(grp.Selected, true, false); err != nil {
@@ -455,7 +470,7 @@ func (grp *TargetGroup) Step() (err erro
 
 	if bpstate := grp.Selected.CurrentThread().Breakpoint(); bpstate.Breakpoint != nil && bpstate.Active && bpstate.SteppingInto && grp.GetDirection() == Backward {
 		grp.Selected.ClearSteppingBreakpoints()
-		return grp.StepInstruction()
+		return grp.StepInstruction(false)
 	}
 
 	return grp.Continue()
@@ -495,7 +510,7 @@ func (grp *TargetGroup) StepOut() error
 		return err
 	}
 	if grp.HasSteppingBreakpoints() {
-		return fmt.Errorf("next while nexting")
+		return errors.New("next while nexting")
 	}
 
 	dbp := grp.Selected
@@ -507,6 +522,16 @@ func (grp *TargetGroup) StepOut() error
 		return err
 	}
 
+	rangeFrames, err := rangeFuncStackTrace(dbp, selg)
+	if err != nil {
+		return err
+	}
+	if rangeFrames != nil {
+		// There are range-over-func body closures skip all of them to the
+		// function containing them and its caller function.
+		topframe, retframe = rangeFrames[len(rangeFrames)-2], rangeFrames[len(rangeFrames)-1]
+	}
+
 	success := false
 	defer func() {
 		if !success {
@@ -567,7 +592,7 @@ func (grp *TargetGroup) StepOut() error
 // one instruction. This method affects only the thread
 // associated with the selected goroutine. All other
 // threads will remain stopped.
-func (grp *TargetGroup) StepInstruction() (err error) {
+func (grp *TargetGroup) StepInstruction(skipCalls bool) (err error) {
 	dbp := grp.Selected
 	thread := dbp.CurrentThread()
 	g := dbp.SelectedGoroutine()
@@ -586,6 +611,12 @@ func (grp *TargetGroup) StepInstruction(
 	if ok, err := dbp.Valid(); !ok {
 		return err
 	}
+	var isCall bool
+	instr, err := disassembleCurrentInstruction(dbp, thread, 0)
+	if err != nil {
+		return err
+	}
+	isCall = len(instr) > 0 && instr[0].IsCall()
 	err = grp.procgrp.StepInstruction(thread.ThreadID())
 	if err != nil {
 		return err
@@ -599,6 +630,11 @@ func (grp *TargetGroup) StepInstruction(
 		dbp.selectedGoroutine = tg
 	}
 	dbp.StopReason = StopNextFinished
+
+	if skipCalls && isCall {
+		return grp.StepOut()
+	}
+
 	return nil
 }
 
@@ -633,6 +669,7 @@ func next(dbp *Target, stepInto, inlined
 	backward := dbp.recman.GetDirection() == Backward
 	selg := dbp.SelectedGoroutine()
 	curthread := dbp.CurrentThread()
+	bi := dbp.BinInfo()
 	topframe, retframe, err := topframe(dbp, selg, curthread)
 	if err != nil {
 		return err
@@ -651,6 +688,11 @@ func next(dbp *Target, stepInto, inlined
 		panic("next called with inlinedStepOut but topframe was not inlined")
 	}
 
+	rangeFrames, err := rangeFuncStackTrace(dbp, selg)
+	if err != nil {
+		return err
+	}
+
 	success := false
 	defer func() {
 		if !success {
@@ -668,15 +710,14 @@ func next(dbp *Target, stepInto, inlined
 		}
 	}
 
-	sameGCond := sameGoroutineCondition(dbp.BinInfo(), selg, curthread.ThreadID())
+	sameGCond := sameGoroutineCondition(bi, selg, curthread.ThreadID())
 
-	var firstPCAfterPrologue uint64
+	firstPCAfterPrologue, err := FirstPCAfterPrologue(dbp, topframe.Current.Fn, false)
+	if err != nil {
+		return err
+	}
 
 	if backward {
-		firstPCAfterPrologue, err = FirstPCAfterPrologue(dbp, topframe.Current.Fn, false)
-		if err != nil {
-			return err
-		}
 		if firstPCAfterPrologue == topframe.Current.PC {
 			// We don't want to step into the prologue so we just execute a reverse step out instead
 			if err := stepOutReverse(dbp, topframe, retframe, sameGCond); err != nil {
@@ -693,7 +734,7 @@ func next(dbp *Target, stepInto, inlined
 		}
 	}
 
-	text, err := disassemble(dbp.Memory(), regs, dbp.Breakpoints(), dbp.BinInfo(), topframe.Current.Fn.Entry, topframe.Current.Fn.End, false)
+	text, err := disassemble(dbp.Memory(), regs, dbp.Breakpoints(), bi, topframe.Current.Fn.Entry, topframe.Current.Fn.End, false)
 	if err != nil && stepInto {
 		return err
 	}
@@ -708,7 +749,11 @@ func next(dbp *Target, stepInto, inlined
 	}
 
 	if !backward && !topframe.Current.Fn.cu.image.Stripped() {
-		_, err = setDeferBreakpoint(dbp, text, topframe, sameGCond, stepInto)
+		fr := topframe
+		if len(rangeFrames) != 0 && !stepInto {
+			fr = rangeFrames[len(rangeFrames)-2]
+		}
+		_, err = setDeferBreakpoint(dbp, text, fr, sameGCond, stepInto)
 		if err != nil {
 			return err
 		}
@@ -740,7 +785,7 @@ func next(dbp *Target, stepInto, inlined
 		if inlinedStepOut {
 			frame = retframe
 		}
-		pcs, err = removeInlinedCalls(pcs, frame)
+		pcs, err = removeInlinedCalls(pcs, &frame, bi)
 		if err != nil {
 			return err
 		}
@@ -756,7 +801,7 @@ func next(dbp *Target, stepInto, inlined
 		}
 
 		if !covered {
-			fn := dbp.BinInfo().PCToFunc(topframe.Ret)
+			fn := bi.PCToFunc(topframe.Ret)
 			if selg != nil && fn != nil && fn.Name == "runtime.goexit" {
 				return nil
 			}
@@ -764,8 +809,12 @@ func next(dbp *Target, stepInto, inlined
 	}
 
 	for _, pc := range pcs {
+		if !stepInto && topframe.Call.Fn.extra(bi).rangeParent != nil {
+			if pc < firstPCAfterPrologue {
+				continue
+			}
+		}
 		if _, err := allowDuplicateBreakpoint(dbp.SetBreakpoint(0, pc, NextBreakpoint, sameFrameCond)); err != nil {
-			dbp.ClearSteppingBreakpoints()
 			return err
 		}
 	}
@@ -777,6 +826,75 @@ func next(dbp *Target, stepInto, inlined
 		}
 	}
 
+	// Stepping into range-over-func-bodies
+	if !stepInto && !inlinedStepOut {
+		rangeParent := topframe.Call.Fn.extra(bi).rangeParent
+		if rangeParent == nil {
+			rangeParent = topframe.Call.Fn
+		}
+		rpoff := topframe.FrameOffset()
+		if len(rangeFrames) > 0 {
+			rpoff = rangeFrames[len(rangeFrames)-2].FrameOffset()
+		}
+		rpc := astutil.And(sameGCond, astutil.Eql(astutil.PkgVar("runtime", "rangeParentOffset"), astutil.Int(rpoff)))
+		for _, fn := range rangeParent.extra(bi).rangeBodies {
+			if fn.Entry != 0 {
+				pc, err := FirstPCAfterPrologue(dbp, fn, false)
+				if err != nil {
+					return err
+				}
+				if _, err := allowDuplicateBreakpoint(dbp.SetBreakpoint(0, pc, NextBreakpoint, rpc)); err != nil {
+					return err
+				}
+			}
+		}
+	}
+
+	// Set step-out breakpoints for range-over-func body closures
+	if !stepInto && selg != nil && topframe.Current.Fn.extra(bi).rangeParent != nil && len(rangeFrames) > 0 {
+		// Set step-out breakpoint for every range-over-func body currently on the stack so that we stop on them.
+		for i := 2; i < len(rangeFrames); i += 2 {
+			fr := &rangeFrames[i]
+			retframecond := astutil.And(sameGCond, frameoffCondition(fr))
+			if !fr.hasInlines {
+				dbp.SetBreakpoint(0, fr.Current.PC, NextBreakpoint, retframecond)
+			} else {
+				// fr.Current.PC does not belong to fr.Call.Fn, because there are inlined calls, therefore set a breakpoint on every statement of fr.Call.Fn
+				pcs, err := fr.Current.Fn.AllPCs("", 0)
+				if err != nil {
+					return err
+				}
+				pcs, err = removeInlinedCalls(pcs, fr, bi)
+				if err != nil {
+					return err
+				}
+				for _, pc := range pcs {
+					dbp.SetBreakpoint(0, pc, NextBreakpoint, retframecond)
+				}
+			}
+		}
+
+		// Set a step-out breakpoint for the first range-over-func body on the
+		// stack, this breakpoint will never cause a stop because the associated
+		// callback always returns false.
+		// Its purpose is to inactivate all the breakpoints for the current
+		// range-over-func body function so that if the iterator re-calls it we
+		// don't end up inside the prologue.
+		if !rangeFrames[0].Inlined {
+			bp, err := dbp.SetBreakpoint(0, rangeFrames[1].Call.PC, NextBreakpoint, astutil.And(sameGCond, frameoffCondition(&rangeFrames[1])))
+			if err == nil {
+				bplet := bp.Breaklets[len(bp.Breaklets)-1]
+				bplet.callback = func(th Thread, p *Target) (bool, error) {
+					rangeFrameInactivateNextBreakpoints(p, rangeFrames[0].Call.Fn)
+					return false, nil
+				}
+			}
+		}
+
+		topframe, retframe = rangeFrames[len(rangeFrames)-2], rangeFrames[len(rangeFrames)-1]
+	}
+
+	// Step-out breakpoint
 	if !topframe.Inlined {
 		topframe, retframe := skipAutogeneratedWrappersOut(dbp, selg, curthread, &topframe, &retframe)
 		retFrameCond := astutil.And(sameGCond, frameoffCondition(retframe))
@@ -789,7 +907,7 @@ func next(dbp *Target, stepInto, inlined
 		// Return address could be wrong, if we are unable to set a breakpoint
 		// there it's ok.
 		if bp != nil {
-			configureReturnBreakpoint(dbp.BinInfo(), bp, topframe, retFrameCond)
+			configureReturnBreakpoint(bi, bp, topframe, retFrameCond)
 		}
 	}
 
@@ -801,6 +919,7 @@ func next(dbp *Target, stepInto, inlined
 }
 
 func setStepIntoBreakpoints(dbp *Target, curfn *Function, text []AsmInstruction, topframe Stackframe, sameGCond ast.Expr) error {
+	gostmt := false
 	for _, instr := range text {
 		if instr.Loc.File != topframe.Current.File || instr.Loc.Line != topframe.Current.Line || !instr.IsCall() {
 			continue
@@ -810,6 +929,12 @@ func setStepIntoBreakpoints(dbp *Target,
 			if err := setStepIntoBreakpoint(dbp, curfn, []AsmInstruction{instr}, sameGCond); err != nil {
 				return err
 			}
+			if curfn != nil && curfn.Name != "runtime." && instr.DestLoc.Fn != nil && instr.DestLoc.Fn.Name == "runtime.newproc" {
+				// The current statement is a go statement, i.e. "go somecall()"
+				// We are excluding this check inside the runtime package because
+				// functions in the runtime package can call runtime.newproc directly.
+				gostmt = true
+			}
 		} else {
 			// Non-absolute call instruction, set a StepBreakpoint here
 			bp, err := allowDuplicateBreakpoint(dbp.SetBreakpoint(0, instr.Loc.PC, StepBreakpoint, sameGCond))
@@ -820,6 +945,9 @@ func setStepIntoBreakpoints(dbp *Target,
 			breaklet.callback = stepIntoCallback
 		}
 	}
+	if gostmt {
+		setStepIntoNewProcBreakpoint(dbp, sameGCond)
+	}
 	return nil
 }
 
@@ -892,37 +1020,89 @@ func FindDeferReturnCalls(text []AsmInst
 }
 
 // Removes instructions belonging to inlined calls of topframe from pcs.
-// If includeCurrentFn is true it will also remove all instructions
-// belonging to the current function.
-func removeInlinedCalls(pcs []uint64, topframe Stackframe) ([]uint64, error) {
+// Inlined calls that belong to range-over-func bodies are not removed.
+func removeInlinedCalls(pcs []uint64, topframe *Stackframe, bi *BinaryInfo) ([]uint64, error) {
 	// TODO(derekparker) it should be possible to still use some internal
 	// runtime information to do this.
 	if topframe.Call.Fn == nil || topframe.Call.Fn.cu.image.Stripped() {
 		return pcs, nil
 	}
-	dwarfTree, err := topframe.Call.Fn.cu.image.getDwarfTree(topframe.Call.Fn.offset)
+
+	topframeRangeParentName := topframe.Call.Fn.Name
+	if topframe.Call.Fn.extra(bi).rangeParent != nil {
+		topframeRangeParentName = topframe.Call.Fn.extra(bi).rangeParent.Name
+	}
+
+	dwarfTree, err := topframe.Current.Fn.cu.image.getDwarfTree(topframe.Current.Fn.offset)
 	if err != nil {
 		return pcs, err
 	}
-	for _, e := range reader.InlineStack(dwarfTree, 0) {
+	color := make([]removePC, len(pcs))
+	removeInlinedCallsColor(topframe, topframeRangeParentName, pcs, color, dwarfTree)
+	out := make([]uint64, 0, len(pcs))
+	for i := range pcs {
+		if color[i] != removePCRemove {
+			out = append(out, pcs[i])
+		}
+	}
+	return out, nil
+}
+
+type removePC uint8
+
+const (
+	removePCUnknown removePC = iota
+	removePCRemove
+	removePCKeep
+)
+
+// removeInlinedCallsColor sets color[i] to removePCRemove or removePCKeep
+// depending on whether pcs[i] should be removed by removeInlinedCalls.
+// This determination is made by checking, for each PC, what is the topmost
+// inlined call.
+func removeInlinedCallsColor(topframe *Stackframe, topframeRangeParentName string, pcs []uint64, color []removePC, e *godwarf.Tree) {
+	switch e.Tag {
+	case dwarf.TagSubprogram, dwarf.TagInlinedSubroutine, dwarf.TagLexDwarfBlock:
+		// ok
+	default:
+		return
+	}
+
+	for _, child := range e.Children {
+		removeInlinedCallsColor(topframe, topframeRangeParentName, pcs, color, child)
+	}
+
+	switch e.Tag {
+	case dwarf.TagInlinedSubroutine:
+		c := removePCRemove
 		if e.Offset == topframe.Call.Fn.offset {
-			continue
+			c = removePCKeep
+		} else {
+			fnname, _ := e.Val(dwarf.AttrName).(string)
+			ridx := rangeParentName(fnname)
+			var rpn string
+			if ridx == -1 {
+				rpn = fnname
+			} else {
+				rpn = fnname[:ridx]
+			}
+			if rpn == topframeRangeParentName {
+				c = removePCKeep
+			}
 		}
 		for _, rng := range e.Ranges {
-			pcs = removePCsBetween(pcs, rng[0], rng[1])
+			colorPCsBetween(pcs, color, c, rng[0], rng[1])
 		}
 	}
-	return pcs, nil
 }
 
-func removePCsBetween(pcs []uint64, start, end uint64) []uint64 {
-	out := pcs[:0]
-	for _, pc := range pcs {
-		if pc < start || pc >= end {
-			out = append(out, pc)
+// colorPCsBetween sets color[i] to c if start <= pcs[i] < end
+func colorPCsBetween(pcs []uint64, color []removePC, c removePC, start, end uint64) {
+	for i, pc := range pcs {
+		if color[i] == removePCUnknown && pc >= start && pc < end {
+			color[i] = c
 		}
 	}
-	return out
 }
 
 func setStepIntoBreakpoint(dbp *Target, curfn *Function, text []AsmInstruction, cond ast.Expr) error {
@@ -968,7 +1148,7 @@ func setStepIntoBreakpoint(dbp *Target,
 		return nil
 	}
 
-	fn, pc = skipAutogeneratedWrappersIn(dbp, fn, pc)
+	fn, pc = skipAutogeneratedWrappersIn(dbp, fn, pc, false)
 
 	// We want to skip the function prologue but we should only do it if the
 	// destination address of the CALL instruction is the entry point of the
@@ -988,6 +1168,108 @@ func setStepIntoBreakpoint(dbp *Target,
 	return nil
 }
 
+// setStepIntoNewProcBreakpoint sets a temporary breakpoint on
+// runtime.newproc that, when hit, clears all temporary breakpoints and sets
+// a new temporary breakpoint on the starting function for the new
+// goroutine.
+func setStepIntoNewProcBreakpoint(p *Target, sameGCond ast.Expr) {
+	const (
+		runtimeNewprocFunc1 = "runtime.newproc.func1"
+		runtimeRunqput      = "runtime.runqput"
+	)
+	rnf := p.BinInfo().LookupFunc()[runtimeNewprocFunc1]
+	if len(rnf) != 1 {
+		logflags.DebuggerLogger().Error("could not find " + runtimeNewprocFunc1)
+		return
+	}
+	text, err := Disassemble(p.Memory(), nil, p.Breakpoints(), p.BinInfo(), rnf[0].Entry, rnf[0].End)
+	if err != nil {
+		logflags.DebuggerLogger().Errorf("could not disassemble "+runtimeNewprocFunc1+": %v", err)
+		return
+	}
+
+	callfile, callline := "", 0
+	for _, instr := range text {
+		if instr.Kind == CallInstruction && instr.DestLoc != nil && instr.DestLoc.Fn != nil && instr.DestLoc.Fn.Name == runtimeRunqput {
+			callfile = instr.Loc.File
+			callline = instr.Loc.Line
+			break
+		}
+	}
+	if callfile == "" {
+		logflags.DebuggerLogger().Error("could not find " + runtimeRunqput + " call in " + runtimeNewprocFunc1)
+		return
+	}
+	var pc uint64
+	for _, pcstmt := range rnf[0].cu.lineInfo.LineToPCs(callfile, callline) {
+		if pcstmt.Stmt {
+			pc = pcstmt.PC
+			break
+		}
+	}
+	if pc == 0 {
+		logflags.DebuggerLogger().Errorf("could not set newproc breakpoint: location not found for " + runtimeRunqput + " call")
+		return
+	}
+
+	bp, err := p.SetBreakpoint(0, pc, StepIntoNewProcBreakpoint, sameGCond)
+	if err != nil {
+		logflags.DebuggerLogger().Errorf("could not set StepIntoNewProcBreakpoint: %v", err)
+		return
+	}
+	blet := bp.Breaklets[len(bp.Breaklets)-1]
+	blet.callback = func(th Thread, p *Target) (bool, error) {
+		// Clear temp breakpoints that exist and set a new one for goroutine
+		// newg.goid on the go statement's target
+		scope, err := ThreadScope(p, th)
+		if err != nil {
+			return false, err
+		}
+		v, err := scope.EvalExpression("newg.goid", loadSingleValue)
+		if err != nil {
+			return false, err
+		}
+		if v.Unreadable != nil {
+			return false, v.Unreadable
+		}
+		newGGoID, _ := constant.Int64Val(v.Value)
+
+		v, err = scope.EvalExpression("newg.startpc", loadSingleValue)
+		if err != nil {
+			return false, err
+		}
+		if v.Unreadable != nil {
+			return false, v.Unreadable
+		}
+		startpc, _ := constant.Int64Val(v.Value)
+
+		// Temp breakpoints must be cleared because the current goroutine could
+		// hit one of them before the new goroutine manages to start.
+		err = p.ClearSteppingBreakpoints()
+		if err != nil {
+			return false, err
+		}
+
+		newGCond := astutil.Eql(astutil.Sel(astutil.PkgVar("runtime", "curg"), "goid"), astutil.Int(newGGoID))
+
+		// We don't want to use startpc directly because it will be an
+		// autogenerated wrapper on some versions of Go. Addditionally, once we
+		// have the correct function we must also skip to prologue.
+		startfn := p.BinInfo().PCToFunc(uint64(startpc))
+		if startfn2, _ := skipAutogeneratedWrappersIn(p, startfn, uint64(startpc), true); startfn2 != nil {
+			startfn = startfn2
+		}
+		if startpc2, err := FirstPCAfterPrologue(p, startfn, false); err == nil {
+			startpc = int64(startpc2)
+		}
+
+		// The new breakpoint must have 'NextBreakpoint' kind because we want to
+		// stop on it.
+		_, err = p.SetBreakpoint(0, uint64(startpc), NextBreakpoint, newGCond)
+		return false, err // we don't want to stop at this breakpoint if there is no error
+	}
+}
+
 func allowDuplicateBreakpoint(bp *Breakpoint, err error) (*Breakpoint, error) {
 	if err != nil {
 		//lint:ignore S1020 this is clearer
@@ -1008,8 +1290,10 @@ func isAutogeneratedOrDeferReturn(loc Lo
 
 // skipAutogeneratedWrappersIn skips autogenerated wrappers when setting a
 // step-into breakpoint.
+// If alwaysSkipFirst is set the first function is always skipped if it is
+// autogenerated, even if it isn't a wrapper for the function it is calling.
 // See genwrapper in: $GOROOT/src/cmd/compile/internal/gc/subr.go
-func skipAutogeneratedWrappersIn(p Process, startfn *Function, startpc uint64) (*Function, uint64) {
+func skipAutogeneratedWrappersIn(p Process, startfn *Function, startpc uint64, alwaysSkipFirst bool) (*Function, uint64) {
 	if startfn == nil {
 		return nil, startpc
 	}
@@ -1061,7 +1345,10 @@ func skipAutogeneratedWrappersIn(p Proce
 		}
 
 		tgtfn := tgtfns[0]
-		if strings.TrimSuffix(tgtfn.BaseName(), "-fm") != strings.TrimSuffix(fn.BaseName(), "-fm") {
+		if alwaysSkipFirst {
+			alwaysSkipFirst = false
+			startfn, startpc = tgtfn, tgtfn.Entry
+		} else if strings.TrimSuffix(tgtfn.BaseName(), "-fm") != strings.TrimSuffix(fn.BaseName(), "-fm") {
 			return startfn, startpc
 		}
 		fn = tgtfn
@@ -1225,7 +1512,6 @@ func stepOutReverse(p *Target, topframe,
 		if ok, pc := isDeferReturnCall(frames, deferReturns); ok && pc != 0 {
 			callpc = pc
 		}
-
 	}
 
 	_, err = allowDuplicateBreakpoint(p.SetBreakpoint(0, callpc, NextBreakpoint, sameGCond))
@@ -1396,3 +1682,26 @@ func (t *Target) handleHardcodedBreakpoi
 	}
 	return nil
 }
+
+func rangeFrameInactivateNextBreakpoints(p *Target, fn *Function) {
+	pc, err := FirstPCAfterPrologue(p, fn, false)
+	if err != nil {
+		logflags.DebuggerLogger().Errorf("Error inactivating next breakpoints after exiting a range-over-func body: %v", err)
+		return
+	}
+
+	for _, bp := range p.Breakpoints().M {
+		if bp.Addr < fn.Entry || bp.Addr >= fn.End || bp.Addr == pc {
+			continue
+		}
+		for _, bplet := range bp.Breaklets {
+			if bplet.Kind != NextBreakpoint {
+				continue
+			}
+			// We set to NextInactivatedBreakpoint instead of deleting them because
+			// we can't delete breakpoints (or breakpointlets) while breakpoint
+			// conditions are being evaluated.
+			bplet.Kind = NextInactivatedBreakpoint
+		}
+	}
+}
diff -pruN 1.22.1-1/pkg/proc/types.go 1.23.0-1/pkg/proc/types.go
--- 1.22.1-1/pkg/proc/types.go	2024-02-21 20:29:06.000000000 +0000
+++ 1.23.0-1/pkg/proc/types.go	2024-07-16 18:44:48.000000000 +0000
@@ -15,10 +15,10 @@ import (
 // some extra flags defined here.
 // See equivalent declaration in $GOROOT/src/reflect/type.go
 const (
-	kindDirectIface = 1 << 5 // +rtype kindDirectIface
-	kindGCProg      = 1 << 6 // +rtype kindGCProg
+	kindDirectIface = 1 << 5 // +rtype kindDirectIface|internal/abi.KindDirectIface
+	kindGCProg      = 1 << 6 // +rtype kindGCProg|internal/abi.KindGCProg
 	kindNoPointers  = 1 << 7
-	kindMask        = (1 << 5) - 1 // +rtype kindMask
+	kindMask        = (1 << 5) - 1 // +rtype kindMask|internal/abi.KindMask
 )
 
 type runtimeTypeDIE struct {
@@ -89,7 +89,7 @@ func (ctxt *loadDebugInfoMapsContext) lo
 	return r
 }
 
-// runtimeTypeToDIE returns the DIE corresponding to the runtime._type.
+// RuntimeTypeToDIE returns the DIE corresponding to the runtime._type.
 // This is done in three different ways depending on the version of go.
 //   - Before go1.7 the type name is retrieved directly from the runtime._type
 //     and looked up in debug_info
@@ -98,18 +98,13 @@ func (ctxt *loadDebugInfoMapsContext) lo
 //     debug_info
 //   - After go1.11 the runtimeTypeToDIE map is used to look up the address of
 //     the type and map it directly to a DIE.
-func runtimeTypeToDIE(_type *Variable, dataAddr uint64) (typ godwarf.Type, kind int64, err error) {
+func RuntimeTypeToDIE(_type *Variable, dataAddr uint64, mds []ModuleData) (typ godwarf.Type, kind int64, err error) {
 	bi := _type.bi
 
 	_type = _type.maybeDereference()
 
 	// go 1.11 implementation: use extended attribute in debug_info
 
-	mds, err := loadModuleData(bi, _type.mem)
-	if err != nil {
-		return nil, 0, fmt.Errorf("error loading module data: %v", err)
-	}
-
 	md := findModuleDataForType(bi, mds, _type.Addr, _type.mem)
 	if md != nil {
 		so := bi.moduleDataToImage(md)
@@ -131,7 +126,7 @@ func runtimeTypeToDIE(_type *Variable, d
 		}
 	}
 
-	return nil, 0, fmt.Errorf("could not resolve interface type")
+	return nil, 0, errors.New("could not resolve interface type")
 }
 
 // resolveParametricType returns the real type of t if t is a parametric
@@ -154,7 +149,12 @@ func resolveParametricType(bi *BinaryInf
 	}
 	_type := newVariable("", rtypeAddr, runtimeType, bi, mem)
 
-	typ, _, err := runtimeTypeToDIE(_type, 0)
+	mds, err := LoadModuleData(bi, _type.mem)
+	if err != nil {
+		return ptyp.TypedefType.Type, fmt.Errorf("error loading module data: %v", err)
+	}
+
+	typ, _, err := RuntimeTypeToDIE(_type, 0, mds)
 	if err != nil {
 		return ptyp.TypedefType.Type, err
 	}
@@ -175,7 +175,7 @@ func dwarfToRuntimeType(bi *BinaryInfo,
 		return 0, 0, false, nil
 	}
 
-	mds, err := loadModuleData(bi, mem)
+	mds, err := LoadModuleData(bi, mem)
 	if err != nil {
 		return 0, 0, false, err
 	}
diff -pruN 1.22.1-1/pkg/proc/variable_test.go 1.23.0-1/pkg/proc/variable_test.go
--- 1.22.1-1/pkg/proc/variable_test.go	2024-02-21 20:29:06.000000000 +0000
+++ 1.23.0-1/pkg/proc/variable_test.go	2024-07-16 18:44:48.000000000 +0000
@@ -35,7 +35,6 @@ func TestGoroutineCreationLocation(t *te
 					t.Fatalf("goroutine creation line incorrect: %v", createdLocation.Line)
 				}
 			}
-
 		}
 
 		p.ClearBreakpoint(bp.Addr)
diff -pruN 1.22.1-1/pkg/proc/variables.go 1.23.0-1/pkg/proc/variables.go
--- 1.22.1-1/pkg/proc/variables.go	2024-02-21 20:29:06.000000000 +0000
+++ 1.23.0-1/pkg/proc/variables.go	2024-07-16 18:44:48.000000000 +0000
@@ -494,7 +494,7 @@ func (g *G) Defer() *Defer {
 		return nil
 	}
 	d := &Defer{variable: dvar}
-	d.load()
+	d.load(true)
 	return d
 }
 
@@ -930,11 +930,11 @@ func (v *Variable) parseG() (*G, error)
 	}
 
 	status := uint64(0)
-	if atomicStatus := v.loadFieldNamed("atomicstatus"); /* +rtype uint32|runtime/internal/atomic.Uint32 */ atomicStatus != nil {
+	if atomicStatus := v.loadFieldNamed("atomicstatus"); /* +rtype uint32|runtime/internal/atomic.Uint32|internal/runtime/atomic.Uint32 */ atomicStatus != nil {
 		if constant.Val(atomicStatus.Value) != nil {
 			status, _ = constant.Uint64Val(atomicStatus.Value)
 		} else {
-			atomicStatus := atomicStatus              // +rtype runtime/internal/atomic.Uint32
+			atomicStatus := atomicStatus              // +rtype runtime/internal/atomic.Uint32|internal/runtime/atomic.Uint32
 			vv := atomicStatus.fieldVariable("value") // +rtype uint32
 			if vv == nil {
 				unreadable = true
@@ -1169,7 +1169,7 @@ func (v *Variable) structMember(memberNa
 func readVarEntry(entry *godwarf.Tree, image *Image) (name string, typ godwarf.Type, err error) {
 	name, ok := entry.Val(dwarf.AttrName).(string)
 	if !ok {
-		return "", nil, fmt.Errorf("malformed variable DIE (name)")
+		return "", nil, errors.New("malformed variable DIE (name)")
 	}
 
 	typ, err = entry.Type(image.dwarf, image.index, image.typeCache)
@@ -1389,8 +1389,15 @@ func (v *Variable) loadValueInternal(rec
 					break
 				}
 				f, _ := v.toField(field)
+				f.Name = field.Name
+				if t.StructName == "" && len(f.Name) > 0 && f.Name[0] == '&' && f.Kind == reflect.Ptr {
+					// This struct is a closure struct and the field is actually a variable
+					// captured by reference.
+					f = f.maybeDereference()
+					f.Flags |= VariableEscaped
+					f.Name = field.Name[1:]
+				}
 				v.Children = append(v.Children, *f)
-				v.Children[i].Name = field.Name
 				v.Children[i].loadValueInternal(recurseLevel+1, cfg)
 			}
 		}
@@ -1435,7 +1442,7 @@ func (v *Variable) loadValueInternal(rec
 			v.FloatSpecial = FloatIsNaN
 		}
 	case reflect.Func:
-		v.readFunctionPtr()
+		v.loadFunctionPtr(recurseLevel, cfg)
 	default:
 		v.Unreadable = fmt.Errorf("unknown or unsupported kind: %q", v.Kind.String())
 	}
@@ -1472,7 +1479,7 @@ func convertToEface(srcv, dstv *Variable
 
 func readStringInfo(mem MemoryReadWriter, arch *Arch, addr uint64, typ *godwarf.StringType) (uint64, int64, error) {
 	// string data structure is always two ptrs in size. Addr, followed by len
-	// http://research.swtch.com/godata
+	// https://research.swtch.com/godata
 
 	mem = cacheMemory(mem, addr, arch.PtrSize()*2)
 
@@ -1833,7 +1840,7 @@ func (v *Variable) readFloatRaw(size int
 		return n, nil
 	}
 
-	return 0.0, fmt.Errorf("could not read float")
+	return 0.0, errors.New("could not read float")
 }
 
 func (v *Variable) writeFloatRaw(f float64, size int64) error {
@@ -1915,7 +1922,7 @@ func (v *Variable) writeCopy(srcv *Varia
 	return err
 }
 
-func (v *Variable) readFunctionPtr() {
+func (v *Variable) loadFunctionPtr(recurseLevel int, cfg LoadConfig) {
 	// dereference pointer to find function pc
 	v.closureAddr = v.funcvalAddr()
 	if v.Unreadable != nil {
@@ -1941,6 +1948,14 @@ func (v *Variable) readFunctionPtr() {
 	}
 
 	v.Value = constant.MakeString(fn.Name)
+	cst := fn.extra(v.bi).closureStructType
+	v.Len = int64(len(cst.Field))
+
+	if recurseLevel <= cfg.MaxVariableRecurse {
+		v2 := v.newVariable("", v.closureAddr, cst, v.mem)
+		v2.loadValueInternal(recurseLevel, cfg)
+		v.Children = v2.Children
+	}
 }
 
 // funcvalAddr reads the address of the funcval contained in a function variable.
@@ -1966,7 +1981,7 @@ func (v *Variable) loadMap(recurseLevel
 
 	for skip := 0; skip < v.mapSkip; skip++ {
 		if ok := it.next(); !ok {
-			v.Unreadable = fmt.Errorf("map index out of bounds")
+			v.Unreadable = errors.New("map index out of bounds")
 			return
 		}
 	}
@@ -2028,7 +2043,7 @@ func (v *Variable) mapIterator() *mapIte
 
 	maptype, ok := sv.RealType.(*godwarf.StructType)
 	if !ok {
-		v.Unreadable = fmt.Errorf("wrong real type for map")
+		v.Unreadable = errors.New("wrong real type for map")
 		return nil
 	}
 
@@ -2169,7 +2184,7 @@ func (it *mapIterator) nextBucket() bool
 
 	// sanity checks
 	if it.tophashes == nil || it.keys == nil || it.values == nil {
-		it.v.Unreadable = fmt.Errorf("malformed map type")
+		it.v.Unreadable = errors.New("malformed map type")
 		return false
 	}
 
@@ -2272,7 +2287,7 @@ func (v *Variable) readInterface() (_typ
 
 	ityp := resolveTypedef(&v.RealType.(*godwarf.InterfaceType).TypedefType).(*godwarf.StructType)
 
-	// +rtype -field iface.tab *itab
+	// +rtype -field iface.tab *itab|*internal/abi.ITab
 	// +rtype -field iface.data unsafe.Pointer
 	// +rtype -field eface._type *_type|*internal/abi.Type
 	// +rtype -field eface.data unsafe.Pointer
@@ -2280,15 +2295,18 @@ func (v *Variable) readInterface() (_typ
 	for _, f := range ityp.Field {
 		switch f.Name {
 		case "tab": // for runtime.iface
-			tab, _ := v.toField(f) // +rtype *itab
+			tab, _ := v.toField(f) // +rtype *itab|*internal/abi.ITab
 			tab = tab.maybeDereference()
 			isnil = tab.Addr == 0
 			if !isnil {
 				var err error
-				_type, err = tab.structMember("_type") // +rtype *_type|*internal/abi.Type
+				_type, err = tab.structMember("Type") // +rtype *internal/abi.Type
 				if err != nil {
-					v.Unreadable = fmt.Errorf("invalid interface type: %v", err)
-					return
+					_type, err = tab.structMember("_type") // +rtype *_type|*internal/abi.Type
+					if err != nil {
+						v.Unreadable = fmt.Errorf("invalid interface type: %v", err)
+						return
+					}
 				}
 			}
 		case "_type": // for runtime.eface
@@ -2315,11 +2333,17 @@ func (v *Variable) loadInterface(recurse
 	}
 
 	if data == nil {
-		v.Unreadable = fmt.Errorf("invalid interface type")
+		v.Unreadable = errors.New("invalid interface type")
+		return
+	}
+
+	mds, err := LoadModuleData(_type.bi, _type.mem)
+	if err != nil {
+		v.Unreadable = fmt.Errorf("error loading module data: %v", err)
 		return
 	}
 
-	typ, kind, err := runtimeTypeToDIE(_type, data.Addr)
+	typ, kind, err := RuntimeTypeToDIE(_type, data.Addr, mds)
 	if err != nil {
 		v.Unreadable = err
 		return
diff -pruN 1.22.1-1/pkg/proc/variables_test.go 1.23.0-1/pkg/proc/variables_test.go
--- 1.22.1-1/pkg/proc/variables_test.go	2024-02-21 20:29:06.000000000 +0000
+++ 1.23.0-1/pkg/proc/variables_test.go	2024-07-16 18:44:48.000000000 +0000
@@ -122,8 +122,8 @@ func TestVariableEvaluation2(t *testing.
 		{"a6.Baz", true, "8", "20", "int", nil},
 		{"a7.Baz", true, "5", "25", "int", nil},
 		{"a8.Baz", true, "\"feh\"", "", "string", nil},
-		{"a9.Baz", true, "nil", "", "int", fmt.Errorf("a9 is nil")},
-		{"a9.NonExistent", true, "nil", "", "int", fmt.Errorf("a9 has no member NonExistent")},
+		{"a9.Baz", true, "nil", "", "int", errors.New("a9 is nil")},
+		{"a9.NonExistent", true, "nil", "", "int", errors.New("a9 has no member NonExistent")},
 		{"a8", true, "main.FooBar2 {Bur: 10, Baz: \"feh\"}", "", "main.FooBar2", nil}, // reread variable after member
 		{"i32", true, "[2]int32 [1,2]", "", "[2]int32", nil},
 		{"b1", true, "true", "false", "bool", nil},
@@ -139,10 +139,10 @@ func TestVariableEvaluation2(t *testing.
 		{"ms", true, "main.Nest {Level: 0, Nest: *main.Nest {Level: 1, Nest: *(*main.Nest)(…", "", "main.Nest", nil},
 		{"ms.Nest.Nest", true, "*main.Nest {Level: 2, Nest: *main.Nest {Level: 3, Nest: *(*main.Nest)(…", "", "*main.Nest", nil},
 		{"ms.Nest.Nest.Nest.Nest.Nest", true, "*main.Nest nil", "", "*main.Nest", nil},
-		{"ms.Nest.Nest.Nest.Nest.Nest.Nest", true, "", "", "*main.Nest", fmt.Errorf("ms.Nest.Nest.Nest.Nest.Nest is nil")},
+		{"ms.Nest.Nest.Nest.Nest.Nest.Nest", true, "", "", "*main.Nest", errors.New("ms.Nest.Nest.Nest.Nest.Nest is nil")},
 		{"main.p1", true, "10", "12", "int", nil},
 		{"p1", true, "10", "13", "int", nil},
-		{"NonExistent", true, "", "", "", fmt.Errorf("could not find symbol value for NonExistent")},
+		{"NonExistent", true, "", "", "", errors.New("could not find symbol value for NonExistent")},
 	}
 
 	protest.AllowRecording(t)
@@ -236,7 +236,6 @@ func TestSetVariable(t *testing.T) {
 				assertNoError(err, t, "EvalVariable()")
 				assertVariable(t, variable, varTest{tc.name, true, tc.finalVal, "", tc.typ, nil})
 			}
-
 		}
 	})
 }
@@ -263,8 +262,8 @@ func TestVariableEvaluationShort(t *test
 		{"a6.Baz", true, "8", "", "int", nil},
 		{"a7.Baz", true, "5", "", "int", nil},
 		{"a8.Baz", true, "\"feh\"", "", "string", nil},
-		{"a9.Baz", true, "nil", "", "int", fmt.Errorf("a9 is nil")},
-		{"a9.NonExistent", true, "nil", "", "int", fmt.Errorf("a9 has no member NonExistent")},
+		{"a9.Baz", true, "nil", "", "int", errors.New("a9 is nil")},
+		{"a9.NonExistent", true, "nil", "", "int", errors.New("a9 has no member NonExistent")},
 		{"a8", true, "main.FooBar2 {Bur: 10, Baz: \"feh\"}", "", "main.FooBar2", nil}, // reread variable after member
 		{"i32", true, "[2]int32 [...]", "", "[2]int32", nil},
 		{"b1", true, "true", "false", "bool", nil},
@@ -280,10 +279,10 @@ func TestVariableEvaluationShort(t *test
 		{"ms", true, "main.Nest {Level: 0, Nest: (*main.Nest)(0x…", "", "main.Nest", nil},
 		{"ms.Nest.Nest", true, "(*main.Nest)(0x…", "", "*main.Nest", nil},
 		{"ms.Nest.Nest.Nest.Nest.Nest", true, "*main.Nest nil", "", "*main.Nest", nil},
-		{"ms.Nest.Nest.Nest.Nest.Nest.Nest", true, "", "", "*main.Nest", fmt.Errorf("ms.Nest.Nest.Nest.Nest.Nest is nil")},
+		{"ms.Nest.Nest.Nest.Nest.Nest.Nest", true, "", "", "*main.Nest", errors.New("ms.Nest.Nest.Nest.Nest.Nest is nil")},
 		{"main.p1", true, "10", "", "int", nil},
 		{"p1", true, "10", "", "int", nil},
-		{"NonExistent", true, "", "", "", fmt.Errorf("could not find symbol value for NonExistent")},
+		{"NonExistent", true, "", "", "", errors.New("could not find symbol value for NonExistent")},
 	}
 
 	protest.AllowRecording(t)
@@ -539,18 +538,18 @@ func getEvalExpressionTestCases() []varT
 		{"s1[2]", false, "\"three\"", "\"three\"", "string", nil},
 		{"s1[3]", false, "\"four\"", "\"four\"", "string", nil},
 		{"s1[4]", false, "\"five\"", "\"five\"", "string", nil},
-		{"s1[5]", false, "", "", "string", fmt.Errorf("index out of bounds")},
+		{"s1[5]", false, "", "", "string", errors.New("index out of bounds")},
 		{"a1[0]", false, "\"one\"", "\"one\"", "string", nil},
 		{"a1[1]", false, "\"two\"", "\"two\"", "string", nil},
 		{"a1[2]", false, "\"three\"", "\"three\"", "string", nil},
 		{"a1[3]", false, "\"four\"", "\"four\"", "string", nil},
 		{"a1[4]", false, "\"five\"", "\"five\"", "string", nil},
-		{"a1[5]", false, "", "", "string", fmt.Errorf("index out of bounds")},
+		{"a1[5]", false, "", "", "string", errors.New("index out of bounds")},
 		{"str1[0]", false, "48", "48", "byte", nil},
 		{"str1[1]", false, "49", "49", "byte", nil},
 		{"str1[2]", false, "50", "50", "byte", nil},
 		{"str1[10]", false, "48", "48", "byte", nil},
-		{"str1[11]", false, "", "", "byte", fmt.Errorf("index out of bounds")},
+		{"str1[11]", false, "", "", "byte", errors.New("index out of bounds")},
 
 		// slice/array/string reslicing
 		{"a1[2:4]", false, "[]string len: 2, cap: 2, [\"three\",\"four\"]", "[]string len: 2, cap: 2, [\"three\",\"four\"]", "[]string", nil},
@@ -559,8 +558,8 @@ func getEvalExpressionTestCases() []varT
 		{"str1[0:11]", false, "\"01234567890\"", "\"01234567890\"", "string", nil},
 		{"str1[:3]", false, "\"012\"", "\"012\"", "string", nil},
 		{"str1[3:]", false, "\"34567890\"", "\"34567890\"", "string", nil},
-		{"str1[0:12]", false, "", "", "string", fmt.Errorf("index out of bounds")},
-		{"str1[5:3]", false, "", "", "string", fmt.Errorf("index out of bounds")},
+		{"str1[0:12]", false, "", "", "string", errors.New("index out of bounds")},
+		{"str1[5:3]", false, "", "", "string", errors.New("index out of bounds")},
 		{"str1[11:]", false, "\"\"", "\"\"", "string", nil},
 		{"longbyteslice[:70]", false, "[]uint8 len: 70, cap: 70, [118,101,114,121,32,108,111,110,103,32,115,116,114,105,110,103,32,48,49,50,51,52,53,54,55,56,57,97,48,49,50,51,52,53,54,55,56,57,98,48,49,50,51,52,53,54,55,56,57,99,48,49,50,51,52,53,54,55,56,57,100,48,49,50,51,52,53,54,55,56]", "[]uint8 len: 70, cap: 70, [118,101,114,121,32,108,111,110,103,32,115,116,114,105,110,103,32,48,49,50,51,52,53,54,55,56,57,97,48,49,50,51,52,53,54,55,56,57,98,48,49,50,51,52,53,54,55,56,57,99,48,49,50,51,52,53,54,55,56,57,100,48,49,50,51,52,53,54,55,56]", "[]uint8", nil},
 
@@ -573,12 +572,12 @@ func getEvalExpressionTestCases() []varT
 		{"*p2", false, "5", "5", "int", nil},
 		{"p2", true, "*5", "(*int)(0x…", "*int", nil},
 		{"p3", true, "*int nil", "*int nil", "*int", nil},
-		{"*p3", false, "", "", "int", fmt.Errorf("nil pointer dereference")},
+		{"*p3", false, "", "", "int", errors.New("nil pointer dereference")},
 
 		// channels
 		{"ch1", true, "chan int 4/11", "chan int 4/11", "chan int", nil},
 		{"chnil", true, "chan int nil", "chan int nil", "chan int", nil},
-		{"ch1+1", false, "", "", "", fmt.Errorf("can not convert 1 constant to chan int")},
+		{"ch1+1", false, "", "", "", errors.New("can not convert 1 constant to chan int")},
 		{"int3chan.buf", false, "*[5]main.ThreeInts [{a: 1, b: 0, c: 0},{a: 2, b: 0, c: 0},{a: 3, b: 0, c: 0},{a: 0, b: 0, c: 0},{a: 0, b: 0, c: 0}]", "(*[5]main.ThreeInts)(…", "*[5]main.ThreeInts", nil},
 
 		// maps
@@ -587,8 +586,8 @@ func getEvalExpressionTestCases() []varT
 		{"m2[c1.sa[2].B-4].A", false, "10", "10", "int", nil},
 		{"m2[*p1].B", false, "11", "11", "int", nil},
 		{"m3[as1]", false, "42", "42", "int", nil},
-		{"mnil[\"Malone\"]", false, "", "", "", fmt.Errorf("key not found")},
-		{"m1[80:]", false, "", "", "", fmt.Errorf("map index out of bounds")},
+		{"mnil[\"Malone\"]", false, "", "", "", errors.New("key not found")},
+		{"m1[80:]", false, "", "", "", errors.New("map index out of bounds")},
 
 		// interfaces
 		{"err1", true, "error(*main.astruct) *{A: 1, B: 2}", "error(*main.astruct) 0x…", "error", nil},
@@ -602,13 +601,13 @@ func getEvalExpressionTestCases() []varT
 		{"iface4", true, "interface {}([]go/constant.Value) [4]", "interface {}([]go/constant.Value) [...]", "interface {}", nil},
 		{"ifacenil", true, "interface {} nil", "interface {} nil", "interface {}", nil},
 		{"err1 == err2", false, "false", "false", "", nil},
-		{"err1 == iface1", false, "", "", "", fmt.Errorf("mismatched types \"error\" and \"interface {}\"")},
+		{"err1 == iface1", false, "", "", "", errors.New("mismatched types \"error\" and \"interface {}\"")},
 		{"errnil == nil", false, "true", "true", "", nil},
 		{"errtypednil == nil", false, "false", "false", "", nil},
 		{"nil == errnil", false, "true", "true", "", nil},
 		{"err1.(*main.astruct)", false, "*main.astruct {A: 1, B: 2}", "(*main.astruct)(0x…", "*main.astruct", nil},
-		{"err1.(*main.bstruct)", false, "", "", "", fmt.Errorf("interface conversion: error is *main.astruct, not *main.bstruct")},
-		{"errnil.(*main.astruct)", false, "", "", "", fmt.Errorf("interface conversion: error is nil, not *main.astruct")},
+		{"err1.(*main.bstruct)", false, "", "", "", errors.New("interface conversion: error is *main.astruct, not *main.bstruct")},
+		{"errnil.(*main.astruct)", false, "", "", "", errors.New("interface conversion: error is nil, not *main.astruct")},
 		{"const1", true, "go/constant.Value(go/constant.int64Val) 3", "go/constant.Value(go/constant.int64Val) 3", "go/constant.Value", nil},
 
 		// combined expressions
@@ -664,8 +663,8 @@ func getEvalExpressionTestCases() []varT
 		// builtins
 		{"cap(parr)", false, "4", "4", "", nil},
 		{"len(parr)", false, "4", "4", "", nil},
-		{"cap(p1)", false, "", "", "", fmt.Errorf("invalid argument p1 (type *int) for cap")},
-		{"len(p1)", false, "", "", "", fmt.Errorf("invalid argument p1 (type *int) for len")},
+		{"cap(p1)", false, "", "", "", errors.New("invalid argument p1 (type *int) for cap")},
+		{"len(p1)", false, "", "", "", errors.New("invalid argument p1 (type *int) for len")},
 		{"cap(a1)", false, "5", "5", "", nil},
 		{"len(a1)", false, "5", "5", "", nil},
 		{"cap(s3)", false, "6", "6", "", nil},
@@ -692,11 +691,11 @@ func getEvalExpressionTestCases() []varT
 
 		// nil
 		{"nil", false, "nil", "nil", "", nil},
-		{"nil+1", false, "", "", "", fmt.Errorf("operator + can not be applied to \"nil\"")},
+		{"nil+1", false, "", "", "", errors.New("operator + can not be applied to \"nil\"")},
 		{"fn1", false, "main.afunc", "main.afunc", "main.functype", nil},
 		{"fn2", false, "nil", "nil", "main.functype", nil},
 		{"nilslice", false, "[]int len: 0, cap: 0, nil", "[]int len: 0, cap: 0, nil", "[]int", nil},
-		{"fn1 == fn2", false, "", "", "", fmt.Errorf("can not compare func variables")},
+		{"fn1 == fn2", false, "", "", "", errors.New("can not compare func variables")},
 		{"fn1 == nil", false, "false", "false", "", nil},
 		{"fn1 != nil", false, "true", "true", "", nil},
 		{"fn2 == nil", false, "true", "true", "", nil},
@@ -714,31 +713,31 @@ func getEvalExpressionTestCases() []varT
 		{"p1 != nil", false, "true", "true", "", nil},
 		{"ch1 == nil", false, "false", "false", "", nil},
 		{"chnil == nil", false, "true", "true", "", nil},
-		{"ch1 == chnil", false, "", "", "", fmt.Errorf("can not compare chan variables")},
+		{"ch1 == chnil", false, "", "", "", errors.New("can not compare chan variables")},
 		{"m1 == nil", false, "false", "false", "", nil},
-		{"mnil == m1", false, "", "", "", fmt.Errorf("can not compare map variables")},
+		{"mnil == m1", false, "", "", "", errors.New("can not compare map variables")},
 		{"mnil == nil", false, "true", "true", "", nil},
-		{"nil == 2", false, "", "", "", fmt.Errorf("can not compare int to nil")},
-		{"2 == nil", false, "", "", "", fmt.Errorf("can not compare int to nil")},
+		{"nil == 2", false, "", "", "", errors.New("can not compare int to nil")},
+		{"2 == nil", false, "", "", "", errors.New("can not compare int to nil")},
 
 		// errors
-		{"&3", false, "", "", "", fmt.Errorf("can not take address of \"3\"")},
-		{"*3", false, "", "", "", fmt.Errorf("expression \"3\" (int) can not be dereferenced")},
-		{"&(i2 + i3)", false, "", "", "", fmt.Errorf("can not take address of \"(i2 + i3)\"")},
-		{"i2 + p1", false, "", "", "", fmt.Errorf("mismatched types \"int\" and \"*int\"")},
-		{"i2 + f1", false, "", "", "", fmt.Errorf("mismatched types \"int\" and \"float64\"")},
-		{"i2 << f1", false, "", "", "", fmt.Errorf("shift count type float64, must be unsigned integer")},
-		{"i2 << -1", false, "", "", "", fmt.Errorf("shift count must not be negative")},
-		{"*(i2 + i3)", false, "", "", "", fmt.Errorf("expression \"(i2 + i3)\" (int) can not be dereferenced")},
-		{"i2.member", false, "", "", "", fmt.Errorf("i2 (type int) is not a struct")},
-		{"fmt.Println(\"hello\")", false, "", "", "", fmt.Errorf("function calls not allowed without using 'call'")},
-		{"*nil", false, "", "", "", fmt.Errorf("nil can not be dereferenced")},
-		{"!nil", false, "", "", "", fmt.Errorf("operator ! can not be applied to \"nil\"")},
-		{"&nil", false, "", "", "", fmt.Errorf("can not take address of \"nil\"")},
-		{"nil[0]", false, "", "", "", fmt.Errorf("expression \"nil\" (nil) does not support indexing")},
-		{"nil[2:10]", false, "", "", "", fmt.Errorf("can not slice \"nil\" (type nil)")},
-		{"nil.member", false, "", "", "", fmt.Errorf("nil (type nil) is not a struct")},
-		{"(map[string]main.astruct)(0x4000)", false, "", "", "", fmt.Errorf("can not convert \"0x4000\" to map[string]main.astruct")},
+		{"&3", false, "", "", "", errors.New("can not take address of \"3\"")},
+		{"*3", false, "", "", "", errors.New("expression \"3\" (int) can not be dereferenced")},
+		{"&(i2 + i3)", false, "", "", "", errors.New("can not take address of \"(i2 + i3)\"")},
+		{"i2 + p1", false, "", "", "", errors.New("mismatched types \"int\" and \"*int\"")},
+		{"i2 + f1", false, "", "", "", errors.New("mismatched types \"int\" and \"float64\"")},
+		{"i2 << f1", false, "", "", "", errors.New("shift count type float64, must be unsigned integer")},
+		{"i2 << -1", false, "", "", "", errors.New("shift count must not be negative")},
+		{"*(i2 + i3)", false, "", "", "", errors.New("expression \"(i2 + i3)\" (int) can not be dereferenced")},
+		{"i2.member", false, "", "", "", errors.New("i2 (type int) is not a struct")},
+		{"fmt.Println(\"hello\")", false, "", "", "", errors.New("function calls not allowed without using 'call'")},
+		{"*nil", false, "", "", "", errors.New("nil can not be dereferenced")},
+		{"!nil", false, "", "", "", errors.New("operator ! can not be applied to \"nil\"")},
+		{"&nil", false, "", "", "", errors.New("can not take address of \"nil\"")},
+		{"nil[0]", false, "", "", "", errors.New("expression \"nil\" (nil) does not support indexing")},
+		{"nil[2:10]", false, "", "", "", errors.New("can not slice \"nil\" (type nil)")},
+		{"nil.member", false, "", "", "", errors.New("nil (type nil) is not a struct")},
+		{"(map[string]main.astruct)(0x4000)", false, "", "", "", errors.New("can not convert \"0x4000\" to map[string]main.astruct")},
 
 		// typecasts
 		{"uint(i2)", false, "2", "2", "uint", nil},
@@ -821,9 +820,9 @@ func getEvalExpressionTestCases() []varT
 		{"afunc(2)", false, "", "", "", errors.New("function calls not allowed without using 'call'")},
 		{"(afunc)(2)", false, "", "", "", errors.New("function calls not allowed without using 'call'")},
 		{"(*afunc)(2)", false, "", "", "", errors.New("expression \"afunc\" (func()) can not be dereferenced")},
-		{"unknownthing(2)", false, "", "", "", errors.New("could not evaluate function or type unknownthing: could not find symbol value for unknownthing")},
-		{"(*unknownthing)(2)", false, "", "", "", errors.New("could not evaluate function or type (*unknownthing): could not find symbol value for unknownthing")},
-		{"(*strings.Split)(2)", false, "", "", "", errors.New("could not evaluate function or type (*strings.Split): could not find symbol value for strings")},
+		{"unknownthing(2)", false, "", "", "", errors.New("could not find symbol value for unknownthing")},
+		{"(*unknownthing)(2)", false, "", "", "", errors.New("could not find symbol value for unknownthing")},
+		{"(*strings.Split)(2)", false, "", "", "", errors.New("could not find symbol value for strings")},
 
 		// pretty printing special types
 		{"tim1", false, `time.Time(1977-05-25T18:00:00Z)…`, `time.Time(1977-05-25T18:00:00Z)…`, "time.Time", nil},
@@ -1196,7 +1195,7 @@ func TestCallFunction(t *testing.T) {
 		{`stringsJoin(nil, "")`, []string{`:string:""`}, nil},
 		{`stringsJoin(stringslice, comma)`, []string{`:string:"one,two,three"`}, nil},
 		{`stringsJoin(stringslice, "~~")`, []string{`:string:"one~~two~~three"`}, nil},
-		{`stringsJoin(s1, comma)`, nil, errors.New(`error evaluating "s1" as argument 1 in function stringsJoin: could not find symbol value for s1`)},
+		{`stringsJoin(s1, comma)`, nil, errors.New(`could not find symbol value for s1`)},
 		{`stringsJoin(intslice, comma)`, nil, errors.New("can not convert value of type []int to []string")},
 		{`noreturncall(2)`, nil, nil},
 
@@ -1296,11 +1295,11 @@ func TestCallFunction(t *testing.T) {
 	}
 
 	var testcasesBefore114After112 = []testCaseCallFunction{
-		{`strings.Join(s1, comma)`, nil, errors.New(`error evaluating "s1" as argument 1 in function strings.Join: could not find symbol value for s1`)},
+		{`strings.Join(s1, comma)`, nil, errors.New(`could not find symbol value for s1`)},
 	}
 
 	var testcases114 = []testCaseCallFunction{
-		{`strings.Join(s1, comma)`, nil, errors.New(`error evaluating "s1" as argument 1 in function strings.Join: could not find symbol value for s1`)},
+		{`strings.Join(s1, comma)`, nil, errors.New(`could not find symbol value for s1`)},
 	}
 
 	var testcases117 = []testCaseCallFunction{
diff -pruN 1.22.1-1/pkg/terminal/command.go 1.23.0-1/pkg/terminal/command.go
--- 1.22.1-1/pkg/terminal/command.go	2024-02-21 20:29:06.000000000 +0000
+++ 1.23.0-1/pkg/terminal/command.go	2024-07-16 18:44:48.000000000 +0000
@@ -122,9 +122,32 @@ func DebugCommands(client service.Client
 Type "help" followed by the name of a command for more information about it.`},
 		{aliases: []string{"break", "b"}, group: breakCmds, cmdFn: breakpoint, helpMsg: `Sets a breakpoint.
 
-	break [name] [locspec]
+	break [name] [locspec] [if <condition>]
 
-See Documentation/cli/locspec.md for the syntax of locspec. If locspec is omitted a breakpoint will be set on the current line.
+Locspec is a location specifier in the form of:
+
+  * *<address> Specifies the location of memory address address. address can be specified as a decimal, hexadecimal or octal number
+  * <filename>:<line> Specifies the line in filename. filename can be the partial path to a file or even just the base name as long as the expression remains unambiguous.
+  * <line> Specifies the line in the current file
+  * +<offset> Specifies the line offset lines after the current one
+  * -<offset> Specifies the line offset lines before the current one
+  * <function>[:<line>] Specifies the line inside function.
+      The full syntax for function is <package>.(*<receiver type>).<function name> however the only required element is the function name,
+      everything else can be omitted as long as the expression remains unambiguous. For setting a breakpoint on an init function (ex: main.init),
+      the <filename>:<line> syntax should be used to break in the correct init function at the correct location.
+  * /<regex>/ Specifies the location of all the functions matching regex
+
+If locspec is omitted a breakpoint will be set on the current line.
+
+If you would like to assign a name to the breakpoint you can do so with the form:
+
+  break mybpname main.go:4
+
+Finally, you can assign a condition to the newly created breakpoint by using the 'if' postfix form, like so:
+
+  break main.go:55 if i == 5
+
+Alternatively you can set a condition on a breakpoint after created by using the 'on' command.
 
 See also: "help on", "help cond" and "help clear"`},
 		{aliases: []string{"trace", "t"}, group: breakCmds, cmdFn: tracepoint, allowedPrefixes: onPrefix, helpMsg: `Set tracepoint.
@@ -186,7 +209,8 @@ For example:
 	continue encoding/json.Marshal
 `},
 		{aliases: []string{"step", "s"}, group: runCmds, cmdFn: c.step, allowedPrefixes: revPrefix, helpMsg: "Single step through program."},
-		{aliases: []string{"step-instruction", "si"}, group: runCmds, allowedPrefixes: revPrefix, cmdFn: c.stepInstruction, helpMsg: "Single step a single cpu instruction."},
+		{aliases: []string{"step-instruction", "si", "stepi"}, group: runCmds, allowedPrefixes: revPrefix, cmdFn: c.stepInstruction, helpMsg: "Single step a single cpu instruction."},
+		{aliases: []string{"next-instruction", "ni", "nexti"}, group: runCmds, allowedPrefixes: revPrefix, cmdFn: c.nextInstruction, helpMsg: "Single step a single cpu instruction, skipping function calls."},
 		{aliases: []string{"next", "n"}, group: runCmds, cmdFn: c.next, allowedPrefixes: revPrefix, helpMsg: `Step over to next source line.
 
 	next [count]
@@ -826,7 +850,7 @@ func threads(t *Term, ctx callContext, a
 
 func thread(t *Term, ctx callContext, args string) error {
 	if len(args) == 0 {
-		return fmt.Errorf("you must specify a thread")
+		return errors.New("you must specify a thread")
 	}
 	tid, err := strconv.Atoi(args)
 	if err != nil {
@@ -1164,6 +1188,13 @@ var waitReasonStrings = [...]string{
 	"GC worker (idle)",
 	"preempted",
 	"debug call",
+	"GC mark termination",
+	"stopping the world",
+	"flushing proc caches",
+	"trace goroutine status",
+	"trace proc status",
+	"page trace flush",
+	"coroutine",
 }
 
 func writeGoroutineLong(t *Term, w io.Writer, g *api.Goroutine, prefix string) {
@@ -1234,7 +1265,7 @@ func restartRecorded(t *Term, ctx callCo
 			}
 		} else {
 			if len(v) > 1 {
-				return fmt.Errorf("too many arguments to restart")
+				return errors.New("too many arguments to restart")
 			}
 			restartPos = v[0]
 		}
@@ -1310,7 +1341,7 @@ func parseNewArgv(args string) (resetArg
 	}
 	if w[0] == "-noargs" {
 		if len(w) > 1 {
-			return false, nil, [3]string{}, fmt.Errorf("too many arguments to restart")
+			return false, nil, [3]string{}, errors.New("too many arguments to restart")
 		}
 		return true, nil, [3]string{}, nil
 	}
@@ -1504,24 +1535,34 @@ func (c *Commands) step(t *Term, ctx cal
 
 var errNotOnFrameZero = errors.New("not on topmost frame")
 
+// stepInstruction implements the step-instruction (stepi) command.
 func (c *Commands) stepInstruction(t *Term, ctx callContext, args string) error {
+	return stepInstruction(t, ctx, c.frame, false)
+}
+
+// nextInstruction implements the next-instruction (nexti) command.
+func (c *Commands) nextInstruction(t *Term, ctx callContext, args string) error {
+	return stepInstruction(t, ctx, c.frame, true)
+}
+
+func stepInstruction(t *Term, ctx callContext, frame int, skipCalls bool) error {
 	if err := scopePrefixSwitch(t, ctx); err != nil {
 		return err
 	}
-	if c.frame != 0 {
+	if frame != 0 {
 		return errNotOnFrameZero
 	}
 
 	defer t.onStop()
 
-	var fn func() (*api.DebuggerState, error)
+	var fn func(bool) (*api.DebuggerState, error)
 	if ctx.Prefix == revPrefix {
 		fn = t.client.ReverseStepInstruction
 	} else {
 		fn = t.client.StepInstruction
 	}
 
-	state, err := exitedToError(fn())
+	state, err := exitedToError(fn(skipCalls))
 	if err != nil {
 		printcontextNoState(t)
 		return err
@@ -1622,7 +1663,7 @@ func (c *Commands) call(t *Term, ctx cal
 
 func clear(t *Term, ctx callContext, args string) error {
 	if len(args) == 0 {
-		return fmt.Errorf("not enough arguments")
+		return errors.New("not enough arguments")
 	}
 	id, err := strconv.Atoi(args)
 	var bp *api.Breakpoint
@@ -1681,7 +1722,7 @@ func clearAll(t *Term, ctx callContext,
 
 func toggle(t *Term, ctx callContext, args string) error {
 	if args == "" {
-		return fmt.Errorf("not enough arguments")
+		return errors.New("not enough arguments")
 	}
 	id, err := strconv.Atoi(args)
 	var bp *api.Breakpoint
@@ -1778,31 +1819,55 @@ func formatBreakpointAttrs(prefix string
 }
 
 func setBreakpoint(t *Term, ctx callContext, tracepoint bool, argstr string) ([]*api.Breakpoint, error) {
-	args := config.Split2PartsBySpace(argstr)
+	var (
+		cond string
+		spec string
 
-	requestedBp := &api.Breakpoint{}
-	spec := ""
-	switch len(args) {
-	case 1:
-		if len(args[0]) != 0 {
-			spec = argstr
-		} else {
-			// no arg specified
-			spec = "+0"
-		}
-	case 2:
-		if api.ValidBreakpointName(args[0]) == nil {
-			requestedBp.Name = args[0]
-			spec = args[1]
-		} else {
-			spec = argstr
+		requestedBp = &api.Breakpoint{}
+	)
+
+	parseSpec := func(args []string) error {
+		switch len(args) {
+		case 1:
+			if len(args[0]) != 0 {
+				spec = argstr
+			} else {
+				// no arg specified
+				spec = "+0"
+			}
+		case 2:
+			if api.ValidBreakpointName(args[0]) == nil {
+				requestedBp.Name = args[0]
+				spec = args[1]
+			} else {
+				spec = argstr
+			}
+		default:
+			return errors.New("address required")
 		}
-	default:
-		return nil, fmt.Errorf("address required")
+		return nil
+	}
+
+	args := config.Split2PartsBySpace(argstr)
+	if err := parseSpec(args); err != nil {
+		return nil, err
 	}
 
 	requestedBp.Tracepoint = tracepoint
 	locs, substSpec, findLocErr := t.client.FindLocation(ctx.Scope, spec, true, t.substitutePathRules())
+	if findLocErr != nil {
+		r := regexp.MustCompile(`^if | if `)
+		if match := r.FindStringIndex(argstr); match != nil {
+			requestedBp.Name = ""
+			cond = argstr[match[1]:]
+			argstr = argstr[:match[0]]
+			args = config.Split2PartsBySpace(argstr)
+			if err := parseSpec(args); err != nil {
+				return nil, err
+			}
+			locs, substSpec, findLocErr = t.client.FindLocation(ctx.Scope, spec, true, t.substitutePathRules())
+		}
+	}
 	if findLocErr != nil && requestedBp.Name != "" {
 		requestedBp.Name = ""
 		spec = argstr
@@ -1835,6 +1900,7 @@ func setBreakpoint(t *Term, ctx callCont
 		fmt.Fprintf(t.stdout, "%s set at %s\n", formatBreakpointName(bp, true), t.formatBreakpointLocation(bp))
 		return nil, nil
 	}
+
 	if findLocErr != nil {
 		return nil, findLocErr
 	}
@@ -1851,6 +1917,7 @@ func setBreakpoint(t *Term, ctx callCont
 			requestedBp.LoadArgs = &ShortLoadConfig
 		}
 
+		requestedBp.Cond = cond
 		bp, err := t.client.CreateBreakpointWithExpr(requestedBp, spec, t.substitutePathRules(), false)
 		if err != nil {
 			return nil, err
@@ -1917,7 +1984,7 @@ func getEditorName() (string, error) {
 	var editor string
 	if editor = os.Getenv("DELVE_EDITOR"); editor == "" {
 		if editor = os.Getenv("EDITOR"); editor == "" {
-			return "", fmt.Errorf("Neither DELVE_EDITOR or EDITOR is set")
+			return "", errors.New("Neither DELVE_EDITOR or EDITOR is set")
 		}
 	}
 	return editor, nil
@@ -2016,7 +2083,7 @@ loop:
 		case "-fmt":
 			arg := nextArg()
 			if arg == "" {
-				return fmt.Errorf("expected argument after -fmt")
+				return errors.New("expected argument after -fmt")
 			}
 			fmtMapToPriFmt := map[string]byte{
 				"oct":         'o',
@@ -2035,22 +2102,22 @@ loop:
 		case "-count", "-len":
 			arg := nextArg()
 			if arg == "" {
-				return fmt.Errorf("expected argument after -count/-len")
+				return errors.New("expected argument after -count/-len")
 			}
 			var err error
 			count, err = strconv.Atoi(arg)
 			if err != nil || count <= 0 {
-				return fmt.Errorf("count/len must be a positive integer")
+				return errors.New("count/len must be a positive integer")
 			}
 		case "-size":
 			arg := nextArg()
 			if arg == "" {
-				return fmt.Errorf("expected argument after -size")
+				return errors.New("expected argument after -size")
 			}
 			var err error
 			size, err = strconv.Atoi(arg)
 			if err != nil || size <= 0 || size > 8 {
-				return fmt.Errorf("size must be a positive integer (<=8)")
+				return errors.New("size must be a positive integer (<=8)")
 			}
 		case "-x":
 			isExpr = true
@@ -2066,11 +2133,11 @@ loop:
 
 	// TODO, maybe configured by user.
 	if count*size > 1000 {
-		return fmt.Errorf("read memory range (count*size) must be less than or equal to 1000 bytes")
+		return errors.New("read memory range (count*size) must be less than or equal to 1000 bytes")
 	}
 
 	if len(args) == 0 {
-		return fmt.Errorf("no address specified")
+		return errors.New("no address specified")
 	}
 
 	if isExpr {
@@ -2126,7 +2193,7 @@ const maxPrintVarChanGoroutines = 100
 
 func (c *Commands) printVar(t *Term, ctx callContext, args string) error {
 	if len(args) == 0 {
-		return fmt.Errorf("not enough arguments")
+		return errors.New("not enough arguments")
 	}
 	if ctx.Prefix == onPrefix {
 		ctx.Breakpoint.Variables = append(ctx.Breakpoint.Variables, args)
@@ -2162,7 +2229,7 @@ func (c *Commands) printVar(t *Term, ctx
 
 func whatisCommand(t *Term, ctx callContext, args string) error {
 	if len(args) == 0 {
-		return fmt.Errorf("not enough arguments")
+		return errors.New("not enough arguments")
 	}
 	val, err := t.client.EvalVariable(ctx.Scope, args, ShortLoadConfig)
 	if err != nil {
@@ -2191,7 +2258,7 @@ func setVar(t *Term, ctx callContext, ar
 	// HACK: in go '=' is not an operator, we detect the error and try to recover from it by splitting the input string
 	_, err := parser.ParseExpr(args)
 	if err == nil {
-		return fmt.Errorf("syntax error '=' not found")
+		return errors.New("syntax error '=' not found")
 	}
 
 	el, ok := err.(scanner.ErrorList)
@@ -2264,7 +2331,7 @@ func packages(t *Term, ctx callContext,
 }
 
 func funcs(t *Term, ctx callContext, args string) error {
-	return t.printSortedStrings(t.client.ListFunctions(args))
+	return t.printSortedStrings(t.client.ListFunctions(args, 0))
 }
 
 func types(t *Term, ctx callContext, args string) error {
@@ -2286,7 +2353,7 @@ func args(t *Term, ctx callContext, args
 	filter, cfg := parseVarArguments(args, t)
 	if ctx.Prefix == onPrefix {
 		if filter != "" {
-			return fmt.Errorf("filter not supported on breakpoint")
+			return errors.New("filter not supported on breakpoint")
 		}
 		ctx.Breakpoint.LoadArgs = &cfg
 		return nil
@@ -2302,7 +2369,7 @@ func locals(t *Term, ctx callContext, ar
 	filter, cfg := parseVarArguments(args, t)
 	if ctx.Prefix == onPrefix {
 		if filter != "" {
-			return fmt.Errorf("filter not supported on breakpoint")
+			return errors.New("filter not supported on breakpoint")
 		}
 		ctx.Breakpoint.LoadLocals = &cfg
 		return nil
@@ -2405,7 +2472,6 @@ func parseStackArgs(argstr string) (stac
 					return 0, fmt.Errorf("expected number after %s: %v", name, err)
 				}
 				return n, nil
-
 			}
 			switch args[i] {
 			case "-full":
@@ -2417,7 +2483,7 @@ func parseStackArgs(argstr string) (stac
 			case "-mode":
 				i++
 				if i >= len(args) {
-					return stackArgs{}, fmt.Errorf("expected normal, simple or fromg after -mode")
+					return stackArgs{}, errors.New("expected normal, simple or fromg after -mode")
 				}
 				switch args[i] {
 				case "normal":
@@ -2428,7 +2494,7 @@ func parseStackArgs(argstr string) (stac
 				case "fromg":
 					r.opts |= api.StacktraceG | api.StacktraceSimple
 				default:
-					return stackArgs{}, fmt.Errorf("expected normal, simple or fromg after -mode")
+					return stackArgs{}, errors.New("expected normal, simple or fromg after -mode")
 				}
 			case "-a":
 				i++
@@ -2447,7 +2513,7 @@ func parseStackArgs(argstr string) (stac
 			default:
 				n, err := strconv.Atoi(args[i])
 				if err != nil {
-					return stackArgs{}, fmt.Errorf("depth must be a number")
+					return stackArgs{}, errors.New("depth must be a number")
 				}
 				r.depth = n
 			}
@@ -2526,7 +2592,7 @@ func listCommand(t *Term, ctx callContex
 
 func (c *Commands) sourceCommand(t *Term, ctx callContext, args string) error {
 	if len(args) == 0 {
-		return fmt.Errorf("wrong number of arguments: source <filename>")
+		return errors.New("wrong number of arguments: source <filename>")
 	}
 
 	if args == "-" {
@@ -2759,6 +2825,8 @@ func printcontextThread(t *Term, th *api
 		bpname = fmt.Sprintf("watchpoint on [%s] ", th.Breakpoint.WatchExpr)
 	} else if th.Breakpoint.Name != "" {
 		bpname = fmt.Sprintf("[%s] ", th.Breakpoint.Name)
+	} else if !th.Breakpoint.Tracepoint {
+		bpname = fmt.Sprintf("[Breakpoint %d] ", th.Breakpoint.ID)
 	}
 
 	if th.Breakpoint.Tracepoint || th.Breakpoint.TraceReturn {
@@ -2840,11 +2908,13 @@ func printBreakpointInfo(t *Term, th *ap
 			fmt.Fprintf(t.stdout, "\t%s: %s\n", v.Name, v.MultilineString("\t", ""))
 		}
 	}
-
 	if bpi.Stacktrace != nil {
-		tracepointnl()
-		fmt.Fprintf(t.stdout, "\tStack:\n")
-		printStack(t, t.stdout, bpi.Stacktrace, "\t\t", false)
+		// TraceFollowCalls and Stacktrace are mutually exclusive as they pollute each others outputs
+		if th.Breakpoint.TraceFollowCalls <= 0 {
+			tracepointnl()
+			fmt.Fprintf(t.stdout, "\tStack:\n")
+			printStack(t, t.stdout, bpi.Stacktrace, "\t\t", false)
+		}
 	}
 }
 
@@ -2853,8 +2923,39 @@ func printTracepoint(t *Term, th *api.Th
 		fmt.Fprintf(t.stdout, "%s ", time.Now().Format(time.RFC3339Nano))
 	}
 
+	var sdepth, rootindex int
+	depthPrefix := ""
+	tracePrefix := ""
+	if th.Breakpoint.TraceFollowCalls > 0 {
+		// Trace Follow Calls; stack is required to calculate depth of functions
+		rootindex = -1
+		if th.BreakpointInfo == nil || th.BreakpointInfo.Stacktrace == nil {
+			return
+		}
+
+		stack := th.BreakpointInfo.Stacktrace
+		for i := len(stack) - 1; i >= 0; i-- {
+			if stack[i].Function.Name() == th.Breakpoint.RootFuncName {
+				if rootindex == -1 {
+					rootindex = i
+					break
+				}
+			}
+		}
+		sdepth = rootindex + 1
+		tracePrefix = fmt.Sprintf("goroutine(%d):frame(%d)", th.GoroutineID, sdepth)
+		if sdepth > 0 {
+			depthPrefix = strings.Repeat(" ", sdepth-1)
+		}
+	} else {
+		tracePrefix = fmt.Sprintf("goroutine(%d):", th.GoroutineID)
+	}
+
 	if th.Breakpoint.Tracepoint {
-		fmt.Fprintf(t.stdout, "> goroutine(%d): %s%s(%s)\n", th.GoroutineID, bpname, fn.Name(), args)
+		// Print trace only if there was a match on the function while TraceFollowCalls is on or if it's a regular trace
+		if rootindex != -1 || th.Breakpoint.TraceFollowCalls <= 0 {
+			fmt.Fprintf(t.stdout, "%s> %s %s%s(%s)\n", depthPrefix, tracePrefix, bpname, fn.Name(), args)
+		}
 		printBreakpointInfo(t, th, !hasReturnValue)
 	}
 	if th.Breakpoint.TraceReturn {
@@ -2862,7 +2963,14 @@ func printTracepoint(t *Term, th *api.Th
 		for _, v := range th.ReturnValues {
 			retVals = append(retVals, v.SinglelineString())
 		}
-		fmt.Fprintf(t.stdout, ">> goroutine(%d): => (%s)\n", th.GoroutineID, strings.Join(retVals, ","))
+		// Print trace only if there was a match on the function while TraceFollowCalls is on or if it's a regular trace
+		if rootindex != -1 || th.Breakpoint.TraceFollowCalls <= 0 {
+			fmt.Fprintf(t.stdout, "%s>> %s %s => (%s)\n", depthPrefix, tracePrefix, fn.Name(), strings.Join(retVals, ","))
+		}
+	}
+	if th.Breakpoint.TraceFollowCalls > 0 {
+		// As of now traceFollowCalls and Stacktrace are mutually exclusive options
+		return
 	}
 	if th.Breakpoint.TraceReturn || !hasReturnValue {
 		if th.BreakpointInfo != nil && th.BreakpointInfo.Stacktrace != nil {
@@ -3015,10 +3123,11 @@ func (c *Commands) onCmd(t *Term, ctx ca
 			return err
 		}
 		defer func() {
+			_ = f.Close()
 			_ = os.Remove(f.Name())
 		}()
 		attrs := formatBreakpointAttrs("", ctx.Breakpoint, true)
-		_, err = f.Write([]byte(strings.Join(attrs, "\n")))
+		_, err = f.WriteString(strings.Join(attrs, "\n"))
 		if err != nil {
 			return err
 		}
@@ -3075,7 +3184,7 @@ func conditionCmd(t *Term, ctx callConte
 	args := config.Split2PartsBySpace(argstr)
 
 	if len(args) < 2 {
-		return fmt.Errorf("not enough arguments")
+		return errors.New("not enough arguments")
 	}
 
 	hitCondPerG := args[0] == "-per-g-hitcount"
@@ -3090,7 +3199,7 @@ func conditionCmd(t *Term, ctx callConte
 
 		args = config.Split2PartsBySpace(args[1])
 		if len(args) < 2 {
-			return fmt.Errorf("not enough arguments")
+			return errors.New("not enough arguments")
 		}
 
 		bp, err := getBreakpointByIDOrName(t, args[0])
@@ -3233,7 +3342,7 @@ func display(t *Term, ctx callContext, a
 		args = strings.TrimSpace(args[len(addOption):])
 		fmtstr, args := parseFormatArg(args)
 		if args == "" {
-			return fmt.Errorf("not enough arguments")
+			return errors.New("not enough arguments")
 		}
 		t.addDisplay(args, fmtstr)
 		t.printDisplay(len(t.displays) - 1)
@@ -3247,14 +3356,14 @@ func display(t *Term, ctx callContext, a
 		return t.removeDisplay(n)
 
 	default:
-		return fmt.Errorf("wrong arguments")
+		return errors.New("wrong arguments")
 	}
 	return nil
 }
 
 func dump(t *Term, ctx callContext, args string) error {
 	if args == "" {
-		return fmt.Errorf("not enough arguments")
+		return errors.New("not enough arguments")
 	}
 	dumpState, err := t.client.CoreDumpStart(args)
 	if err != nil {
@@ -3414,7 +3523,7 @@ func formatBreakpointName(bp *api.Breakp
 		thing = "watchpoint"
 	}
 	if upcase {
-		thing = strings.Title(thing)
+		thing = strings.ToUpper(string(thing[0])) + thing[1:]
 	}
 	id := bp.Name
 	if id == "" {
@@ -3452,7 +3561,7 @@ func (t *Term) formatBreakpointLocation(
 }
 
 func shouldAskToSuspendBreakpoint(t *Term) bool {
-	fns, _ := t.client.ListFunctions(`^plugin\.Open$`)
+	fns, _ := t.client.ListFunctions(`^plugin\.Open$`, 0)
 	_, err := t.client.GetState()
 	return len(fns) > 0 || isErrProcessExited(err) || t.client.FollowExecEnabled()
 }
diff -pruN 1.22.1-1/pkg/terminal/command_test.go 1.23.0-1/pkg/terminal/command_test.go
--- 1.22.1-1/pkg/terminal/command_test.go	2024-02-21 20:29:06.000000000 +0000
+++ 1.23.0-1/pkg/terminal/command_test.go	2024-07-16 18:44:48.000000000 +0000
@@ -901,7 +901,7 @@ func TestPrintContextParkedGoroutine(t *
 		frameout := strings.Split(term.MustExec("frame 0"), "\n")
 		t.Logf("frame 0 -> %q", frameout)
 		if strings.Contains(frameout[0], "stacktraceme") {
-			t.Fatal("bad output for `frame 0` command on a parked goorutine")
+			t.Fatal("bad output for `frame 0` command on a parked goroutine")
 		}
 
 		listout := strings.Split(term.MustExec("list"), "\n")
@@ -1366,7 +1366,7 @@ func TestTranscript(t *testing.T) {
 	withTestTerminal("math", t, func(term *FakeTerminal) {
 		term.MustExec("break main.main")
 		out := term.MustExec("continue")
-		if !strings.HasPrefix(out, "> main.main()") {
+		if !strings.HasPrefix(out, "> [Breakpoint 1] main.main()") {
 			t.Fatalf("Wrong output for next: <%s>", out)
 		}
 		fh, err := os.CreateTemp("", "test-transcript-*")
@@ -1435,6 +1435,47 @@ func TestCreateBreakpointByLocExpr(t *te
 	})
 }
 
+func TestCreateBreakpointWithCondition(t *testing.T) {
+	withTestTerminal("break", t, func(term *FakeTerminal) {
+		term.MustExec("break bp1 main.main:4 if i == 3")
+		out := term.MustExec("breakpoints")
+		if !strings.Contains(out, "Breakpoint bp1") {
+			t.Fatal("incorrect breakpoint name")
+		}
+		listIsAt(t, term, "continue", 7, -1, -1)
+		out = term.MustExec("print i")
+		t.Logf("%q", out)
+		if !strings.Contains(out, "3\n") {
+			t.Fatalf("wrong value of i")
+		}
+	})
+}
+
+func TestCreateBreakpointWithCondition2(t *testing.T) {
+	withTestTerminal("break", t, func(term *FakeTerminal) {
+		term.MustExec("continue main.main:4")
+		term.MustExec("break if i == 3")
+		out := term.MustExec("breakpoints")
+		if strings.Contains(out, "Breakpoint if") {
+			t.Fatal("incorrect breakpoint name, should be ID")
+		}
+		listIsAt(t, term, "continue", 7, -1, -1)
+		out = term.MustExec("print i")
+		t.Logf("%q", out)
+		if !strings.Contains(out, "3\n") {
+			t.Fatalf("wrong value of i")
+		}
+	})
+}
+
+func TestCreateBreakpointWithCondition3(t *testing.T) {
+	withTestTerminal("test if path/main", t, func(term *FakeTerminal) {
+		// We should not attempt to parse this as a condition.
+		term.MustExec(`break _fixtures/test if path/main.go:4`)
+		listIsAt(t, term, "continue", 4, -1, -1)
+	})
+}
+
 func TestRestartBreakpoints(t *testing.T) {
 	// Tests that breakpoints set using just a line number and with a line
 	// offset are preserved after restart. See issue #3423.
diff -pruN 1.22.1-1/pkg/terminal/config.go 1.23.0-1/pkg/terminal/config.go
--- 1.22.1-1/pkg/terminal/config.go	2024-02-21 20:29:06.000000000 +0000
+++ 1.23.0-1/pkg/terminal/config.go	2024-07-16 18:44:48.000000000 +0000
@@ -18,7 +18,7 @@ func configureCmd(t *Term, ctx callConte
 	case "-save":
 		return config.SaveConfig(t.conf)
 	case "":
-		return fmt.Errorf("wrong number of arguments to \"config\"")
+		return errors.New("wrong number of arguments to \"config\"")
 	default:
 		err := configureSet(t, args)
 		if err != nil {
@@ -103,7 +103,7 @@ func configureSetSubstitutePath(t *Term,
 		}
 		t.conf.SubstitutePath = append(t.conf.SubstitutePath, config.SubstitutePathRule{From: argv[0], To: argv[1]})
 	default:
-		return fmt.Errorf("too many arguments to \"config substitute-path\"")
+		return errors.New("too many arguments to \"config substitute-path\"")
 	}
 	return nil
 }
diff -pruN 1.22.1-1/pkg/terminal/docgen.go 1.23.0-1/pkg/terminal/docgen.go
--- 1.22.1-1/pkg/terminal/docgen.go	2024-02-21 20:29:06.000000000 +0000
+++ 1.23.0-1/pkg/terminal/docgen.go	2024-07-16 18:44:48.000000000 +0000
@@ -63,7 +63,6 @@ func (c *Commands) WriteMarkdown(w io.Wr
 			fmt.Fprintf(w, "[%s](#%s) | %s\n", cmd.aliases[0], cmd.aliases[0], h)
 		}
 		fmt.Fprint(w, "\n")
-
 	}
 
 	for _, cmd := range c.cmds {
diff -pruN 1.22.1-1/pkg/terminal/starbind/conv.go 1.23.0-1/pkg/terminal/starbind/conv.go
--- 1.22.1-1/pkg/terminal/starbind/conv.go	2024-02-21 20:29:06.000000000 +0000
+++ 1.23.0-1/pkg/terminal/starbind/conv.go	2024-07-16 18:44:48.000000000 +0000
@@ -93,7 +93,7 @@ func (v sliceAsStarlarkValue) Freeze() {
 }
 
 func (v sliceAsStarlarkValue) Hash() (uint32, error) {
-	return 0, fmt.Errorf("not hashable")
+	return 0, errors.New("not hashable")
 }
 
 func (v sliceAsStarlarkValue) String() string {
@@ -155,7 +155,7 @@ func (v structAsStarlarkValue) Freeze()
 }
 
 func (v structAsStarlarkValue) Hash() (uint32, error) {
-	return 0, fmt.Errorf("not hashable")
+	return 0, errors.New("not hashable")
 }
 
 func (v structAsStarlarkValue) String() string {
@@ -290,7 +290,7 @@ func (v structVariableAsStarlarkValue) F
 }
 
 func (v structVariableAsStarlarkValue) Hash() (uint32, error) {
-	return 0, fmt.Errorf("not hashable")
+	return 0, errors.New("not hashable")
 }
 
 func (v structVariableAsStarlarkValue) String() string {
@@ -350,7 +350,7 @@ func (v sliceVariableAsStarlarkValue) Fr
 }
 
 func (v sliceVariableAsStarlarkValue) Hash() (uint32, error) {
-	return 0, fmt.Errorf("not hashable")
+	return 0, errors.New("not hashable")
 }
 
 func (v sliceVariableAsStarlarkValue) String() string {
@@ -416,7 +416,7 @@ func (v ptrVariableAsStarlarkValue) Free
 }
 
 func (v ptrVariableAsStarlarkValue) Hash() (uint32, error) {
-	return 0, fmt.Errorf("not hashable")
+	return 0, errors.New("not hashable")
 }
 
 func (v ptrVariableAsStarlarkValue) String() string {
@@ -500,7 +500,7 @@ func (v mapVariableAsStarlarkValue) Free
 }
 
 func (v mapVariableAsStarlarkValue) Hash() (uint32, error) {
-	return 0, fmt.Errorf("not hashable")
+	return 0, errors.New("not hashable")
 }
 
 func (v mapVariableAsStarlarkValue) String() string {
diff -pruN 1.22.1-1/pkg/terminal/starbind/conv_test.go 1.23.0-1/pkg/terminal/starbind/conv_test.go
--- 1.22.1-1/pkg/terminal/starbind/conv_test.go	2024-02-21 20:29:06.000000000 +0000
+++ 1.23.0-1/pkg/terminal/starbind/conv_test.go	2024-07-16 18:44:48.000000000 +0000
@@ -1,8 +1,9 @@
 package starbind
 
 import (
-	"go.starlark.net/starlark"
 	"testing"
+
+	"go.starlark.net/starlark"
 )
 
 func TestConv(t *testing.T) {
@@ -10,7 +11,7 @@ func TestConv(t *testing.T) {
 # A list global that we'll unmarshal into a slice.
 x = [1,2]
 `
-	globals, err := starlark.ExecFile(&starlark.Thread{}, "test.star", script, nil)
+	globals, err := execFileOptions(nil, &starlark.Thread{}, "test.star", script, nil)
 	starlarkVal, ok := globals["x"]
 	if !ok {
 		t.Fatal("missing global 'x'")
diff -pruN 1.22.1-1/pkg/terminal/starbind/repl.go 1.23.0-1/pkg/terminal/starbind/repl.go
--- 1.22.1-1/pkg/terminal/starbind/repl.go	2024-02-21 20:29:06.000000000 +0000
+++ 1.23.0-1/pkg/terminal/starbind/repl.go	2024-07-16 18:44:48.000000000 +0000
@@ -34,6 +34,7 @@ package starbind
 // OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 
 import (
+	"errors"
 	"fmt"
 	"io"
 	"os"
@@ -116,7 +117,7 @@ func rep(rl *liner.State, thread *starla
 	if expr := soleExpr(f); expr != nil {
 		//TODO: check for 'exit'
 		// eval
-		v, err := starlark.EvalExpr(thread, expr, globals)
+		v, err := evalExprOptions(nil, thread, expr, globals)
 		if err != nil {
 			printError(err)
 			return nil
@@ -186,7 +187,7 @@ func MakeLoad() func(thread *starlark.Th
 		if e == nil {
 			if ok {
 				// request for package whose loading is in progress
-				return nil, fmt.Errorf("cycle in load graph")
+				return nil, errors.New("cycle in load graph")
 			}
 
 			// Add a placeholder to indicate "load in progress".
@@ -194,7 +195,7 @@ func MakeLoad() func(thread *starlark.Th
 
 			// Load it.
 			thread := &starlark.Thread{Name: "exec " + module, Load: thread.Load}
-			globals, err := starlark.ExecFile(thread, module, nil, nil)
+			globals, err := execFileOptions(nil, thread, module, nil, nil)
 			e = &entry{globals, err}
 
 			// Update the cache.
diff -pruN 1.22.1-1/pkg/terminal/starbind/starlark.go 1.23.0-1/pkg/terminal/starbind/starlark.go
--- 1.22.1-1/pkg/terminal/starbind/starlark.go	2024-02-21 20:29:06.000000000 +0000
+++ 1.23.0-1/pkg/terminal/starbind/starlark.go	2024-07-16 18:44:48.000000000 +0000
@@ -2,6 +2,7 @@ package starbind
 
 import (
 	"context"
+	"errors"
 	"fmt"
 	"io"
 	"os"
@@ -11,8 +12,8 @@ import (
 	"sync"
 
 	startime "go.starlark.net/lib/time"
-	"go.starlark.net/resolve"
 	"go.starlark.net/starlark"
+	"go.starlark.net/syntax"
 
 	"github.com/go-delve/delve/service"
 	"github.com/go-delve/delve/service/api"
@@ -32,14 +33,12 @@ const (
 	helpBuiltinName              = "help"
 )
 
-func init() {
-	resolve.AllowNestedDef = true
-	resolve.AllowLambda = true
-	resolve.AllowFloat = true
-	resolve.AllowSet = true
-	resolve.AllowBitwise = true
-	resolve.AllowRecursion = true
-	resolve.AllowGlobalReassign = true
+var defaultSyntaxFileOpts = &syntax.FileOptions{
+	Set:             true,
+	While:           true,
+	TopLevelControl: true,
+	GlobalReassign:  true,
+	Recursion:       true,
 }
 
 // Context is the context in which starlark scripts are evaluated.
@@ -88,7 +87,7 @@ func New(ctx Context, out EchoWriter) *E
 		for i := range args {
 			a, ok := args[i].(starlark.String)
 			if !ok {
-				return nil, fmt.Errorf("argument of dlv_command is not a string")
+				return nil, errors.New("argument of dlv_command is not a string")
 			}
 			argstrs[i] = string(a)
 		}
@@ -102,11 +101,11 @@ func New(ctx Context, out EchoWriter) *E
 
 	env.env[readFileBuiltinName] = starlark.NewBuiltin(readFileBuiltinName, func(thread *starlark.Thread, _ *starlark.Builtin, args starlark.Tuple, kwargs []starlark.Tuple) (starlark.Value, error) {
 		if len(args) != 1 {
-			return nil, decorateError(thread, fmt.Errorf("wrong number of arguments"))
+			return nil, decorateError(thread, errors.New("wrong number of arguments"))
 		}
 		path, ok := args[0].(starlark.String)
 		if !ok {
-			return nil, decorateError(thread, fmt.Errorf("argument of read_file was not a string"))
+			return nil, decorateError(thread, errors.New("argument of read_file was not a string"))
 		}
 		buf, err := os.ReadFile(string(path))
 		if err != nil {
@@ -118,11 +117,11 @@ func New(ctx Context, out EchoWriter) *E
 
 	env.env[writeFileBuiltinName] = starlark.NewBuiltin(writeFileBuiltinName, func(thread *starlark.Thread, _ *starlark.Builtin, args starlark.Tuple, kwargs []starlark.Tuple) (starlark.Value, error) {
 		if len(args) != 2 {
-			return nil, decorateError(thread, fmt.Errorf("wrong number of arguments"))
+			return nil, decorateError(thread, errors.New("wrong number of arguments"))
 		}
 		path, ok := args[0].(starlark.String)
 		if !ok {
-			return nil, decorateError(thread, fmt.Errorf("first argument of write_file was not a string"))
+			return nil, decorateError(thread, errors.New("first argument of write_file was not a string"))
 		}
 		err := os.WriteFile(string(path), []byte(args[1].String()), 0o640)
 		return starlark.None, decorateError(thread, err)
@@ -220,7 +219,7 @@ func (env *Env) Execute(path string, sou
 	}()
 
 	thread := env.newThread()
-	globals, err := starlark.ExecFile(thread, path, source, env.env)
+	globals, err := execFileOptions(nil, thread, path, source, env.env)
 	if err != nil {
 		return starlark.None, err
 	}
@@ -305,7 +304,7 @@ func (env *Env) createCommand(name strin
 
 	env.ctx.RegisterCommand(name, helpMsg, func(args string) error {
 		thread := env.newThread()
-		argval, err := starlark.Eval(thread, "<input>", "("+args+")", env.env)
+		argval, err := evalOptions(nil, thread, "<input>", "("+args+")", env.env)
 		if err != nil {
 			return err
 		}
@@ -369,3 +368,30 @@ type EchoWriter interface {
 	Echo(string)
 	Flush()
 }
+
+// execFileOptions is a wrapper around starlark.ExecFileOptions.
+// If no options are provided, it uses default options.
+func execFileOptions(opts *syntax.FileOptions, thread *starlark.Thread, path string, source any, env starlark.StringDict) (starlark.StringDict, error) {
+	if opts == nil {
+		opts = defaultSyntaxFileOpts
+	}
+	return starlark.ExecFileOptions(opts, thread, path, source, env)
+}
+
+// evalOptions is a wrapper around starlark.EvalOptions.
+// If no options are provided, it uses default options.
+func evalOptions(opts *syntax.FileOptions, thread *starlark.Thread, path string, source any, env starlark.StringDict) (starlark.Value, error) {
+	if opts == nil {
+		opts = defaultSyntaxFileOpts
+	}
+	return starlark.EvalOptions(opts, thread, path, source, env)
+}
+
+// evalExprOptions is a wrapper around starlark.EvalExprOptions.
+// If no options are provided, it uses default options.
+func evalExprOptions(opts *syntax.FileOptions, thread *starlark.Thread, expr syntax.Expr, globals starlark.StringDict) (starlark.Value, error) {
+	if opts == nil {
+		opts = defaultSyntaxFileOpts
+	}
+	return starlark.EvalExprOptions(opts, thread, expr, globals)
+}
diff -pruN 1.22.1-1/pkg/terminal/starbind/starlark_mapping.go 1.23.0-1/pkg/terminal/starbind/starlark_mapping.go
--- 1.22.1-1/pkg/terminal/starbind/starlark_mapping.go	2024-02-21 20:29:06.000000000 +0000
+++ 1.23.0-1/pkg/terminal/starbind/starlark_mapping.go	2024-07-16 18:44:48.000000000 +0000
@@ -1094,11 +1094,19 @@ func (env *Env) starlarkPredeclare() (st
 				return starlark.None, decorateError(thread, err)
 			}
 		}
+		if len(args) > 1 && args[1] != starlark.None {
+			err := unmarshalStarlarkValue(args[1], &rpcArgs.FollowCalls, "FollowCalls")
+			if err != nil {
+				return starlark.None, decorateError(thread, err)
+			}
+		}
 		for _, kv := range kwargs {
 			var err error
 			switch kv[0].(starlark.String) {
 			case "Filter":
 				err = unmarshalStarlarkValue(kv[1], &rpcArgs.Filter, "Filter")
+			case "FollowCalls":
+				err = unmarshalStarlarkValue(kv[1], &rpcArgs.FollowCalls, "FollowCalls")
 			default:
 				err = fmt.Errorf("unknown argument %q", kv[0])
 			}
@@ -1112,7 +1120,7 @@ func (env *Env) starlarkPredeclare() (st
 		}
 		return env.interfaceToStarlarkValue(rpcRet), nil
 	})
-	doc["functions"] = "builtin functions(Filter)\n\nfunctions lists all functions in the process matching filter."
+	doc["functions"] = "builtin functions(Filter, FollowCalls)\n\nfunctions lists all functions in the process matching filter."
 	r["goroutines"] = starlark.NewBuiltin("goroutines", func(thread *starlark.Thread, _ *starlark.Builtin, args starlark.Tuple, kwargs []starlark.Tuple) (starlark.Value, error) {
 		if err := isCancelled(thread); err != nil {
 			return starlark.None, decorateError(thread, err)
diff -pruN 1.22.1-1/pkg/terminal/terminal.go 1.23.0-1/pkg/terminal/terminal.go
--- 1.22.1-1/pkg/terminal/terminal.go	2024-02-21 20:29:06.000000000 +0000
+++ 1.23.0-1/pkg/terminal/terminal.go	2024-07-16 18:44:48.000000000 +0000
@@ -3,6 +3,7 @@ package terminal
 //lint:file-ignore ST1005 errors here can be capitalized
 
 import (
+	"errors"
 	"fmt"
 	"io"
 	"net/rpc"
@@ -242,7 +243,6 @@ func (t *Term) sigintGuard(ch <-chan os.
 			default:
 				fmt.Fprintln(t.stdout, "only p or q allowed")
 			}
-
 		} else {
 			fmt.Fprintf(t.stdout, "received SIGINT, stopping process (will not forward signal)\n")
 			_, err := t.client.Halt()
@@ -266,7 +266,7 @@ func (t *Term) Run() (int, error) {
 
 	fns := trie.New()
 	cmds := trie.New()
-	funcs, _ := t.client.ListFunctions("")
+	funcs, _ := t.client.ListFunctions("", 0)
 	for _, fn := range funcs {
 		fns.Add(fn, nil)
 	}
@@ -360,7 +360,7 @@ func (t *Term) Run() (int, error) {
 				fmt.Fprintln(t.stdout, "exit")
 				return t.handleExit()
 			}
-			return 1, fmt.Errorf("Prompt for input failed.\n")
+			return 1, errors.New("Prompt for input failed.\n")
 		}
 		t.stdout.Echo(t.prompt + cmdstr + "\n")
 
diff -pruN 1.22.1-1/pkg/version/version.go 1.23.0-1/pkg/version/version.go
--- 1.22.1-1/pkg/version/version.go	2024-02-21 20:29:06.000000000 +0000
+++ 1.23.0-1/pkg/version/version.go	2024-07-16 18:44:48.000000000 +0000
@@ -17,7 +17,7 @@ type Version struct {
 var (
 	// DelveVersion is the current version of Delve.
 	DelveVersion = Version{
-		Major: "1", Minor: "22", Patch: "1", Metadata: "",
+		Major: "1", Minor: "23", Patch: "0", Metadata: "",
 		Build: "$Id$",
 	}
 )
diff -pruN 1.22.1-1/service/api/conversions.go 1.23.0-1/service/api/conversions.go
--- 1.22.1-1/service/api/conversions.go	2024-02-21 20:29:06.000000000 +0000
+++ 1.23.0-1/service/api/conversions.go	2024-07-16 18:44:48.000000000 +0000
@@ -19,21 +19,23 @@ import (
 // ConvertLogicalBreakpoint converts a proc.LogicalBreakpoint into an API breakpoint.
 func ConvertLogicalBreakpoint(lbp *proc.LogicalBreakpoint) *Breakpoint {
 	b := &Breakpoint{
-		ID:            lbp.LogicalID,
-		FunctionName:  lbp.FunctionName,
-		File:          lbp.File,
-		Line:          lbp.Line,
-		Name:          lbp.Name,
-		Tracepoint:    lbp.Tracepoint,
-		TraceReturn:   lbp.TraceReturn,
-		Stacktrace:    lbp.Stacktrace,
-		Goroutine:     lbp.Goroutine,
-		Variables:     lbp.Variables,
-		LoadArgs:      LoadConfigFromProc(lbp.LoadArgs),
-		LoadLocals:    LoadConfigFromProc(lbp.LoadLocals),
-		TotalHitCount: lbp.TotalHitCount,
-		Disabled:      !lbp.Enabled,
-		UserData:      lbp.UserData,
+		ID:               lbp.LogicalID,
+		FunctionName:     lbp.FunctionName,
+		File:             lbp.File,
+		Line:             lbp.Line,
+		Name:             lbp.Name,
+		Tracepoint:       lbp.Tracepoint,
+		TraceReturn:      lbp.TraceReturn,
+		Stacktrace:       lbp.Stacktrace,
+		Goroutine:        lbp.Goroutine,
+		Variables:        lbp.Variables,
+		LoadArgs:         LoadConfigFromProc(lbp.LoadArgs),
+		LoadLocals:       LoadConfigFromProc(lbp.LoadLocals),
+		TotalHitCount:    lbp.TotalHitCount,
+		Disabled:         !lbp.Enabled,
+		UserData:         lbp.UserData,
+		RootFuncName:     lbp.RootFuncName,
+		TraceFollowCalls: lbp.TraceFollowCalls,
 	}
 
 	b.HitCount = map[string]uint64{}
@@ -427,7 +429,6 @@ func ConvertRegisters(in *op.DwarfRegist
 			return a.DwarfNumber < b.DwarfNumber
 		}
 		return an < bn
-
 	})
 	return
 }
diff -pruN 1.22.1-1/service/api/prettyprint.go 1.23.0-1/service/api/prettyprint.go
--- 1.22.1-1/service/api/prettyprint.go	2024-02-21 20:29:06.000000000 +0000
+++ 1.23.0-1/service/api/prettyprint.go	2024-07-16 18:44:48.000000000 +0000
@@ -176,6 +176,15 @@ func (v *Variable) writeTo(buf io.Writer
 			fmt.Fprint(buf, "nil")
 		} else {
 			fmt.Fprintf(buf, "%s", v.Value)
+			if flags.newlines() && len(v.Children) > 0 {
+				fmt.Fprintf(buf, " {\n")
+				for i := range v.Children {
+					fmt.Fprintf(buf, "%s%s%s %s = ", indent, indentString, v.Children[i].Name, v.Children[i].typeStr(flags))
+					v.Children[i].writeTo(buf, flags.set(prettyTop, false).set(prettyIncludeType, false), indent+indentString, fmtstr)
+					fmt.Fprintf(buf, "\n")
+				}
+				fmt.Fprintf(buf, "%s}", indent)
+			}
 		}
 	default:
 		v.writeBasicType(buf, fmtstr)
@@ -479,7 +488,6 @@ func (v *Variable) writeSliceOrArrayTo(b
 // `format` specifies the data format (or data type), `size` specifies size of each data,
 // like 4byte integer, 1byte character, etc. `count` specifies the number of values.
 func PrettyExamineMemory(address uintptr, memArea []byte, isLittleEndian bool, format byte, size int) string {
-
 	var (
 		cols      int
 		colFormat string
diff -pruN 1.22.1-1/service/api/types.go 1.23.0-1/service/api/types.go
--- 1.22.1-1/service/api/types.go	2024-02-21 20:29:06.000000000 +0000
+++ 1.23.0-1/service/api/types.go	2024-07-16 18:44:48.000000000 +0000
@@ -133,6 +133,11 @@ type Breakpoint struct {
 	Disabled bool `json:"disabled"`
 
 	UserData interface{} `json:"-"`
+
+	// RootFuncName is the Root function from where tracing needs to be done
+	RootFuncName string
+	// TraceFollowCalls indicates the Depth of tracing
+	TraceFollowCalls int
 }
 
 // ValidBreakpointName returns an error if
@@ -321,12 +326,12 @@ type Variable struct {
 	// Function variables will store the name of the function in this field
 	Value string `json:"value"`
 
-	// Number of elements in an array or a slice, number of keys for a map, number of struct members for a struct, length of strings
+	// Number of elements in an array or a slice, number of keys for a map, number of struct members for a struct, length of strings, number of captured variables for functions
 	Len int64 `json:"len"`
 	// Cap value for slices
 	Cap int64 `json:"cap"`
 
-	// Array and slice elements, member fields of structs, key/value pairs of maps, value of complex numbers
+	// Array and slice elements, member fields of structs, key/value pairs of maps, value of complex numbers, captured variables of functions.
 	// The Name field in this slice will always be the empty string except for structs (when it will be the field name) and for complex numbers (when it will be "real" and "imaginary")
 	// For maps each map entry will have to items in this slice, even numbered items will represent map keys and odd numbered items will represent their values
 	// This field's length is capped at proc.maxArrayValues for slices and arrays and 2*proc.maxArrayValues for maps, in the circumstances where the cap takes effect len(Children) != Len
@@ -456,8 +461,12 @@ const (
 	ReverseStepOut = "reverseStepOut"
 	// StepInstruction continues for exactly 1 cpu instruction.
 	StepInstruction = "stepInstruction"
+	// NextInstruction continues for 1 cpu instruction, skipping over CALL instructions.
+	NextInstruction = "nextInstruction"
 	// ReverseStepInstruction reverses execution for exactly 1 cpu instruction.
 	ReverseStepInstruction = "reverseStepInstruction"
+	// ReverseNextInstruction reverses execution for 1 cpu instruction, skipping over CALL instructions.
+	ReverseNextInstruction = "reverseNextInstruction"
 	// Next continues to the next source line, not entering function calls.
 	Next = "next"
 	// ReverseNext continues backward to the previous line of source code, not entering function calls.
diff -pruN 1.22.1-1/service/client.go 1.23.0-1/service/client.go
--- 1.22.1-1/service/client.go	2024-02-21 20:29:06.000000000 +0000
+++ 1.23.0-1/service/client.go	2024-07-16 18:44:48.000000000 +0000
@@ -53,9 +53,9 @@ type Client interface {
 	Call(goroutineID int64, expr string, unsafe bool) (*api.DebuggerState, error)
 
 	// StepInstruction will step a single cpu instruction.
-	StepInstruction() (*api.DebuggerState, error)
+	StepInstruction(skipCalls bool) (*api.DebuggerState, error)
 	// ReverseStepInstruction will reverse step a single cpu instruction.
-	ReverseStepInstruction() (*api.DebuggerState, error)
+	ReverseStepInstruction(skipCalls bool) (*api.DebuggerState, error)
 	// SwitchThread switches the current thread context.
 	SwitchThread(threadID int) (*api.DebuggerState, error)
 	// SwitchGoroutine switches the current goroutine (and the current thread as well)
@@ -105,7 +105,7 @@ type Client interface {
 	// ListSources lists all source files in the process matching filter.
 	ListSources(filter string) ([]string, error)
 	// ListFunctions lists all functions in the process matching filter.
-	ListFunctions(filter string) ([]string, error)
+	ListFunctions(filter string, tracefollow int) ([]string, error)
 	// ListTypes lists all types in the process matching filter.
 	ListTypes(filter string) ([]string, error)
 	// ListPackagesBuildInfo lists all packages in the process matching filter.
diff -pruN 1.22.1-1/service/dap/config.go 1.23.0-1/service/dap/config.go
--- 1.22.1-1/service/dap/config.go	2024-02-21 20:29:06.000000000 +0000
+++ 1.23.0-1/service/dap/config.go	2024-07-16 18:44:48.000000000 +0000
@@ -2,6 +2,7 @@ package dap
 
 import (
 	"bytes"
+	"errors"
 	"fmt"
 	"strings"
 
@@ -90,7 +91,7 @@ func configureSetSubstitutePath(args *la
 		args.substitutePathServerToClient = append(args.substitutePathServerToClient, [2]string{argv[1], argv[0]})
 
 	default:
-		return fmt.Errorf("too many arguments to \"config substitutePath\"")
+		return errors.New("too many arguments to \"config substitutePath\"")
 	}
 	return nil
 }
@@ -124,7 +125,7 @@ func configureSetShowPprofLabels(args *l
 			args.ShowPprofLabels = append(args.ShowPprofLabels, argv[0])
 		}
 	default:
-		return fmt.Errorf("too many arguments to \"config showPprofLabels\"")
+		return errors.New("too many arguments to \"config showPprofLabels\"")
 	}
 	return nil
 }
diff -pruN 1.22.1-1/service/dap/server.go 1.23.0-1/service/dap/server.go
--- 1.22.1-1/service/dap/server.go	2024-02-21 20:29:06.000000000 +0000
+++ 1.23.0-1/service/dap/server.go	2024-07-16 18:44:48.000000000 +0000
@@ -181,14 +181,23 @@ type Config struct {
 }
 
 type connection struct {
-	mu     sync.Mutex
-	closed bool
+	mu         sync.Mutex
+	closed     bool
+	closedChan chan struct{}
 	io.ReadWriteCloser
 }
 
+func newConnection(conn io.ReadWriteCloser) *connection {
+	return &connection{ReadWriteCloser: conn, closedChan: make(chan struct{})}
+}
+
 func (c *connection) Close() error {
 	c.mu.Lock()
 	defer c.mu.Unlock()
+
+	if !c.closed {
+		close(c.closedChan)
+	}
 	c.closed = true
 	return c.ReadWriteCloser.Close()
 }
@@ -335,7 +344,7 @@ func NewSession(conn io.ReadWriteCloser,
 	return &Session{
 		config:            config,
 		id:                sessionCount,
-		conn:              &connection{ReadWriteCloser: conn},
+		conn:              newConnection(conn),
 		stackFrameHandles: newHandlesMap(),
 		variableHandles:   newVariablesHandlesMap(),
 		args:              defaultArgs,
@@ -1182,7 +1191,7 @@ func (s *Session) getPackageDir(pkg stri
 // requires holding mu lock. It prepares process exec.Cmd to be started.
 func (s *Session) newNoDebugProcess(program string, targetArgs []string, wd string, redirected bool) (cmd *exec.Cmd, err error) {
 	if s.noDebugProcess != nil {
-		return nil, fmt.Errorf("another launch request is in progress")
+		return nil, errors.New("another launch request is in progress")
 	}
 
 	cmd = exec.Command(program, targetArgs...)
@@ -1366,7 +1375,7 @@ func (s *Session) halt() (*api.DebuggerS
 	s.config.log.Debug("halting")
 	// Only send a halt request if the debuggee is running.
 	if s.debugger.IsRunning() {
-		return s.debugger.Command(&api.DebuggerCommand{Name: api.Halt}, nil)
+		return s.debugger.Command(&api.DebuggerCommand{Name: api.Halt}, nil, nil)
 	}
 	s.config.log.Debug("process not running")
 	return s.debugger.State(false)
@@ -1458,7 +1467,7 @@ func (s *Session) setBreakpoints(prefix
 
 		var err error
 		if _, ok := createdBps[want.name]; ok {
-			err = fmt.Errorf("breakpoint already exists")
+			err = errors.New("breakpoint already exists")
 		} else {
 			got.Disabled = false
 			got.Cond = want.condition
@@ -1487,7 +1496,7 @@ func (s *Session) setBreakpoints(prefix
 		wantLoc, err := locFunc(i)
 		if err == nil {
 			if _, ok := createdBps[want.name]; ok {
-				err = fmt.Errorf("breakpoint already exists")
+				err = errors.New("breakpoint already exists")
 			} else {
 				bp := &api.Breakpoint{
 					Name:    want.name,
@@ -1563,7 +1572,7 @@ func (s *Session) onSetFunctionBreakpoin
 		}
 
 		if want.Name[0] == '.' {
-			return nil, fmt.Errorf("breakpoint names that are relative paths are not supported")
+			return nil, errors.New("breakpoint names that are relative paths are not supported")
 		}
 		// Find the location of the function name. CreateBreakpoint requires the name to include the base
 		// (e.g. main.functionName is supported but not functionName).
@@ -2048,7 +2057,7 @@ func (s *Session) stoppedOnBreakpointGor
 // due to an error, so the server is ready to receive new requests.
 func (s *Session) stepUntilStopAndNotify(command string, threadId int, granularity dap.SteppingGranularity, allowNextStateChange *syncflag) {
 	defer allowNextStateChange.raise()
-	_, err := s.debugger.Command(&api.DebuggerCommand{Name: api.SwitchGoroutine, GoroutineID: int64(threadId)}, nil)
+	_, err := s.debugger.Command(&api.DebuggerCommand{Name: api.SwitchGoroutine, GoroutineID: int64(threadId)}, nil, s.conn.closedChan)
 	if err != nil {
 		s.config.log.Errorf("Error switching goroutines while stepping: %v", err)
 		// If we encounter an error, we will have to send a stopped event
@@ -2746,7 +2755,7 @@ func (s *Session) convertVariableWithOpt
 				variablesReference = maybeCreateVariableHandle(v)
 			}
 		}
-	case reflect.Struct:
+	case reflect.Struct, reflect.Func:
 		if v.Len > int64(len(v.Children)) { // Not fully loaded
 			if len(v.Children) == 0 { // Fully missing
 				value = reloadVariable(v, qualifiedNameOrExpr)
@@ -2771,7 +2780,7 @@ func (s *Session) convertVariableWithOpt
 			v.Children[1].Kind = reflect.Float64
 		}
 		fallthrough
-	default: // Complex, Scalar, Chan, Func
+	default: // Complex, Scalar, Chan
 		if len(v.Children) > 0 {
 			variablesReference = maybeCreateVariableHandle(v)
 		}
@@ -2891,7 +2900,7 @@ func (s *Session) doCall(goid, frame int
 	// and the user will get an unexpected result or an unexpected symbol error.
 	// We prevent this but disallowing any frames other than topmost.
 	if frame > 0 {
-		return nil, nil, fmt.Errorf("call is only supported with topmost stack frame")
+		return nil, nil, errors.New("call is only supported with topmost stack frame")
 	}
 	stateBeforeCall, err := s.debugger.State( /*nowait*/ true)
 	if err != nil {
@@ -2914,7 +2923,7 @@ func (s *Session) doCall(goid, frame int
 		Expr:                 expr,
 		UnsafeCall:           false,
 		GoroutineID:          int64(goid),
-	}, nil)
+	}, nil, s.conn.closedChan)
 	if processExited(state, err) {
 		s.preTerminatedWG.Wait()
 		e := &dap.TerminatedEvent{Event: *newEvent("terminated")}
@@ -3228,7 +3237,6 @@ func (s *Session) onDisassembleRequest(r
 			instructions[i] = invalidInstruction
 			instructions[i].Address = fmt.Sprintf("%#x", uint64(math.MaxUint64))
 			continue
-
 		}
 		instruction := api.ConvertAsmInstruction(procInstructions[i-offset], s.debugger.AsmInstructionText(&procInstructions[i-offset], proc.GoFlavour))
 		instructions[i] = dap.DisassembledInstruction{
@@ -3258,7 +3266,7 @@ func findInstructions(procInstructions [
 		return procInstructions[i].Loc.PC >= addr
 	})
 	if ref == len(procInstructions) || procInstructions[ref].Loc.PC != addr {
-		return nil, -1, fmt.Errorf("could not find memory reference")
+		return nil, -1, errors.New("could not find memory reference")
 	}
 	// offset is the number of instructions that should appear before the first instruction
 	// returned by findInstructions.
@@ -3646,7 +3654,7 @@ func (s *Session) resumeOnce(command str
 		state, err := s.debugger.State(false)
 		return false, state, err
 	}
-	state, err := s.debugger.Command(&api.DebuggerCommand{Name: command}, asyncSetupDone)
+	state, err := s.debugger.Command(&api.DebuggerCommand{Name: command}, asyncSetupDone, s.conn.closedChan)
 	return true, state, err
 }
 
@@ -3734,7 +3742,6 @@ func (s *Session) runUntilStopAndNotify(
 			stopped.Body.Reason = "pause"
 			stopped.Body.HitBreakpointIds = []int{}
 		}
-
 	} else {
 		s.exceptionErr = err
 		s.config.log.Error("runtime error: ", err)
@@ -3938,7 +3945,7 @@ func parseLogPoint(msg string) (bool, *l
 				if braceCount--; braceCount == 0 {
 					argStr := strings.TrimSpace(string(argSlice))
 					if len(argStr) == 0 {
-						return false, nil, fmt.Errorf("empty evaluation string")
+						return false, nil, errors.New("empty evaluation string")
 					}
 					args = append(args, argStr)
 					formatSlice = append(formatSlice, '%', 's')
@@ -3954,7 +3961,7 @@ func parseLogPoint(msg string) (bool, *l
 
 		switch r {
 		case '}':
-			return false, nil, fmt.Errorf("invalid log point format, unexpected '}'")
+			return false, nil, errors.New("invalid log point format, unexpected '}'")
 		case '{':
 			if braceCount++; braceCount == 1 {
 				isArg, argSlice = true, []rune{}
@@ -3964,7 +3971,7 @@ func parseLogPoint(msg string) (bool, *l
 		formatSlice = append(formatSlice, r)
 	}
 	if isArg {
-		return false, nil, fmt.Errorf("invalid log point format")
+		return false, nil, errors.New("invalid log point format")
 	}
 	if len(formatSlice) == 0 {
 		return false, nil, nil
diff -pruN 1.22.1-1/service/dap/server_test.go 1.23.0-1/service/dap/server_test.go
--- 1.22.1-1/service/dap/server_test.go	2024-02-21 20:29:06.000000000 +0000
+++ 1.23.0-1/service/dap/server_test.go	2024-07-16 18:44:48.000000000 +0000
@@ -1848,9 +1848,7 @@ func TestScopesAndVariablesRequests2(t *
 					if ref > 0 {
 						client.VariablesRequest(ref)
 						ch1 := client.ExpectVariablesResponse(t)
-						checkChildren(t, ch1, "ch1", 11)
 						checkVarExact(t, ch1, 0, "qcount", "ch1.qcount", "4 = 0x4", "uint", noChildren)
-						checkVarRegex(t, ch1, 10, "lock", "ch1.lock", `runtime\.mutex {.*key: 0.*}`, `runtime\.mutex`, hasChildren)
 						validateEvaluateName(t, client, ch1, 0)
 						validateEvaluateName(t, client, ch1, 10)
 					}
@@ -2288,7 +2286,7 @@ func TestVariablesLoading(t *testing.T)
 						checkChildren(t, tm, "tm", 1)
 						ref = checkVarExact(t, tm, 0, "v", "tm.v", "[]map[string]main.astruct len: 1, cap: 1, [[...]]", "[]map[string]main.astruct", hasChildren)
 						if ref > 0 {
-							// Auto-loading of fully missing map chidlren happens here, but they get truncated at MaxArrayValues
+							// Auto-loading of fully missing map children happens here, but they get truncated at MaxArrayValues
 							client.VariablesRequest(ref)
 							tmV := client.ExpectVariablesResponse(t)
 							checkChildren(t, tmV, "tm.v", 1)
@@ -2317,7 +2315,7 @@ func TestVariablesLoading(t *testing.T)
 							checkChildren(t, tm, "tm", 1)
 							ref = checkVarExact(t, tm, 0, "v", "", "[]map[string]main.astruct len: 1, cap: 1, [[...]]", "[]map[string]main.astruct", hasChildren)
 							if ref > 0 {
-								// Auto-loading of fully missing map chidlren happens here, but they get trancated at MaxArrayValues
+								// Auto-loading of fully missing map children happens here, but they get truncated at MaxArrayValues
 								client.VariablesRequest(ref)
 								tmV := client.ExpectVariablesResponse(t)
 								checkChildren(t, tmV, "tm.v", 1)
@@ -4888,7 +4886,6 @@ func TestStepOutPreservesGoroutine(t *te
 					} else if len(candg) > 0 {
 						goroutineId = candg[rand.Intn(len(candg))]
 						t.Logf("selected goroutine %d\n", goroutineId)
-
 					}
 
 					if goroutineId != 0 {
@@ -6739,7 +6736,7 @@ func launchDebuggerWithTargetRunning(t *
 	var err error
 	go func() {
 		t.Helper()
-		_, err = dbg.Command(&api.DebuggerCommand{Name: api.Continue}, running)
+		_, err = dbg.Command(&api.DebuggerCommand{Name: api.Continue}, running, nil)
 		select {
 		case <-running:
 		default:
@@ -6937,7 +6934,7 @@ func (s *MultiClientCloseServerMock) sto
 	// they are part of dap.Session.
 	// We must take it down manually as if we are in rpccommon::ServerImpl::Stop.
 	if s.debugger.IsRunning() {
-		s.debugger.Command(&api.DebuggerCommand{Name: api.Halt}, nil)
+		s.debugger.Command(&api.DebuggerCommand{Name: api.Halt}, nil, nil)
 	}
 	s.debugger.Detach(true)
 }
diff -pruN 1.22.1-1/service/debugger/debugger.go 1.23.0-1/service/debugger/debugger.go
--- 1.22.1-1/service/debugger/debugger.go	2024-02-21 20:29:06.000000000 +0000
+++ 1.23.0-1/service/debugger/debugger.go	2024-07-16 18:44:48.000000000 +0000
@@ -494,7 +494,6 @@ func (d *Debugger) Restart(rerecord bool
 
 	if !resetArgs && (d.config.Stdout.File != nil || d.config.Stderr.File != nil) {
 		return nil, ErrCanNotRestart
-
 	}
 
 	if err := d.detach(true); err != nil {
@@ -523,7 +522,7 @@ func (d *Debugger) Restart(rerecord bool
 			}
 		default:
 			// We cannot build a process that we didn't start, because we don't know how it was built.
-			return nil, fmt.Errorf("cannot rebuild a binary")
+			return nil, errors.New("cannot rebuild a binary")
 		}
 	}
 
@@ -916,6 +915,8 @@ func copyLogicalBreakpointInfo(lbp *proc
 	lbp.LoadArgs = api.LoadConfigToProc(requested.LoadArgs)
 	lbp.LoadLocals = api.LoadConfigToProc(requested.LoadLocals)
 	lbp.UserData = requested.UserData
+	lbp.RootFuncName = requested.RootFuncName
+	lbp.TraceFollowCalls = requested.TraceFollowCalls
 	lbp.Cond = nil
 	if requested.Cond != "" {
 		var err error
@@ -1160,9 +1161,7 @@ func (d *Debugger) IsRunning() bool {
 }
 
 // Command handles commands which control the debugger lifecycle
-func (d *Debugger) Command(command *api.DebuggerCommand, resumeNotify chan struct{}) (*api.DebuggerState, error) {
-	var err error
-
+func (d *Debugger) Command(command *api.DebuggerCommand, resumeNotify chan struct{}, clientStatusCh chan struct{}) (state *api.DebuggerState, err error) {
 	if command.Name == api.Halt {
 		// RequestManualStop does not invoke any ptrace syscalls, so it's safe to
 		// access the process directly.
@@ -1255,13 +1254,25 @@ func (d *Debugger) Command(command *api.
 		if err := d.target.ChangeDirection(proc.Forward); err != nil {
 			return nil, err
 		}
-		err = d.target.StepInstruction()
+		err = d.target.StepInstruction(false)
 	case api.ReverseStepInstruction:
 		d.log.Debug("reverse single stepping")
 		if err := d.target.ChangeDirection(proc.Backward); err != nil {
 			return nil, err
 		}
-		err = d.target.StepInstruction()
+		err = d.target.StepInstruction(false)
+	case api.NextInstruction:
+		d.log.Debug("single stepping")
+		if err := d.target.ChangeDirection(proc.Forward); err != nil {
+			return nil, err
+		}
+		err = d.target.StepInstruction(true)
+	case api.ReverseNextInstruction:
+		d.log.Debug("reverse single stepping")
+		if err := d.target.ChangeDirection(proc.Backward); err != nil {
+			return nil, err
+		}
+		err = d.target.StepInstruction(true)
 	case api.StepOut:
 		d.log.Debug("step out")
 		if err := d.target.ChangeDirection(proc.Forward); err != nil {
@@ -1327,6 +1338,8 @@ func (d *Debugger) Command(command *api.
 		bp.Disabled = true
 		d.amendBreakpoint(bp)
 	}
+
+	d.maybePrintUnattendedBreakpointWarning(d.target.Selected.StopReason, state.CurrentThread, clientStatusCh)
 	return state, err
 }
 
@@ -1374,7 +1387,13 @@ func (d *Debugger) collectBreakpointInfo
 
 	s, err := proc.GoroutineScope(tgt, thread)
 	if err != nil {
-		return err
+		var errNoGoroutine proc.ErrNoGoroutine
+		if errors.As(err, &errNoGoroutine) {
+			s, err = proc.ThreadScope(tgt, thread)
+		}
+		if err != nil {
+			return err
+		}
 	}
 
 	if len(bp.Variables) > 0 {
@@ -1441,7 +1460,7 @@ func uniq(s []string) []string {
 }
 
 // Functions returns a list of functions in the target process.
-func (d *Debugger) Functions(filter string) ([]string, error) {
+func (d *Debugger) Functions(filter string, followCalls int) ([]string, error) {
 	d.targetMutex.Lock()
 	defer d.targetMutex.Unlock()
 
@@ -1455,7 +1474,15 @@ func (d *Debugger) Functions(filter stri
 	for t.Next() {
 		for _, f := range t.BinInfo().Functions {
 			if regex.MatchString(f.Name) {
-				funcs = append(funcs, f.Name)
+				if followCalls > 0 {
+					newfuncs, err := traverse(t, &f, 1, followCalls)
+					if err != nil {
+						return nil, fmt.Errorf("traverse failed with error %w", err)
+					}
+					funcs = append(funcs, newfuncs...)
+				} else {
+					funcs = append(funcs, f.Name)
+				}
 			}
 		}
 	}
@@ -1464,6 +1491,67 @@ func (d *Debugger) Functions(filter stri
 	return funcs, nil
 }
 
+func traverse(t proc.ValidTargets, f *proc.Function, depth int, followCalls int) ([]string, error) {
+	type TraceFunc struct {
+		Func    *proc.Function
+		Depth   int
+		visited bool
+	}
+	type TraceFuncptr *TraceFunc
+
+	TraceMap := make(map[string]TraceFuncptr)
+	queue := make([]TraceFuncptr, 0, 40)
+	funcs := []string{}
+	rootnode := &TraceFunc{Func: new(proc.Function), Depth: depth, visited: false}
+	rootnode.Func = f
+
+	// cache function details in a map for reuse
+	TraceMap[f.Name] = rootnode
+	queue = append(queue, rootnode)
+	for len(queue) > 0 {
+		parent := queue[0]
+		queue = queue[1:]
+		if parent == nil {
+			panic("attempting to open file Delve cannot parse")
+		}
+		if parent.Depth > followCalls {
+			continue
+		}
+		if !parent.visited {
+			funcs = append(funcs, parent.Func.Name)
+			parent.visited = true
+		} else if parent.visited {
+			continue
+		}
+
+		if parent.Depth+1 > followCalls {
+			// Avoid diassembling if we already cross the follow-calls depth
+			continue
+		}
+		f := parent.Func
+		text, err := proc.Disassemble(t.Memory(), nil, t.Breakpoints(), t.BinInfo(), f.Entry, f.End)
+		if err != nil {
+			return nil, fmt.Errorf("disassemble failed with error %w", err)
+		}
+		for _, instr := range text {
+			if instr.IsCall() && instr.DestLoc != nil && instr.DestLoc.Fn != nil {
+				cf := instr.DestLoc.Fn
+				if (strings.HasPrefix(cf.Name, "runtime.") || strings.HasPrefix(cf.Name, "runtime/internal")) && cf.Name != "runtime.deferreturn" && cf.Name != "runtime.gorecover" && cf.Name != "runtime.gopanic" {
+					continue
+				}
+				childnode := TraceMap[cf.Name]
+				if childnode == nil {
+					childnode = &TraceFunc{Func: nil, Depth: parent.Depth + 1, visited: false}
+					childnode.Func = cf
+					TraceMap[cf.Name] = childnode
+					queue = append(queue, childnode)
+				}
+			}
+		}
+	}
+	return funcs, nil
+}
+
 // Types returns all type information in the binary.
 func (d *Debugger) Types(filter string) ([]string, error) {
 	d.targetMutex.Lock()
@@ -1774,7 +1862,10 @@ func (d *Debugger) GroupGoroutines(gs []
 func (d *Debugger) Stacktrace(goroutineID int64, depth int, opts api.StacktraceOptions) ([]proc.Stackframe, error) {
 	d.targetMutex.Lock()
 	defer d.targetMutex.Unlock()
+	return d.stacktrace(goroutineID, depth, opts)
+}
 
+func (d *Debugger) stacktrace(goroutineID int64, depth int, opts api.StacktraceOptions) ([]proc.Stackframe, error) {
 	if _, err := d.target.Valid(); err != nil {
 		return nil, err
 	}
@@ -1908,7 +1999,6 @@ func (d *Debugger) convertDefers(defers
 				SP: defers[i].SP,
 			}
 		}
-
 	}
 
 	return r
@@ -1929,7 +2019,7 @@ func (d *Debugger) CurrentPackage() (str
 		return "", err
 	}
 	if loc.Fn == nil {
-		return "", fmt.Errorf("unable to determine current package due to unspecified function location")
+		return "", errors.New("unable to determine current package due to unspecified function location")
 	}
 	return loc.Fn.PackageName(), nil
 }
@@ -2259,7 +2349,12 @@ func (d *Debugger) TargetGroup() *proc.T
 }
 
 func (d *Debugger) BuildID() string {
-	return d.target.Selected.BinInfo().BuildID
+	loc, err := d.target.Selected.CurrentThread().Location()
+	if err != nil {
+		return ""
+	}
+	img := d.target.Selected.BinInfo().PCToImage(loc.PC)
+	return img.BuildID
 }
 
 func (d *Debugger) AttachPid() int {
@@ -2356,7 +2451,7 @@ func go11DecodeErrorCheck(err error) err
 		return err
 	}
 
-	return fmt.Errorf("executables built by Go 1.11 or later need Delve built by Go 1.11 or later")
+	return errors.New("executables built by Go 1.11 or later need Delve built by Go 1.11 or later")
 }
 
 const NoDebugWarning string = "debuggee must not be built with 'go run' or -ldflags='-s -w', which strip debug info"
@@ -2416,3 +2511,57 @@ var attachErrorMessage = attachErrorMess
 func attachErrorMessageDefault(pid int, err error) error {
 	return fmt.Errorf("could not attach to pid %d: %s", pid, err)
 }
+
+func (d *Debugger) maybePrintUnattendedBreakpointWarning(stopReason proc.StopReason, currentThread *api.Thread, clientStatusCh <-chan struct{}) {
+	select {
+	case <-clientStatusCh:
+		// the channel will be closed if the client that sends the command has left
+		// i.e. closed the connection.
+	default:
+		return
+	}
+
+	const defaultStackTraceDepth = 50
+	frames, err := d.stacktrace(currentThread.GoroutineID, defaultStackTraceDepth, 0)
+	if err != nil {
+		fmt.Fprintln(os.Stderr, "err", err)
+		return
+	}
+
+	apiFrames, err := d.convertStacktrace(frames, nil)
+	if err != nil {
+		fmt.Fprintln(os.Stderr, "err", err)
+		return
+	}
+
+	bp := currentThread.Breakpoint
+	if bp == nil {
+		switch stopReason {
+		case proc.StopManual:
+			// print nothing
+			return
+		default:
+			fmt.Fprintln(os.Stderr, "Stop reason: "+stopReason.String())
+			return
+		}
+	}
+
+	switch bp.Name {
+	case proc.FatalThrow, proc.UnrecoveredPanic:
+		fmt.Fprintln(os.Stderr, "\n** execution is paused because your program is panicking **")
+	default:
+		fmt.Fprintln(os.Stderr, "\n** execution is paused because a breakpoint is hit **")
+	}
+
+	fmt.Fprintf(os.Stderr, "To continue the execution please connect your client to the debugger.")
+	fmt.Fprintln(os.Stderr, "\nStack trace:")
+
+	formatPathFunc := func(s string) string {
+		return s
+	}
+	includeFunc := func(f api.Stackframe) bool {
+		// todo(fata): do not include the final panic/fatal function if bp.Name is fatalthrow/panic
+		return true
+	}
+	api.PrintStack(formatPathFunc, os.Stderr, apiFrames, "", false, api.StackTraceColors{}, includeFunc)
+}
diff -pruN 1.22.1-1/service/rpc1/doc.go 1.23.0-1/service/rpc1/doc.go
--- 1.22.1-1/service/rpc1/doc.go	1970-01-01 00:00:00.000000000 +0000
+++ 1.23.0-1/service/rpc1/doc.go	2024-07-16 18:44:48.000000000 +0000
@@ -0,0 +1,5 @@
+// Package rpc1 implements version 1 of Delve's API and is only
+// kept for backwards compatibility.
+// client.go is the old client code used by Delve's frontend (delve/cmd/dlv) and
+// is preserved for backwards compatibility with integration tests.
+package rpc1
diff -pruN 1.22.1-1/service/rpc1/readme.txt 1.23.0-1/service/rpc1/readme.txt
--- 1.22.1-1/service/rpc1/readme.txt	2024-02-21 20:29:06.000000000 +0000
+++ 1.23.0-1/service/rpc1/readme.txt	1970-01-01 00:00:00.000000000 +0000
@@ -1,5 +0,0 @@
-This package implements version 1 of Delve's API and is only
-kept here for backwards compatibility. Client.go is the old
-client code used by Delve's frontend (delve/cmd/dlv), it is
-only preserved here for the backwards compatibility tests in
-service/test/integration1_test.go.
diff -pruN 1.22.1-1/service/rpc1/server.go 1.23.0-1/service/rpc1/server.go
--- 1.22.1-1/service/rpc1/server.go	2024-02-21 20:29:06.000000000 +0000
+++ 1.23.0-1/service/rpc1/server.go	2024-07-16 18:44:48.000000000 +0000
@@ -56,7 +56,7 @@ func (s *RPCServer) State(arg interface{
 }
 
 func (s *RPCServer) Command(command *api.DebuggerCommand, cb service.RPCCallback) {
-	st, err := s.debugger.Command(command, cb.SetupDoneChan())
+	st, err := s.debugger.Command(command, cb.SetupDoneChan(), cb.DisconnectChan())
 	cb.Return(st, err)
 }
 
@@ -263,8 +263,8 @@ func (s *RPCServer) ListSources(filter s
 	return nil
 }
 
-func (s *RPCServer) ListFunctions(filter string, funcs *[]string) error {
-	fns, err := s.debugger.Functions(filter)
+func (s *RPCServer) ListFunctions(filter string, followCalls int, funcs *[]string) error {
+	fns, err := s.debugger.Functions(filter, followCalls)
 	if err != nil {
 		return err
 	}
diff -pruN 1.22.1-1/service/rpc2/client.go 1.23.0-1/service/rpc2/client.go
--- 1.22.1-1/service/rpc2/client.go	2024-02-21 20:29:06.000000000 +0000
+++ 1.23.0-1/service/rpc2/client.go	2024-07-16 18:44:48.000000000 +0000
@@ -183,15 +183,23 @@ func (c *RPCClient) Call(goroutineID int
 	return &out.State, err
 }
 
-func (c *RPCClient) StepInstruction() (*api.DebuggerState, error) {
+func (c *RPCClient) StepInstruction(skipCalls bool) (*api.DebuggerState, error) {
 	var out CommandOut
-	err := c.call("Command", api.DebuggerCommand{Name: api.StepInstruction}, &out)
+	name := api.StepInstruction
+	if skipCalls {
+		name = api.NextInstruction
+	}
+	err := c.call("Command", api.DebuggerCommand{Name: name}, &out)
 	return &out.State, err
 }
 
-func (c *RPCClient) ReverseStepInstruction() (*api.DebuggerState, error) {
+func (c *RPCClient) ReverseStepInstruction(skipCalls bool) (*api.DebuggerState, error) {
 	var out CommandOut
-	err := c.call("Command", api.DebuggerCommand{Name: api.ReverseStepInstruction}, &out)
+	name := api.ReverseStepInstruction
+	if skipCalls {
+		name = api.ReverseNextInstruction
+	}
+	err := c.call("Command", api.DebuggerCommand{Name: name}, &out)
 	return &out.State, err
 }
 
@@ -339,9 +347,9 @@ func (c *RPCClient) ListSources(filter s
 	return sources.Sources, err
 }
 
-func (c *RPCClient) ListFunctions(filter string) ([]string, error) {
+func (c *RPCClient) ListFunctions(filter string, TraceFollow int) ([]string, error) {
 	funcs := new(ListFunctionsOut)
-	err := c.call("ListFunctions", ListFunctionsIn{filter}, funcs)
+	err := c.call("ListFunctions", ListFunctionsIn{filter, TraceFollow}, funcs)
 	return funcs.Funcs, err
 }
 
diff -pruN 1.22.1-1/service/rpc2/server.go 1.23.0-1/service/rpc2/server.go
--- 1.22.1-1/service/rpc2/server.go	2024-02-21 20:29:06.000000000 +0000
+++ 1.23.0-1/service/rpc2/server.go	2024-07-16 18:44:48.000000000 +0000
@@ -127,7 +127,7 @@ type CommandOut struct {
 
 // Command interrupts, continues and steps through the program.
 func (s *RPCServer) Command(command api.DebuggerCommand, cb service.RPCCallback) {
-	st, err := s.debugger.Command(&command, cb.SetupDoneChan())
+	st, err := s.debugger.Command(&command, cb.SetupDoneChan(), cb.DisconnectChan())
 	if err != nil {
 		cb.Return(nil, err)
 		return
@@ -578,7 +578,8 @@ func (s *RPCServer) ListSources(arg List
 }
 
 type ListFunctionsIn struct {
-	Filter string
+	Filter      string
+	FollowCalls int
 }
 
 type ListFunctionsOut struct {
@@ -587,7 +588,7 @@ type ListFunctionsOut struct {
 
 // ListFunctions lists all functions in the process matching filter.
 func (s *RPCServer) ListFunctions(arg ListFunctionsIn, out *ListFunctionsOut) error {
-	fns, err := s.debugger.Functions(arg.Filter)
+	fns, err := s.debugger.Functions(arg.Filter, arg.FollowCalls)
 	if err != nil {
 		return err
 	}
@@ -978,7 +979,7 @@ type ExaminedMemoryOut struct {
 
 func (s *RPCServer) ExamineMemory(arg ExamineMemoryIn, out *ExaminedMemoryOut) error {
 	if arg.Length > 1000 {
-		return fmt.Errorf("len must be less than or equal to 1000")
+		return errors.New("len must be less than or equal to 1000")
 	}
 	Mem, err := s.debugger.ExamineMemory(arg.Address, arg.Length)
 	if err != nil {
diff -pruN 1.22.1-1/service/rpccallback.go 1.23.0-1/service/rpccallback.go
--- 1.22.1-1/service/rpccallback.go	2024-02-21 20:29:06.000000000 +0000
+++ 1.23.0-1/service/rpccallback.go	2024-07-16 18:44:48.000000000 +0000
@@ -8,4 +8,8 @@ type RPCCallback interface {
 	// asynchronous method has completed setup and the server is ready to
 	// receive other requests.
 	SetupDoneChan() chan struct{}
+
+	// DisconnectChan returns a channel that should be closed to signal that
+	// the client that initially issued the command has been disconnected.
+	DisconnectChan() chan struct{}
 }
diff -pruN 1.22.1-1/service/rpccommon/server.go 1.23.0-1/service/rpccommon/server.go
--- 1.22.1-1/service/rpccommon/server.go	2024-02-21 20:29:06.000000000 +0000
+++ 1.23.0-1/service/rpccommon/server.go	2024-07-16 18:44:48.000000000 +0000
@@ -4,6 +4,7 @@ import (
 	"bufio"
 	"bytes"
 	"encoding/json"
+	"errors"
 	"fmt"
 	"io"
 	"net"
@@ -48,11 +49,12 @@ type ServerImpl struct {
 }
 
 type RPCCallback struct {
-	s         *ServerImpl
-	sending   *sync.Mutex
-	codec     rpc.ServerCodec
-	req       rpc.Request
-	setupDone chan struct{}
+	s              *ServerImpl
+	sending        *sync.Mutex
+	codec          rpc.ServerCodec
+	req            rpc.Request
+	setupDone      chan struct{}
+	disconnectChan chan struct{}
 }
 
 var _ service.RPCCallback = &RPCCallback{}
@@ -97,7 +99,7 @@ func (s *ServerImpl) Stop() error {
 		s.listener.Close()
 	}
 	if s.debugger.IsRunning() {
-		s.debugger.Command(&api.DebuggerCommand{Name: api.Halt}, nil)
+		s.debugger.Command(&api.DebuggerCommand{Name: api.Halt}, nil, nil)
 	}
 	kill := s.config.Debugger.AttachPid == 0
 	return s.debugger.Detach(kill)
@@ -112,7 +114,7 @@ func (s *ServerImpl) Run() error {
 		s.config.APIVersion = 1
 	}
 	if s.config.APIVersion > 2 {
-		return fmt.Errorf("unknown API version")
+		return errors.New("unknown API version")
 	}
 
 	// Create and start the debugger
@@ -277,7 +279,9 @@ func suitableMethods(rcvr interface{}, m
 }
 
 func (s *ServerImpl) serveJSONCodec(conn io.ReadWriteCloser) {
+	clientDisconnectChan := make(chan struct{})
 	defer func() {
+		close(clientDisconnectChan)
 		if !s.config.AcceptMulti && s.config.DisconnectChan != nil {
 			close(s.config.DisconnectChan)
 		}
@@ -361,7 +365,7 @@ func (s *ServerImpl) serveJSONCodec(conn
 				s.log.Debugf("(async %d) <- %s(%T%s)", req.Seq, req.ServiceMethod, argv.Interface(), argvbytes)
 			}
 			function := mtype.method.Func
-			ctl := &RPCCallback{s, sending, codec, req, make(chan struct{})}
+			ctl := &RPCCallback{s, sending, codec, req, make(chan struct{}), clientDisconnectChan}
 			go func() {
 				defer func() {
 					if ierr := recover(); ierr != nil {
@@ -412,9 +416,28 @@ func (cb *RPCCallback) Return(out interf
 		outbytes, _ := json.Marshal(out)
 		cb.s.log.Debugf("(async %d) -> %T%s error: %q", cb.req.Seq, out, outbytes, errmsg)
 	}
+
+	if cb.hasDisconnected() {
+		return
+	}
+
 	cb.s.sendResponse(cb.sending, &cb.req, &resp, out, cb.codec, errmsg)
 }
 
+func (cb *RPCCallback) DisconnectChan() chan struct{} {
+	return cb.disconnectChan
+}
+
+func (cb *RPCCallback) hasDisconnected() bool {
+	select {
+	case <-cb.disconnectChan:
+		return true
+	default:
+	}
+
+	return false
+}
+
 func (cb *RPCCallback) SetupDoneChan() chan struct{} {
 	return cb.setupDone
 }
@@ -433,7 +456,7 @@ func (s *RPCServer) SetApiVersion(args a
 		args.APIVersion = 1
 	}
 	if args.APIVersion > 2 {
-		return fmt.Errorf("unknown API version")
+		return errors.New("unknown API version")
 	}
 	s.s.config.APIVersion = args.APIVersion
 	return nil
diff -pruN 1.22.1-1/service/test/integration1_test.go 1.23.0-1/service/test/integration1_test.go
--- 1.22.1-1/service/test/integration1_test.go	2024-02-21 20:29:06.000000000 +0000
+++ 1.23.0-1/service/test/integration1_test.go	2024-07-16 18:44:48.000000000 +0000
@@ -511,7 +511,6 @@ func Test1ClientServer_traceContinue(t *
 			if state.Err != nil {
 				t.Fatalf("Unexpected error during continue: %v\n", state.Err)
 			}
-
 		}
 
 		if count != 3 {
@@ -550,7 +549,6 @@ func Test1ClientServer_traceContinue2(t
 			if state.Err != nil {
 				t.Fatalf("Unexpected error during continue: %v\n", state.Err)
 			}
-
 		}
 
 		if countMain != 1 {
diff -pruN 1.22.1-1/service/test/integration2_test.go 1.23.0-1/service/test/integration2_test.go
--- 1.22.1-1/service/test/integration2_test.go	2024-02-21 20:29:06.000000000 +0000
+++ 1.23.0-1/service/test/integration2_test.go	2024-07-16 18:44:48.000000000 +0000
@@ -798,6 +798,42 @@ func TestClientServer_infoLocals(t *test
 	})
 }
 
+func matchFunctions(t *testing.T, funcs []string, expected []string, depth int) {
+	for i := range funcs {
+		if funcs[i] != expected[i] {
+			t.Fatalf("Function %s  not found in ListFunctions --follow-calls=%d output", expected[i], depth)
+		}
+	}
+}
+
+func TestTraceFollowCallsCommand(t *testing.T) {
+	protest.AllowRecording(t)
+	withTestClient2("testtracefns", t, func(c service.Client) {
+		depth := 3
+		functions, err := c.ListFunctions("main.A", depth)
+		assertNoError(err, t, "ListFunctions()")
+		expected := []string{"main.A", "main.B", "main.C", "main.D"}
+		matchFunctions(t, functions, expected, depth)
+
+		functions, err = c.ListFunctions("main.first", depth)
+		assertNoError(err, t, "ListFunctions()")
+		expected = []string{"main.first", "main.second"}
+		matchFunctions(t, functions, expected, depth)
+
+		depth = 4
+		functions, err = c.ListFunctions("main.callme", depth)
+		assertNoError(err, t, "ListFunctions()")
+		expected = []string{"main.callme", "main.callme2", "main.callmed", "main.callmee"}
+		matchFunctions(t, functions, expected, depth)
+
+		depth = 6
+		functions, err = c.ListFunctions("main.F0", depth)
+		assertNoError(err, t, "ListFunctions()")
+		expected = []string{"main.F0", "main.F0.func1", "main.F1", "main.F2", "main.F3", "main.F4", "runtime.deferreturn", "runtime.gopanic", "runtime.gorecover"}
+		matchFunctions(t, functions, expected, depth)
+	})
+}
+
 func TestClientServer_infoArgs(t *testing.T) {
 	protest.AllowRecording(t)
 	withTestClient2("testnextprog", t, func(c service.Client) {
@@ -891,7 +927,6 @@ func TestClientServer_traceContinue(t *t
 			if state.Err != nil {
 				t.Fatalf("Unexpected error during continue: %v\n", state.Err)
 			}
-
 		}
 
 		if count != 3 {
@@ -931,7 +966,6 @@ func TestClientServer_traceContinue2(t *
 			if state.Err != nil {
 				t.Fatalf("Unexpected error during continue: %v\n", state.Err)
 			}
-
 		}
 
 		if countMain != 1 {
@@ -1011,7 +1045,6 @@ func TestClientServer_FindLocations(t *t
 		if locsNoSubst[0].PC != locsSubst[0].PC {
 			t.Fatalf("FindLocation with substitute rules mismatch %#v %#v", locsNoSubst[0], locsSubst[0])
 		}
-
 	})
 
 	withTestClient2("testnextdefer", t, func(c service.Client) {
@@ -1334,7 +1367,7 @@ func TestIssue355(t *testing.T) {
 		assertErrorOrExited(s, err, t, "Next()")
 		s, err = c.Step()
 		assertErrorOrExited(s, err, t, "Step()")
-		s, err = c.StepInstruction()
+		s, err = c.StepInstruction(false)
 		assertErrorOrExited(s, err, t, "StepInstruction()")
 		s, err = c.SwitchThread(tid)
 		assertErrorOrExited(s, err, t, "SwitchThread()")
@@ -1452,7 +1485,7 @@ func TestDisasm(t *testing.T) {
 			if count > 20 {
 				t.Fatal("too many step instructions executed without finding a call instruction")
 			}
-			state, err := c.StepInstruction()
+			state, err := c.StepInstruction(false)
 			assertNoError(err, t, fmt.Sprintf("StepInstruction() %d", count))
 
 			d3, err = c.DisassemblePC(api.EvalScope{GoroutineID: -1}, state.CurrentThread.PC, api.IntelFlavour)
@@ -2623,7 +2656,6 @@ func TestLongStringArg(t *testing.T) {
 			t.Logf("%#v\n", var2)
 			if var2.Value != val2 {
 				t.Fatalf("wrong value for variable: %q", var2.Value)
-
 			}
 			return var1.Addr
 		}
@@ -3105,3 +3137,33 @@ func TestClientServer_chanGoroutines(t *
 		}
 	})
 }
+
+func TestNextInstruction(t *testing.T) {
+	protest.AllowRecording(t)
+	withTestClient2("testprog", t, func(c service.Client) {
+		fp := testProgPath(t, "testprog")
+		_, err := c.CreateBreakpoint(&api.Breakpoint{File: fp, Line: 19})
+		state := <-c.Continue()
+		assertNoError(state.Err, t, "Continue()")
+
+		state, err = c.StepInstruction(true)
+		assertNoError(err, t, "Step()")
+		if state.CurrentThread.Line != 20 {
+			t.Fatalf("expected line %d got %d", 20, state.CurrentThread.Line)
+		}
+	})
+}
+
+func TestBreakpointVariablesWithoutG(t *testing.T) {
+	// Tests that evaluating variables on a breakpoint that is hit on a thread
+	// without a goroutine does not cause an error.
+	withTestClient2("math", t, func(c service.Client) {
+		_, err := c.CreateBreakpoint(&api.Breakpoint{
+			FunctionName: "runtime.mallocgc",
+			LoadArgs:     &normalLoadConfig,
+		})
+		assertNoError(err, t, "CreateBreakpoint")
+		state := <-c.Continue()
+		assertNoError(state.Err, t, "Continue()")
+	})
+}
